dos_header:

db "MZ"

dw 0, 1, 0, 4/*Header size in paragraphs*/, 0, 0
dw 0, 0xFFFE  // stack
dw 0  // csum
dw offset dos_main, 0  // ip, cs
dw 0, 0
dw 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 0, 0
dd offset pe_header  // lfanew

[bits 16]

dos_str: db "Requires 32 bit OS\0"

dos_writez:

l_dos_writez_1:
  mov al, [cs:si]
  inc si
  or al, al
  jz l_dos_writez_9
    mov ah, 0Eh
    xor bh, bh
    int 10h
    jmp l_dos_writez_1

l_dos_writez_9:
ret


dos_main:
mov si, offset dos_str
call dos_writez

dos_end:
mov ax, 4C00h
int 21h

WM_KEYDOWN = 100h
WM_KEYUP   = 101h
WM_COMMAND = 111h
WM_TIMER   = 113h

MAX_PATH = 260
MAX_DIRS = 1024
MAX_FILES = 4096
MAX_BUFFER = 10000  // >= 512

COFS = 0x401000 - 0x400

ERC_NOT_FILE = 3
ERC_WRITE_ERROR = 4

TAB_H = 20

COLOR_DISKS = 70h
COLOR_ACTIVEDISK = 0Fh
COLOR_PATH = 7
COLOR_LABEL = 30h
COLOR_INACTIVE = 71h
COLOR_ACTIVE = 1Fh
COLOR_BOTTOM = 70h
COLOR_BORDER = 6Eh
COLOR_INFO = 1Fh
COLOR_FORMAT = 1Fh
COLOR_SELECT = 31h
COLOR_ERROR = 0Ch

SORT_AZ = 0
SORT_ZA = 1
SORT_SIZE_ASC = 2
SORT_SIZE_DESC = 3
SORT_CHANGE_ASC = 4
SORT_CHANGE_DESC = 5

VK_LEFT = 37
VK_RIGHT = 39
VK_UP = 38
VK_DOWN = 40
VK_ENTER = 13
VK_ESC = 27
VK_BSP = 8
VK_TAB = 9
VK_HOME = 36
VK_END = 35
VK_PGUP = 33
VK_PGDN = 34
VK_INS = 45
VK_DEL = 46

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000

FOPEN_READ = 1
FOPEN_WRITE = 3
FOPEN_APPEND = 10h
FOPEN_CREATE = 20h

FILE_ATTRIBUTE_READONLY  = 0x00000001
FILE_ATTRIBUTE_HIDDEN    = 0x00000002
FILE_ATTRIBUTE_SYSTEM    = 0x00000004
FILE_ATTRIBUTE_DIRECTORY = 0x00000010
FILE_ATTRIBUTE_ARCHIVE   = 0x00000020
FILE_ATTRIBUTE_DEVICE    = 0x00000040
FILE_ATTRIBUTE_NORMAL    = 0x00000080
FILE_ATTRIBUTE_TEMPORARY     = 0x00000100
FILE_ATTRIBUTE_SPARSE_FILE   = 0x00000200
FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400
FILE_ATTRIBUTE_COMPRESSED    = 0x00000800
FILE_ATTRIBUTE_OFFLINE       = 0x00001000
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000
FILE_ATTRIBUTE_ENCRYPTED       = 0x00004000
FILE_ATTRIBUTE_VALID_FLAGS     = 0x00007fb7
FILE_ATTRIBUTE_VALID_SET_FLAGS = 0x000031a7
FILE_ATTRIBUTE_LINUX = 0x08000000
FILE_ATTRIBUTE_LINK  = 0x04000000

ACCESS_R = 4 //read
ACCESS_W = 2 //write
ACCESS_X = 1 //execute

FSID_EXT2 = 82h
FSID_NTFS = 7
FSID_FAT12 = 0F0h
FSID_CD = 30h

EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER = 0x0001 // Sparse Superblock
EXT2_FEATURE_RO_COMPAT_LARGE_FILE = 0x0002   // 64-bit file size
EXT2_FEATURE_RO_COMPAT_BTREE_DIR = 0x0004    // Binary tree sorted directories

struct StringBuilder{
  uns4 len, max
  ptr4 data
}

struct DateTime8{
  uns8 datetime
}

struct SearchRec{
  uns4 FileAttributes
  DateTime8 CreationTime
  DateTime8 LastAccessTime
  DateTime8 LastWriteTime
  uns8 FileSize
  uns8 Reserved
  char FileName[MAX_PATH]
  char AlternateFileName[14]
}

struct ViewRec{
  uns4 path_len, dirs_count, files_count, sy, y, x, w
  char path[MAX_PATH]
  uns4 pdirs[MAX_DIRS]
  uns4 pfiles[MAX_FILES]
  StringBuilder dirs, files
}

struct FileInfo{
  uns4 FileAttributes
  uns8 FileSize
  uns8 CreationTime
  uns8 LastAccessTime
  uns8 LastWriteTime
  char FileName[MAX_PATH]
}

struct SystemTime{
  uns2 wYear
  uns2 wMonth
  uns2 wDayOfWeek
  uns2 wDay
  uns2 wHour
  uns2 wMinute
  uns2 wSecond
  uns2 wMilliseconds
}

struct SuperBlock{
  uns4 s_inodes_count, s_blocks_count, s_r_blocks_count, s_free_blocks_count
  uns4 s_free_inodes_count, s_first_data_block, s_log_block_size
  uns4 s_log_frag_size, s_blocks_per_group, s_frags_per_group
  uns4 s_inodes_per_group, s_mtime, s_wtime
  uns2 s_mnt_count, s_max_mnt_count, s_magic, s_state, s_errors
  uns2 s_minor_rev_level
  uns4 s_lastcheck, s_checkinterval, s_creator_os, s_rev_level
  uns2 s_def_resuid, s_def_resgid
  uns4 s_first_ino
  uns2 s_inode_size, s_block_group_nr
  uns4 s_feature_compat, s_feature_incompat, s_feature_ro_compat
  //...
}

struct GroupBlock{
  uns4 bg_block_bitmap, bg_inode_bitmap, bg_inode_table
  uns2 bg_free_blocks_count, bg_free_inodes_count
  uns2 bg_used_dirs_count, bg_pad
  uns1 bg_reserved[12]
}

struct INode{
  uns2 i_mode, i_uid
  uns4 i_size, i_atime, i_ctime, i_mtime, i_dtime
  uns2 i_gid, i_links_count
  uns4 i_blocks, i_flags, i_osd1
  uns4 i_block[15]
  uns4 i_generation, i_file_acl, i_dir_acl/*size 32-63*/, i_faddr
  uns1 i_osd[12]
}

[dorg 0x500000]

ViewRec view[2]

SearchRec srch

FileInfo finfo

[dalign 32]
uns4 i, tab_ofs, first, last, f1, f2, pos1, pos2, c1, c2
uns4 ptrfi, atrv
int4 time_zone
uns8 time, num
SystemTime localtime
char temp[10]

char disks[32]
uns1 disks_count

uns1 color, sort_by, sort_by_inner, x0, y0, x, y, len, atri

char path[MAX_PATH], path2[MAX_PATH]

char buffer[MAX_BUFFER]

char fs_formatfn[63]
uns1 format_disk, fs_count, fs_filesystems, fs_filesystem
uns1 fs_cluzi, fs_systemdisk, fs_partition_type, fs_pdiskn
uns1 fs_buffer[512], fs_bootsect[512]
bool fs_formatsystem

[dalign 32]
uns4 fs_ofs_format, fs_setup_size, fs_kernel_size, fs_bootsofs
uns4 fs_value, fs_gb_diskofs, fs_syssect
uns4 e2_groups, e2_gblocks, e2_tmp

uns4 uid, gid
StringBuilder info_sb

[dalign 64]
uns8 e2_disksize

SuperBlock e2_sb
GroupBlock e2_gb
INode e2_inode

ERC_OUT_OF_RANGE        = 5
ERC_DISK_CHANGED        = 6
ERC_NOT_FLUSHED         = 7
ERC_DISK_IO             = 8
ERC_INVALID_DISK_NUMBER = 10h
ERC_NOT_FOUND_IN_CACHE  = 12h
ERC_UNKNOWN_GEOMETRY    = 15h
ERC_DISK_FULL           = 16h

ERC_NOT_IMPLEMENTED     = 0FFh

ERC_INVALID_CHANNEL_NUMBER = 18h
ERC_INVALID_MEMORY_ADDRESS = 19h
ERC_INVALID_COUNT          = 1Ah

ERC_NOT_ENOUGH_MEMORY = 21h
ERC_ALIGN             = 24h
ERC_ALREADY_FREE      = 25h
ERC_OVERFLOW          = 26h
ERC_UNDERFLOW         = 27h

ERC_MSG_QUEUE_EMPTY    = 30h
ERC_MSG_QUEUE_FULL     = 31h
ERC_MSG_INVALID_TARGET = 32h

ERC_TOO_MANY_PROCS   = 40h
ERC_TOO_MANY_THREADS = 41h

ERC_TIMER_FULL      = 42
ERC_TIMER_NOT_FOUND = 43

ERC_PATH_NOT_FOUND = 44h
ERC_FILE_NOT_FOUND = 45h
ERC_TOO_MANY_OPEN_FILES = 46h
ERC_DIR_ALREADY_EXISTS = 47h
ERC_UNKNOWN_FILESYSTEM = 48h
ERC_DIR_NOT_EMPTY = 49h
ERC_CANT_REMOVE = 4Ah
ERC_DUPLICATE_NAME = 4Bh
ERC_INVALID_FHANDLE = 4Ch
ERC_INVALID_THREAD = 4Dh
ERC_FS = 4Eh
ERC_READ_ONLY = 4Fh
ERC_IN_USE = 50h
ERC_OUT_OF_DISK = 51h
ERC_TOO_MANY_SEARCHES = 52h
ERC_INVALID_SHANDLE = 53h
ERC_CANT_RENAME = 54h

ERC_INVALID_PID = 55h
ERC_STACK_OVERFLOW = 56h
ERC_INVALID_HEADER = 57h
ERC_INVALID_SERVICE = 58h

ERC_TOO_LONG = 59h
ERC_ONLY_STARTER = 5Ah
ERC_INVALID_MEMORY_LOCATION = 5Bh
ERC_INVALID_THREADID = 5Ch
ERC_ACCESS_DENIED = 5Dh
ERC_INVALID_PRIORITY = 5Eh
ERC_INVALID_ATRBS = 5Fh
ERC_INVALID_VALUE = 60h
ERC_INVALID_POINTER = 61h
ERC_INVALID_CHAR = 62h
ERC_DISK_REMOVED = 63h
ERC_TOO_BIG_HOLE = 64h
ERC_UTF8 = 65h
ERC_BUSY = 66h
ERC_DIR_TOO_BIG = 67h
ERC_LINK = 68h
ERC_NOT_A_LINK = 69h
ERC_INFINITE_LINK = 70h
ERC_CANT_MOVE = 71h
ERC_FILE_TOO_BIG = 72h

[align 32]

pe_header:

db "PE"

dw 0, 14Ch, 2/*Number of sections*/
dd 0, 0/*Pointer to symbol table*/, 0/*Number of symbols*/
dw 224 /*Size of optional header*/, 0 /*Characteristics*/

// Optional header
dw 0/*OH magic*/

db 0, 0
dd offset lastoffset /*Size of code*/
dd 0/*Size of initialized data*/, #/*Size of uninitialized data*/
dd 0x1000/*Address of entry point*/
dd 0/*Base of code*/, 0x10000/*Base of data*/

dd 0x400000/*Image base*/
dd 0x1000 /*Section alignment*/, 0x200 /*File alignment*/
dw 4, 0 /*OS version*/, 0, 0 /*Image version*/, 4, 0 /*Subsystem version*/
dd 0, 0x10000/*Size of image*/, 0x400/*Size of headers*/
dd 0 /*Checksum*/
dw 2/*Subsystem*/, 0/*DLL characteristics*/
dd 0x100000/*stack*/, 0x1000
dd 0x100000/*heap*/, 0x1000
dd 0/*Loader flags*/, 16

dd 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0

// Section table [lfanew + 18h + sizeOfOptionalHeader]
db ".text   "
dd offset lastoffset // VSize
dd 0x1000 // VAdr
dd offset lastoffset // Size of raw data
dd 0x400 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0x60000060 // Characteristics

db ".data   "
dd # - 0x500000 // VSize
dd 0x100000 // VAdr
dd 0 // Size of raw data
dd 0 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0xC0000040 // Characteristics

times 0x400 - $, 0

[bits 32]

jmp main

// IN: dl = x, dh = y
curto:
push ecx
 push esi
  push edx
   push edi
    push ebx
  
     mov ah, 3
     int 20h
  
    pop ebx
   pop edi
  pop edx
 pop esi
pop ecx
ret

// IN: esi -> string, ecx = length, bl = color
write:
push edx
 push edi
  push ebx
  
  mov ah, 2
  int 20h
  
  pop ebx
 pop edi
pop edx
ret

// IN: eax = number, ecx = system, bl = color
writen:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writen_1
		mov ecx, 10		// ecx must be >= 2

	l_writen_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writen_2
			add dl, '0'
			jmp short l_writen_3

		l_writen_2:
			add dl, 55

		l_writen_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writen_1
	
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
      dec esi
      inc ecx
      mov [esi], dl
      
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

// IN: eax = number, ecx = system, bl = color, bh = minlen
writemin:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writemin_1
		mov ecx, 10		// ecx must be >= 2

	l_writemin_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writemin_2
			add dl, '0'
			jmp short l_writemin_3

		l_writemin_2:
			add dl, 55

		l_writemin_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writemin_1
	
	cmp bh, 36
	jb l_writemin_4
	  mov bh, 36
	  
	l_writemin_4:
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
	l_writemin_5:
	  cmp cl, bh
	  jnb l_writemin_6
          dec esi
          inc ecx
          mov [esi], dl
          jmp short l_writemin_5
      
	l_writemin_6:	  
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

THOUSAND_SEPARATOR = ','

// IN: edx:eax = number, ecx = system, bl = color
writen8:
push ecx
 push esi
  push edi

    sub esp, 72

    // Parse digits from the number
    mov esi, esp
    add esi, 72

    mov dword ptr num[0], eax
    mov dword ptr num[4], edx
    xor bh, bh

    cmp ecx, 2
    jnb l_writen8_1
      mov ecx, 10		// ecx must be >= 2
    
    l_writen8_1:
      cmp bh, 3
      jb l_writen_12
        dec esi
        mov byte ptr [esi], THOUSAND_SEPARATOR
        xor bh, bh
        
      l_writen_12:
      inc bh
      xor edx, edx
      mov eax, dword ptr num[4]
      div ecx
      mov dword ptr num[4], eax
      mov eax, dword ptr num[0]
      div ecx
      mov dword ptr num[0], eax
      
      cmp dl, 10
      jnb l_writen8_2
        add dl, '0'
        jmp short l_writen8_3
      
      l_writen8_2:
        add dl, 55
      
      l_writen8_3:
      dec esi
      mov [esi], dl
      
      mov eax, dword ptr num[0]
      mov edx, dword ptr num[4]
      test eax, eax
      jnz l_writen8_1
        test edx, edx
        jnz l_writen8_1
      
    mov ecx, esp
    add ecx, 72
    sub ecx, esi  // ecx = len
    mov dl, ' '
    
    dec esi
    inc ecx
    mov [esi], dl
     
    call write
     
    add esp, 72
    
  pop edi
 pop esi
pop ecx
ret

// IN: edx -> path & mask, edi -> SearchRec
// OUT: al = 0 || erc
find_first:
mov ah, 22
int 20h
cmp al, ERC_BUSY
jnz l_find_first_9
  call noop
  jmp short find_first
  
l_find_first_9:
ret

// IN: edi -> SearchRec
// OUT: al = 0 || erc
find_next:
mov ah, 23
int 20h
cmp al, ERC_BUSY
jnz l_find_next_9
  call noop
  jmp short find_next
  
l_find_next_9:
ret

// IN: edi -> SearchRec
find_close:
mov ah, 48
int 20h
ret

// IN: edx -> pathz
cdir:
mov ah, 16
int 20h
cmp al, ERC_BUSY
jnz l_cdir_9
  call noop
  jmp short cdir
  
l_cdir_9:
ret

// IN: edi -> buffer[MAX_PATH]
// OUT: al = 0 || erc
get_current_directory:
mov ah, 52
int 20h
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopen:
mov esi, 3
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopen_9
  call noop
  jmp short fopen
  
l_fopen_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopenread:
mov esi, 1
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopenread_9
  call noop
  jmp short fopenread
  
l_fopenread_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fcreate:
mov esi, 20h
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fcreate_9
  call noop
  jmp short fcreate
  
l_fcreate_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fpos
fgetpos:
mov ah, 14
int 20h
cmp al, ERC_BUSY
jnz l_fgetpos_9
  call noop
  jmp short fgetpos
  
l_fgetpos_9:
ret

// IN: ebx = fhandle, edx:edi = file offset
// OUT: al = erc
fsetpos:
mov ah, 12
int 20h
cmp al, ERC_BUSY
jnz l_fsetpos_9
  call noop
  jmp short fsetpos
  
l_fsetpos_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fsize
fgetsize:
mov ah, 15
int 20h
cmp al, ERC_BUSY
jnz l_fgetsize_9
  call noop
  jmp short fgetsize
  
l_fgetsize_9:
ret

// IN: ebx = fhandle
fclose:
mov ah, 9
int 20h
cmp al, ERC_BUSY
jnz l_fclose_9
  call noop
  jmp short fclose
  
l_fclose_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size read
fread:
mov ah, 10
int 20h
cmp al, ERC_BUSY
jnz l_fread_9
  call noop
  jmp short fread
  
l_fread_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size write
fwrite:
mov ah, 11
int 20h
cmp al, ERC_BUSY
jnz l_fwrite_9
  call noop
  jmp short fwrite
  
l_fwrite_9:
ret

// IN: edx -> filenamez
rm:
mov ah, 18
int 20h
cmp al, ERC_BUSY
jnz l_rm_9
  call noop
  jmp short rm
  
l_rm_9:
ret

// IN: edx -> filenamez
md:
mov ah, 17
int 20h
cmp al, ERC_BUSY
jnz l_md_9
  call noop
  jmp short md
  
l_md_9:
ret

// IN: edx -> path & filenamez, esi -> new filenamez
// OUT: al = erc
ren:
mov ah, 20
int 20h
cmp al, ERC_BUSY
jnz l_ren_9
  call noop
  jmp short ren
  
l_ren_9:
ret

// IN: edx -> filenamez, esi -> new path
mv:
mov ah, 21
int 20h
cmp al, ERC_BUSY
jnz l_mv_9
  call noop
  jmp short mv
  
l_mv_9:
ret

// IN: esi = ldiskn
resetdisk:
mov ah, 63
int 20h
ret

// IN: edx -> filenamez, esi = mode
// OUT: al = erc, ebx = fhandle
open_link:
mov ah, 66
int 20h
cmp al, ERC_BUSY
jnz l_open_link_9
  call noop
  jmp short open_link
  
l_open_link_9:
ret

// IN: edx -> filenamez
// OUT: al = erc
rm_link:
mov ah, 67
int 20h
cmp al, ERC_BUSY
jnz l_rm_link_9
  call noop
  jmp short rm_link
  
l_rm_link_9:
ret

// IN: al = ldiskn
// OUT: al = erc
flush:
movzx esi, al

l_flush_1:
mov ah, 39 
int 20h
cmp al, ERC_BUSY
jnz l_flush_9
  call noop
  jmp short l_flush_1
  
l_flush_9:
ret

// IN: ebx = fhandle
// OUT: al = erc, edx:ecx = ftime
get_mtime:
mov ah, 74
int 20h
cmp al, ERC_BUSY
jnz l_get_mtime_9
  call noop
  jmp short get_mtime
  
l_get_mtime_9:
ret

// IN: ebx = fhandle, edx:ecx = ftime
// OUT: al = erc
set_mtime:
mov ah, 75
int 20h
cmp al, ERC_BUSY
jnz l_set_mtime_9
  call noop
  jmp short set_mtime
  
l_set_mtime_9:
ret

// IN: edx -> filenamez, esi = atrbs
// OUT: al = errorcode
// differrent behavior for windows and linux
chmod:
mov ah, 76
int 20h
cmp al, ERC_BUSY
jnz l_chmod_9
  call noop
  jmp short chmod
  
l_chmod_9:
ret

// only starter, root
// IN: edx -> filenamez, esi = new owner
// OUT: al = erc
chown:
mov ah, 78
int 20h
cmp al, ERC_BUSY
jnz l_chown_9
  call noop
  jmp short chown
  
l_chown_9:
ret

// only starter, root or owner
// IN: edx -> filenamez, esi = new group
// OUT: al = erc
chgrp:
mov ah, 79
int 20h
cmp al, ERC_BUSY
jnz l_chgrp_9
  call noop
  jmp short chgrp
  
l_chgrp_9:
ret

// IN: edx -> filenamez
// OUT: al = erc, ecx = uid, edx = gid
fuidgid:
mov ah, 82
int 20h
cmp al, ERC_BUSY
jnz l_fuidgid_9
  call noop
  jmp short fuidgid
  
l_fuidgid_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> target
disk_read:
mov ah, 36
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_9
  call noop
  jmp short disk_read
  
l_disk_read_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> source
disk_write:
mov ah, 37
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_9
  call noop
  jmp short disk_write
  
l_disk_write_9:
ret

// OUT: al = logical disk number
get_boot_disk:
mov ah, 77
int 20h
movzx eax, al
ret

// OUT: al = logical disk number
get_users_disk:
mov ah, 83
int 20h
movzx eax, al
ret

// IN: esi = logical disk number
// OUT: al = type (2:fd, 3:cd, 4:hd), ah = pdiskn,
//      edx:ecx = disk size in sectors, edi:esi = base in sectors
get_disk_type:
mov ah, 53
int 20h
ret

// IN: esi = logical disk number
// OUT: edx:eax = disk size in bytes
get_disk_size:
mov ah, 38
int 20h
ret

// IN: al = ldiskn
// OUT: cl = erc, edx:eax = free bytes)
disk_free:
mov esi, eax

l_disk_free_1:
mov ah, 68
int 20h
cmp al, ERC_BUSY
jnz l_disk_free_9
  call noop
  jmp short l_disk_free_1
  
l_disk_free_9:
xchg eax, ecx
ret

// IN: al = ldiskn
// OUT: al = erc
reset_disk:
mov esi, eax

l_reset_disk_1:
mov ah, 63
int 20h
cmp al, ERC_BUSY
jnz l_reset_disk_9
  call noop
  jmp short l_reset_disk_1
  
l_reset_disk_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_read_sector:
mov ah, 40
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_sector_9
  call noop
  jmp short disk_read_sector
  
l_disk_read_sector_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_write_sector:
mov ah, 41
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_sector_9
  call noop
  jmp short disk_write_sector
  
l_disk_write_sector_9:
ret

noop:
mov ah, 0
int 20h
ret

// IN: ecx = size
// OUT: al = erc, ebx = ptr
malloc:
mov ah, 24
int 20h
ret

// IN: ebx = ptr
free:
mov ah, 25
int 20h
ret

// OUT: al = 0 || errorcode, ebx = wnd:sender, ecx = msg, edx = wp, esi = lp
getmsg:
mov ah, 5 // get system message
int 20h
or al, al
jz l_getmsg_9
  mov ah, 7 // get message
  int 20h
  or al, al
  jz l_getmsg_9
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    jmp short getmsg
  
l_getmsg_9:
ret

// KEEP: ebx, ebp
waitkey:
push ebx
 push ebp

  l_waitkey_5:
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    call getmsg
    cmp ecx, WM_KEYDOWN
    jnz l_waitkey_5

 pop ebp
pop ebx
ret

// IN: esi -> ftime, edi -> SystemTime
ftime2local:
mov eax, time_zone
mov ecx, 3600
imul ecx
mov ecx, 10000000
imul ecx

add eax, [esi]
adc edx, [esi + 4]
mov dword ptr time[0], eax
mov dword ptr time[4], edx

mov esi, offset time
mov ah, 59
int 20h
ret

// IN: ecx = uid, edi -> byte[256]
getuserinfo:
mov ah, 80
int 20h
cmp al, ERC_BUSY
jnz l_getuserinfo_9
  call noop
  jmp short getuserinfo
  
l_getuserinfo_9:
ret

// IN: ecx = gid, edi -> byte[256]
getgroupinfo:
mov ah, 81
int 20h
cmp al, ERC_BUSY
jnz l_getgroupinfo_9
  call noop
  jmp short getgroupinfo
  
l_getgroupinfo_9:
ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_init:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

// IN: esi -> StringBuilder, edi -> data, ecx = len
// OUT: al = erc (0: ok, 1: not enough memory)
// KEEP: esi
sb_add:
mov edx, [esi + offset StringBuilder.max]
mov eax, [esi + offset StringBuilder.len]
add eax, ecx
cmp eax, edx
jna l_sb_add2
  // len + ecx > max
  cmp edx, 16
  jnb l_sb_add11
    mov edx, 16
    
  l_sb_add11:
  cmp eax, edx
  jna l_sb_add14
    shl edx, 1
    cmp edx, 0
    jnz l_sb_add11
      
      l_sb_add13:
      
      mov al, 1
      
      ret
    
  l_sb_add14:
  // allocate a new block
  push esi
   push edi
    push ecx
     push edx
      mov ecx, edx
      call malloc
      // OUT: ebx
     pop edx
    pop ecx
   pop edi
  pop esi
  or al, al
  jnz l_sb_add13
  
  // copy old data to the new block
  mov [esi + offset StringBuilder.max], edx
  push esi
   push edi
    push ecx
     push ebx
       mov ecx, [esi + offset StringBuilder.len]
       mov esi, [esi + offset StringBuilder.data]
       mov edi, ebx
       mov ebx, esi
       cld
       rep movsb
       
       // free the old block
       or ebx, ebx
       jz l_sb_add18
         call free
         
       l_sb_add18:
     pop ebx 
    pop ecx
   pop edi
  pop esi
  mov [esi + offset StringBuilder.data], ebx

l_sb_add2:
// copy data
mov ebx, edi
mov edi, [esi + offset StringBuilder.data]
add edi, [esi + offset StringBuilder.len]
add [esi + offset StringBuilder.len], ecx

push esi
  mov esi, ebx
  cld
  rep movsb
pop esi

mov al, 0

ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_done:
mov ebx, [esi + offset StringBuilder.data]
or ebx, ebx
jz sb_done_2
  
  push esi
  
    call free
  
  pop esi
  
sb_done_2:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

vkeys:    db 0,27,"1234567890\xBD\xBB",8,9,"QWERTYUIOP\xDB\xDD",13
          db 17,"ASDFGHJKL\xBA\xDE\xDC",
          db 16,"\xE2","ZXCVBNM\xBC\xBE\xBF",16,106,18," "

movekeys: db 36, 38, 33, 109, 37, 12, 39, 107, 35,40,34,45,46
numkeys:  db 103,104,105,109, 100,101,102,107, 97,98,99,96,110
anumkeys: db "789-456+1230."

akeys0:   dw 0,27,"1\02\03\04\05\06\07\08\09\00\0-\0=\0",8
          dw 9,"q\0w\0e\0r\0t\0y\0u\0i\0o\0p\0[\0]\0",13
          dw 0,"a\0s\0d\0f\0g\0h\0j\0k\0l\0;\0'\0`\0"
          dw 0,"\\","z\0x\0c\0v\0b\0n\0m\0,\0.\0/\0",0,"*",0," "

akeys1:   dw 0,27,"!\0@\0#\0$\0%\0^\0&\0*\0(\0)\0_\0+\0",8
          dw 9,"Q\0W\0E\0R\0T\0Y\0U\0I\0O\0P\0{\0}\0",13
          dw 0,"A\0S\0D\0F\0G\0H\0J\0K\0L\0:\0\"\0~\0"
          dw 0,"|","Z\0X\0C\0V\0B\0N\0M\0<\0>\0?\0",0,"*",0," "

akeys2:   dw 0,27,"1\02\03\04\05\06\07\08\09\00\0-\0=\0",8
          dw 9,"Q\0W\0E\0R\0T\0Y\0U\0I\0O\0P\0[\0]\0",13
          dw 0,"A\0S\0D\0F\0G\0H\0J\0K\0L\0;\0'\0`\0"
          dw 0,"\\","Z\0X\0C\0V\0B\0N\0M\0,\0.\0/\0",0,"*",0," "

akeys3:   dw 0,27,"!\0@\0#\0$\0%\0^\0&\0*\0(\0)\0_\0+\0",8
          dw 9,"q\0w\0e\0r\0t\0y\0u\0i\0o\0p\0{\0}\0",13
          dw 0,"a\0s\0d\0f\0g\0h\0j\0k\0l\0:\0\"\0~\0"
          dw 0,"|","z\0x\0c\0v\0b\0n\0m\0<\0>\0?\0",0,"*",0," "

ctrlkeys: dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,127
          dw 0,17,23,5,18,20,25,21,9,15,16,27,29,10
          dw 0,1,19,4,6,7,8,10,11,12,0,0,28
          dw 0,28,26,24,3,22,2,14,13,0,0,0,0,"*",0," "

// IN: eax = escan key, edx = locks
// OUT: eax = VK, ecx = UTF-16 key
keys:
xor ecx, ecx
cmp eax, 135h // "/" on num
jnz l_keys_1
  mov eax, 111
  mov ecx, "/"
  jmp l_keys_9
  
l_keys_1:
test dl, KBD_NUMLK // num lock
jz l_keys_2
  test dl, KBD_RSH | KBD_LSH  // any shift
  jnz l_keys_2

    cmp al, 47h
    jb l_keys_2
      cmp al, 53h
      ja l_keys_2

        cmp ah, 1  // not num
        jz l_keys_2
          // num keys
          movzx ecx, byte ptr [cs:offset anumkeys + COFS + eax - 47h]
          movzx eax, byte ptr [cs:offset numkeys + COFS + eax - 47h]
          jmp l_keys_9

l_keys_2:
and eax, 127

cmp al, 47h
jb l_keys_3
  cmp al, 53h
  ja l_keys_3
    // move keys
    movzx eax, byte ptr [cs:offset movekeys + COFS + eax - 47h]
    cmp al, 109
    jnz l_keys_21
      mov ecx, '-'
      jmp l_keys_9
      
    l_keys_21:
    cmp al, 107
    jnz near l_keys_9
      mov ecx, '+'
      jmp l_keys_9

l_keys_3:
cmp al, 3Ah // Caps lock
jnb l_keys_4
  mov ecx, eax
  shl ecx, 1
  // vkey
  movzx eax, byte ptr [cs:offset vkeys + COFS + eax]
  // UTF-16 key
  test dx, KBD_CTRL
  jz l_keys_31
    movzx ecx, word ptr [cs:offset ctrlkeys + COFS + ecx]
    jmp l_keys_9
    
  l_keys_31:
  test dx, KBD_CPSLK
  jnz l_keys_34
    test dx, KBD_RSH | KBD_LSH
    jnz l_keys_32
      movzx ecx, word ptr [cs:offset akeys0 + COFS + ecx]
      jmp short l_keys_9
      
    l_keys_32:
    movzx ecx, word ptr [cs:offset akeys1 + COFS + ecx]
    jmp short l_keys_9
    
  l_keys_34:
  test dx, KBD_RSH | KBD_LSH
  jnz l_keys_36
    movzx ecx, word ptr [cs:offset akeys2 + COFS + ecx]
    jmp short l_keys_9
    
  l_keys_36:
  movzx ecx, word ptr [cs:offset akeys3 + COFS + ecx]
  jmp short l_keys_9

l_keys_4:
jnz l_keys_5
  // Caps lock
  mov eax, 20
  jmp short l_keys_9
  
l_keys_5:
cmp al, 3Bh  // F1
jb l_keys_52
  cmp al, 44h  // F10
  ja l_keys_52
    add eax, 112 - 3Bh
    jmp short l_keys_9

l_keys_52:
cmp al, 57h  // F11
jnz l_keys_53
  mov eax, 122
  jmp short l_keys_9
  
l_keys_53:
cmp al, 58h  // F12
jnz l_keys_54
  mov eax, 123
  jmp short l_keys_9

l_keys_54:
cmp al, 45h
jnz l_keys_9
  test dx, KBD_VCTRL
  jnz l_keys_6
    // num lock
    mov eax, 144
    jmp short l_keys_9
  
  l_keys_6:
  // break
  mov eax, 19
  
l_keys_9:
ret

/*
8 BACKSPACE
9 TAB
12 *5
13 ENTER
16 SHIFT
17 CTRL
19 BREAK
20 CAPS
27 ESC

33 PGUP
34 PGDN
35 END
36 HOME
37 <-
38 A
39 ->
40 V
45 INS
46 DEL

91 LWIN
92 RWIN
93 MENU

96 0
97 1
98 2
99 3
100 4
101 5
102 6
103 7
104 8
105 9
106 *
107 +
109 -
110 .
111 /

112 F1
113 F2
114 F3
115 F4
116 F5
117 F6
118 F7
119 F8
120 F9
121 F10
122 F11
123 F12

144 NUM

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000
*/

// IN: esi -> stringz
// OUT: ecx
// KEEP: ebx, esi, edi
strlen:
push esi
  xor ecx, ecx
  
  l_strlen_1:
    lodsb
    cmp al, 0
    jz l_strlen_9
      inc ecx
      jmp short l_strlen_1
  
  l_strlen_9:
pop esi
ret

// IN: ebx -> ViewRec
// KEEP: ebx
load:
// init dirs
mov esi, ebx
add esi, offset ViewRec.dirs
push ebx
  call sb_done
  call sb_init
pop ebx
mov dword ptr [ebx + offset ViewRec.dirs_count], 0
// init files
mov esi, ebx
add esi, offset ViewRec.files
push ebx
  call sb_done
  call sb_init
pop ebx
mov dword ptr [ebx + offset ViewRec.files_count], 0
// init find
mov edx, ebx
add edx, offset ViewRec.path
mov edi, offset srch
push ebx
  call find_first
pop ebx
or al, al
jnz near l_load_9
  
  l_load_1:
    test srch.FileAttributes, FILE_ATTRIBUTE_DIRECTORY
    jz near l_load_2
      // directory
      mov eax, [ebx + offset ViewRec.dirs_count]
      cmp eax, MAX_DIRS
      jnb near l_load_8
       cmp word ptr srch.FileName, '.'
       jz near l_load_8
       cmp word ptr srch.FileName, '..'
       jz near l_load_8
        inc dword ptr [ebx + offset ViewRec.dirs_count]
        mov esi, ebx
        shl eax, 2
        add esi, offset ViewRec.dirs  // esi -> view.dirs
        add eax, offset ViewRec.pdirs
        add eax, ebx
        mov ecx, [esi + offset StringBuilder.len]
        mov [eax], ecx
        
        mov eax, dword ptr srch.FileAttributes
        mov dword ptr finfo.FileAttributes, eax
        mov eax, dword ptr srch.FileSize[0]
        mov edx, dword ptr srch.FileSize[4]
        mov dword ptr finfo.FileSize[0], eax
        mov dword ptr finfo.FileSize[4], edx
        mov eax, dword ptr srch.CreationTime[0]
        mov edx, dword ptr srch.CreationTime[4]
        mov dword ptr finfo.CreationTime[0], eax
        mov dword ptr finfo.CreationTime[4], edx
        mov eax, dword ptr srch.LastAccessTime[0]
        mov edx, dword ptr srch.LastAccessTime[4]
        mov dword ptr finfo.LastAccessTime[0], eax
        mov dword ptr finfo.LastAccessTime[4], edx
        mov eax, dword ptr srch.LastWriteTime[0]
        mov edx, dword ptr srch.LastWriteTime[4]
        mov dword ptr finfo.LastWriteTime[0], eax
        mov dword ptr finfo.LastWriteTime[4], edx
        push esi
          mov esi, offset srch.FileName
          mov edi, offset finfo.FileName
          xor ecx, ecx
          
          l_load_15:
            lodsb
            stosb
            inc ecx
            or al, al
            jz l_load_18
              cmp ecx, MAX_PATH
              jb l_load_15
                mov byte ptr [edi - 1], 0
              
          l_load_18:
        pop esi
        add ecx, offset FileInfo.FileName
        
        // IN: esi, ecx
        mov edi, offset finfo
        push ebx
          call sb_add
        pop ebx
      jmp l_load_8
      
    l_load_2:
      // file
      mov eax, [ebx + offset ViewRec.files_count]
      cmp eax, MAX_FILES
      jnb near l_load_8
        inc dword ptr [ebx + offset ViewRec.files_count]
        mov esi, ebx
        shl eax, 2
        add esi, offset ViewRec.files  // esi -> view.files
        add eax, offset ViewRec.pfiles
        add eax, ebx
        mov ecx, [esi + offset StringBuilder.len]
        mov [eax], ecx
        
        mov eax, dword ptr srch.FileAttributes
        mov dword ptr finfo.FileAttributes, eax
        mov eax, dword ptr srch.FileSize[0]
        mov edx, dword ptr srch.FileSize[4]
        mov dword ptr finfo.FileSize[0], eax
        mov dword ptr finfo.FileSize[4], edx
        mov eax, dword ptr srch.CreationTime[0]
        mov edx, dword ptr srch.CreationTime[4]
        mov dword ptr finfo.CreationTime[0], eax
        mov dword ptr finfo.CreationTime[4], edx
        mov eax, dword ptr srch.LastAccessTime[0]
        mov edx, dword ptr srch.LastAccessTime[4]
        mov dword ptr finfo.LastAccessTime[0], eax
        mov dword ptr finfo.LastAccessTime[4], edx
        mov eax, dword ptr srch.LastWriteTime[0]
        mov edx, dword ptr srch.LastWriteTime[4]
        mov dword ptr finfo.LastWriteTime[0], eax
        mov dword ptr finfo.LastWriteTime[4], edx
        push esi
          mov esi, offset srch.FileName
          mov edi, offset finfo.FileName
          xor ecx, ecx
          
          l_load_25:
            lodsb
            stosb
            inc ecx
            or al, al
            jz l_load_28
              cmp ecx, MAX_PATH
              jb l_load_25
                mov byte ptr [edi - 1], 0
              
          l_load_28:
        pop esi
        add ecx, offset FileInfo.FileName
        
        // IN: esi, ecx
        mov edi, offset finfo
        push ebx
          call sb_add
        pop ebx

    l_load_8:
    mov edi, offset srch
    push ebx
      call find_next
    pop ebx
    or al, al
    jz near l_load_1
  
  push eax
    mov edi, offset srch
    push ebx
      call find_close
    pop ebx
  pop eax
  
l_load_9:
call writeerror
ret

// OUT: disks, disks_count
// KEEP: ebx
load_disks:
push ebx
  mov disks_count, 0
  xor ebx, ebx
  
  l_load_disks_1:
    mov esi, ebx
    push ebx
      call get_disk_type
    pop ebx
    or al, al
    jz l_load_disks_no
    
    l_load_disks_yes:
    movzx edi, disks_count
    mov al, bl
    or al, 64
    mov disks[edi], al
    inc disks_count
    
    l_load_disks_no:
    inc ebx
    cmp bl, 32
    jb l_load_disks_1
  
pop ebx  
ret

// IN: localtime, color
writedate:
// year
movzx eax, word ptr localtime.wYear
xor edx, edx
mov ecx, 1000
div ecx
add al, 48
mov temp[0], al
xchg eax, edx
xor edx, edx
mov ecx, 100
div ecx
add al, 48
mov temp[1], al
xchg eax, edx
xor edx, edx
mov ecx, 10
div ecx
add al, 48
mov temp[2], al
xchg eax, edx
add al, 48
mov temp[3], al

// month
mov temp[4], '-'
movzx eax, word ptr localtime.wMonth
xor edx, edx
mov ecx, 10
div ecx
add al, 48
mov temp[5], al
xchg eax, edx
add al, 48
mov temp[6], al

// day
mov temp[7], '-'
movzx eax, word ptr localtime.wDay
xor edx, edx
mov ecx, 10
div ecx
add al, 48
mov temp[8], al
xchg eax, edx
add al, 48
mov temp[9], al

mov esi, offset temp
mov ecx, 10
mov bl, color
call write
ret

str_altplus: db " Alt +"
str_spaces:  db "                                                                                "
str_label1:  db " File Name                                                                      "
str_label2:  db "Size    Change     "
str_iB:      db "iB    "
str_KMGTPE:  db "KMGTPE"
str_dir:     db "<directory>       "

// IN: ebx -> ViewRec
// KEEP: ebx
paint:

// disks
push ebx
  
  mov bh, [ebx + offset ViewRec.path]
  and bh, 31
  
  mov dl, 0
  mov dh, 0
  call curto
  mov esi, offset str_altplus + COFS
  mov ecx, 6
  mov bl, COLOR_DISKS
  call write
  xor edi, edi
  
  l_paint_15:
    mov esi, offset str_spaces + COFS
    mov ecx, 1
    mov bl, COLOR_DISKS
    call write
    mov esi, offset disks
    add esi, edi
    mov al, [esi]
    and al, 31
    cmp al, bh
    jnz l_paint_16
      mov bl, COLOR_ACTIVEDISK
      jmp short l_paint_17
      
    l_paint_16:
      mov bl, COLOR_DISKS
      
    l_paint_17:
    mov ecx, 1
    call write
    
    inc edi
    movzx eax, byte ptr disks_count
    cmp edi, eax
    jb l_paint_15
  
  mov esi, offset str_spaces + COFS
  mov ecx, 80
  mov eax, edi
  shl eax, 1
  add eax, 6
  sub ecx, eax
  mov bl, COLOR_DISKS
  call write
  
pop ebx

// path line
mov ecx, [ebx + offset ViewRec.path_len]
cmp ecx, 80
jna l_paint_21
  mov ecx, 80
  
l_paint_21:
push ebx
  mov esi, ebx
  add esi, offset ViewRec.path
  mov bl, COLOR_PATH
  push ecx
    call write
  pop ecx
  
  mov eax, 80
  sub eax, ecx
  xchg eax, ecx
  mov esi, offset str_spaces + COFS
  call write
pop ebx

// tab
mov dl, [ebx + offset ViewRec.x]
mov dh, 2
call curto  // KEEP: ebx
push ebx
  mov ecx, [ebx + offset ViewRec.w]
  sub ecx, 18  // w - 19
  mov esi, offset str_label1 + COFS
  mov bl, COLOR_LABEL
  call write

  mov ecx, 18  // w - 19
  mov esi, offset str_label2 + COFS
  call write
pop ebx

// foreach line
mov i, 0

l_paint_31:
  // cursor position
  mov eax, i
  mov dl, [ebx + offset ViewRec.x]
  add eax, 3 // 3
  mov dh, al
  call curto
  
  mov eax, i
  add eax, [ebx + offset ViewRec.sy]
  
  // color
  cmp eax, [ebx + offset ViewRec.y]
  jz l_paint_312
    mov dl, COLOR_INACTIVE
    jmp short l_paint_313
    
  l_paint_312:
    mov dl, COLOR_ACTIVE
    
  l_paint_313:
  mov color, dl
  
  // write first space
  push ebx
   push eax
    mov ecx, 1
    mov esi, offset str_spaces + COFS
    mov bl, color
    call write
   pop eax
  pop ebx
  
  // set edi -> filerec
  cmp eax, [ebx + offset ViewRec.dirs_count]
  jnb l_paint_32
    mov edi, [eax * 4 + ebx + offset ViewRec.pdirs]
    add edi, [ebx + offset ViewRec.dirs.data]
    jmp l_paint_34
    
  l_paint_32:
  sub eax, [ebx + offset ViewRec.dirs_count]
  cmp eax, [ebx + offset ViewRec.files_count]
  jnb l_paint_33
    mov edi, [eax * 4 + ebx + offset ViewRec.pfiles]
    add edi, [ebx + offset ViewRec.files.data]
    jmp l_paint_34
    
  l_paint_33:
  // write blank
  push ebx
    mov ecx, [ebx + offset ViewRec.w]
    dec ecx  // first space
    mov esi, offset str_spaces + COFS
    mov bl, color
    call write
  pop ebx
  jmp l_paint_37

  l_paint_34:
  // * write file name *
  mov esi, edi
  add esi, offset FileInfo.FileName
  call strlen  // KEEP: ebx, esi, edi
  mov edx, [ebx + offset ViewRec.w]
  sub edx, 19  // w - 19
  cmp ecx, edx
  jna l_paint_341
    mov ecx, edx
    
  l_paint_341:
  push ebx
   push ecx
    push edi
     mov bl, color
     call write
    pop edi
   pop ecx
  pop ebx

  // fill file name
  mov eax, [ebx + offset ViewRec.w]
  sub eax, ecx
  sub eax, 19  // w - 19
  push ebx
   push edi
    xchg eax, ecx
    mov esi, offset str_spaces + COFS
    mov bl, color
    call write
   pop edi
  pop ebx
  
  // dir?
  mov eax, [edi + offset FileInfo.FileAttributes]
  test eax, FILE_ATTRIBUTE_DIRECTORY
  jz l_paint_344
    push ebx
     mov esi, offset str_dir + COFS
     mov ecx, 18
     mov bl, color
     call write
    pop ebx
    jmp l_paint_37
    
  l_paint_344:
  // * write file size *
  mov eax, [edi + offset FileInfo.FileSize]
  mov edx, [edi + offset FileInfo.FileSize + 4]
  xor ecx, ecx
  
  l_paint_351:
    cmp edx, 0
    jnz l_paint_352
      cmp eax, 1024
      jb l_paint_353
        
        l_paint_352:
        add eax, 1023
        adc edx, 0
        
        mov esi, edx
        shr eax, 10
        shr edx, 10
        shl esi, 32 - 10
        or eax, esi
        
        inc ecx
        jmp short l_paint_351
      
  l_paint_353:
  push ebx
   push ecx
    push edi
      mov ecx, 10
      mov bl, color
      mov bh, 4
      call writemin  // write 0-1023
    pop edi
   pop ecx
  pop ebx
  
  or ecx, ecx
  jnz l_paint_354
    mov esi, offset str_iB + COFS + 1
    mov ecx, 4
    push ebx
     push edi
       mov bl, color
       call write
     pop edi
    pop ebx
    jmp short l_paint_358
    
  l_paint_354:
  mov esi, offset str_KMGTPE + COFS
  add esi, ecx
  dec esi
  mov ecx, 1
  push ebx
   push edi
     mov bl, color
     call write  // write KMGTPE
     
     mov esi, offset str_iB + COFS
     mov ecx, 3
     mov bl, color
     call write  // write iB
   pop edi
  pop ebx
  
  l_paint_358:
  
  // * write last change *
  mov eax, [edi + offset FileInfo.LastWriteTime]
  mov edx, [edi + offset FileInfo.LastWriteTime + 4]
  push ebx
   push edi
    mov dword ptr time[0], eax
    mov dword ptr time[4], edx
    mov esi, offset time
    mov edi, offset localtime
    call ftime2local
    call writedate
   pop edi
  pop ebx
  
  l_paint_37:
  // next i
  inc i
  cmp i, TAB_H
  jb near l_paint_31

ret

str_bottom: db " F2 ren  F4 cmp  F5 copy  F6 move  F7 md  F8 del  F9 link  F10 flush  F12 frmt  "

bottom:
push ebx
  mov dl, 0
  mov dh, 24
  call curto
  
  mov esi, offset str_bottom + COFS
  mov ecx, 79
  mov bl, COLOR_BOTTOM
  call write
pop ebx
ret

// IN: sort_by, ebx -> ViewRec
sort:
push ebp
  // dirs
  cmp sort_by, SORT_ZA
  jnz l_sort_1
    mov sort_by_inner, SORT_ZA
    jmp short l_sort_2
    
  l_sort_1:
  mov sort_by_inner, SORT_AZ
  
  l_sort_2:
  mov esi, ebx
  add esi, offset ViewRec.pdirs
  
  mov edi, esi
  mov eax, [ebx + offset ViewRec.dirs_count]
  shl eax, 2
  add edi, eax
  sub edi, 4
  
  mov ebp, [ebx + offset ViewRec.dirs.data]
  
  push ebx
    call insertsort
  pop ebx
  
  // files
  mov al, sort_by
  mov sort_by_inner, al
  
  mov esi, ebx
  add esi, offset ViewRec.pfiles
  
  mov edi, esi
  mov eax, [ebx + offset ViewRec.files_count]
  shl eax, 2
  add edi, eax
  sub edi, 4
  
  mov ebp, [ebx + offset ViewRec.files.data]
  
  push ebx
    call insertsort
  pop ebx
  
pop ebp
ret

// IN: esi -> *FileInfo, edi -> *FileInfo2, ebp -> data
insertsort:
mov first, esi
mov last, edi
mov edx, esi

l_insertsort_5:
  add edx, 4
  cmp edx, last
  ja l_insertsort_9
    mov edi, [edx]
    mov ebx, edx
    
    l_insertsort_55:
      cmp ebx, first
      jna l_insertsort_58
        push edi
          mov esi, [ebx - 4]
          call compare
        pop edi
        cmp al, 2
        jnz l_insertsort_58
          mov eax, [ebx - 4]
          mov [ebx], eax
          sub ebx, 4
          jmp short l_insertsort_55
        
    l_insertsort_58:  
    mov [ebx], edi  
    jmp short l_insertsort_5

l_insertsort_9:
ret

// IN: ebp+esi -> FileInfo, ebp+edi -> FileInfo2, sort_by_inner
// OUT: al = 0 (equal), 1 (asc), 2 (desc)
// KEEP: edx, ebx, ebp
compare:
add esi, ebp
add edi, ebp
test sort_by_inner, 1
jz l_compare_1
  xchg esi, edi
  
l_compare_1:
test sort_by_inner, 2
jz l_compare_2
  // size
  mov eax, [esi + offset FileInfo.FileSize + 4]
  cmp eax, [edi + offset FileInfo.FileSize + 4]
  jnz l_compare_39
    mov eax, [esi + offset FileInfo.FileSize]
    cmp eax, [edi + offset FileInfo.FileSize]
    jmp l_compare_39

l_compare_2:
test sort_by_inner, 4
jz l_compare_3
  // change
  mov eax, [esi + offset FileInfo.LastWriteTime + 4]
  cmp eax, [edi + offset FileInfo.LastWriteTime + 4]
  jnz l_compare_39
    mov eax, [esi + offset FileInfo.LastWriteTime]
    cmp eax, [edi + offset FileInfo.LastWriteTime]
    jmp l_compare_39
  
l_compare_3:
// name
add esi, offset FileInfo.FileName
add edi, offset FileInfo.FileName

l_compare_31:
  mov al, [esi]
  mov cl, [edi]
  
  // UpCase
  cmp al, 'a'
  jb l_compare_32
    cmp al, 'z'
    ja l_compare_32
      sub al, 32

  l_compare_32:
  cmp cl, 'a'
  jb l_compare_33
    cmp cl, 'z'
    ja l_compare_33
      sub cl, 32

  l_compare_33:
  // compare
  cmp al, cl
  jnz l_compare_39
    or al, al
    jz l_compare_39
      inc esi
      inc edi
      jmp short l_compare_31
  
l_compare_39:
jnz l_compare_391
  // equal
  mov al, 0
  jmp short l_compare_9
  
l_compare_391:
jnb l_compare_392
  // less
  mov al, 1
  jmp short l_compare_9
  
l_compare_392:
// greater
mov al, 2

l_compare_9:
ret

err_msg: db "Error"
erm3: db ": Not a file\0"
erm16: db ": Disk is full\0"
erm44: db ": Path not found\0"
erm45: db ": File not found\0"
erm47: db ": Directory already exists\0"
erm48: db ": Unknown filesystem\0"
erm49: db ": Directory not empty\0"
erm4A: db ": Can't remove (first directory in root)\0"
erm4B: db ": Duplicate file name\0"
erm4E: db ": Error in filesystem (switched off without flush)\0"
erm4F: db ": Read only\0"
erm51: db ": Can't move to other disk\0"
erm54: db ": Can't rename files starting with .\0"
erm5D: db ": Access denied\0"
erm62: db ": Invalid character in file name (/*?;:<>|) or . ..\0"
erm69: db ": File already exists\0"

// IN: al = erc
// KEEP: eax, ebx
writeerror:
push ebx
 push eax
  // curto(0,23)
  mov dl, 0
  mov dh, 23
  call curto
  // clear line
  mov esi, offset str_spaces + COFS
  mov ecx, 80
  mov bl, 7
  call write
  // curto(0,23)
  mov dl, 0
  mov dh, 23
  call curto
 pop eax
 push eax
  movzx eax, al
  cmp al, 2
  jb near l_writeerror_9
    push eax
      mov esi, offset err_msg + COFS
      mov ecx, 5
      mov bl, COLOR_ERROR
      call write
    pop eax
    push eax
      mov ecx, 16
      mov bl, COLOR_ERROR
      call writen
    pop eax

    // Strings
    xor esi, esi
    cmp al, 3
    jnz l_writeerror_61
      mov esi, offset erm3 + COFS
      
    l_writeerror_61:
    cmp al, 16h
    jnz l_writeerror_62
      mov esi, offset erm16 + COFS
      
    l_writeerror_62:
    cmp al, 44h
    jnz l_writeerror_63
      mov esi, offset erm44 + COFS
      
    l_writeerror_63:
    cmp al, 45h
    jnz l_writeerror_64
      mov esi, offset erm45 + COFS
      
    l_writeerror_64:
    cmp al, 47h
    jnz l_writeerror_65
      mov esi, offset erm47 + COFS
      
    l_writeerror_65:
    cmp al, 48h
    jnz l_writeerror_66
      mov esi, offset erm48 + COFS
      
    l_writeerror_66:
    cmp al, 49h
    jnz l_writeerror_67
      mov esi, offset erm49 + COFS
      
    l_writeerror_67:
    cmp al, 4Fh
    jnz l_writeerror_68
      mov esi, offset erm4F + COFS
      
    l_writeerror_68:
    cmp al, 54h
    jnz l_writeerror_69
      mov esi, offset erm54 + COFS
      
    l_writeerror_69:
    cmp al, 62h
    jnz l_writeerror_70
      mov esi, offset erm62 + COFS
      
    l_writeerror_70:
    cmp al, 4Ah
    jnz l_writeerror_71
      mov esi, offset erm4A + COFS
      
    l_writeerror_71:
    cmp al, 4Bh
    jnz l_writeerror_72
      mov esi, offset erm4B + COFS
      
    l_writeerror_72:
    cmp al, 4Eh
    jnz l_writeerror_73
      mov esi, offset erm4E + COFS
      
    l_writeerror_73:
    cmp al, 51h
    jnz l_writeerror_731
      mov esi, offset erm51 + COFS
      
    l_writeerror_731:
    cmp al, 5Dh
    jnz l_writeerror_74
      mov esi, offset erm5D + COFS
      
    l_writeerror_74:
    cmp al, 69h
    jnz l_writeerror_79
      mov esi, offset erm69 + COFS
      
    l_writeerror_79:
    or esi, esi
    jz l_writeerror_9
      call strlen
      mov bl, COLOR_ERROR
      call write

  l_writeerror_9:
 pop eax
pop ebx
ret

wregs1: db "\n | acdb = "
wregs2: db " | sbsd = "

wregs:
pushad
  mov ebp, esp
  
  mov esi, offset wregs1 + COFS
  mov ecx, 10
  mov bl, 7
  call write
  
  mov eax, [ebp + 28]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 24]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 20]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 16]
  mov ecx, 16
  call writen
  
  
  mov esi, offset wregs2 + COFS
  mov ecx, 9
  mov bl, 7
  call write
  
  mov eax, [ebp + 12]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 8]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 4]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 0]
  mov ecx, 16
  call writen

popad
ret

ww:
call wregs
pushad
  
  l_ww_5:
  mov ah, 45 // get pid, tid; OUT: edi = tid
  int 20h
  mov ah, 35 // stop thread
  int 20h
  call getmsg
  cmp ecx, WM_KEYDOWN
  jnz l_ww_5
  
popad
ret

// IN: dl = x, dh = y, edi -> buffer[512], ebx = count
writesect:
mov x0, dl
mov y0, dh

// border
push ebx
  dec dl
  dec dh
  call curto
  mov esi, offset str_spaces + COFS
  mov ecx, 32 + 2
  mov bl, COLOR_BORDER
  call write
  
  mov ecx, 16
  
  l_writesect_15:
    jecxz l_writesect_18
    inc dh
    push ecx
      call curto
      mov esi, offset str_spaces + COFS
      mov ecx, 1
      mov bl, COLOR_BORDER
      call write
      
      add dl, 33
      call curto
      mov esi, offset str_spaces + COFS
      mov ecx, 1
      mov bl, COLOR_BORDER
      call write
      sub dl, 33
    pop ecx
    loop l_writesect_15
    
  l_writesect_18:
  inc dh
  call curto
  mov esi, offset str_spaces + COFS
  mov ecx, 32 + 2
  mov bl, COLOR_BORDER
  call write
pop ebx

// contents
mov ecx, 16
mov dl, x0
mov dh, y0
l_writesect_25:
  jecxz l_writesect_28
  push ecx
    call curto
    inc dh
    mov ecx, 32
    l_writesect_255:
      jecxz l_writesect_258
      mov al, [edi]
      inc edi
      push ebx  
        or ebx, ebx
        jnz l_writesect_2551
          mov al, ' '
          mov bl, COLOR_BORDER
          jmp short l_writesect_257
          
        l_writesect_2551:
        cmp al, 32
        jnb l_writesect_256
          add al, 64
          mov bl, 7
          jmp short l_writesect_257
          
        l_writesect_256:
          mov bl, 31h
          
        l_writesect_257:
        push ecx
          mov byte ptr temp, al
          mov esi, offset temp
          mov ecx, 1
          call write
        pop ecx
      pop ebx
      or ebx, ebx
      jz l_writesect_2571
        dec ebx
        
      l_writesect_2571:
      loop l_writesect_255
      
    l_writesect_258:
  pop ecx
  loop l_writesect_25
  
l_writesect_28:
ret

// IN: ebx -> ViewRec
// OUT: al = erc, path
// KEEP: ebx
cdcurdir:
mov edi, offset path
mov ecx, [ebx + offset ViewRec.path_len]
push edi
 push ecx
  mov esi, offset ViewRec.path
  add esi, ebx
  cld
  rep movsb
 pop ecx
pop edi

l_cdcurdir_5:
  jecxz l_cdcurdir_6
    dec ecx
    mov al, [edi + ecx]
    cmp al, '/'
    jnz l_cdcurdir_5
    
  inc ecx

l_cdcurdir_6:
mov al, 0
mov [edi + ecx], al

push ebx
  mov edx, edi
  call cdir
pop ebx
ret

// IN: esi -> msgz
// OUT: al = 0 (yes) || 1 (no)
// KEEP: ebx, ebp
ask:
push ebx
  mov dl, 0
  mov dh, 23
  call curto
  
  call strlen
  mov bl, 7
  call write
  
  l_ask_5:
    call getmsg
    cmp ecx, WM_KEYDOWN
    jnz l_ask_5
    
    mov eax, edx
    mov edx, esi
    call keys
    
    cmp al, 'Y'
    jz l_ask_yes
      cmp al, 'N'
      jnz l_ask_5
      
      mov al, 1
      jmp short l_ask_9
  
  l_ask_yes:
  mov al, 0
  
  l_ask_9:
pop ebx
ret

// IN: esi -> messagez, x, len, path
// OUT: len, path
input:
call strlen
mov x0, cl

mov dl, 0
mov dh, 23
call curto
mov bl, 7
call write

l_input_5:
  // write string
  mov dl, x0
  mov dh, 23
  call curto
  mov esi, offset path
  movzx ecx, len
  mov bl, 7
  call write
  // write spaces
  mov al, x0
  add al, len
  mov cl, 80
  sub cl, al
  movzx ecx, cl
  mov esi, offset str_spaces + COFS
  mov bl, 7
  call write
  // cursor position
  mov dl, x0
  add dl, x
  mov dh, 23
  call curto
  
  l_input_51:
  call getmsg
  cmp ecx, WM_KEYDOWN
  jnz l_input_51
  
  mov eax, edx
  mov edx, esi
  call keys
  
  cmp al, VK_ENTER  // enter
  jz near l_input_99
  cmp al, VK_ESC  // esc
  jz near l_input_91
  
  cmp ecx, 32
  jb near l_input_515
    // char
    mov al, len
    add al, x0
    cmp al, 80 - 1
    jnb near l_input_5
    
    push ecx
      movzx eax, x
      movzx ecx, len
      mov esi, offset path
      mov edi, offset path
      add esi, ecx
      add edi, ecx
      dec esi
      sub cl, al
      std
      rep movsb
      cld
    pop ecx
    movzx eax, x
    add eax, offset path
    mov [eax], cl
    inc len
    inc x
    jmp l_input_5
  
  l_input_515:
  cmp al, VK_LEFT
  jnz l_input_52
    // left
    cmp x, 0
    jna near l_input_5
      dec x
      jmp l_input_5
    
  l_input_52:
  cmp al, VK_RIGHT
  jnz l_input_53
    // right
    mov al, x
    cmp al, len
    jnb near l_input_5
      inc x
      jmp l_input_5
    
  l_input_53:
  cmp al, VK_HOME
  jnz l_input_54
    // home
    mov x, 0
    jmp l_input_5
    
  l_input_54:
  cmp al, VK_END
  jnz l_input_55
    // end
    mov al, len
    mov x, al
    jmp l_input_5
    
  l_input_55:
  cmp al, VK_DEL
  jnz l_input_56
    // del
    mov al, x
    cmp al, len
    jnb near l_input_5
      movzx esi, x
      mov edi, esi
      inc esi
      movzx ecx, len
      sub cl, x
      add esi, offset path
      add edi, offset path
      cld
      rep movsb
      dec len      
      jmp l_input_5
    
  l_input_56:
  cmp al, VK_BSP
  jnz near l_input_5
    // bsp
    cmp x, 0
    jz near l_input_5
      movzx esi, x
      dec x
      movzx edi, x
      movzx ecx, len
      sub cl, x
      add esi, offset path
      add edi, offset path
      cld
      rep movsb
      dec len
      jmp l_input_5
  
l_input_91:
mov len, 0

l_input_99:
movzx ecx, len
mov path[ecx], 0
ret

msg_overwrite: db "File already exists, overwrite? y/n\0"
msg_copying: db "Copying\0"
msg_0000: db "0000\0"

// IN: ebx -> ViewRec
// KEEP: ebx, ebp
copy:
push ebx
 push ebp
  call cdcurdir  // out: path
  // set ebp -> ViewRec2
  cmp ebx, offset view
  jz l_copy_1
    mov ebp, offset view
    jmp short l_copy_2
  
  l_copy_1:
  mov ebp, offset view + sizeof ViewRec
  
  l_copy_2:
  or al, al
  jnz near l_copy_9
    // get path2
    mov edi, offset path2
    mov esi, offset ViewRec.path
    add esi, ebp
    mov ecx, [ebp + offset ViewRec.path_len]
    push edi
     push ecx
      cld
      rep movsb
     pop ecx
    pop edi
    
    l_copy_25:
      jecxz l_copy_26
        dec ecx
        mov al, [edi + ecx]
        cmp al, '/'
        jnz l_copy_25
        
      inc ecx
    
    l_copy_26:
    mov al, 0
    mov [edi + ecx], al
    
    // add file name to path, path2
    mov esi, offset path
    
    mov edi, [ebx + offset ViewRec.files.data]
    mov eax, [ebx + offset ViewRec.y]
    sub eax, [ebx + offset ViewRec.dirs_count]
    jb near l_copy_81
      cmp eax, [ebx + offset ViewRec.files_count]
      jnb near l_copy_81
        add edi, [eax * 4 + ebx + offset ViewRec.pfiles]
        add edi, offset FileInfo.FileName
        xchg esi, edi
        push esi
            
          l_copy_31:
            lodsb
            stosb
            cmp al, 0
            jnz l_copy_31
          
        pop edi
        mov esi, offset path2
        call strlen
        add esi, ecx
        xchg esi, edi
        
        l_copy_33:
          lodsb
          stosb
          cmp al, 0
          jnz l_copy_33
        /*
        //$$$
        mov esi, offset path
        mov ecx, 80
        mov bl, 0Fh
        call write
        mov esi, offset path2
        mov ecx, 80
        mov bl, 0Fh
        call write
        call ww
        */
        
        // check file exists
        mov edx, offset path2
        call fopenread
        cmp al, ERC_FILE_NOT_FOUND
        jz l_copy_4
          or al, al
          jnz near l_copy_9
            call fclose
            // File already exists
            mov esi, offset msg_overwrite + COFS
            call ask
            or al, al
            jnz near l_copy_9
            
        l_copy_4:
        // path2 not found / overwrite
        mov edx, offset path
        call fopenread
        or al, al
        jnz near l_copy_9
          mov f1, ebx  // f1 = fopenread(path)
          
          mov edx, offset path2
          call fcreate
          or al, al
          jz l_copy_41
            push eax
              mov ebx, f1
              call fclose
            pop eax
            jmp l_copy_9
            
          l_copy_41:
          mov f2, ebx  // f2 = fcreate(path2)
          
          // set mtime
          mov ebx, f1
          call get_mtime
          mov ebx, f2
          call set_mtime
          
          // clear bottom line
          mov dl, 0
          mov dh, 23
          call curto
          mov esi, offset str_spaces + COFS
          mov ecx, 80
          mov bl, 7
          call write
          
          mov i, 0
          
          l_copy_5:
            // write copying
            inc i
            mov dl, 0
            mov dh, 23
            call curto
            mov esi, offset msg_copying + COFS
            mov ecx, 7
            mov bl, 7
            call write
            mov eax, i
            mov ecx, 10
            call writen
            mov esi, offset msg_0000 + COFS
            mov ecx, 4
            mov bl, 7
            call write
            // rw
            mov ebx, f1
            mov edi, offset buffer
            mov ecx, MAX_BUFFER
            call fread
            or al, al
            jnz l_copy_6
              jecxz l_copy_6
                
                mov ebx, f2
                mov edi, offset buffer
                push ecx
                  call fwrite
                pop edx
                or al, al
                jnz l_copy_6
                  cmp edx, ecx
                  jz l_copy_5
              
            //mov al, ERC_WRITE_ERROR
            
          l_copy_6:
          push eax
            // close
            mov ebx, f1
            call fclose
            mov ebx, f2
            call fclose
            
            test al, al
            jz l_copy_66
              pop ebx
              jmp short l_copy_9
              
            l_copy_66:
          pop eax
          jmp short l_copy_9
          
  l_copy_81:
  mov al, ERC_NOT_FILE
  
  l_copy_9:
  call writeerror
  cmp al, 2
  jb l_copy_91
    call waitkey
    
  l_copy_91:
  mov ebx, ebp
  call load
  call sort
  call paint

 pop ebp
pop ebx

call paint
ret

msg_delete: "Do you really want to delete this file? y/n\0"
msg_lfesc: "Delete link or file? l/f/esc\0"

// IN: ebx -> ViewRec
// KEEP: ebx
delete:
push ebx
  call cdcurdir
  or al, al
  jnz near l_delete_9
    
    // set ebp -> ViewRec2
    cmp ebx, offset view
    jz l_delete_11
      mov ebp, offset view
      jmp short l_delete_12
    
    l_delete_11:
    mov ebp, offset view + sizeof ViewRec
    
    l_delete_12:
    // get object
    mov esi, offset path
    
    mov eax, [ebx + offset ViewRec.y]
    cmp eax, [ebx + offset ViewRec.dirs_count]
    jnb l_delete_2
      mov edi, [ebx + offset ViewRec.dirs.data]
      add edi, [eax * 4 + ebx + offset ViewRec.pdirs]
      jmp short l_delete_30
      
    l_delete_2:
      sub eax, [ebx + offset ViewRec.dirs_count]
      cmp eax, [ebx + offset ViewRec.files_count]
      jnb near l_delete_81
        mov edi, [ebx + offset ViewRec.files.data]
        add edi, [eax * 4 + ebx + offset ViewRec.pfiles]
        
        l_delete_30:
        mov eax, [edi + offset FileInfo.FileAttributes]
        test eax, FILE_ATTRIBUTE_LINK
        jnz l_delete_6
        
        add edi, offset FileInfo.FileName
        xchg esi, edi
        
        l_delete_31:
          lodsb
          stosb
          cmp al, 0
          jnz l_delete_31
        
        // ask
        mov esi, offset msg_delete + COFS
        call ask
        or al, al
        jnz l_delete_9
        
        // delete
        mov edx, offset path
        call rm
        jmp l_delete_9
        
    l_delete_6:
    // link
    add edi, offset FileInfo.FileName
    xchg esi, edi
    
    l_delete_61:
      lodsb
      stosb
      cmp al, 0
      jnz l_delete_61
    
    mov esi, offset msg_lfesc + COFS
    mov dl, 0
    mov dh, 23
    call curto
    call strlen
    mov bl, 7
    call write
    
    l_delete_65:
      call getmsg
      cmp ecx, WM_KEYDOWN
      jnz l_delete_65

    mov eax, edx
    mov edx, esi
    call keys
    
    cmp al, 'F'
    jnz l_delete_66
      mov edx, offset path
      call rm
      jmp l_delete_9
      
    l_delete_66:
    cmp al, 'L'
    jnz l_delete_67
      mov edx, offset path
      call rm_link
      jmp l_delete_9
      
    l_delete_67:
    cmp al, VK_ESC
    jnz l_delete_65
      jmp short l_delete_91
      
  l_delete_81:
  mov al, ERC_NOT_FILE
    
  l_delete_9:
  call writeerror
  cmp al, 2
  jb l_delete_91
    call waitkey

  l_delete_91:
  mov ebx, ebp
  call load
  call sort
  call paint
  
pop ebx
call load
call sort
call paint
ret

msg_ren: "New file name: \0"

// IN: ebx -> ViewRec
// KEEP: ebx
rename:
push ebx
  call cdcurdir
  // get old file name
  mov eax, [ebx + offset ViewRec.y]
  cmp eax, [ebx + offset ViewRec.dirs_count]
  jnb l_rename_73
    // dir
    mov esi, [ebx + offset ViewRec.dirs.data]
    add esi, [eax * 4 + ebx + offset ViewRec.pdirs]
    add esi, offset FileInfo.FileName

    l_rename_70:  // dir & file
    mov edi, offset path
    xor ecx, ecx
    
    l_rename_71:
      lodsb
      cmp al, 0
      jz l_rename_72
        stosb
        inc ecx
        jmp short l_rename_71
        
    l_rename_72:
    stosb
    jmp l_rename_76
      
  l_rename_73:
  sub eax, [ebx + offset ViewRec.dirs_count]
  cmp eax, [ebx + offset ViewRec.files_count]
  jnb near l_rename_78
    // file
    mov esi, [ebx + offset ViewRec.files.data]
    add esi, [eax * 4 + ebx + offset ViewRec.pfiles]
    add esi, offset FileInfo.FileName
    jmp l_rename_70
    
  l_rename_76:
  // copy path to path2
  mov esi, offset path
  mov edi, offset path2
  push ecx
    inc ecx
    cld
    rep movsb
  pop ecx
  // read new file name
  mov esi, offset msg_ren + COFS
  mov len, cl
  mov x, cl
  call input
  cmp len, 0
  jz l_rename_78
    // rename
    mov edx, offset path2
    mov esi, offset path
    call ren
    call writeerror
    cmp al, 2
    jb l_rename_78
      call waitkey
  
  l_rename_78:
pop ebx
call load
call sort
call paint
ret

// IN: ebx -> ViewRec
// KEEP: ebx
move:

push ebx
 push ebp

  call cdcurdir
  or al, al
  jnz near l_move_9

    // set ebp -> ViewRec2
    cmp ebx, offset view
    jz l_move_1
      mov ebp, offset view
      jmp short l_move_12
    
    l_move_1:
    mov ebp, offset view + sizeof ViewRec
    
    l_move_12:

    // get dir/file name
    mov esi, offset path
    
    mov eax, [ebx + offset ViewRec.y]
    cmp eax, [ebx + offset ViewRec.dirs_count]
    jnb l_move_2
      mov edi, [ebx + offset ViewRec.dirs.data]
      add edi, [eax * 4 + ebx + offset ViewRec.pdirs]
      jmp short l_move_30
      
    l_move_2:
      sub eax, [ebx + offset ViewRec.dirs_count]
      cmp eax, [ebx + offset ViewRec.files_count]
      jnb near l_move_81
        mov edi, [ebx + offset ViewRec.files.data]
        add edi, [eax * 4 + ebx + offset ViewRec.pfiles]
        
    l_move_30:
    add edi, offset FileInfo.FileName
    xchg esi, edi
    
    l_move_31:
      lodsb
      stosb
      cmp al, 0
      jnz l_move_31
 
    // get path2
    mov edi, offset path2
    mov esi, offset ViewRec.path
    add esi, ebp
    mov ecx, [ebp + offset ViewRec.path_len]
    push edi
     push ecx
      cld
      rep movsb
     pop ecx
    pop edi
    
    l_move_5:
      jecxz l_move_6
        dec ecx
        mov al, [edi + ecx]
        cmp al, '/'
        jnz l_move_5
        
      inc ecx
    
    l_move_6:
    mov al, 0
    mov [edi + ecx], al
    
    // do move
    mov edx, offset path
    mov esi, offset path2
    call mv
    jmp short l_move_9
    
  l_move_81:
  mov al, ERC_NOT_FILE
  
  l_move_9:
  call writeerror
  cmp al, 2
  jb l_move_91
    call waitkey

  l_move_91:
  mov ebx, ebp
  call load
  call sort
  call paint

 pop ebp
pop ebx

call load
call sort
call paint
ret

str_h: db "h"

// IN: ebx -> ViewRec
// KEEP: ebx
cmpfiles:
push ebx
 push ebp
 
  call cdcurdir
  or al, al
  jnz near l_cmpfiles_9

    // set ebp -> ViewRec2
    cmp ebx, offset view
    jz l_cmpfiles_1
      mov ebp, offset view
      jmp short l_cmpfiles_12
    
    l_cmpfiles_1:
    mov ebp, offset view + sizeof ViewRec
    
    l_cmpfiles_12:
    mov byte ptr path, 0
    mov byte ptr path2, 0
    mov pos1, 0
    mov pos2, 0

    // get dir/file name
    mov esi, offset path
    
    mov eax, [ebx + offset ViewRec.y]
    sub eax, [ebx + offset ViewRec.dirs_count]
    jb near l_cmpfiles_4
    
    cmp eax, [ebx + offset ViewRec.files_count]
    jnb near l_cmpfiles_4
    
    mov edi, [ebx + offset ViewRec.files.data]
    add edi, [eax * 4 + ebx + offset ViewRec.pfiles]
      
    l_cmpfiles_30:
    add edi, offset FileInfo.FileName
    xchg esi, edi
    
    l_cmpfiles_31:
      lodsb
      stosb
      cmp al, 0
      jnz l_cmpfiles_31
    
    l_cmpfiles_4:
    // get path2
    mov eax, [ebp + offset ViewRec.y]
    sub eax, [ebp + offset ViewRec.dirs_count]
    jb near l_cmpfiles_5
    
    cmp eax, [ebp + offset ViewRec.files_count]
    jnb near l_cmpfiles_5
    
    mov esi, [ebp + offset ViewRec.files.data]
    add esi, [eax * 4 + ebp + offset ViewRec.pfiles]
    
    push esi
      
      mov edi, offset path2
      mov esi, offset ViewRec.path
      add esi, ebp
      mov ecx, [ebp + offset ViewRec.path_len]
      push edi
       push ecx
        cld
        rep movsb
       pop ecx
      pop edi
      
      l_cmpfiles_41:
        jecxz l_cmpfiles_42
          dec ecx
          mov al, [edi + ecx]
          cmp al, '/'
          jnz l_cmpfiles_41
          
        inc ecx
      
      l_cmpfiles_42:
      add edi, ecx
    
    pop esi
      
    add esi, offset FileInfo.FileName
    
    l_cmpfiles_45:
      lodsb
      stosb
      cmp al, 0
      jnz l_cmpfiles_45
    
  l_cmpfiles_5:
/*
    //$$$
    mov esi, offset path
    mov ecx, 80
    mov bl, 0Fh
    call write
    mov esi, offset path2
    mov ecx, 80
    mov bl, 0Fh
    call write
    call ww
*/
    cmp pos1, 0
    jnl l_cmpfiles_501
      mov pos1, 0
      
    l_cmpfiles_501:
    
    // Zero buffer
    mov edi, offset buffer
    mov ecx, 512 * 2 / 4
    xor eax, eax
    cld
    rep stosd
    
    // pos2 = pos1
    mov eax, pos1
    mov pos2, eax
    
    // Load file1
    mov c1, 0
    mov edx, offset path
    call fopenread
    or al, al
    jnz l_cmpfiles_51
      mov f1, ebx
      
      xor edx, edx
      mov edi, pos1
      call fsetpos
      
      mov ebx, f1
      mov edi, offset buffer
      mov ecx, 512
      call fread
      mov c1, ecx
      
      mov ebx, f1
      call fclose
    
    l_cmpfiles_51:
    
    // Load file2
    mov c2, 0
    mov edx, offset path2
    call fopenread
    or al, al
    jnz l_cmpfiles_52
      mov f2, ebx
      
      xor edx, edx
      mov edi, pos2
      call fsetpos
      
      mov ebx, f2
      mov edi, offset buffer + 512
      mov ecx, 512
      call fread
      mov c2, ecx
      
      mov ebx, f2
      call fclose
    
    l_cmpfiles_52:
    
    // paint windows
    mov dl, 4
    mov dh, 4
    mov edi, offset buffer
    mov ebx, c1
    call writesect
    
    mov dl, 4 - 1
    mov dh, 4 + 16
    call curto
    mov eax, pos1
    mov ecx, 10
    mov bl, COLOR_BORDER
    call writen
    
    mov eax, pos1
    mov ecx, 16
    mov bl, COLOR_BORDER
    call writen
    mov esi, offset str_h + COFS
    mov ecx, 1
    mov bl, COLOR_BORDER
    call write
    
    mov dl, 44
    mov dh, 4
    mov edi, offset buffer + 512
    mov ebx, c2
    call writesect
    
    // read key
    l_cmpfiles_55:
      mov dl, 4
      mov dh, 4
      call curto
      call getmsg
      cmp ecx, WM_KEYDOWN
      jnz l_cmpfiles_55
    
    mov eax, edx
    mov edx, esi
    call keys
    
    // keys
    cmp al, VK_ESC
    jz near l_cmpfiles_9
    
    cmp al, VK_UP
    jnz l_cmpfiles_61
      sub pos1, 32
      jmp l_cmpfiles_5
    
    l_cmpfiles_61:
    cmp al, VK_DOWN
    jnz l_cmpfiles_62
      add pos1, 32
      jmp l_cmpfiles_5
      
    l_cmpfiles_62:
    cmp al, VK_PGUP
    jnz l_cmpfiles_63
      sub pos1, 512
      jmp l_cmpfiles_5
        
    l_cmpfiles_63:
    cmp al, VK_PGDN
    jnz l_cmpfiles_64
      add pos1, 512
      jmp l_cmpfiles_5
      
    l_cmpfiles_64:
    cmp al, VK_HOME
    jnz l_cmpfiles_65
      mov pos1, 0
      jmp l_cmpfiles_5
      
    l_cmpfiles_65:
    cmp al, VK_END
    jnz l_cmpfiles_66
      // VK_END
      mov edx, offset path
      call fopenread
      or al, al
      jnz l_cmpfiles_652
        mov f1, ebx
        
        call fgetsize
        shr ecx, 9
        shl ecx, 9
        mov pos1, ecx
        
        mov ebx, f1
        call fclose
      
      l_cmpfiles_652:
      jmp l_cmpfiles_5  
      
    l_cmpfiles_66:
    cmp al, VK_LEFT
    jnz l_cmpfiles_67
      dec pos1
      jmp l_cmpfiles_5
      
    l_cmpfiles_67:
    cmp al, VK_RIGHT
    jnz l_cmpfiles_68
      inc pos1
      jmp l_cmpfiles_5
      
    l_cmpfiles_68:
    jmp l_cmpfiles_5
    
  l_cmpfiles_9:
  mov ebx, ebp
  call paint
 pop ebp
pop ebx
call paint
ret

msg_link: "New link name: \0"

// IN: ebx -> ViewRec
// KEEP: ebx
link:
push ebx
  // set ebp -> ViewRec2
  cmp ebx, offset view
  jz l_link_1
    mov ebp, offset view
    jmp short l_link_12
  
  l_link_1:
  mov ebp, offset view + sizeof ViewRec
  
  l_link_12:
  // get path2
  mov edi, offset path2
  mov esi, offset ViewRec.path
  add esi, ebp
  mov ecx, [ebp + offset ViewRec.path_len]
  push edi
   push ecx
    cld
    rep movsb
   pop ecx
  pop edi
  
  l_link_5:
    jecxz l_link_6
      dec ecx
      mov al, [edi + ecx]
      cmp al, '/'
      jnz l_link_5
      
    inc ecx
  
  l_link_6:
  add edi, ecx
  
  // get dir/file name
  xchg esi, edi  
  mov eax, [ebp + offset ViewRec.y]
  cmp eax, [ebp + offset ViewRec.dirs_count]
  jnb l_link_2
    mov edi, [ebp + offset ViewRec.dirs.data]
    add edi, [eax * 4 + ebp + offset ViewRec.pdirs]
    jmp short l_link_30
    
  l_link_2:
    sub eax, [ebp + offset ViewRec.dirs_count]
    cmp eax, [ebp + offset ViewRec.files_count]
    jnb near l_link_81
      mov edi, [ebp + offset ViewRec.files.data]
      add edi, [eax * 4 + ebp + offset ViewRec.pfiles]
      
  l_link_30:
  add edi, offset FileInfo.FileName
  xchg esi, edi
  
  l_link_31:
    lodsb
    stosb
    cmp al, 0
    jnz l_link_31
/*
push ebx
  mov esi, offset path2
  call strlen
  mov bl, 1Eh
  call write
pop ebx
*/
  // input
  call cdcurdir
  mov esi, offset msg_link + COFS
  mov len, 0
  mov x, 0
  call input
  mov al, 0
  cmp len, 0
  jz l_link_9
    movzx esi, len
    mov path[esi], 0
    mov edx, offset path
    mov esi, FOPEN_CREATE
    // IN: edx -> filenamez, esi = mode
    // OUT: al = erc, ebx = fhandle
    call open_link
    test al, al
    jnz l_link_9
      mov edi, offset path2
      mov esi, edi
      call strlen
/*
push ebx
 push ecx
  mov esi, offset path2
  call strlen
  mov bl, 1Eh
  call write
 pop ecx
pop ebx
call ww//$$$
*/
      push ebx
        // IN: ebx = fhandle, edi -> data, ecx = size
        // OUT: al = erc, ecx = size write
        call fwrite
      pop ebx
      call fclose
      jmp l_link_9
    
  l_link_81:
  mov al, ERC_NOT_FILE
  
  l_link_9:
  call writeerror
  cmp al, 2
  jb l_link_91
    call waitkey
    
  l_link_91:
pop ebx
call load
call sort
call paint
ret

strinfo1: db " \0"
strinfo2: db "-> \0"
strinfo3: db "Size:\0"
strinfo_ctime: db "Created:  \0"
strinfo_atime: db "Accessed: \0"
strinfo_mtime: db "Modified: \0"
strinfo_df: db "Disk free:\0"
strinfo_slash: db " /\0"
strinfo_zero: db "-\0"
strinfo_notzero: db "1\0"
strinfo_aro: db "Read only: \0"
strinfo_ahid: db "Hidden: \0"
strinfo_asys: db "System: \0"
strinfo_aar: db "Archive: \0"
strinfo_anor: db "Normal: \0"
strinfo_atmp: db "Temporary: \0"
strinfo_aspr: db "Sparse: \0"
strinfo_acpr: db "Compressed: \0"
strinfo_anx: db "Not indexed: \0"
strinfo_aenc: db "Encrypted: \0"
strinfo_u: db "User:  \0"
strinfo_g: db "Group: \0"
strinfo_o: db "Other: \0"
strinfo_r: db "r\0"
strinfo_w: db "w\0"
strinfo_x: db "x\0"

// IN: dl = x, dh = y, esi -> str, eax = atrbs, ebx = mask
// KEEP: eax
writeatr:
push eax
 push ebx
  push esi
    call curto
  pop esi
  call strlen
  mov bl, COLOR_INFO
  call write
 pop ebx
pop eax
test eax, ebx
jnz l_writeatr_51
  // 0
  mov esi, offset strinfo_zero + COFS  
  jmp short l_writeatr_52
  
l_writeatr_51:
  // not zero
  mov esi, offset strinfo_notzero + COFS
  
l_writeatr_52:
push eax
  call strlen
  mov bl, COLOR_INFO
  call write
pop eax
ret

// IN: eax = atr
writeatrlinux:
test al, ACCESS_R
jnz l_writeatrlinux_21
  mov esi, offset strinfo_zero + COFS
  jmp short l_writeatrlinux_22
  
l_writeatrlinux_21:
  mov esi, offset strinfo_r + COFS

l_writeatrlinux_22:
push eax
  call strlen
  mov bl, COLOR_INFO
  call write
pop eax

test al, ACCESS_W
jnz l_writeatrlinux_23
  mov esi, offset strinfo_zero + COFS
  jmp short l_writeatrlinux_24
  
l_writeatrlinux_23:
  mov esi, offset strinfo_w + COFS

l_writeatrlinux_24:
push eax
  call strlen
  mov bl, COLOR_INFO
  call write
pop eax

test al, ACCESS_X
jnz l_writeatrlinux_25
  mov esi, offset strinfo_zero + COFS
  jmp short l_writeatrlinux_26
  
l_writeatrlinux_25:
  mov esi, offset strinfo_x + COFS

l_writeatrlinux_26:
push eax
  call strlen
  mov bl, COLOR_INFO
  call write
pop eax
ret

// IN: esi -> ftime
writedtm:
mov edi, offset localtime
call ftime2local
call writedate

mov temp[0], ' '
mov temp[1], ' '
movzx eax, localtime.wHour
mov ecx, 10
xor edx, edx
div ecx
add al, '0'
add dl, '0'
mov temp[2], al
mov temp[3], dl
mov temp[4], ':'
movzx eax, localtime.wMinute
mov ecx, 10
xor edx, edx
div ecx
add al, '0'
add dl, '0'
mov temp[5], al
mov temp[6], dl
mov temp[7], ':'
movzx eax, localtime.wSecond
mov ecx, 10
xor edx, edx
div ecx
add al, '0'
add dl, '0'
mov temp[8], al
mov temp[9], dl

mov esi, offset temp
mov ecx, 10
mov bl, color
call write
ret
selu1: db "c:/users/users.sys\0"
selu2: db "                                "

SELECT_HEIGHT = 18
SELECT_TOP = 4
SELECT_LEFT = 42

// IN: path
// USES: uid, info_sb, f1, buffer, i, c1, pos1, pos2
selectuser:
// load users
mov esi, offset info_sb
call sb_init

call get_users_disk
mov [offset selu1 + COFS], al

mov edx, offset selu1 + COFS
call fopenread
test al, al
jz l_selectuser_11
  call writeerror
  call waitkey
  jmp l_selectuser_9
  
l_selectuser_11:
mov f1, ebx
xor eax, eax
mov i, eax
mov c1, eax    // user count
mov pos1, eax  // line number
mov pos2, eax  // scroll

l_selectuser_15:
  mov eax, i
  mov dword ptr buffer[0], eax
  cmp eax, uid
  jnz l_selectuser_16
    mov eax, c1
    mov pos1, eax
    
  l_selectuser_16:
  inc i
  
  mov ebx, f1
  mov edi, offset buffer + 5
  mov ecx, 256
  call fread
  test al, al
  jnz l_selectuser_19
  jecxz l_selectuser_19
  
  cmp byte ptr buffer[5], 0
  jz l_selectuser_15
  
  mov byte ptr buffer[5 + 31], 0
  mov esi, offset buffer + 5
  call strlen
  mov byte ptr buffer[4], cl
  add ecx, 5
  mov esi, offset info_sb
  mov edi, offset buffer
  call sb_add
  inc c1
  jmp l_selectuser_15
  
l_selectuser_19:
cmp c1, 0
jz near l_selectuser_9
  
l_selectuser_2:
// check pos1, pos2
cmp pos1, 0
jnl l_selectuser_201
  // pos1 < 0
  mov pos1, 0

l_selectuser_201:
mov eax, c1
cmp pos1, eax
jl l_selectuser_202
  // pos1 >= c1
  dec eax
  mov pos1, eax

l_selectuser_202:
mov eax, pos1
cmp pos2, eax
jng l_selectuser_203
  // pos2 > pos1
  mov pos2, eax

l_selectuser_203:
mov eax, pos2
add eax, SELECT_HEIGHT - 1
cmp eax, pos1
jnl l_selectuser_204
  // pos2 + h - 1 < pos1
  mov eax, pos1
  sub eax, SELECT_HEIGHT - 1
  mov pos2, eax

l_selectuser_204:
// print bg
mov i, 0

l_selectuser_205:
  cmp i, SELECT_HEIGHT
  jnb l_selectuser_208
    mov dl, SELECT_LEFT
    mov dh, byte ptr i
    add dh, SELECT_TOP
    call curto
    mov esi, offset selu2 + COFS
    mov ecx, 32
    mov bl, COLOR_SELECT
    call write
    inc i
    jmp l_selectuser_205
    
l_selectuser_208:

// print users
mov ebx, info_sb.data
mov ecx, pos2

l_selectuser_21:
  jecxz l_selectuser_22
    movzx eax, byte ptr [ebx + 4]
    add eax, 5
    add ebx, eax
    loop l_selectuser_21

l_selectuser_22:
mov ecx, SELECT_HEIGHT
mov edi, c1
sub edi, pos2  // edi = c1 - pos2

l_selectuser_23:
  cmp edi, 0
  jz l_selectuser_24
    dec edi
    push edi
     push ecx
      push ebx
       mov dl, SELECT_LEFT
       mov dh, SELECT_HEIGHT + SELECT_TOP
       sub dh, cl
       call curto
      pop ebx
      push ebx
       mov esi, ebx
       add esi, 5
       movzx ecx, byte ptr [ebx + 4]
       mov bl, COLOR_SELECT
       call write
      pop ebx
     pop ecx
    pop edi
    movzx eax, byte ptr [ebx + 4]
    add eax, 5
    add ebx, eax
    loop l_selectuser_23
  
l_selectuser_24:

// main loop
l_selectuser_5:
  mov dl, SELECT_LEFT
  mov eax, pos1
  sub eax, pos2
  mov dh, al
  add dh, SELECT_TOP
  call curto
  
  call waitkey
  mov eax, edx
  mov edx, esi
  call keys
  
  cmp al, VK_ESC
  jz near l_selectuser_9
  
  cmp al, VK_UP
  jnz l_selectuser_51
    dec pos1
    jmp l_selectuser_2
    
  l_selectuser_51:
  cmp al, VK_DOWN
  jnz l_selectuser_52
    inc pos1
    jmp l_selectuser_2
    
  l_selectuser_52:
  cmp al, VK_HOME
  jnz l_selectuser_53
    mov pos1, 0
    jmp l_selectuser_2
    
  l_selectuser_53:
  cmp al, VK_END
  jnz l_selectuser_54
    mov eax, c1
    dec eax
    mov pos1, eax
    jmp l_selectuser_2
    
  l_selectuser_54:
  cmp al, VK_PGUP
  jnz l_selectuser_55
    sub pos1, SELECT_HEIGHT
    jmp l_selectuser_2
    
  l_selectuser_55:
  cmp al, VK_PGDN
  jnz l_selectuser_56
    add pos1, SELECT_HEIGHT
    add pos2, SELECT_HEIGHT
    jmp l_selectuser_2
    
  l_selectuser_56:
  cmp al, VK_ENTER
  jz l_selectuser_8

  jmp l_selectuser_5

l_selectuser_8:
// ENTER
mov ebx, info_sb.data
mov ecx, pos1

l_selectuser_81:
  jecxz l_selectuser_82
    movzx eax, byte ptr [ebx + 4]
    add eax, 5
    add ebx, eax
    loop l_selectuser_81
    
l_selectuser_82:
mov esi, [ebx]
mov edx, offset path
call chown
test al, al
jz l_selectuser_9
  call writeerror
  call waitkey

l_selectuser_9:
// END
mov esi, offset info_sb
call sb_done
ret

selg1: db "c:/users/groups.sys\0"

// IN: path
// USES: gid, info_sb, f1, buffer, i, c1, pos1, pos2
selectgroup:
// load groups
mov esi, offset info_sb
call sb_init

call get_users_disk
mov [offset selg1 + COFS], al

mov edx, offset selg1 + COFS
call fopenread
test al, al
jz l_selectgroup_11
  call writeerror
  call waitkey
  jmp l_selectgroup_9
  
l_selectgroup_11:
mov f1, ebx
xor eax, eax
mov i, eax
mov c1, eax    // group count
mov pos1, eax  // line number
mov pos2, eax  // scroll

l_selectgroup_15:
  mov eax, i
  mov dword ptr buffer[0], eax
  cmp eax, gid
  jnz l_selectgroup_16
    mov eax, c1
    mov pos1, eax
    
  l_selectgroup_16:
  inc i
  
  mov ebx, f1
  mov edi, offset buffer + 5
  mov ecx, 256
  call fread
  test al, al
  jnz l_selectgroup_19
  jecxz l_selectgroup_19
  
  // fsetpos(filepos+(gc*4))
  mov ebx, f1
  call fgetpos
  mov eax, dword ptr buffer[5 + 256 - 4]
  shl eax, 2
  add ecx, eax
  adc edx, 0
  mov ebx, f1
  mov edi, ecx
  call fsetpos
  
  cmp byte ptr buffer[5], 0
  jz l_selectgroup_15
  
  mov byte ptr buffer[5 + 31], 0
  mov esi, offset buffer + 5
  call strlen
  mov byte ptr buffer[4], cl
  add ecx, 5
  mov esi, offset info_sb
  mov edi, offset buffer
  call sb_add
  inc c1
  jmp l_selectgroup_15
  
l_selectgroup_19:
cmp c1, 0
jz near l_selectgroup_9
  
l_selectgroup_2:
// check pos1, pos2
cmp pos1, 0
jnl l_selectgroup_201
  // pos1 < 0
  mov pos1, 0

l_selectgroup_201:
mov eax, c1
cmp pos1, eax
jl l_selectgroup_202
  // pos1 >= c1
  dec eax
  mov pos1, eax

l_selectgroup_202:
mov eax, pos1
cmp pos2, eax
jng l_selectgroup_203
  // pos2 > pos1
  mov pos2, eax

l_selectgroup_203:
mov eax, pos2
add eax, SELECT_HEIGHT - 1
cmp eax, pos1
jnl l_selectgroup_204
  // pos2 + h - 1 < pos1
  mov eax, pos1
  sub eax, SELECT_HEIGHT - 1
  mov pos2, eax

l_selectgroup_204:
// print bg
mov i, 0

l_selectgroup_205:
  cmp i, SELECT_HEIGHT
  jnb l_selectgroup_208
    mov dl, SELECT_LEFT
    mov dh, byte ptr i
    add dh, SELECT_TOP
    call curto
    mov esi, offset selu2 + COFS
    mov ecx, 32
    mov bl, COLOR_SELECT
    call write
    inc i
    jmp l_selectgroup_205
    
l_selectgroup_208:

// print groups
mov ebx, info_sb.data
mov ecx, pos2

l_selectgroup_21:
  jecxz l_selectgroup_22
    movzx eax, byte ptr [ebx + 4]
    add eax, 5
    add ebx, eax
    loop l_selectgroup_21

l_selectgroup_22:
mov ecx, SELECT_HEIGHT
mov edi, c1
sub edi, pos2  // edi = c1 - pos2

l_selectgroup_23:
  cmp edi, 0
  jz l_selectgroup_24
    dec edi
    push edi
     push ecx
      push ebx
       mov dl, SELECT_LEFT
       mov dh, SELECT_HEIGHT + SELECT_TOP
       sub dh, cl
       call curto
      pop ebx
      push ebx
       mov esi, ebx
       add esi, 5
       movzx ecx, byte ptr [ebx + 4]
       mov bl, COLOR_SELECT
       call write
      pop ebx
     pop ecx
    pop edi
    movzx eax, byte ptr [ebx + 4]
    add eax, 5
    add ebx, eax
    loop l_selectgroup_23
  
l_selectgroup_24:

// main loop
l_selectgroup_5:
  mov dl, SELECT_LEFT
  mov eax, pos1
  sub eax, pos2
  mov dh, al
  add dh, SELECT_TOP
  call curto
  
  call waitkey
  mov eax, edx
  mov edx, esi
  call keys
  
  cmp al, VK_ESC
  jz near l_selectgroup_9
  
  cmp al, VK_UP
  jnz l_selectgroup_51
    dec pos1
    jmp l_selectgroup_2
    
  l_selectgroup_51:
  cmp al, VK_DOWN
  jnz l_selectgroup_52
    inc pos1
    jmp l_selectgroup_2
    
  l_selectgroup_52:
  cmp al, VK_HOME
  jnz l_selectgroup_53
    mov pos1, 0
    jmp l_selectgroup_2
    
  l_selectgroup_53:
  cmp al, VK_END
  jnz l_selectgroup_54
    mov eax, c1
    dec eax
    mov pos1, eax
    jmp l_selectgroup_2
    
  l_selectgroup_54:
  cmp al, VK_PGUP
  jnz l_selectgroup_55
    sub pos1, SELECT_HEIGHT
    jmp l_selectgroup_2
    
  l_selectgroup_55:
  cmp al, VK_PGDN
  jnz l_selectgroup_56
    add pos1, SELECT_HEIGHT
    add pos2, SELECT_HEIGHT
    jmp l_selectgroup_2
    
  l_selectgroup_56:
  cmp al, VK_ENTER
  jz l_selectgroup_8

  jmp l_selectgroup_5

l_selectgroup_8:
// ENTER
mov ebx, info_sb.data
mov ecx, pos1

l_selectgroup_81:
  jecxz l_selectgroup_82
    movzx eax, byte ptr [ebx + 4]
    add eax, 5
    add ebx, eax
    loop l_selectgroup_81
    
l_selectgroup_82:
mov esi, [ebx]
mov edx, offset path
call chgrp
test al, al
jz l_selectgroup_9
  call writeerror
  call waitkey

l_selectgroup_9:
// END
mov esi, offset info_sb
call sb_done
ret

EXT2_S_IFSYS  = 0x0200 //system file (only starter)

// USES: path, buffer, i, ptrfi, x, atri, atrv
info:
mov atri, 0
mov x, 0

push ebx
  
  // get path
  mov edi, offset path
  mov esi, offset ViewRec.path
  add esi, ebx
  mov ecx, [ebx + offset ViewRec.path_len]
  push edi
   push ecx
    cld
    rep movsb
   pop ecx
  pop edi
  
  l_info_15:
    jecxz l_info_16
      dec ecx
      mov al, [edi + ecx]
      cmp al, '/'
      jnz l_info_15
      
    inc ecx
  
  l_info_16:
  add edi, ecx
  
  // add file name to path
  xchg esi, edi
  
  mov eax, [ebx + offset ViewRec.y]
  cmp eax, [ebx + offset ViewRec.dirs_count]
  jnb l_info_22
    mov edi, [ebx + offset ViewRec.dirs.data]
    add edi, [eax * 4 + ebx + offset ViewRec.pdirs]
    jmp short l_info_24
    
  l_info_22:
    sub eax, [ebx + offset ViewRec.dirs_count]
    cmp eax, [ebx + offset ViewRec.files_count]
    jnb near l_info_9
      mov edi, [ebx + offset ViewRec.files.data]
      add edi, [eax * 4 + ebx + offset ViewRec.pfiles]
      
  l_info_24:
  mov ptrfi, edi
  mov eax, [edi + offset FileInfo.FileAttributes]
  mov atrv, eax

  add edi, offset FileInfo.FileName
  xchg esi, edi
  
  l_info_25:
    lodsb
    stosb
    cmp al, 0
    jnz l_info_25
  
  l_info_3:
  // background
  xor eax, eax
  mov i, eax
  
  l_info_31:
    mov dl, 4
    mov dh, byte ptr i
    add dh, 2
    call curto
    
    mov ecx, 72
    
    l_info_35:
      push ecx
        mov esi, offset strinfo1 + COFS
        mov ecx, 1
        mov bl, COLOR_INFO
        call write
      pop ecx
      loop l_info_35
    
    inc i
    cmp i, 22
    jb l_info_31

  // write file name
  mov dl, 6
  mov dh, 3
  call curto
  
  mov esi, offset path
  call strlen
  mov bl, COLOR_INFO
  call write
  
  // link
  mov edi, ptrfi
  mov eax, [edi + offset FileInfo.FileAttributes]
  test eax, FILE_ATTRIBUTE_LINK
  jz l_info_4
    mov edx, offset path
    mov esi, FOPEN_READ
    call open_link
    push ebx
      mov edi, offset path2
      mov ecx, MAX_PATH - 1
      call fread
      mov byte ptr path2[ecx], 0
    pop ebx
    call fclose
    
    mov dl, 6
    mov dh, 4
    call curto
    
    mov esi, offset strinfo2 + COFS
    mov ecx, 3
    mov bl, COLOR_INFO
    call write
    
    mov esi, offset path2
    call strlen
    mov bl, COLOR_INFO
    call write
    
  l_info_4:

  // size
  mov dl, 6
  mov dh, 6
  call curto
  
  mov esi, offset strinfo3 + COFS
  call strlen
  mov bl, COLOR_INFO
  call write
  
  mov edi, ptrfi
  mov eax, [edi + offset FileInfo.FileSize]
  mov edx, [edi + offset FileInfo.FileSize + 4]
  mov ecx, 10
  call writen8
  
  // times
  mov color, COLOR_INFO
  mov dl, 6
  mov dh, 7
  call curto
  mov esi, offset strinfo_ctime + COFS
  call strlen
  mov bl, COLOR_INFO
  call write
  mov esi, ptrfi
  add esi, offset FileInfo.CreationTime
  call writedtm
  
  mov dl, 6
  mov dh, 8
  call curto
  mov esi, offset strinfo_atime + COFS
  call strlen
  mov bl, COLOR_INFO
  call write
  mov esi, ptrfi
  add esi, offset FileInfo.LastAccessTime
  call writedtm
  
  mov dl, 6
  mov dh, 9
  call curto
  mov esi, offset strinfo_mtime + COFS
  call strlen
  mov bl, COLOR_INFO
  call write
  mov esi, ptrfi
  add esi, offset FileInfo.LastWriteTime
  call writedtm
  
  // disk free
  mov dl, 6
  mov dh, 11
  call curto
  mov esi, offset strinfo_df + COFS
  call strlen
  mov bl, COLOR_INFO
  call write
  
  mov al, byte ptr path[0]
  and al, 31
  call disk_free
  mov bl, COLOR_INFO
  mov ecx, 10
  call writen8
  
  mov esi, offset strinfo_slash + COFS
  call strlen
  mov bl, COLOR_INFO
  call write
  
  mov al, byte ptr path[0]
  and al, 31
  movzx esi, al
  call get_disk_size
  mov bl, COLOR_INFO
  mov ecx, 10
  call writen8

  // attribs
  mov eax, atrv
  test eax, FILE_ATTRIBUTE_LINUX
  jnz near l_info_6
    // windows
    
    l_info_51:
    mov eax, atrv

    mov dl, 6
    mov dh, 13
    mov esi, offset strinfo_aro + COFS
    mov ebx, FILE_ATTRIBUTE_READONLY
    call writeatr
    mov dl, 6
    mov dh, 14
    mov esi, offset strinfo_ahid + COFS
    mov ebx, FILE_ATTRIBUTE_HIDDEN
    call writeatr
    mov dl, 6
    mov dh, 15
    mov esi, offset strinfo_asys + COFS
    mov ebx, FILE_ATTRIBUTE_SYSTEM
    call writeatr
    mov dl, 6
    mov dh, 16
    mov esi, offset strinfo_aar + COFS
    mov ebx, FILE_ATTRIBUTE_ARCHIVE
    call writeatr
    mov dl, 6
    mov dh, 17
    mov esi, offset strinfo_anor + COFS
    mov ebx, FILE_ATTRIBUTE_NORMAL
    call writeatr
    mov dl, 6
    mov dh, 18
    mov esi, offset strinfo_atmp + COFS
    mov ebx, FILE_ATTRIBUTE_TEMPORARY
    call writeatr
    mov dl, 6
    mov dh, 19
    mov esi, offset strinfo_aspr + COFS
    mov ebx, FILE_ATTRIBUTE_SPARSE_FILE
    call writeatr
    mov dl, 6
    mov dh, 20
    mov esi, offset strinfo_acpr + COFS
    mov ebx, FILE_ATTRIBUTE_COMPRESSED
    call writeatr
    mov dl, 6
    mov dh, 21
    mov esi, offset strinfo_anx + COFS
    mov ebx, FILE_ATTRIBUTE_NOT_CONTENT_INDEXED
    call writeatr
    mov dl, 6
    mov dh, 22
    mov esi, offset strinfo_aenc + COFS
    mov ebx, FILE_ATTRIBUTE_ENCRYPTED
    call writeatr
    
    // main cycle windows
    l_info_52:
    mov dl, 6
    mov dh, atri
    add dh, 13
    call curto
    call waitkey
    mov eax, edx
    mov edx, esi
    call keys
    cmp eax, VK_UP
    jnz l_info_53
      cmp atri, 0
      jz l_info_53
        dec atri
        jmp l_info_52
        
    l_info_53:
    cmp eax, VK_DOWN
    jnz l_info_54
      cmp atri, 9
      jz l_info_54
        inc atri
        jmp l_info_52
    
    l_info_54:
    cmp eax, ' '
    jnz l_info_55
      mov eax, atrv
      cmp atri, 0
      jnz l_info_541
        xor eax, FILE_ATTRIBUTE_READONLY
        
      l_info_541:
      cmp atri, 1
      jnz l_info_542
        xor eax, FILE_ATTRIBUTE_HIDDEN
        
      l_info_542:
      cmp atri, 2
      jnz l_info_543
        xor eax, FILE_ATTRIBUTE_SYSTEM
        
      l_info_543:
      cmp atri, 3
      jnz l_info_544
        xor eax, FILE_ATTRIBUTE_ARCHIVE
        
      l_info_544:
      mov atrv, eax
      jmp l_info_51
      
    l_info_55:
    cmp eax, VK_ENTER
    jnz l_info_56
      mov esi, atrv
      mov edx, offset path
      call chmod
pop ebx
push ebx
      push eax
        call load
        call sort
      pop eax
      call writeerror
      cmp al, 2
      jb near l_info_9
        call waitkey
        jmp l_info_9
      
    l_info_56:
    cmp eax, VK_ESC
    jz near l_info_8
      cmp eax, 112 - 1 + 1  // F1
      jz near l_info_8
        jmp l_info_51
    
  l_info_6:
    // linux
    
    l_info_61:
    mov dl, 6
    mov dh, 13
    call curto
    mov esi, offset strinfo_u + COFS
    call strlen
    mov bl, COLOR_INFO
    call write    
    mov eax, atrv
    shr eax, 8 + 6
    call writeatrlinux
    
    mov dl, 6
    mov dh, 14
    call curto
    mov esi, offset strinfo_g + COFS
    call strlen
    mov bl, COLOR_INFO
    call write    
    mov eax, atrv
    shr eax, 8 + 3
    call writeatrlinux
    
    mov dl, 6
    mov dh, 15
    call curto
    mov esi, offset strinfo_o + COFS
    call strlen
    mov bl, COLOR_INFO
    call write    
    mov eax, atrv
    shr eax, 8
    call writeatrlinux
    
    // user & group
    mov edi, offset buffer
    mov ecx, 256 * 2 / 4
    xor eax, eax
    cld
    rep stosd
    
    mov dl, 18
    mov dh, 13
    call curto
    
    mov edx, offset path
    call fuidgid
    mov uid, ecx
    mov gid, edx
    push edx
      mov edi, offset buffer
      call getuserinfo
    pop ecx
    mov edi, offset buffer + 256
    call getgroupinfo
    
    mov esi, offset buffer
    call strlen
    mov bl, COLOR_INFO
    call write
    
    mov dl, 18
    mov dh, 14
    call curto
    
    mov esi, offset buffer + 256
    call strlen
    mov bl, COLOR_INFO
    call write
    
    // system file
    mov dl, 6
    mov dh, 17
    mov esi, offset strinfo_asys + COFS
    mov eax, atrv
    mov ebx, EXT2_S_IFSYS << 8
    call writeatr
    
    // main cycle linux
    l_info_62:
    mov dl, x
    add dl, 6 + 7
    cmp x, 3
    jnz l_info_622
      mov dl, 18
      cmp atri, 1
      jna l_info_622
        mov atri, 1
        
    l_info_622:
    mov dh, atri
    cmp dh, 3
    jb l_info_623
      inc dh
      mov x, 0
      mov dl, 6 + 8
      
    l_info_623:
    add dh, 13
    call curto
    call waitkey
    mov eax, edx
    mov edx, esi
    call keys
    
    cmp eax, VK_UP
    jnz l_info_63
      cmp atri, 0
      jz l_info_63
        dec atri
        jmp l_info_62
        
    l_info_63:
    cmp eax, VK_DOWN
    jnz l_info_64
      cmp atri, 3
      jz l_info_64
        inc atri
        jmp l_info_62
        
    l_info_64:
    cmp eax, VK_LEFT
    jnz l_info_65
      cmp x, 0
      jz l_info_65
        dec x
        jmp l_info_62
        
    l_info_65:
    cmp eax, VK_RIGHT
    jnz l_info_66
      cmp x, 3
      jz l_info_66
        inc x
        jmp l_info_62
        
    l_info_66:
    cmp eax, ' '
    jnz l_info_67
      cmp x, 3
      jb l_info_668
        
        l_info_661:
        // select user/group
        cmp atri, 0
        jnz l_info_662
          call selectuser
          jmp l_info_3

        l_info_662:
        call selectgroup
        jmp l_info_3
        
      l_info_668:
      cmp atri, 3
      jb l_info_669
        xor atrv, EXT2_S_IFSYS << 8
        jmp l_info_61
        
      l_info_669:
      mov ebx, atrv
      mov al, 2
      sub al, atri
      mov cl, 3
      mul cl
      mov cl, 2
      sub cl, x
      add al, cl
      adc ah, 0
      xchg eax, ecx
      mov eax, 1 << 8
      shl eax, cl
      xor ebx, eax
      mov atrv, ebx
      jmp l_info_61
      
    l_info_67:
    cmp eax, VK_ENTER
    jnz l_info_68
      cmp x, 3
      jz l_info_661
      
      mov esi, atrv
      mov edx, offset path
      call chmod
pop ebx
push ebx
      push eax
        call load
        call sort
      pop eax
      call writeerror
      cmp al, 2
      jb l_info_9
        call waitkey
        jmp short l_info_9
      
    l_info_68:
    cmp eax, VK_ESC
    jz l_info_8
      cmp eax, 112 - 1 + 1  // F1
      jz l_info_8
        jmp l_info_61
    
  l_info_8:
  // curto(0,23)
  mov dl, 0
  mov dh, 23
  call curto
  // clear line
  mov esi, offset str_spaces + COFS
  mov ecx, 80
  mov bl, 7
  call write
  
  l_info_9:
pop ebx
// set ebp -> ViewRec2
cmp ebx, offset view
jz l_info_91
  mov ebp, offset view
  jmp short l_info_92

l_info_91:
mov ebp, offset view + sizeof ViewRec

l_info_92:
push ebx
  call bottom
  mov ebx, ebp
  call paint
pop ebx
call paint
ret




formatpath: "c:/system/format/\0"
formatbootsect: "bootsect.dat\0"
formatbootscd: "bootscd.dat\0"
formatbootshd: "bootshd.dat\0"
formatsetup: "setup.dat\0"
formatkernel: "kernel.dat\0"
formatstarter: "starter.exe\0"
formatsystem: "c:/system\0"
formatsystemstarter: "c:/system/starter.exe\0"

// IN: fs_bootsofs, fs_formatsystem
// OUT: al = erc, fs_ofs_format, fs_bootsect,
//      fs_kernel_size in sectors, fs_setup_size in sectors
// KEEP: edi
format_sizes:

push edi
  
  xor eax, eax
  mov fs_kernel_size, eax
  mov fs_setup_size, eax
  
  // clear buffer
  mov ecx, 512 / 4
  mov edi, offset fs_bootsect
  cld
  rep stosd
  
  // system?
  test fs_formatsystem, 1
  jz near l_format_sizes_9  // al = 0
  
  mov edi, offset fs_formatfn
  
  // path
  mov esi, offset formatpath + COFS
  
  l_format_sizes_11:
  lodsb
  test al, al
  jz l_format_sizes_12
    stosb
    jmp short l_format_sizes_11
  
  l_format_sizes_12:
  mov fs_ofs_format, edi
  
  // bootsect
  mov esi, fs_bootsofs
  
  l_format_sizes_13:
    lodsb
    stosb
    test al, al
    jnz l_format_sizes_13
    
  // read from file
  mov edx, offset fs_formatfn
  call fopenread
pop edi
test al, al
jnz near l_format_sizes_9
push edi
  push ebx
    mov edi, offset fs_bootsect
    mov ecx, 512
    call fread
  pop ebx
  call fclose
  
  // end of sector marker
  mov word ptr fs_bootsect[510], 0AA55h
  
  // setup size
  mov edi, fs_ofs_format
  mov esi, offset formatsetup + COFS
  
  l_format_sizes_14:
    lodsb
    stosb
    test al, al
    jnz l_format_sizes_14
  
  mov edx, offset fs_formatfn
  call fopenread
pop edi
test al, al
jnz near l_format_sizes_9
push edi
  push ebx
    call fgetsize
  pop ebx
  push ecx
    call fclose
    
    // kernel size
    mov edi, fs_ofs_format
    mov esi, offset formatkernel + COFS
    
    l_format_sizes_15:
      lodsb
      stosb
      test al, al
      jnz l_format_sizes_15
    
    mov edx, offset fs_formatfn
    call fopenread
  pop ecx
pop edi
test al, al
jnz near l_format_sizes_9
push edi
  push ecx
    push ebx
      call fgetsize
    pop ebx
    push ecx
      call fclose
    pop ecx
    add ecx, 511
    shr ecx, 9
    mov fs_kernel_size, ecx
  pop eax
  add eax, 511
  shr eax, 9
  mov fs_setup_size, eax
  add eax, ecx
  inc eax  // bootsect
  
  cmp eax, 512
  jna l_format_sizes_8
    mov al, ERC_FILE_TOO_BIG
    jmp short l_format_sizes_9
  
  l_format_sizes_8:
    mov al, 0
  
  l_format_sizes_9:

pop edi

ret

// IN: fs_formatfn, format_disk,
//     ecx = sector count, esi = first sector number
// USES: fs_buffer
format_copy:
mov edx, offset fs_formatfn
push esi
 push ecx
  call fopenread
 pop ecx
pop esi
test al, al
jnz l_format_copy_9

l_format_copy_5:
  push ebx
   push ecx
   
    push esi
      mov edi, offset fs_buffer
      mov ecx, 512
      call fread
    pop esi
    
    push esi
      xor edx, edx
      mov ebx, esi
      shl ebx, 9
      mov ecx, 512
      mov edi, offset fs_buffer
      movzx esi, format_disk
      call disk_write
    pop esi
    
   pop ecx
  pop ebx
  inc esi
  loop l_format_copy_5
  
call fclose
mov al, 0

l_format_copy_9:
ret

// IN: format_disk, fs_partition_type
// USES: fs_pdiskn
format_correct_partition:
movzx esi, format_disk
// IN: esi = logical disk number
// OUT: al = type (2:fd, 3:cd, 4:hd), ah = pdiskn,
//      edx:ecx = disk size in sectors, edi:esi = base in sectors
call get_disk_type
mov fs_pdiskn, ah
cmp al, 4
jnz l_format_correct_partition_9
 cmp edi, 0
 jnz l_format_correct_partition_9
  push esi
    movzx esi, fs_pdiskn
    xor edx, edx
    xor ebx, ebx
    mov ecx, 1
    mov edi, offset fs_buffer
    // IN: edx:ebx = sector, ecx = count, edi -> data,
    //     esi = physical HD number
    call disk_read_sector
  pop esi
  
  mov ebx, 1BEh
  
  l_format_correct_partition_5:
    mov eax, dword ptr fs_buffer[ebx + 8]  // partition offset in sectors
    cmp eax, esi
    jnz l_format_correct_partition_6
      // current partition
      mov al, fs_partition_type
      cmp al, fs_buffer[ebx + 4]  // partition type
      jz l_format_correct_partition_9
        mov fs_buffer[ebx + 4], al
        
        movzx esi, fs_pdiskn
        xor edx, edx
        xor ebx, ebx
        mov ecx, 1
        mov edi, offset fs_buffer
        // IN: edx:ebx = sector, ecx = count, edi -> data,
        //     esi = physical HD number
        call disk_write_sector
        jmp short l_format_correct_partition_9
        
    l_format_correct_partition_6:
    add ebx, 16
    cmp ebx, 1FEh
    jb l_format_correct_partition_5
  
l_format_correct_partition_9:
ret

[bits 16]

format_notsys:
push 7C0h
pop ds
mov si, offset format_notsysmsg - offset format_notsys + 32
call format_notsys_writez
mov ah, 0
int 16h
//int 18h
format_notsys1: jmp short format_notsys1

format_notsys_writez:
lodsb
test al, al
jz l_format_notsys_9
  xor bh, bh
  mov ah, 0Eh
  int 10h
  jmp short format_notsys_writez
  
l_format_notsys_9:
ret

format_notsysmsg: db "Not system disk\0"
format_notsysend:

[bits 32]

format_copystarter:
mov edi, fs_ofs_format
mov esi, offset formatstarter + COFS

l_format_copystarter_1:
  lodsb
  stosb
  test al, al
  jnz l_format_copystarter_1

mov al, format_disk
or al, 64
mov [offset formatsystem + COFS], al
mov [offset formatsystemstarter + COFS], al

// md system
mov edx, offset formatsystem + COFS
call md

// copy format/starter.exe
mov edx, offset fs_formatfn
call fopenread
test al, al
jnz l_format_copystarter_9
  mov f1, ebx
  
  mov edx, offset formatsystemstarter + COFS
  call fcreate
  test al, al
  jnz l_format_copystarter_8
    mov f2, ebx
    
    l_format_copystarter_5:
      mov ebx, f1
      mov edi, offset buffer
      mov ecx, MAX_BUFFER
      push edi
        call fread
      pop edi
      test al, al
      jnz l_format_copystarter_7
      
      mov ebx, f2
      call fwrite
      test al, al
      jnz l_format_copystarter_7
      cmp ecx, MAX_BUFFER
      jz l_format_copystarter_5
      
    l_format_copystarter_7:
    mov ebx, f2
    call fclose
    
    mov al, 0
    
  l_format_copystarter_8:
  push eax
    mov ebx, f1
    call fclose
  pop eax
  
l_format_copystarter_9:
ret

FAT12_MAX_ROOT = 224

SETUP_SIZE_OFS = 32
KERNEL_SIZE_OFS = 36

// IN: al = ldiskn, fs_formatsystem, fs_systemdisk
//     edi = logblocksize (0..3 = 1024..8192)
// OUT: al = erc, format_disk, fs_bootsect
// USES: fs_buffer, fs_bootsect
FAT12_format:
and al, 31
mov format_disk, al

mov al, fs_systemdisk
or al, 64
mov [offset formatpath + COFS], al

cmp edi, 4
jb l_FAT12_format_1
  mov al, ERC_INVALID_VALUE
  ret
  
l_FAT12_format_1:

// * first sector *
mov fs_bootsofs, offset formatbootsect + COFS
call format_sizes
test al, al
jnz near l_FAT12_format_9

mov eax, fs_kernel_size
mov dword ptr fs_bootsect[KERNEL_SIZE_OFS], eax
mov eax, fs_setup_size
mov dword ptr fs_bootsect[SETUP_SIZE_OFS], eax

test fs_formatsystem, 1
jnz near l_FAT12_format_19

l_FAT12_format_18:
  // not system
  push edi
    mov dword ptr fs_bootsect[0], 1DE9h  // jmp main
    // [32]
    mov esi, offset format_notsys + COFS
    mov edi, offset fs_bootsect + 32
    mov ecx, offset format_notsysend - offset format_notsys
    cld
    rep movsb
  pop edi

l_FAT12_format_19:
mov dword ptr fs_bootsect[3], "TR32"  // OEM id
mov dword ptr fs_bootsect[7], "    "
mov word ptr fs_bootsect[11], 200h  // sector size
mov ecx, edi
mov eax, 1
shl eax, cl
mov byte ptr fs_bootsect[13], al  // cluster size in sectors
mov ax, 1
test fs_formatsystem, 1
jz l_FAT12_format_2
  mov ax, 512
  
l_FAT12_format_2:
mov word ptr fs_bootsect[14], ax  // reserved sectors
mov byte ptr fs_bootsect[16], 2  // number of FATs
mov word ptr fs_bootsect[17], FAT12_MAX_ROOT
movzx esi, format_disk
push edi
  call get_disk_size
pop edi
test eax, eax
jnz l_FAT12_format_3
  mov al, ERC_INVALID_DISK_NUMBER
  ret
  
l_FAT12_format_3:
shr eax, 9
mov word ptr fs_bootsect[19], ax  // number of sectors
mov byte ptr fs_bootsect[21], 0F0h  // media descriptor
mov ecx, edi
movzx edx, word ptr fs_bootsect[14]
sub eax, edx
shr eax, cl  // eax = clusters
mov edx, eax
inc edx
shr edx, 1
add eax, edx  // eax = eax * 1.5
add eax, 511
shr eax, 9
mov word ptr fs_bootsect[22], ax  // size of FAT in sectors

mov ax, word ptr fs_bootsect[19]  // number of sectors
cmp ax, 720
jnz l_FAT12_format_31
  mov ax, 9
  jmp short l_FAT12_format_39
  
l_FAT12_format_31:
cmp ax, 2400
jnz l_FAT12_format_32
  mov ax, 15
  jmp short l_FAT12_format_39
  
l_FAT12_format_32:
cmp ax, 1440
jnz l_FAT12_format_33
  mov ax, 9
  jmp short l_FAT12_format_39
  
l_FAT12_format_33:
cmp ax, 2880
jnz l_FAT12_format_34
  mov ax, 18
  jmp short l_FAT12_format_39
  
l_FAT12_format_34:
cmp ax, 5760
jnz l_FAT12_format_35
  mov ax, 36
  jmp short l_FAT12_format_39
  
l_FAT12_format_35:
mov ax, 18

l_FAT12_format_39:
mov word ptr fs_bootsect[24], ax  // sectors per track
mov word ptr fs_bootsect[26], 2  // number of surfaces
xor eax, eax
mov dword ptr fs_bootsect[28], eax  // partition offset
mov word ptr fs_bootsect[510], 0AA55h  // end of sector marker

l_FAT12_format_4:
  xor edx, edx
  xor ebx, ebx
  mov ecx, 512
  mov edi, offset fs_bootsect
  movzx esi, format_disk
  call disk_write
  cmp al, ERC_DISK_CHANGED
  jz l_FAT12_format_4
  
test al, al
jnz near l_FAT12_format_9

// * FATs *
movzx ebx, word ptr fs_bootsect[14]  // reserved sectors
xor eax, eax
mov edi, offset fs_buffer
mov ecx, 512 / 4
cld
rep stosd
movzx ecx, word ptr fs_bootsect[22]  // size of FAT in sectors
test ecx, ecx
jnz l_FAT12_format_48
  mov al, ERC_FS
  jmp l_FAT12_format_9
  
l_FAT12_format_48:
mov fs_count, 2

l_FAT12_format_5:
  mov dword ptr fs_buffer[0], 0xFFFFF0
  
  push ebx
   push ecx
    xor edx, edx
    shl ebx, 9
    mov ecx, 512
    mov edi, offset fs_buffer
    movzx esi, format_disk
    call disk_write
   pop ecx
  pop ebx  
  test al, al
  jnz near l_FAT12_format_9
  
  inc ebx
  mov dword ptr fs_buffer[0], 0
  
  push ecx
    dec ecx
    jecxz l_FAT12_format_69
    
    l_FAT12_format_6:
      push ebx
       push ecx
        xor edx, edx
        shl ebx, 9
        mov ecx, 512
        mov edi, offset fs_buffer
        movzx esi, format_disk
        call disk_write
       pop ecx
      pop ebx
      test al, al
      jnz l_FAT12_format_69
      
      inc ebx
      loop l_FAT12_format_6
    
    l_FAT12_format_69:
  pop ecx
  test al, al
  jnz near l_FAT12_format_9
  
  dec fs_count
  cmp fs_count, 0
  ja l_FAT12_format_5

// clear root directory
mov ecx, FAT12_MAX_ROOT
shl ecx, 5  // log2 sizeof DirRec
add ecx, 511
shr ecx, 9

l_FAT12_format_7:
  push ebx
   push ecx
    xor edx, edx
    shl ebx, 9
    mov ecx, 512
    mov edi, offset fs_buffer
    movzx esi, format_disk
    call disk_write
   pop ecx
  pop ebx
  test al, al
  jnz near l_FAT12_format_9
  
  inc ebx
  loop l_FAT12_format_7

test fs_formatsystem, 1
jz near l_FAT12_format_9
  
  // copy setup
  mov edi, fs_ofs_format
  mov esi, offset formatsetup + COFS
  
  l_FAT12_format_81:
    lodsb
    stosb
    test al, al
    jnz l_FAT12_format_81
  
  mov ecx, fs_setup_size
  xor esi, esi
  inc esi
  call format_copy
  test al, al
  jnz l_FAT12_format_9
    
    // copy kernel
    mov edi, fs_ofs_format
    mov esi, offset formatkernel + COFS
    
    l_FAT12_format_83:
      lodsb
      stosb
      test al, al
      jnz l_FAT12_format_83
    
    mov ecx, fs_kernel_size
    mov esi, fs_setup_size
    inc esi
    call format_copy
    
l_FAT12_format_9:
ret

SETUP_SIZE_OFS_HD = 20
KERNEL_SIZE_OFS_HD = 24
BOOT_DISK_OFS_HD = 28
SYSTEM_BOOT_OFS_HD = 32

EXT2_FIRST_INO = 11
EXT2_ROOT_INO = 2

RESERVED_INODES = EXT2_FIRST_INO - 1
LOG_INODES = 10 + 2

EXT2_S_IFDIR  = 0x4000 //directory
ACCESS_DEFAULT = (ACCESS_R|ACCESS_W|ACCESS_X)<<6 | ((ACCESS_R|ACCESS_X)<<3) | ACCESS_R|ACCESS_X


// IN: al = ldiskn, fs_formatsystem, fs_systemdisk
//     edi = logblocksize (0..3 = 1024..8192), 
// OUT: al = erc, format_disk
// USES: fs_buffer, fs_bootsect, e2_disksize, fs_syssect
e2_format:
and al, 31
mov format_disk, al

mov al, fs_systemdisk
or al, 64
mov [offset formatpath + COFS], al

// edi
cmp edi, 4
jb l_e2_format_1
  mov al, ERC_INVALID_VALUE
  ret
  
l_e2_format_1:
add edi, 10

// system sizes
mov fs_bootsofs, offset formatbootshd + COFS
call format_sizes  // keep edi
test al, al
jnz near l_e2_format_9

// bootsect
mov eax, fs_setup_size
mov dword ptr fs_bootsect[SETUP_SIZE_OFS_HD], eax
mov eax, fs_kernel_size
mov dword ptr fs_bootsect[KERNEL_SIZE_OFS_HD], eax
mov al, format_disk
mov fs_bootsect[BOOT_DISK_OFS_HD], al

// disk size
push edi
  movzx esi, format_disk
  call get_disk_size
  mov dword ptr e2_disksize[0], eax
  mov dword ptr e2_disksize[4], edx
pop edi

// super block
mov eax, dword ptr e2_disksize[0]
mov edx, dword ptr e2_disksize[4]
shr eax, LOG_INODES
mov ebx, edx
shr edx, LOG_INODES
shl ebx, 32 - LOG_INODES
or eax, ebx
mov e2_sb.s_inodes_count, eax

l_e2_format_10:
mov ecx, edi
mov ebx, 1
shl ebx, cl
mov eax, dword ptr e2_disksize[4]
xor edx, edx
div ebx
test eax, eax
jz l_e2_format_11
  inc edi
  cmp edi, 3
  jna l_e2_format_10
    dec edi
    mov eax, -1
    jmp short l_e2_format_12

l_e2_format_11:
mov eax, dword ptr e2_disksize[0]
div ebx  // assert blocks_count < 4 Gi

l_e2_format_12:
mov e2_sb.s_blocks_count, eax

mov e2_sb.s_r_blocks_count, 0
mov ecx, edi
sub cl, 10
jecxz l_e2_format_21
  mov e2_sb.s_first_data_block, 0 // 1024 1, else 0
  jmp short l_e2_format_22
  
l_e2_format_21:
  mov e2_sb.s_first_data_block, 1 // 1024 1, else 0

l_e2_format_22:
mov e2_sb.s_log_block_size, ecx
mov e2_sb.s_log_frag_size, ecx
mov ebx, 1
add cl, 10 + 3 // 8192 * block_size
shl ebx, cl
mov e2_sb.s_blocks_per_group, ebx
mov e2_sb.s_frags_per_group, ebx
mov e2_sb.s_inode_size, 128

mov e2_sb.s_feature_ro_compat, EXT2_FEATURE_RO_COMPAT_LARGE_FILE

// calc groups
mov eax, e2_sb.s_blocks_count
dec eax
dec eax
xor edx, edx
div e2_sb.s_blocks_per_group
inc eax
mov e2_groups, eax

// calc gblocks
mov eax, e2_groups
shl eax, 5  // assert sizeof GroupBlock = 32
mov ecx, edi
mov ebx, 1
shl ebx, cl
dec ebx  // ebx = block_size - 1
add eax, ebx
shr eax, cl
mov e2_gblocks, eax

// calc inodes per group, free inodes
mov eax, e2_sb.s_inodes_count
xor edx, edx
div e2_groups
shl eax, 7  // log s_inode_size
dec eax
or eax, ebx
inc eax
shr eax, 7  // log s_inode_size
mov e2_sb.s_inodes_per_group, eax
mul e2_groups
mov e2_sb.s_inodes_count, eax
sub eax, RESERVED_INODES
mov e2_sb.s_free_inodes_count, eax

// group blocks, free blocks
xor eax, eax
mov e2_sb.s_free_blocks_count, eax
xor esi, esi

l_e2_format_5:
  xor ebx, ebx
  cmp esi, 0
  jnz l_e2_format_52
    // group 0
    mov ebx, e2_gblocks
    add ebx, e2_sb.s_first_data_block
    jmp short l_e2_format_53
    
  l_e2_format_52:
  cmp esi, 1
  jnz l_e2_format_53
    // group 1
    mov ebx, e2_gblocks
    inc ebx
    
  l_e2_format_53:
  mov eax, esi
  mul e2_sb.s_blocks_per_group
  inc eax
  add eax, ebx
  
  mov e2_gb.bg_block_bitmap, eax
  // zero bitmap, keep eax, ebx, esi, edi
  push esi
   push edi
    push eax
     push ebx
      
      push edi
        mov edi, offset fs_buffer
        xor eax, eax
        mov ecx, 512 / 4
        cld
        rep stosd
      pop ecx
      
      mov ch, cl
      mov ebx, e2_gb.bg_block_bitmap
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl  // edx:ebx = block_bitmap << block_size_log
      
      mov cl, ch
      sub cl, 9
      mov eax, 1
      shl eax, cl
      xchg eax, ecx  // ecx = sectors512
      
      l_e2_format_535:
        push ecx
         push edx
          push ebx
            mov ecx, 512
            mov edi, offset fs_buffer
            movzx esi, format_disk
            call disk_write
          pop ebx
         pop edx
        pop ecx
        add ebx, 512
        loop l_e2_format_535
        
     pop ebx
    pop eax
   pop edi
  pop esi

  inc eax
  mov e2_gb.bg_inode_bitmap, eax
  // zero bitmap, keep eax, ebx, esi, edi
  push esi
   push edi
    push eax
     push ebx
      
      mov ecx, edi
      
      mov ch, cl
      mov ebx, e2_gb.bg_inode_bitmap
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl  // edx:ebx = inode_bitmap << block_size_log
      
      mov cl, ch
      sub cl, 9
      mov eax, 1
      shl eax, cl
      xchg eax, ecx  // ecx = sectors512
      
      l_e2_format_536:
        push ecx
         push edx
          push ebx
            mov ecx, 512
            mov edi, offset fs_buffer
            movzx esi, format_disk
            call disk_write
          pop ebx
         pop edx
        pop ecx
        add ebx, 512
        loop l_e2_format_536
        
     pop ebx
    pop eax
   pop edi
  pop esi

  
  // reserved inodes
  test esi, esi
  jnz l_e2_format_546
    push esi
     push edi
      push eax
       push ebx
        mov e2_tmp, (1 << RESERVED_INODES) - 1  // inodes reserved
        xor edx, edx
        mov ebx, eax
        mov ecx, edi
        shl ebx, cl
        mov ecx, 4
        mov edi, offset e2_tmp
        movzx esi, format_disk
        call disk_write
       pop ebx
      pop eax
     pop edi
    pop esi
    
  l_e2_format_546:
  inc eax
  mov e2_gb.bg_inode_table, eax
  
  mov eax, e2_sb.s_inodes_per_group
  movzx ecx, e2_sb.s_inode_size
  mul ecx
  mov ecx, edi
  shr eax, cl
  
  mov edx, e2_sb.s_blocks_per_group
  sub edx, eax
  sub edx, ebx
  sub edx, 2  // edx = blocks_per_group - size_inode_table - ebx - 2
  mov e2_gb.bg_free_blocks_count, dx
  
  mov eax, e2_sb.s_inodes_per_group
  test esi, esi
  jnz l_e2_format_548
    sub eax, RESERVED_INODES  // inodes reserved
    
  l_e2_format_548:
  mov e2_gb.bg_free_inodes_count, ax
  
  mov e2_gb.bg_used_dirs_count, 0
  
  // last group, KEEP esi  IN ebx  OUT edx
  mov eax, esi
  inc eax
  cmp eax, e2_groups
  jnz l_e2_format_56
    dec eax
    mul e2_sb.s_blocks_per_group
    inc eax
    mov edx, e2_sb.s_blocks_count
    sub edx, eax  // edx = blocks_count - (esi * blocks_per_group) - 1
    mov eax, ebx
    add eax, 2  // eax = ebx + 2
    cmp edx, eax
    jnb l_e2_format_55
      xor eax, eax
      xor edx, edx
      mov e2_gb.bg_free_inodes_count, ax
      mov e2_gb.bg_free_blocks_count, dx
      jmp short l_e2_format_558
      
    l_e2_format_55:
    sub edx, eax  // edx - eax
    mov ebx, edx
    mov eax, e2_sb.s_inodes_per_group
    movzx ecx, e2_sb.s_inode_size
    mul ecx
    mov ecx, edi
    shr eax, cl  // eax = inodes_per_group * inode_size / block_size
    cmp ebx, eax
    jnb l_e2_format_551
      shl eax, cl
      xor edx, edx
      div ecx
      mov e2_gb.bg_free_inodes_count, ax
      xor edx, edx
      mov e2_gb.bg_free_blocks_count, dx
      jmp short l_e2_format_558
    
    l_e2_format_551:
    sub ebx, eax  // ebx = edx - eax
    mov edx, ebx
    mov e2_gb.bg_free_blocks_count, dx
    
    l_e2_format_558:  // new edx
  
  l_e2_format_56:
  // sb free blocks
  add e2_sb.s_free_blocks_count, edx
  
  // write gb, KEEP esi, edi
  push esi
   push edi
    mov ebx, esi
    shl ebx, 5  // assert sizeof GroupBlock = 32
    mov ecx, edi
    mov edx, 1
    shl edx, cl
    cmp cl, 10
    jnz l_e2_format_57
      add edx, 1024
      
    l_e2_format_57:
    add ebx, edx
    xor edx, edx
    mov edi, offset e2_gb
    mov ecx, sizeof GroupBlock
    movzx esi, format_disk
    call disk_write
   pop edi
  pop esi
  test al, al
  jnz near l_e2_format_9
    
  // next esi
  inc esi
  cmp esi, e2_groups
  jb near l_e2_format_5

// reserved inodes
push edi
  mov edi, offset e2_inode
  mov ecx, sizeof INode / 4
  xor eax, eax
  cld
  rep stosd
pop edi

mov ebx, e2_gblocks
add ebx, e2_sb.s_first_data_block
add ebx, 1 + 1 + 1  // boot_block, block_bitmap, inode_bitmap
mov ecx, edi
shl ebx, cl

mov ecx, RESERVED_INODES

push edi
  jecxz l_e2_format_578
  
  l_e2_format_571:
  cmp ecx, RESERVED_INODES - EXT2_ROOT_INO + 1
  jnz l_e2_format_572
    mov e2_inode.i_mode, EXT2_S_IFDIR | ACCESS_DEFAULT
    jmp short l_e2_format_573
    
  l_e2_format_572:
    mov e2_inode.i_mode, 0
  
  l_e2_format_573:
  push ecx
   push ebx
    xor edx, edx
    mov edi, offset e2_inode
    mov ecx, sizeof INode
    movzx esi, format_disk
    call disk_write
   pop ebx
   movzx eax, e2_sb.s_inode_size
   add ebx, eax
  pop ecx
  loop l_e2_format_571
  
  l_e2_format_578:
pop edi

// write sb
push edi
  mov edi, offset e2_sb
  mov ecx, sizeof SuperBlock
  mov ebx, 1024
  xor edx, edx
  movzx esi, format_disk
  call disk_write
pop edi
test al, al
jnz near l_e2_format_9

test fs_formatsystem, 1
jnz near l_e2_format_60
  // * not system *
  push edi
    mov dword ptr fs_bootsect[0], 1DE9h  // jmp main
    // [32]
    mov esi, offset format_notsys + COFS
    mov edi, offset fs_bootsect + 32
    mov ecx, offset format_notsysend - offset format_notsys
    cld
    rep movsb
  pop edi
  
  mov dword ptr fs_bootsect[3], "TR32"  // OEM id
  mov dword ptr fs_bootsect[7], "    "
  mov word ptr fs_bootsect[11], 200h  // sector size
  mov ecx, edi
  mov eax, 1
  shl eax, cl
  mov byte ptr fs_bootsect[13], al  // cluster size in sectors
  jmp l_e2_format_8

l_e2_format_60:

// * copy system *

// read the first gb
xor ebx, ebx
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, 1
shl edx, cl
cmp cl, 10
jnz l_e2_format_61
  add edx, 1024
  
l_e2_format_61:
add ebx, edx
xor edx, edx
mov edi, offset e2_gb
mov ecx, sizeof GroupBlock
movzx esi, format_disk
mov fs_gb_diskofs, ebx  // fs_gb_diskofs
call disk_read
test al, al
jnz near l_e2_format_9

// check sizes
mov eax, fs_setup_size
add eax, fs_kernel_size
cmp eax, 512
jna l_e2_format_62
  mov al, ERC_FILE_TOO_BIG
  jmp l_e2_format_9
  
l_e2_format_62:
// system size
mov cl, byte ptr e2_sb.s_log_block_size
mov eax, 256  // 512 sectors
shr eax, cl

sub e2_sb.s_free_blocks_count, eax  // needs to be saved
sub e2_gb.bg_free_blocks_count, ax  // needs to be saved
jnc l_e2_format_63
  mov al, ERC_DISK_FULL
  jmp l_e2_format_9
  
l_e2_format_63:
// load block bitmap
push eax
  xor edx, edx
  mov ebx, e2_gb.bg_block_bitmap
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  shl ebx, cl
  mov edi, offset fs_buffer
  mov ecx, 512
  movzx esi, format_disk
  call disk_read
pop edx
test al, al
jnz near l_e2_format_9

// allocate bitmap
add edx, 7
shr edx, 3

xor eax, eax
mov ecx, 512
sub ecx, edx

l_e2_format_631:
  cmp byte ptr fs_buffer[eax], 0  // find first 0
  jz l_e2_format_633
    inc eax
    cmp eax, ecx
    jb l_e2_format_631

l_e2_format_632:
mov al, ERC_FS
jmp l_e2_format_9

l_e2_format_633:
mov fs_syssect, eax // fs_syssect = first in 8 clusters
mov ecx, edx

l_e2_format_635:
  cmp byte ptr fs_buffer[eax], 0
  jnz l_e2_format_632
    mov byte ptr fs_buffer[eax], 255  // occupy 8 clusters
    inc eax
    loop l_e2_format_635

// save block bitmap
mov ebx, e2_gb.bg_block_bitmap
xor edx, edx
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
shl ebx, cl
mov edi, offset fs_buffer
mov ecx, 512
movzx esi, format_disk
call disk_write

// first_block_in_group = (s_inodes_per_group * s_inode_size)
//   >> (s_log_block_size + 10) + bg_inode_table
mov eax, e2_sb.s_inodes_per_group
movzx ecx, e2_sb.s_inode_size
mul ecx
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
shr eax, cl
add eax, e2_gb.bg_inode_table

mov ebx, fs_syssect
shl ebx, 3
add eax, ebx
sub cl, 9
shl eax, cl
mov edx, eax

// copy setup
mov edi, fs_ofs_format
mov esi, offset formatsetup + COFS

l_e2_format_641:
  lodsb
  stosb
  test al, al
  jnz l_e2_format_641

mov ecx, fs_setup_size
mov esi, edx
mov fs_syssect, edx  // fs_syssect
push edx
  call format_copy
pop edx

test al, al
jnz near l_e2_format_9

// copy kernel
mov edi, fs_ofs_format
mov esi, offset formatkernel + COFS

l_e2_format_643:
  lodsb
  stosb
  test al, al
  jnz l_e2_format_643

mov ecx, fs_kernel_size
add edx, fs_setup_size
mov esi, edx
call format_copy

test al, al
jnz near l_e2_format_9

// save gb
mov ebx, fs_gb_diskofs
xor edx, edx
mov edi, offset e2_gb
mov ecx, sizeof GroupBlock
movzx esi, format_disk
call disk_write
test al, al
jnz l_e2_format_9

// save sb
mov edi, offset e2_sb
mov ecx, sizeof SuperBlock
mov ebx, 1024
xor edx, edx
movzx esi, format_disk
call disk_write
test al, al
jnz l_e2_format_9

// save bootsect
mov eax, fs_syssect
mov dword ptr fs_bootsect[SYSTEM_BOOT_OFS_HD], eax

l_e2_format_8:
mov edi, offset fs_bootsect
mov ecx, 512
xor ebx, ebx
xor edx, edx
movzx esi, format_disk
call disk_write

l_e2_format_9:
ret

strformat1: db " \0"
strformatdisk: db "Format disk: A\0"
strformatfs: db "Filesystem:\0"
strformatfat12: db "( ) FAT12\0"
strformatext2: db "( ) EXT2\0"
strformatselect: db "*\0"
strformatcluz: db "Cluster size:\0"
strformatbrackets: db "( )\0"
strformatbracketsselected: db "(*)\0"
strformatsystem: db "[ ] Transfer system from disk A\0"
strformatsystemselect: db "x\0"
strformatting: db "Formatting...\0"
strformatsame: db "Can't transfer system from the same disk\0"
strformatask: db "Do you really want to format this disk? y/n\0"

// USES: i, x, y, fs_filesystems, fs_filesystem, fs_value, ViewRec.path
format:
push ebx
  mov al, [ebx + offset ViewRec.path]
  and al, 31
  mov format_disk, al

  mov x, 0
  mov y, 0
  mov fs_cluzi, 0
  mov fs_formatsystem, 0
  call get_boot_disk
  and al, 31
  mov fs_systemdisk, al
  
  // filesystems
  mov fs_filesystem, 0
  mov fs_filesystems, 0
  mov al, format_disk
  cmp al, 3
  jb l_format_11
    mov fs_filesystems, 1
    
  l_format_11:
  
  l_format_2:
  // background
  xor eax, eax
  mov i, eax
  
  l_format_15:
    mov dl, 4
    mov dh, byte ptr i
    add dh, 2
    call curto
    
    mov esi, offset str_spaces + COFS
    mov ecx, 72
    mov bl, COLOR_FORMAT
    call write
  
    inc i
    cmp i, 20
    jb l_format_15
  
  // format disk
  mov dl, 6
  mov dh, 3
  call curto
  mov esi, offset strformatdisk + COFS
  mov al, format_disk
  or al, 64
  mov [esi + 13], al  // :KLUDGE:
  call strlen
  mov bl, COLOR_FORMAT
  call write
  
  // filesystem
  mov dl, 6
  mov dh, 5
  call curto
  mov esi, offset strformatfs + COFS
  call strlen
  mov bl, COLOR_FORMAT
  call write
  
  mov dl, 6 + 12
  mov dh, 5
  call curto
  cmp fs_filesystems, 0
  jnz l_format_21
    mov esi, offset strformatfat12 + COFS
    jmp short l_format_22
    
  l_format_21:
    mov esi, offset strformatext2 + COFS
    
  l_format_22:
  call strlen
  mov bl, COLOR_FORMAT
  call write
  
  mov dl, 6 + 13
  mov dh, 5
  add dh, fs_filesystem
  call curto
  mov esi, offset strformatselect + COFS
  mov ecx, 1
  mov bl, COLOR_FORMAT
  call write
  
  // cluster size
  mov dl, 6
  mov dh, 9
  call curto
  mov esi, offset strformatcluz + COFS
  call strlen
  mov bl, COLOR_FORMAT
  call write
  
  mov fs_value, 512
  cmp fs_filesystems, 1
  jnz l_format_24
    // EXT2
    mov fs_value, 1024
  
  l_format_24:
  mov byte ptr i, 0
  
  l_format_25:
    cmp byte ptr i, 4
    jnb l_format_26
      mov dl, 6 + 14
      mov dh, 9
      add dh, byte ptr i
      call curto
      mov al, byte ptr i
      cmp al, fs_cluzi
      jz l_format_252
        mov esi, offset strformatbrackets + COFS
        jmp short l_format_253
        
      l_format_252:
        mov esi, offset strformatbracketsselected + COFS
        
      l_format_253:
      mov ecx, 3
      mov bl, COLOR_FORMAT
      call write
      
      mov eax, fs_value
      mov ecx, 10
      mov bl, COLOR_FORMAT
      call writen
      
      shl fs_value, 1
      inc byte ptr i
      jmp l_format_25
      
  l_format_26:
  // transfer system
  mov dl, 6
  mov dh, 14
  call curto
  mov esi, offset strformatsystem + COFS
  mov al, fs_systemdisk
  or al, 64
  mov [esi + 30], al  // :KLUDGE:
  call strlen
  mov bl, COLOR_FORMAT
  call write
  cmp fs_formatsystem, 1
  jnz l_format_28
    mov dl, 7
    mov dh, 14
    call curto
    mov esi, offset strformatsystemselect + COFS
    mov ecx, 1
    mov bl, COLOR_FORMAT
    call write
    
  l_format_28:
  
  l_format_5:
  mov dh, y
  cmp dh, 3
  jnb l_format_51
    mov dl, 19
    add dh, 5
    jmp short l_format_58
    
  l_format_51:
  cmp dh, 7
  jnb l_format_52
    mov dl, 21
    add dh, 6
    jmp short l_format_58
    
  l_format_52:
    mov dl, 7
    add dh, 7
    cmp x, 0
    jz l_format_58
      mov dl, 36
    
  l_format_58:
  call curto
  call waitkey
  mov eax, edx
  mov edx, esi
  call keys
  
  cmp al, VK_ESC
  jz near l_format_9
  cmp al, VK_ENTER
  jz near l_format_8
  
  cmp al, VK_UP
  jnz l_format_61
    cmp y, 0
    jz l_format_61
      dec y
      //cmp fs_filesystems, 0
      cmp y, 2
      jnz near l_format_5
        mov y, 0
        jmp l_format_5
      
  l_format_61:
  cmp al, VK_DOWN
  jnz l_format_62
    cmp y, 7
    jz l_format_62
      inc y
      //cmp fs_filesystems, 0
      cmp y, 1
      jnz near l_format_5
        mov y, 3
        jmp l_format_5
      
  l_format_62:
  cmp al, VK_LEFT
  jnz l_format_63
    mov x, 0
    jmp l_format_5
    
  l_format_63:
  cmp al, VK_RIGHT
  jnz l_format_64
    mov x, 1
    jmp l_format_5
    
  l_format_64:
  cmp al, VK_END
  jnz l_format_65
    mov y, 7
    jmp l_format_5
    
  l_format_65:
  cmp al, VK_HOME
  jnz l_format_66
    mov y, 0
    jmp l_format_5
    
  l_format_66:
  cmp al, ' '
  jnz l_format_67
    cmp y, 3
    jnb l_format_661
      mov al, y
      mov fs_filesystem, al
      jmp l_format_2
      
    l_format_661:
    cmp y, 7
    jnb l_format_662
      mov al, y
      sub al, 3
      mov fs_cluzi, al
      jmp l_format_2
      
    l_format_662:
    xor fs_formatsystem, 1
    jmp l_format_2
    
  l_format_67:
  cmp y, 7
  jnz l_format_68
    cmp al, 'A'
    jb l_format_68
      cmp al, 'Z'
      jna l_format_671
        cmp al, 'a'
        jb l_format_68
          cmp al, 'z'
          ja l_format_68
          
    l_format_671:
    and al, 31
    mov fs_systemdisk, al
    jmp l_format_2
    
  l_format_68:
  jmp l_format_5
  
  l_format_8:
  // Do format
  test fs_formatsystem, 1
  jz l_format_802
    mov al, format_disk
    cmp al, fs_systemdisk
    jnz l_format_802
      // write "can't transfer from the same disk"
      mov dl, 0
      mov dh, 23
      call curto
      mov esi, offset strformatsame + COFS
      call strlen
      mov bl, COLOR_ERROR
      call write
      call waitkey
      jmp l_format_9
      
  l_format_802:
  // ask really format
  mov esi, offset strformatask + COFS
  call ask
  test al, 1
  jnz near l_format_9
  // write "Formatting..."
  mov dl, 0
  mov dh, 23
  call curto
  mov esi, offset str_spaces + COFS
  mov ecx, 80
  mov bl, 7
  call write
  mov dl, 0
  mov dh, 23
  call curto
  mov esi, offset strformatting + COFS
  call strlen
  mov bl, COLOR_PATH
  call write
  // prepare format
  mov al, format_disk
  movzx edi, fs_cluzi

  cmp fs_filesystems, 0
  jnz l_format_81
    // FAT12
    mov fs_partition_type, FSID_FAT12
    call FAT12_format
    jmp l_format_84
    
  l_format_81:
  cmp fs_filesystem, 0
  jnz l_format_82
    // EXT2
    mov fs_partition_type, FSID_EXT2
    call e2_format
    jmp l_format_84
    
  l_format_82:
  //...
  
  l_format_84:
  // reset disk
  push eax
    mov al, format_disk
    call reset_disk
  pop eax
  // copy starter.exe
  test al, al
  jnz l_format_88
    test fs_formatsystem, 1
    jz l_format_88
      call format_copystarter
    
  l_format_88:
  push eax
    // correct partition
    call format_correct_partition
    // flush
    mov al, format_disk
    call flush
  pop eax
  
  // write error
  call writeerror
  test al, al
  jz l_format_89
    call waitkey
    
  l_format_89:
  
  l_format_9:
pop ebx

// set ebp -> ViewRec2
cmp ebx, offset view
jz l_format_91
  mov ebp, offset view
  jmp short l_format_92

l_format_91:
mov ebp, offset view + sizeof ViewRec

l_format_92:
push ebx
  call bottom
  mov ebx, ebp
  call load
  call sort
  call paint
pop ebx
call load
call sort
call paint
ret

msg_md: "Directory name: \0"

main:
mov time_zone, 0
mov sort_by, SORT_AZ

call bottom

call load_disks

// Get current disk
mov edi, offset path
push edi
  call get_current_directory
pop edi
mov eax, "A:/*"    // A:/*
mov al, [edi]

// left path
mov dword ptr view.path, eax
mov dword ptr view.path[4], 0 //2A2Eh  // .*
mov view.path_len, 6

// right path
mov dword ptr view.path[sizeof ViewRec], "C:/*"
mov view.path_len[sizeof ViewRec], 4

// init views
mov view.sy, 0
mov view.y, 0
mov view.x, 0
mov view.w, 40

mov view.sy[sizeof ViewRec], 0
mov view.y[sizeof ViewRec], 0
mov view.x[sizeof ViewRec], 41
mov view.w[sizeof ViewRec], 39

// load views
mov ebx, offset view + sizeof ViewRec
call load
call sort
call paint

mov ebx, offset view
call load
call sort
call paint

mov tab_ofs, offset view

// main cycle
l_main_5:
  mov ebx, tab_ofs
  mov eax, [ebx + offset ViewRec.y]
  sub eax, [ebx + offset ViewRec.sy]
  mov dh, al
  mov dl, [ebx + offset ViewRec.x]
  inc dl
  add dh, 3
  call curto
  
  call getmsg
  
  cmp ecx, WM_KEYDOWN
  jnz l_main_5

mov eax, edx
mov edx, esi
call keys
mov ebx, tab_ofs

cmp eax, VK_UP
jnz l_main_52
  // up
  dec dword ptr [ebx + offset ViewRec.y]
  
  // check y, sy
  l_main_ysy:
  mov eax, [ebx + offset ViewRec.dirs_count]
  add eax, [ebx + offset ViewRec.files_count]
  cmp eax, [ebx + offset ViewRec.y]
  jg l_main_ysy1
    dec eax
    mov [ebx + offset ViewRec.y], eax
    
  l_main_ysy1:
  cmp dword ptr [ebx + offset ViewRec.y], 0
  jnl l_main_ysy2
    mov dword ptr [ebx + offset ViewRec.y], 0
    
  l_main_ysy2:
  cmp dword ptr [ebx + offset ViewRec.sy], 0
  jnl l_main_ysy3
    mov dword ptr [ebx + offset ViewRec.sy], 0
  
  l_main_ysy3:
  mov eax, [ebx + offset ViewRec.y]
  cmp eax, [ebx + offset ViewRec.sy]
  jnl l_main_ysy4
    mov [ebx + offset ViewRec.sy], eax
    
  l_main_ysy4:
  mov eax, [ebx + offset ViewRec.sy]
  add eax, TAB_H - 1
  cmp [ebx + offset ViewRec.y], eax
  jl l_main_ysy5
    mov eax, [ebx + offset ViewRec.y]
    sub eax, TAB_H - 1
    mov [ebx + offset ViewRec.sy], eax
    
  l_main_ysy5:
  
  call paint
  jmp l_main_5
  
l_main_52:
cmp eax, VK_DOWN
jnz l_main_521
  // down
  inc dword ptr [ebx + offset ViewRec.y]
  jmp l_main_ysy

l_main_521:
cmp eax, VK_HOME
jnz l_main_522
  // home
  mov dword ptr [ebx + offset ViewRec.y], 0
  mov dword ptr [ebx + offset ViewRec.sy], 0
  jmp l_main_ysy
  
l_main_522:
cmp eax, VK_END
jnz l_main_523
  // end
  mov eax, [ebx + offset ViewRec.dirs_count]
  add eax, [ebx + offset ViewRec.files_count]
  dec eax
  mov [ebx + offset ViewRec.y], eax
  jmp l_main_ysy
  
l_main_523:
cmp eax, VK_PGUP
jnz l_main_524
  // page up
  sub dword ptr [ebx + offset ViewRec.y], TAB_H
  sub dword ptr [ebx + offset ViewRec.sy], TAB_H
  jmp l_main_ysy
  
l_main_524:
cmp eax, VK_PGDN
jnz l_main_53
  // page down
  add dword ptr [ebx + offset ViewRec.y], TAB_H
  add dword ptr [ebx + offset ViewRec.sy], TAB_H
  jmp l_main_ysy
  
l_main_53:
cmp eax, VK_TAB
jnz l_main_534
  // tab
  cmp tab_ofs, offset view
  jnz l_main_531
    mov tab_ofs, offset view + sizeof ViewRec
    jmp short l_main_532
    
  l_main_531:
  mov tab_ofs, offset view
  
  l_main_532:
  mov ebx, tab_ofs
  call load_disks
  call paint
  jmp l_main_5
  
l_main_534:
cmp eax, 112 - 1 + 5
jnz l_main_535
  // F5
  call copy  
  jmp l_main_5
  
l_main_535:
cmp eax, 112 - 1 + 8
jnz l_main_5351
  // F8
  call delete
  jmp l_main_5
  
l_main_5351:
cmp eax, 112 - 1 + 9
jnz l_main_5352
  // F9
  call link
  jmp l_main_5
  
l_main_5352:
cmp eax, 112 - 1 + 1
jnz l_main_5353
  // F1
  call info
  jmp l_main_5

l_main_5353:
cmp eax, 112 - 1 + 10
jnz l_main_536
  // F10
  mov al, [ebx + offset ViewRec.path]
  call flush
  jmp l_main_5

l_main_536:
cmp eax, 112 - 1 + 7
jnz l_main_537
  // F7 - make directory
  push ebx
    call cdcurdir
    mov esi, offset msg_md + COFS
    mov len, 0
    mov x, 0
    call input
    cmp len, 0
    jz l_main_5362
      mov edx, offset path
      call md
      call writeerror
      cmp al, 2
      jb l_main_5362
        call waitkey
    
    l_main_5362:
  pop ebx
  call load
  call sort
  call paint
  jmp l_main_5
  
l_main_537:
cmp eax, 112 - 1 + 2
jnz l_main_538
  // F2 - rename
  call rename
  jmp l_main_5

l_main_538:
cmp eax, 112 - 1 + 6
jnz l_main_539
  // F6 - move
  call move
  jmp l_main_5
  
l_main_539:
cmp eax, 112 - 1 + 4
jnz l_main_5391
  // F4 - compare
  call cmpfiles
  jmp l_main_5

l_main_5391:
cmp eax, 112 - 1 + 12
jnz l_main_54
  // F12 - format
  call format
  jmp l_main_5

l_main_54:
cmp eax, VK_RIGHT
jz near l_main_60
  cmp eax, VK_ENTER
  jz near l_main_60
    cmp eax, VK_LEFT
    jz near l_main_70
      cmp eax, VK_BSP
      jz near l_main_70

  test edx, 8
  jz near l_main_56
    // alt + A..Z: change disk
    cmp al, 'A'
    jb l_main_542
      cmp al, 'Z'
      ja l_main_542
        and eax, 31
        mov esi, eax
        or al, 64
        mov [ebx + offset ViewRec.path], al
        mov dword ptr [ebx + offset ViewRec.path + 1], 2A2F3Ah //":/*"
        mov dword ptr [ebx + offset ViewRec.path_len], 4
        mov dword ptr [ebx + offset ViewRec.sy], 0
        mov dword ptr [ebx + offset ViewRec.y], 0
        push ebx
          call resetdisk
        pop ebx
        call load_disks
        call load
        call sort
        call paint
        jmp l_main_5

    l_main_542:
    // alt + 1..3: sort
    cmp al, '1'
    jnz l_main_544
      cmp sort_by, 0
      jz l_main_543
        mov sort_by, 0
        call sort
        call paint
        jmp l_main_5
        
      l_main_543:
      mov sort_by, 1
      call sort
      call paint
      jmp l_main_5
      
    l_main_544:
    cmp al, '2'
    jnz l_main_546
      cmp sort_by, 2
      jz l_main_545
        mov sort_by, 2
        call sort
        call paint
        jmp l_main_5
        
      l_main_545:
      mov sort_by, 3
      call sort
      call paint
      jmp l_main_5
      
    l_main_546:
    cmp al, '3'
    jnz near l_main_5
      cmp sort_by, 4
      jz l_main_547
        mov sort_by, 4
        call sort
        call paint
        jmp l_main_5
        
      l_main_547:
      mov sort_by, 5
      call sort
      call paint
      jmp l_main_5
      

  l_main_56:
  // not alt
  //...
  jmp l_main_5

l_main_60:
// cd
mov eax, [ebx + offset ViewRec.y]
mov edx, [ebx + offset ViewRec.dirs_count]
cmp eax, edx
jnb near l_main_5

mov esi, [eax * 4 + ebx + offset ViewRec.pdirs]
add esi, [ebx + offset ViewRec.dirs.data]
add esi, offset FileInfo.FileName  // esi -> filename
push esi
  call strlen
pop esi  // ecx = filenamelen

mov eax, [ebx + offset ViewRec.path_len]
inc ecx
inc eax
add eax, ecx  // eax = path_len + filenamelen + 2
cmp eax, MAX_PATH
jnb near l_main_5

dec eax
mov edi, eax
add edi, offset ViewRec.path
add edi, ebx  // edi -> path[eax]
push esi
 push ecx
  mov esi, offset ViewRec.path
  add esi, ebx
  add esi, [ebx + offset ViewRec.path_len]  // esi -> path[path_len]
  push esi
    xor ecx, ecx
    
    l_main_61:
      inc ecx
      dec esi
      cmp byte ptr [esi], '/'
      jnz l_main_61
    
    l_main_62:
    add esi, ecx
    std
    push ecx
      inc ecx
      rep movsb
    pop ecx
    cld
    
    l_main_63:
  pop edi
  sub edi, ecx
 pop ecx
pop esi

add [ebx + offset ViewRec.path_len], ecx  // path_len + ecx
inc edi
dec ecx
rep movsb

mov dword ptr [ebx + offset ViewRec.sy], 0
mov dword ptr [ebx + offset ViewRec.y], 0

call load
call sort
call paint

jmp l_main_5

l_main_70:
// cd ..
mov esi, [ebx + offset ViewRec.path_len]
mov edx, ebx
add edx, offset ViewRec.path  // edx -> path[0]
add esi, edx  // esi -> path[path_len]
xor ecx, ecx

l_main_71:
  dec esi
  inc ecx
  cmp byte ptr [esi], '/'
  jz l_main_72
    cmp esi, edx
    jna near l_main_5
      jmp short l_main_71

l_main_72:
mov edi, esi

l_main_73:
  dec edi
  cmp byte ptr [edi], '/'
  jz l_main_74
    cmp edi, edx
    jna near l_main_5
      jmp short l_main_73

l_main_74:
mov eax, esi
sub eax, edi
sub [ebx + offset ViewRec.path_len], eax

inc ecx
rep movsb

mov dword ptr [ebx + offset ViewRec.sy], 0
mov dword ptr [ebx + offset ViewRec.y], 0

call load
call sort
call paint

jmp l_main_5

//ret

lastoffset:

