// KERNEL.ASM 1.2 generated by Dingo Source Manager 3.3
// Licence: Open Source

[org 0]
[bits 32]

// Shared Symbolic Constants -->

BPB_FLOPPYSIZE = 13h
BPB_SECS       = 18h
BPB_SFS        = 1Ah
BPB_SETUPSECS  = 40h
BPB_KERNELSECS = 44h
BPB_BOOTDISK   = 48h

// Setup Memory Model
SIZE_BOOTSECT = 512

PA_BOOT         = 7C00h
PA_BOOTSECTCOPY = 600h

PA_SETUP_CODE   = 80000h
PA_SETUP_DATA   = 88000h
PA_SETUP_STACK  = 88000h

SIZE_SETUP_STACK = 8000h - 16

// Kernel Memory Model (physical memory - PA)
PA_IDT         =   800h // size 2 KiB (800h)
PA_PD0         =  1000h // size 4 KiB (1000h)
PA_KERNEL_DATA =  2000h // size 0E000h
PA_GDT         = 10000h // size 32 KiB (8000h)
PA_PT_PROCS    = 18000h // size 4 KiB (1000h)
PA_PT_THREADS  = 19000h // size 4 KiB (1000h)
PA_PT_SD       = 1A000h // size 4 KiB (1000h)
PA_PT_VAR      = 1E000h // size 4 KiB (1000h)
PA_PT_SYS      = 1F000h // size 4 KiB (1000h)
PA_KERNEL_CODE = 20000h // size 256 KiB (40000h)
PA_TMR         = 60000h // size 16 KiB (4000h)
PA_DMA_BUFFERS = 70000h // size 20000h

SIZE_KERNEL_DATA = PA_GDT - PA_KERNEL_DATA
SIZE_GDT         = PA_PT_PROCS - PA_GDT
SIZE_TMR         = 4000h

// Selectors (must match KERNEL_GDT)
SELECTOR_SETUP_CODE  =  8
SELECTOR_KERNEL_CODE = 10h
SELECTOR_KERNEL_DATA = 18h
SELECTOR_USER_CODE   = 20h
SELECTOR_USER_DATA   = 28h
SELECTOR_ALL_CODE    = 30h
SELECTOR_ALL_DATA    = 38h
SELECTOR_VIDEO       = 40h
SELECTOR_TEXTVIDEO   = 48h
SELECTOR_TSS         = 50h
SELECTOR_LDT         = 58h

// Paging
VA_GLOBAL   = 0xC0000000
VA_ACCESS   = 0xD0000000
VA_RAMDISK  = 0xD0000000
VA_GRAPHICS = 0xE0000000
VA_SYSTEM   = 0xF0000000
VA_PROCS    = 0xF8000000
VA_THREADS  = 0xF9000000
VA_VAR      = 0xFA000000
VA_SD       = 0xFB000000

PG_MASK_P   = 1
PG_MASK_W   = 2
PG_MASK_U   = 4
PG_MASK_PWT = 8
PG_MASK_PCD = 16
PG_MASK_A   = 32
PG_MASK_D   = 64
PG_MASK_PS  = 128
PG_MASK_G   = 256

// Initialization constants
KERNEL_IDT_OFS  = 0
KERNEL_IDT_SIZE = 40h * 8
KERNEL_GDT_OFS  = KERNEL_IDT_OFS + KERNEL_IDT_SIZE
KERNEL_GDT_SIZE = 16 * 8

IRQ0INT = 30h
IRQ8INT = 38h

START_SYSTEM_INT = 27h

M_INFO_MAXCOUNT  = 32
M_INFO_ENTRYSIZE = 24

MAX_PROCS   = 512
MAX_THREADS = 1024  // max 1024

// <-- Shared Symbolic Constants


// Shared Structures -->

struct VbeInfoBlock {
   char VbeSignature[4] // == "VESA"
   uns2 VbeVersion      // == 0x0300 for VBE 3.0
   uns4 OemStringPtr    // isa vbeFarPtr
   uns1 Capabilities[4]
   uns4 VideoModePtr    // real mode far ptr to array of words terminated -1
   uns2 TotalMemory     // as # of 64KB blocks
   
   uns2 OemSoftwareRev    // VBE implementation Software revision
   uns4 OemVendorNamePtr  // Pointer to Vendor Name String
   uns4 OemProductNamePtr // Pointer to Product Name String
   uns4 OemProductRevPtr  // Pointer to Product Revision String
   uns1 Reserved[222]     // Reserved for VBE implementation
   uns1 OemData[256]      // Data Area for OEM Strings     
}

struct ModeInfoBlock {
  uns2 attributes
  uns1 winA, winB
  uns2 granularity
  uns2 winsize
  uns2 segmentA, segmentB
  uns4 realFctPtr  // Pointer to window function
  uns2 pitch       // Bytes per scan line
  
  // VBE 1.2
  uns2 xres, yres
  uns1 xchar, ychar, planes, bpp, banks
  uns1 memory_model, bank_size, image_pages
  uns1 reserved0
 
  uns1 red_mask, red_position
  uns1 green_mask, green_position
  uns1 blue_mask, blue_position
  uns1 rsv_mask, rsv_position
  uns1 directcolor_attributes
  
  // VBE 2.0
  uns4 physbase  // LFB (Linear Framebuffer) address
  uns4 OffScreenMemOffset
  uns2 OffScreenMemSize
  
  uns1 reserved[206]
}

// <-- Shared Structures

PL0_STACK_SIZE = 1024
P_MSG_MAX = 32

WM_KEYDOWN = 100h
WM_KEYUP   = 101h
WM_COMMAND = 111h
WM_TIMER   = 113h
WM_TERMINATED = 180h
WM_NEW_CLIP = 181h
WM_DEVICECHANGE = 219h

THREAD_FLAGS_VALID = 1
THREAD_FLAGS_USE_FPU = 4  // first byte!
THREAD_FLAGS_DONT_WAKE_BY_MESSAGE = 8  // first byte!
THREAD_FLAGS_M_PAGES_BUSY = 10h  // first byte!
THREAD_FLAGS_M_HEAP_BUSY = 20h  // first byte!
THREAD_FLAGS_DISK_BUSY = 40h  // first byte!
THREAD_FLAGS_P_LOAD_BUSY = 80h  // first word!
THREAD_FLAGS_G_BUSY = 100h  // first word!

MAX_PATH = 260

FOPEN_READ = 1
FOPEN_WRITE = 3
FOPEN_APPEND = 10h
FOPEN_CREATE = 20h
FOPEN_LINK = 40h  // internal

DISK_MAX = 32

FSID_EXT2 = 82h
FSID_NTFS = 7
FSID_FAT12 = 0F0h
FSID_CD = 30h

MAX_FILES = 128
MAX_SRCH = 64

X_FLAG_VALID = 1
X_FLAG_SYSTEM = 2

// MemInfo (24)
struct MemInfoRec{
 uns8 base, size
 uns1 type[8]
}

// HeapRec (16)
struct HeapRec{
  uns4 next, last, size, type
}

// DateTime (8)
struct DateTime{
 uns4 time, date
}

// TMR (16)
struct TmrRec{
 uns4 ticks, threadid_wnd, id, ofs
}

// MSG (16)
struct MsgRec{
 uns2 sender, id
 uns4 msg, wp, lp
}

// CAH (16)
struct CatchRec{
  uns4 esp, ebp, eip, flags
}

// TSS (104)
struct TssRec{
 uns2 bptr, rsv0
 uns4 esp0
 uns2 ss0, rsv1
 uns4 esp1
 uns2 ss1, rsv2
 uns4 esp2
 uns2 ss2, rsv3
 uns4 cr3
 uns4 eip, eflags
 uns4 eax, ecx, edx, ebx, esp, ebp, esi, edi
 uns2 es, rsv4
 uns2 cs, rsv5
 uns2 ss, rsv6
 uns2 ds, rsv7
 uns2 fs, rsv8
 uns2 gs, rsv9
 uns2 ldt, rsv10
 uns2 TSS_RSV11, portsofs
}

// Process (512)
struct ProcessRec{
  uns4 cr3, mainthread, previnstance
  uns4 memused  // size of allocated pages
  char filename[512 - (4 * 4)]
}

// Thread (4 KiB)
struct ThreadRec{
 TssRec tss
 uns4 next, last, flags, process

 uns1 fstate[108]
 uns4 uid, gid
 uns4 erc, ero
 uns4 tmr_spent
 uns4 priority
 uns4 stack3_ptr, stack3_aligned
 uns4 new_eip
 uns4 curdir, curdirsize
 uns1 curdisk
 char curdirtext[MAX_PATH]
 //...
 [dalign 32]
 CatchRec catch
 // messages
 uns4 msgw, msgr, msgusrw, msgusrr
 MsgRec msg[P_MSG_MAX]     // (512)
 MsgRec msgusr[P_MSG_MAX]  // (512)
 // PL0 stack
 uns4 pl0stack[PL0_STACK_SIZE / 4]    // (1024)
}

// Logical disk info
struct DiskInfoRec{
  uns1 type, fsid, number, partition
  uns4 main  // offset of function ?d_main
  uns8 base_sectors, size_sectors, flags
}

// fopen
struct OpenFileRec{
 uns8 size, pos, sectn
 uns1 disk, mode
 uns2 threadid
 uns4 file
}

// Time
struct SystemTime{
  uns2 wYear
  uns2 wMonth
  uns2 wDayOfWeek
  uns2 wDay
  uns2 wHour
  uns2 wMinute
  uns2 wSecond
  uns2 wMilliseconds
}

// Window = 32 B
struct WinRec{
  int2 x, y, w, h
  uns4 flags, cr3, pwnd, pbitmap, rsv1, rsv2
}

ERC_HARDWARE            = 2
ERC_OUT_OF_RANGE        = 5
ERC_DISK_CHANGED        = 6
ERC_NOT_FLUSHED         = 7
ERC_DISK_IO             = 8
ERC_INVALID_DISK_NUMBER = 10h
ERC_NOT_FOUND_IN_CACHE  = 12h  // internal
ERC_UNKNOWN_GEOMETRY    = 15h
ERC_DISK_FULL           = 16h

ERC_NOT_IMPLEMENTED     = 0FFh

ERC_INVALID_CHANNEL_NUMBER = 18h
ERC_INVALID_MEMORY_ADDRESS = 19h
ERC_INVALID_COUNT          = 1Ah

ERC_NOT_ENOUGH_MEMORY = 21h
ERC_ALIGN             = 24h
ERC_ALREADY_FREE      = 25h
ERC_OVERFLOW          = 26h
ERC_UNDERFLOW         = 27h

ERC_MSG_QUEUE_EMPTY    = 30h
ERC_MSG_QUEUE_FULL     = 31h
ERC_MSG_INVALID_TARGET = 32h

ERC_TOO_MANY_PROCS   = 40h
ERC_TOO_MANY_THREADS = 41h

ERC_TIMER_FULL      = 42
ERC_TIMER_NOT_FOUND = 43

ERC_PATH_NOT_FOUND = 44h
ERC_FILE_NOT_FOUND = 45h
ERC_TOO_MANY_OPEN_FILES = 46h
ERC_DIR_ALREADY_EXISTS = 47h
ERC_UNKNOWN_FILESYSTEM = 48h
ERC_DIR_NOT_EMPTY = 49h
ERC_CANT_REMOVE = 4Ah
ERC_DUPLICATE_NAME = 4Bh
ERC_INVALID_FHANDLE = 4Ch
ERC_INVALID_THREAD = 4Dh
ERC_FS = 4Eh
ERC_READ_ONLY = 4Fh
ERC_IN_USE = 50h
ERC_OUT_OF_DISK = 51h
ERC_TOO_MANY_SEARCHES = 52h
ERC_INVALID_SHANDLE = 53h
ERC_CANT_RENAME = 54h

ERC_INVALID_PID = 55h
ERC_STACK_OVERFLOW = 56h
ERC_INVALID_HEADER = 57h
ERC_INVALID_SERVICE = 58h

ERC_TOO_LONG = 59h
ERC_ONLY_STARTER = 5Ah
ERC_INVALID_MEMORY_LOCATION = 5Bh
ERC_INVALID_THREADID = 5Ch
ERC_ACCESS_DENIED = 5Dh
ERC_INVALID_PRIORITY = 5Eh
ERC_INVALID_ATRBS = 5Fh
ERC_INVALID_VALUE = 60h
ERC_INVALID_POINTER = 61h
ERC_INVALID_CHAR = 62h
ERC_DISK_REMOVED = 63h
ERC_TOO_BIG_HOLE = 64h  // internal
ERC_UTF8 = 65h
ERC_BUSY = 66h
ERC_DIR_TOO_BIG = 67h
ERC_LINK = 68h  // internal
ERC_NOT_A_LINK = 69h
ERC_INFINITE_LINK = 70h
ERC_CANT_MOVE = 71h
ERC_FILE_TOO_BIG = 72h
ERC_NOT_FIT_IN_MFT = 73h
ERC_INVALID_LINK = 74h

// Shared Kernel Variables -->

[dorg 2000h] // PA_KERNEL_DATA

// set by the setup

uns2 cur_pos

uns2 boot_disk  // 0x300 = cd

[dalign 32]
uns4 m_RAMSize
uns4 m_info_count
uns1 m_info[M_INFO_MAXCOUNT * M_INFO_ENTRYSIZE]

[dalign 32]
uns4 m_lastbyte, m_bitmap_base, m_bitmap_size, m_first_alloc

ModeInfoBlock g_info
uns2 g_mode

// <-- Shared Kernel Variables

ThreadRec tss
uns4 ldt[2]

// Memory
[dalign 32]
uns4 m_free

// Process
uns4 p_current, p_idle
uns4 p_procs_max_size, p_threads_max_size

// Locks
bool m_pages_busy, m_heap_busy, fs_busy, p_load_busy

// Disks
[dalign 32]
DiskInfoRec disk_info[DISK_MAX]

uns2 hdt_port_base
uns1 hdt_slave_bit, link_depth
bool take_link

// Keyboard
[dalign 32]
uns1 kbd_state[128]

// Timer
[dalign 32]
uns4 tmr_total
uns2 tmr_ms

// Filesystem
[dalign 32]
OpenFileRec files[MAX_FILES]

// Time
int4 time_zone

// Graphics
uns1 g_busy

// Users
uns1 users_disk

// This table is copied to PA_IDT by the setup.
idt:	// [KERNEL_IDT_OFS] (KERNEL_IDT_SIZE)

// processor interrupts
dw offset isr0,  10h, 8F00h, 0
dw offset isr1,  10h, 8F00h, 0
dw offset isr2,  10h, 8F00h, 0
dw offset isr3,  10h, 8F00h, 0
dw offset isr4,  10h, 8F00h, 0
dw offset isr5,  10h, 8F00h, 0
dw offset isr6,  10h, 8F00h, 0
dw offset isr7,  10h, 8F00h, 0
dw offset isr8,  10h, 8F00h, 0
dw offset isr9,  10h, 8F00h, 0
dw offset isr0A, 10h, 8F00h, 0
dw offset isr0B, 10h, 8F00h, 0
dw offset isr0C, 10h, 8F00h, 0
dw offset isr0D, 10h, 8F00h, 0
dw offset isr0E, 10h, 8F00h, 0
dw offset isr0F, 10h, 8F00h, 0
dw offset isr10, 10h, 8F00h, 0
dw offset isr11, 10h, 8F00h, 0
dw offset isr12, 10h, 8F00h, 0
dw offset isr13, 10h, 8F00h, 0
dw offset isr14, 10h, 8F00h, 0
dw offset isr15, 10h, 8F00h, 0
dw offset isr16, 10h, 8F00h, 0
dw offset isr17, 10h, 8F00h, 0
dw offset isr18, 10h, 8F00h, 0
dw offset isr19, 10h, 8F00h, 0
dw offset isr1A, 10h, 8F00h, 0
dw offset isr1B, 10h, 8F00h, 0
dw offset isr1C, 10h, 8F00h, 0
dw offset isr1D, 10h, 8F00h, 0
dw offset isr1E, 10h, 8F00h, 0
dw offset isr1F, 10h, 8F00h, 0

// OS interrupts
dw offset services,	10h, 0EF00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset start_system,	10h, 8F00h, 0

dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0

// IRQ interrupts
dw offset IRQ0, 10h, 8E00h, 0
dw offset IRQ1, 10h, 8E00h, 0
dw offset IRQ2, 10h, 8E00h, 0
dw offset IRQ3, 10h, 8E00h, 0
dw offset IRQ4, 10h, 8E00h, 0
dw offset IRQ5, 10h, 8E00h, 0
dw offset IRQ6, 10h, 8E00h, 0
dw offset IRQ7, 10h, 8E00h, 0

dw offset IRQ8, 10h, 8E00h, 0
dw offset IRQ9, 10h, 8E00h, 0
dw offset IRQ10, 10h, 8E00h, 0
dw offset IRQ11, 10h, 8E00h, 0
dw offset IRQ12, 10h, 8E00h, 0
dw offset IRQ13, 10h, 8E00h, 0
dw offset IRQ14, 10h, 8E00h, 0
dw offset IRQ15, 10h, 8E00h, 0

// This table is copied to PA_GDT by the setup.
gdt:	// [KERNEL_GDT_OFS] (KERNEL_GDT_SIZE)

EXT_GRANULARITY = 80h
EXT_SIZE        = 40h

RIGHTS_CODE = 18h | 80h | 2
RIGHTS_DATA = 10h | 80h | 2
RIGHTS_TSS  =  1  | 80h | 8 //| 60h
RIGHTS_LDT  =  2  | 80h

RIGHTS_CODE_USER = RIGHTS_CODE | 60h
RIGHTS_DATA_USER = RIGHTS_DATA | 60h

EXT_DEFAULT = EXT_GRANULARITY | EXT_SIZE | 0Fh

// dw limit & 0FFFFh, base & 0FFFFh, ((base / 10000h) & 0FFh) | (rights * 100h), extend | ((base / 10000h) & 0FF00h)

// invalid selector
dw 0, 0, 0, 0
// setup code
dw 0FFFFh, PA_SETUP_CODE & 0FFFFh, (PA_SETUP_CODE / 10000h) | (RIGHTS_CODE * 100h), EXT_SIZE

// kernel code, data (base + 0xF0000000 when paging is on)
dw 3Fh, PA_KERNEL_CODE & 0FFFFh, (PA_KERNEL_CODE / 10000h) | (RIGHTS_CODE * 100h), EXT_DEFAULT
dw 0FFFFh, 0, (RIGHTS_DATA * 100h), EXT_DEFAULT

// user code, data
dw 0FFFFh, 0, (RIGHTS_CODE_USER * 100h), EXT_DEFAULT
dw 0FFFFh, 0, (RIGHTS_DATA_USER * 100h), EXT_DEFAULT

// all memory code, data
dw 0FFFFh, 0, (RIGHTS_CODE * 100h), EXT_DEFAULT
dw 0FFFFh, 0, (RIGHTS_DATA * 100h), EXT_DEFAULT

// video, hardware mapped memory
dw 05Fh, 0, 0Ah | (RIGHTS_DATA * 100h), EXT_GRANULARITY | EXT_SIZE
// text video
dw 07FFFh, 8000h, 0Bh | (RIGHTS_DATA * 100h), EXT_SIZE

// TSS
dw sizeof ThreadRec - 1, offset tss & 0FFFFh, (offset tss / 10000h) | (RIGHTS_TSS * 100h), EXT_SIZE

// LDT
dw 7, offset ldt, RIGHTS_LDT * 100h, EXT_SIZE

dw 0, 0, 0, 0
dw 0, 0, 0, 0
dw 0, 0, 0, 0
dw 0, 0, 0, 0

str_fn: db "/system/starter.exe\0"
msg_init_kernel: "Initializing kernel\n\0"
msg_loading_starter: "Loading starter...\0"
msg_system_halted: "\nSystem halted\0"

start_system:

// Cancel mapping 0 -> 0
mov ebx, PA_PD0
xor eax, eax
mov [ebx], eax

// Set selectors
mov dx, SELECTOR_KERNEL_DATA
mov ds, dx
mov ax, SELECTOR_ALL_DATA
mov es, ax

// Write initializing kernel
mov esi, offset msg_init_kernel
call writec

// Init
call irqs_init
call h_dma_init
call m_init
call p_init
call h_disks_init
call fs_init

//call h_ps2mouse_init
call h_kbd_init
call h_timer_init

//call test_nt
//call test_ext2
//call test_graphic
//call test_sd
//call test_search
//call test_memory
//call main

sti

mov esi, offset msg_loading_starter
call writec

// load starter; run starter

mov eax, p_current
mov edi, [es:eax + offset ThreadRec.process]
add edi, offset ProcessRec.filename

mov esi, eax
add esi, offset ThreadRec.curdirtext

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset str_fn

push edi
  call fs_merge
pop edx

call p_new_proc

// System halted

mov esi, offset msg_system_halted
call writec

l_start_system_8:
jmp l_start_system_8
//iretd

uns1 irqs[16]

irqs_init:

push es

 push ds
 pop es
 mov edi, offset irqs
 xor eax, eax
 mov ecx, 16
 cld
 rep stosb

pop es

mov al, 0  // enable all irqs 0-7
out 0A1h, al
call delay

mov al, 0  // enable all irqs 8-15
out 21h, al
call delay

//sti      // enable interrupts

ret

fault:
fault2:
    push ds
    push es

    mov al, 20h
    out 20h, al

    movzx ebx, bl

// throw(ebx)
//...

// this should never happen
    push ecx
     push edx
      push ebx
       mov esi, offset msg_fail
       call writec
      pop eax
      mov ecx, 16
      call writen
     pop eax
     mov ecx, 16
     call writen
    pop eax
    mov ecx, 16
    call writen

fdie: jmp fdie

msg_fail: db "\n Error\0"



ignore_int:
iretd

invalid_int:
    pushad
    mov bl, 0FFh
    jmp fault


isr0:   pushad
	mov bl, 80h
	jmp fault		// zero divide
isr5:   pushad
	mov bl, 85h
	jmp fault		// BOUND
isr6:   pushad
	mov bl, 86h
	jmp fault		// invalid opcode
isr7:   pushad
	mov bl, 87h
	jmp fault		// coprocessor not available
isr10:  pushad
	mov bl, 0D0h
	jmp fault

//	fault handlers w/error code (EIP -> on)
isr0A:  pushad
	mov bl, 8Ah
	jmp fault2		// bad TSS
isr0B:  pushad
	mov bl, 8Bh
	jmp fault2		// segment not present
isr0C:  pushad
	mov bl, 8Ch
	jmp fault2		// stack fault	//... brief 17

isr0D:
 pushad
 mov edx, esp
 mov eax, [ss:edx + (8 * 4)] // error code
 mov bl, 8Dh
 jmp fault2		// GPF

//	aborts (EIP = ?)
isr9: pushad
    	mov bl, 89h	// coprocessor segment overrun
	jmp fault

//	aborts w/error code (EIP = ?)
isr8: pushad
	mov bl, 88h		// double fault	//... brief 16
	jmp fault2

//	traps (EIP -> after)
isr1:   pushad
	mov bl, 81h
	jmp fault		// debug (XXX - may be fault or trap)
isr2:   pushad
	mov bl, 82h
	jmp fault		// non-maskable interrupt
isr3:   pushad
	mov bl, 83h
	jmp fault		// INT3
isr4:   pushad
	mov bl, 84h
	jmp fault		// INTO
isr0F:  pushad
	mov bl, 8Fh
	jmp fault		// coprocessor error
isr11:  pushad
	mov bl, 91h
	jmp fault		// alignment check
isr12:  pushad
	mov bl, 92h
	jmp fault
isr13:  pushad
	mov bl, 93h
	jmp fault
isr14:  pushad
	mov bl, 94h
	jmp fault
isr15:  pushad
	mov bl, 95h
	jmp fault
isr16:  pushad
	mov bl, 96h
	jmp fault
isr17:  pushad
	mov bl, 97h
	jmp fault
isr18:  pushad
	mov bl, 98h
	jmp fault
isr19:  pushad
	mov bl, 99h
	jmp fault
isr1A:  pushad
	mov bl, 9Ah
	jmp fault
isr1B:  pushad
	mov bl, 9Bh
	jmp fault
isr1C:  pushad
	mov bl, 9Ch
	jmp fault
isr1D:  pushad
	mov bl, 9Dh
	jmp fault
isr1E:  pushad
	mov bl, 9Eh
	jmp fault
isr1F:  pushad
	mov bl, 9Fh
	jmp fault

// BEFORE: pushad
IRQall:

 push ds
  push es

    movzx ecx, bl

    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx  // es = ALLMEM

    mov al, 20h
    out 20h, al

    and cl, 15
    inc irqs[ecx]

/*
    //$$$
    mov eax, ecx
    mov ecx, 10
    call writen
*/
  pop es
 pop ds

popad
iretd

IRQ2:
    pushad
    mov bl, 2
    jmp IRQall

IRQ3:
    pushad
    mov bl, 3
    jmp IRQall

IRQ4:
    pushad
    mov bl, 4
    jmp IRQall

IRQ5:
    pushad
    mov bl, 5
    jmp IRQall


IRQ7:
    pushad
    mov bl, 7
    jmp IRQall

IRQ8:
    pushad
    mov bl, 8
    jmp IRQall

IRQ9:
    pushad
    mov bl, 9
    jmp IRQall

IRQ10:
    pushad
    mov bl, 10
    jmp IRQall

IRQ11:
    pushad
    mov bl, 11
    jmp IRQall

IRQ13:
    pushad
    mov bl, 13
    jmp IRQall

[align 32]

services_offsets:

dd offset p_noop // 0
dd offset s_exit // 1
dd offset s_write  // 2
dd offset s_cursorto // 3

dd offset s_p_msg_send // 4
dd offset p_msg_get // 5
dd offset p_msg_usr_send // 6
dd offset p_msg_usr_get // 7

dd offset s_fs_fopen // 8
dd offset s_fs_fclose // 9
dd offset s_fs_fread // 10
dd offset s_fs_fwrite // 11

dd offset s_fs_fsetpos // 12
dd offset s_fs_fcut // 13
dd offset s_fgetpos // 14
dd offset s_fgetsize // 15

dd offset s_cd // 16
dd offset s_md // 17
dd offset s_rm // 18
dd offset s_getcurpos // 19

dd offset s_rename // 20
dd offset s_move // 21
dd offset s_find_first // 22
dd offset fs_find_next // 23

dd offset m_heap_alloc_local // 24
dd offset m_heap_free_local // 25
dd offset m_heap_alloc_global // 26
dd offset m_heap_free_global // 27

dd offset p_create_process // 28
dd offset p_kill_process // 29
dd offset p_create_thread // 30
dd offset p_kill_thread // 31

dd offset p_sleep // 32
dd offset s_getpriority // 33
dd offset s_p_start // 34
dd offset s_p_stop // 35

dd offset s_diskread // 36
dd offset s_diskwrite // 37
dd offset s_disksize // 38
dd offset s_diskflush // 39

dd offset s_hdread // 40
dd offset s_hdwrite // 41
dd offset s_procinfo // 42
dd offset s_setpriority // 43

dd offset s_getprocname // 44
dd offset s_getpid // 45
dd offset s_reloaddisks // 46
dd offset s_identify // 47

dd offset fs_find_close // 48
dd offset s_getkeystate // 49
dd offset s_login // 50
dd offset s_logrp // 51

dd offset s_getcurdir // 52
dd offset s_disktype // 53
dd offset s_getuid // 54
dd offset s_getgid // 55

dd offset s_gettimezone // 56
dd offset s_settimezone // 57
dd offset s_systime2ftime // 58
dd offset s_ftime2systime // 59

dd offset s_getlocal // 60
dd offset s_setlocal // 61
dd offset s_getsystem // 62
dd offset fs_resetdisk // 63

dd offset s_timer_add // 64
dd offset s_timer_rm // 65
dd offset s_link_open // 66
dd offset s_link_rm // 67

dd offset fs_diskfree // 68
dd offset s_sendtoall // 69
dd offset s_memfree // 70
dd offset s_create_ramdisk // 71

dd offset p_clip_set // 72
dd offset p_clip_get // 73
dd offset fs_get_mtime // 74
dd offset fs_set_mtime // 75

dd offset fs_chmod // 76
dd offset s_get_boot_disk // 77
dd offset fs_chown // 78
dd offset fs_chgrp // 79

dd offset s_get_user // 80
dd offset s_get_group // 81
dd offset fs_fuidgid // 82
dd offset get_users_disk // 83

//...

services_offsets_end:

// Chkstarter
// KEEP: ecx, edx, ebx, esi, edi
s_chkstarter:
mov eax, p_current
mov eax, [es:eax + offset ThreadRec.process]
sub eax, VA_PROCS
jz l_s_chkstarter_8
  mov al, ERC_ONLY_STARTER

l_s_chkstarter_8:  
ret

// Exit
s_exit:
mov ebx, p_current
mov ebx, [es:ebx + offset ThreadRec.process]
sub ebx, VA_PROCS
shr ebx, 9 // assert sizeof ProcessRec = 512
jmp p_kill_process
ret

// Write
s_write_calc:
movzx eax, dh
push edx
  mov edi, 80
  mul edi
pop edx
add al, dl
adc ah, 0
shl eax, 1
mov edi, eax

mov ah, bl
ret

// IN: es:esi -> str, ecx = len, bl = color
s_write:
mov dx, cur_pos
push es
 push ds
  push es
  pop ds
  mov ax, SELECTOR_TEXTVIDEO
  mov es, ax
  cld
  
  call s_write_calc
  
  s_write_5:
    jecxz s_write_9
      dec ecx
      lodsb
      cmp al, 13
      jz s_write_5
      
      cmp al, 10
      jz s_write_56

      stosw
        
      s_write_55:
      inc dl
      cmp dl, 80
      jb s_write_5
        
        s_write_56:
        xor dl, dl
        inc dh
        cmp dh, 25
        jb s_write_57
          call l_writec_over_screen
        
        s_write_57:
        call s_write_calc
        
      jmp s_write_5

  s_write_9:
 pop ds
pop es
mov cur_pos, dx
call cursorto
ret

// IN: dl = x, dh = y
s_cursorto:
mov cur_pos, dx
jmp cursorto

// OUT: dl = x, dh = y
s_getcurpos:
movzx edx, cur_pos
ret

// IN: ebx = wnd:threadid, ecx = msg, edx = wp, esi = lp
s_p_msg_send:
call s_chkstarter
jz l_s_p_msg_send_5
  mov al, ERC_ONLY_STARTER
  jmp short l_s_p_msg_send_9

l_s_p_msg_send_5:
  call p_msg_send

l_s_p_msg_send_9:
ret

// IN: esi = mode, es:edx -> fname
// OUT: al = erc, ebx = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
s_fs_fopen:
mov eax, esi
mov ah, 0
call fs_fopen
mov ebx, esi
ret

// IN: ebx = fhandle
s_fs_fclose:
mov esi, ebx
call fs_fclose
ret

// IN: ebx = fhandle, es:edi -> data, ecx = size
s_fs_fread: // 10
mov esi, ebx
mov eax, edi
add eax, ecx
cmp eax, VA_ACCESS
ja l_fs_fread_8
  cmp eax, edi
  jnb near fs_fread

l_fs_fread_8:  // also s_fs_write
mov al, ERC_INVALID_POINTER
xor ecx, ecx
ret

// IN: ebx = fhandle, es:edi -> data, ecx = size
s_fs_fwrite: // 11
mov esi, ebx
mov eax, edi
add eax, ecx
cmp eax, VA_ACCESS
ja l_fs_fread_8
  cmp eax, edi
  jb l_fs_fread_8
jmp fs_fwrite

// IN: ebx = fhandle, edx:edi = file offset
s_fs_fsetpos:
mov esi, ebx
mov ebx, edi
jmp fs_fsetpos

// IN: ebx = fhandle
s_fs_fcut:
mov esi, ebx
jmp fs_fcut

// IN: ebx = fhandle
// OUT: edx:ecx = fpos
s_fgetpos: // 14
mov esi, ebx
call fs_check_thread_esi
or al, al
jnz l_s_fgetpos_9
  mov ecx, dword files.pos[esi]
  mov edx, dword files.pos[esi + 4]
  mov al, 0

l_s_fgetpos_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fsize
s_fgetsize: // 15
mov esi, ebx
call fs_check_thread_esi
or al, al
jnz l_s_fgetsize_9
  mov ecx, dword files.size[esi]
  mov edx, dword files.size[esi + 4]
  mov al, 0

l_s_fgetsize_9:
ret

s_cd: // 16
mov ah, 0
jmp fs_cd
//ret

s_md: // 17
mov ah, 0
jmp fs_md
//ret

s_rm: // 18
mov ah, 0
jmp fs_rm
//ret

s_rename: // 20
mov ah, 1
jmp fs_rename
//ret

s_move: // 21
mov ah, 0
jmp fs_move
//ret

s_find_first: // 22
mov ah, 0
jmp fs_find_first
//ret

// IN: edi = threadid
// OUT: edx = priority
s_getpriority: // 33
shl edi, 12  // assert sizeof ThreadRec = 4096
cmp edi, p_threads_max_size
jb l_s_getpriority_1
  mov al, ERC_INVALID_THREADID
  ret

l_s_getpriority_1:
add edi, VA_THREADS
cmp byte[es:edi + offset ThreadRec.flags], 0
jnz l_s_getpriority_2
  mov al, ERC_INVALID_THREADID
  ret

l_s_getpriority_2:
mov eax, [es:edi + offset ThreadRec.priority]
xor edx, edx
mov ecx, 1193
div ecx
xchg eax, edx

mov al, 0
ret

// chkthread
s_chkthread:
pushfd
cli

shl edi, 12  // assert sizeof ThreadRec = 4096
cmp edi, p_threads_max_size
jb l_s_chkthread_1
  mov al, ERC_INVALID_THREADID
  popfd
  ret

l_s_chkthread_1:
add edi, VA_THREADS
cmp byte[es:edi + offset ThreadRec.flags], 0
jnz l_s_chkthread_2
  mov al, ERC_INVALID_THREADID
  popfd
  ret
  
l_s_chkthread_2:
mov eax, p_current
mov eax, [es:eax + offset ThreadRec.process]
cmp eax, [es:edi + offset ThreadRec.process]
jz l_s_chkthread_3
  mov al, ERC_ACCESS_DENIED
  popfd
  ret

l_s_chkthread_3:
mov al, 0
popfd
ret


// IN: edi = threadid
s_p_start: // 34
call s_chkthread
or al, al
jnz l_s_p_start_1
  jmp p_start

l_s_p_start_1:
ret

// IN: edi = threadid
s_p_stop: // 35
call s_chkthread
or al, al
jnz l_s_p_stop_1
  jmp p_stop

l_s_p_stop_1:
ret

// IN: edx:ebx = disk offset, ecx = size, esi = ldiskn, edi -> target
s_diskread:  // 36
call fs_enter
call s_chkstarter
jnz l_s_diskread_9
  and esi, 31
  mov eax, esi
  shl esi, 5  // assert sizeof DiskInfoRec = 32
  mov esi, disk_info.main[esi]
  or esi, esi
  jz l_s_diskread_2
    mov ah, 2
    call esi
    jmp short l_s_diskread_9

l_s_diskread_2:
mov al, ERC_INVALID_DISK_NUMBER

l_s_diskread_9:
call fs_leave
ret

// IN: edx:ebx = disk offset, ecx = size, esi = ldiskn, edi -> target
s_diskwrite:  // 37
call fs_enter
call s_chkstarter
jnz l_s_diskwrite_9
  and esi, 31
  mov eax, esi
  shl esi, 5  // assert sizeof DiskInfoRec = 32
  mov esi, disk_info.main[esi]
  or esi, esi
  jz l_s_diskwrite_2
    mov ah, 3
    call esi
    jmp short l_s_diskwrite_9

l_s_diskwrite_2:
mov al, ERC_INVALID_DISK_NUMBER

l_s_diskwrite_9:
call fs_leave
ret

// IN: esi = ldiskn
// OUT: edx:eax = disk size in bytes
s_disksize:  // 38
call fs_enter
and esi, 31
mov eax, esi
shl esi, 5  // assert sizeof DiskInfoRec = 32
mov esi, disk_info.main[esi]
or esi, esi
jz l_s_disksize_2
  mov ah, 4
  call esi
  jmp short l_s_disksize_9

l_s_disksize_2:
xor eax, eax
xor edx, edx

l_s_disksize_9:
call fs_leave
ret

// IN: esi = ldiskn
s_diskflush:  // 39
call fs_enter
and esi, 31
mov eax, esi
shl esi, 5  // assert sizeof DiskInfoRec = 32
mov esi, disk_info.main[esi]
or esi, esi
jz l_s_diskflush_2
  mov ah, 5
  call esi
  jmp short l_s_diskflush_9

l_s_diskflush_2:
mov al, ERC_INVALID_DISK_NUMBER

l_s_diskflush_9:
call fs_leave
ret

// IN: edx:ebx = sector, ecx = count, edi -> data, esi = physical HD number
s_hdread: // 40
call fs_enter
mov eax, esi
//and al, 3
call h_hd_prepare_port_slave
call h_hd_p_read
call fs_leave
ret

// IN: edx:ebx = sector, ecx = count, edi -> data, esi = physical HD number
s_hdwrite: // 41
call fs_enter
mov eax, esi
//and al, 3
call h_hd_prepare_port_slave
call h_hd_p_write
call fs_leave
ret

// IN: ebx = pid
// OUT: es:ebx -> process
s_get_proc_ptr:
shl ebx, 9  // assert sizeof ProcessRec = 512
cmp ebx, p_procs_max_size
jb l_s_get_proc_ptr_5

  l_s_get_proc_ptr_3:
  mov al, ERC_INVALID_PID
  jmp short l_s_get_proc_ptr_9

l_s_get_proc_ptr_5:
add ebx, VA_PROCS

cmp dword ptr [es:ebx + offset ProcessRec.cr3], 0
jz l_s_get_proc_ptr_3

mov al, 0

l_s_get_proc_ptr_9:
ret

// IN: ebx = pid
// OUT: ecx = cpu ticks, edx = total ticks, ebx = used memory, esi = flags
s_procinfo: // 42
call s_get_proc_ptr
or al, al
jnz l_s_procinfo_9

xor esi, esi
xor ecx, ecx
xor edi, edi
l_s_procinfo_6:
  add edi, VA_THREADS
    mov eax, [es:edi + offset ThreadRec.flags]
    or eax, eax
    jz l_s_procinfo_7
      cmp [es:edi + offset ThreadRec.process], ebx
      jnz l_s_procinfo_7
        or esi, eax
        add ecx, [es:edi + offset ThreadRec.tmr_spent]

    l_s_procinfo_7:
  sub edi, VA_THREADS - 4096
  cmp edi, p_threads_max_size
  jb l_s_procinfo_6

mov ebx, [es:ebx + offset ProcessRec.memused]

mov al, 0

l_s_procinfo_9:
mov edx, tmr_total
ret

// IN: edi = threadid, dl = priority
// OUT: al = erc
s_setpriority: // 43
movzx eax, dl
cmp al, 1
jb l_s_setpriority_8
  cmp al, 50
  ja l_s_setpriority_8
  
mov edx, 1193
mul edx  // eax = ticks

shl edi, 12 // assert sizeof ThreadRec = 4096
cmp edi, p_threads_max_size
jb l_s_setpriority_1
  mov al, ERC_INVALID_THREADID
  jmp short l_s_setpriority_9

l_s_setpriority_1:
add edi, VA_THREADS
cmp dword[es:edi + offset ThreadRec.flags], 0
jnz l_s_setpriority_15
  mov al, ERC_INVALID_THREADID
  jmp short l_s_setpriority_9

l_s_setpriority_15:
mov ebx, p_current
cmp edi, ebx
jnz l_s_setpriority_2
  // self
  cmp eax, [es:edi + offset ThreadRec.priority]
  ja l_s_setpriority_2
    
    l_s_setpriority_16:
    mov [es:edi + offset ThreadRec.priority], eax
    mov al, 0
    jmp short l_s_setpriority_9

l_s_setpriority_2:
// starter
push eax
  call s_chkstarter
pop eax
jz l_s_setpriority_16

mov al, ERC_ACCESS_DENIED
jmp short l_s_setpriority_9

l_s_setpriority_8:
mov al, ERC_INVALID_PRIORITY

l_s_setpriority_9:
ret

// IN: ebx = pid, es:edi -> target
s_getprocname: // 44
call s_get_proc_ptr
or al, al
jnz l_s_getprocname_9

cmp edi, VA_ACCESS
jb l_s_getprocname_5
  mov al, ERC_INVALID_MEMORY_LOCATION
  jmp short l_s_getprocname_9

l_s_getprocname_5:
mov esi, ebx
add esi, offset ProcessRec.filename
mov ecx, MAX_PATH

l_s_getprocname_6:
  mov al, [esi]
  inc esi
  stosb
  cmp al, 0
  jz l_s_getprocname_8
    loop l_s_getprocname_6

l_s_getprocname_8:
mov al, 0

l_s_getprocname_9:
ret

// OUT: ebx = pid, edx = ppid, edi = threadid
s_getpid: // 45
mov edi, p_current
mov ebx, [es:edi + offset ThreadRec.process]
mov edx, [es:ebx + offset ProcessRec.previnstance]
sub edi, VA_THREADS
sub ebx, VA_PROCS
sub edx, VA_PROCS
shr edi, 12 // assert sizeof ThreadRec == 4096
shr ebx, 9  // assert sizeof ProcessRec == 512
shr edx, 9  // assert sizeof ProcessRec == 512
ret

s_reloaddisks: // 46
call s_chkstarter
jnz l_s_reloaddisks_9
  call fs_enter
  call h_disks_reset
  call fs_leave

l_s_reloaddisks_9:
ret

// IN: esi = pdiskn, es:edi -> buffer[512]
s_identify:
cmp edi, VA_ACCESS
jnb l_s_identify_28

mov eax, esi
cld

test al, 40h
jz l_s_identify_20
  // sata hard disk
  call h_sd_p_identify
  test al, al
  jz l_s_identify_29
    jmp short l_s_identify_28
  
l_s_identify_20:
// hard disk
call h_hd_prepare_port_slave

mov dx, hdt_port_base
or dx, 7
in al, dx
cmp al, 0FFh
jz l_s_identify_28
  
  push edi
    call h_hd_p_identify
  pop edi
  test al, al
  jz l_s_identify_29 // HD
  
  cmp al, ERC_INVALID_DISK_NUMBER
  jz l_s_identify_28
    // CD/other (erc = 104h)
    call h_hd_p_identifyp
    jmp short l_s_identify_29
  
l_s_identify_28:
xor eax, eax
mov ecx, 512/4
rep stosd

l_s_identify_29:
ret

// IN: eax = scan key
// OUT: eax = state
s_getkeystate: // 49
//and eax, 127
//movzx eax, byte kbd_state[eax]
xor eax, eax
ret

// IN: ebx = uid
s_login: // 50
call s_chkstarter
jnz l_s_login_9
  mov eax, p_current
  mov [es:eax + offset ThreadRec.uid], ebx
  
l_s_login_9:
ret

// IN: ebx = gid
s_logrp: // 51
call s_chkstarter
jnz l_s_logrp_9
  mov eax, p_current
  mov [es:eax + offset ThreadRec.gid], ebx
  
l_s_logrp_9:
ret

// IN: edi -> char[MAX_PATH]
s_getcurdir: // 52
cmp edi, VA_ACCESS
jb l_s_getcurdir_2
  mov al, ERC_INVALID_MEMORY_LOCATION
  ret
  
l_s_getcurdir_2:
mov esi, p_current
add esi, offset ThreadRec.curdirtext
mov ecx, MAX_PATH
cld

l_s_getcurdir_5:
  mov al, [es:esi]
  inc esi
  stosb
  cmp al, 0
  jz l_s_getcurdir_7
    loop l_s_getcurdir_5

  mov al, ERC_TOO_LONG

l_s_getcurdir_7:
ret

// IN: esi -> ldiskn
s_disktype: // 53
and esi, 31
shl esi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.type[esi]
mov ah, disk_info.number[esi]
mov bl, disk_info.fsid[esi]
mov bh, disk_info.partition[esi]
mov ecx, dword ptr disk_info.size_sectors[esi]
mov edx, dword ptr disk_info.size_sectors[esi + 4]
mov edi, dword ptr disk_info.base_sectors[esi + 4]
mov esi, dword ptr disk_info.base_sectors[esi]
ret

// OUT: eax = uid
s_getuid: // 54
mov eax, p_current
mov eax, [es:eax + offset ThreadRec.uid]
ret

// OUT: eax = gid
s_getgid: // 55
mov eax, p_current
mov eax, [es:eax + offset ThreadRec.gid]
ret

// OUT: eax = time zone
s_gettimezone: // 56
mov eax, time_zone
ret

// IN: edx = time zone, OUT: al = erc
s_settimezone: // 57
call s_chkstarter
jnz l_s_settimezone_8
  xchg eax, edx
  cmp eax, -24
  jl l_s_settimezone_7
    cmp eax, 24
    jg l_s_settimezone_7
      mov time_zone, eax
      mov al, 0
      jmp short l_s_settimezone_9

l_s_settimezone_7:
mov al, ERC_INVALID_VALUE
jmp short l_s_settimezone_9

l_s_settimezone_8:
mov al, ERC_ONLY_STARTER

l_s_settimezone_9:
ret

// IN: es:edi -> SystemTime, es:esi -> ftime, max year = 32767
s_systime2ftime: // 58
cmp edi, VA_ACCESS
jb l_s_systime2ftime_1
  mov al, ERC_INVALID_POINTER
  ret
  
l_s_systime2ftime_1:
cmp esi, VA_ACCESS
jb l_s_systime2ftime_2
  mov al, ERC_INVALID_POINTER
  ret

l_s_systime2ftime_2:
jmp t_systime2ftime
//ret

// IN: es:esi -> ftime, es:edi -> SystemTime
s_ftime2systime: // 59
cmp edi, VA_ACCESS
jb l_s_ftime2systime_1
  mov al, ERC_INVALID_POINTER
  ret

l_s_ftime2systime_1:
cmp esi, VA_ACCESS
jb l_s_ftime2systime_2
  mov al, ERC_INVALID_POINTER
  ret
  
l_s_ftime2systime_2:
jmp t_ftime2systime
//ret

// IN: es:edi -> SystemTime
s_getlocal: // 60
cmp edi, VA_ACCESS
jb l_s_getlocal_1
  mov al, ERC_INVALID_POINTER
  ret
  
l_s_getlocal_1:
jmp t_getlocal
//ret

// IN: es:edi -> SystemTime
s_setlocal: // 61
call s_chkstarter
jz l_s_setlocal_1
  mov al, ERC_ONLY_STARTER
  ret
  
l_s_setlocal_1:
cmp edi, VA_ACCESS
jb l_s_setlocal_2
  mov al, ERC_INVALID_POINTER
  ret

l_s_setlocal_2:
jmp t_setlocal
//ret

// IN: es:edi -> SystemTime
s_getsystem: // 62
cmp edi, VA_ACCESS
jb l_s_getsystem_1
  mov al, ERC_INVALID_POINTER
  ret
  
l_s_getsystem_1:
jmp t_getsystem
//ret

// IN: ecx = ms, dx = hwnd, ebx = id, edi = ofs
// OUT: al = 0 || errorcode
s_timer_add: // 64
push edx
  mov eax, 1193
  mul ecx
pop edx
xchg eax, ecx
mov eax, p_current
sub eax, VA_THREADS
shr eax, 12  // sizeof ThreadRec = 4096
shl eax, 16
movzx edx, dx
or edx, eax
jmp h_timer_add
//ret

// IN: dx = hwnd, ebx = id
// OUT: al = 0 || errorcode
s_timer_rm: // 65
mov eax, p_current
sub eax, VA_THREADS
shr eax, 12  // sizeof ThreadRec = 4096
shl eax, 16
movzx edx, dx
or edx, eax
jmp h_timer_remove
//ret

// IN: esi = mode, es:edx -> fname
// OUT: al = erc, ebx = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
s_link_open: // 66
mov eax, esi
mov ah, 1
call fs_fopen
mov ebx, esi
ret

// IN: es:edx -> filename
// OUT: al = erc
s_link_rm: // 67
mov ah, 1
jmp fs_rm
//ret

// IN: ecx = WM_DEVICECHANGE, edx = ldiskn, esi = 0 removed | 1 inserted
// OUT: al = erc
s_sendtoall: // 69
call s_chkstarter
jnz l_s_sendtoall_9
  jmp p_msg_send_to_all

l_s_sendtoall_9:
ret


// OUT: eax = free bytes
s_memfree: // 70
mov eax, m_free
shl eax, 12
ret

// IN: ecx = RAM disk size (max 256 MiB)
// OUT: al = erc, dl = ldiskn
s_create_ramdisk: // 71
call s_chkstarter
jnz l_s_create_ramdisk_9
  call h_rd_create  // OUT al
  test al, al
  jnz l_s_create_ramdisk_3
    mov al, ERC_NOT_ENOUGH_MEMORY
    jmp short l_s_create_ramdisk_9
    
  l_s_create_ramdisk_3:
  push eax
    mov edi, 0  // 1024
    call e2_format
  pop edx
  mov al, 0
  
l_s_create_ramdisk_9:
ret

// OUT: al = boot disk
s_get_boot_disk: // 77
mov al, byte ptr boot_disk
ret

// IN: ecx = uid, edi -> byte[256]
s_get_user: // 80
cmp edi, VA_ACCESS
jb l_s_get_user_1
  mov al, ERC_INVALID_POINTER
  jmp short l_s_get_user_9
  
l_s_get_user_1:
call get_user

l_s_get_user_9:
ret

// IN: ecx = gid, edi -> byte[256]
s_get_group: // 81
cmp edi, VA_ACCESS
jb l_s_get_group_1
  mov al, ERC_INVALID_POINTER
  jmp short l_s_get_group_9
  
l_s_get_group_1:
call get_group

l_s_get_group_9:
ret

// IN: ah = operation
services:

//call wregs//$$$

 push ds
  push es
  
   push SELECTOR_KERNEL_DATA
   pop ds
   push SELECTOR_ALL_DATA
   pop es
   
   movzx eax, ah
   shl eax, 2  // sizeof addr
   add eax, offset services_offsets
   cmp eax, offset services_offsets_end
   jb services_ok
     mov al, ERC_INVALID_SERVICE
     jmp short services_9
     
   services_ok:
   call dword[cs:eax]
   
   services_9:
   
  pop es
 pop ds

iretd

delay:
jmp short l_delay_8
l_delay_8:
ret

// DESTROY: al
empty_8042:
call delay
in al, 0x64		// 8042 status port
test al, 1		// Anything to read?
jz l_empty_8042_no_output
	call delay
	in al, 0x60	// Read it
	jmp	empty_8042
l_empty_8042_no_output:
test al, 2		// Is input buffer full?
jnz	empty_8042
ret

// IN: dl = x, dh = y
// DESTROY: ax, cx, dx
cursorto:
mov al, dh
mov ah, 80
mul ah
add al, dl
adc ah, 0
mov cx, ax
mov dx, 3D4h
mov al, 0Fh
out dx, al
mov al, cl
inc dx
out dx, al
dec dx
mov al, 0Eh
out dx, al
mov al, ch
inc dx
out dx, al
ret

TSCR_W = 80
TSCR_H = 25

// IN: cs:esi->string, cur_pos, ds = KERNEL_DATA
// OUT: cur_pos
writec:
push es
 push edi
  push edx
   push ecx
    push eax

mov cx, SELECTOR_TEXTVIDEO
mov es, cx

mov dx, cur_pos
call writec_calc

l_writec_1:
  mov al, [cs:esi]
  inc esi
  cmp al, 0
  jz l_writec_9
    cmp al, 13
    jz l_writec_1  // ignore CR

    cmp al, 10  // LF = new line
    jnz l_writec_3
      xor dl, dl
      inc dh
      cmp dh, TSCR_H
      jnb l_writec_2
        call writec_calc
        jmp l_writec_1
      
      l_writec_2:
      call l_writec_over_screen
      jmp l_writec_1
      
    l_writec_3:
    stosb
    inc edi  // skip color
    inc dl
    cmp dl, TSCR_W
    jb l_writec_1
    
    xor dl, dl
    inc dh
    cmp dh, TSCR_H
    jb l_writec_1
    
    call l_writec_over_screen
    jmp l_writec_1

l_writec_9:
mov cur_pos, dx
call cursorto

    pop eax
   pop ecx
  pop edx
 pop edi
pop es
ret

// IN: dl = curx, dh = cury
// OUT: edi
writec_calc:  // also used by writen
push edx
  movzx eax, dh
  mov edi, 80
  mul edi  // eax = dh * 80
pop edx
add al, dl
adc ah, 0
shl eax, 1
mov edi, eax  // edi = (dh * 80 + dl) * 2
ret

// IN: dl, dh, es = SELECTOR_TEXTVIDEO
// OUT: dl, dh, edi
l_writec_over_screen:	// also used by writen, s_write
dec dh
push esi
 push ecx
  push ds
    push es
    pop ds
    mov esi, TSCR_W * 2
    xor edi, edi
    mov ecx, TSCR_W * (TSCR_H - 1) * 2 / 4
    cld
    rep movsd
    mov ax, 0x0720
    mov ecx, TSCR_W
    rep stosw
  pop ds
 pop ecx
pop esi
mov edi, TSCR_W * (TSCR_H - 1) * 2
ret

// IN: eax = number, ecx = base, cur_pos, ds
// OUT: cur_pos
writen:
push ecx
 push edx
  push ebx
   push es
    push edi

sub esp, 36

// Parse digits from the number

mov ebx, esp
cmp ecx, 2
jnb l_writen_1
  mov ecx, 10  // ecx must be >= 2

l_writen_1:
  xor edx, edx
  div ecx
  cmp dl, 10
  jnb l_writen_2
    add dl, '0'
    jmp short l_writen_3
  
  l_writen_2:
  add dl, 55
  
  l_writen_3:
  mov [ss:ebx], dl
  inc ebx
  test eax, eax
  jnz l_writen_1

mov dl, ' '
mov [ss:ebx], dl
inc ebx

mov ecx, ebx
sub ecx, esp  // ecx = len

// Write it

mov ax, SELECTOR_TEXTVIDEO
mov es, ax

mov dx, cur_pos
call writec_calc

l_writen_8:
  jcxz l_writen_9
    dec ebx
    dec ecx
    mov al, [ss:ebx]
    stosb
    inc edi
    inc dl
    cmp dl, TSCR_W
    jb l_writen_8
    
    xor dl, dl
    inc dh
    cmp dh, TSCR_H
    jb l_writen_8
    
    call l_writec_over_screen
    jmp l_writen_8

l_writen_9:
mov cur_pos, dx
call cursorto

add esp, 36
    
    pop edi
   pop es
  pop ebx
 pop edx
pop ecx
ret

TMR_MAX = SIZE_TMR / sizeof TmrRec

TMR_PREEMPT_MS = 10
TMR_MAX_MS     = 50

TMR_THREADID_WND_PREEMPT = 0FFFFF000h
TMR_THREADID_WND_WAKE    = 0F001h
TMR_THREADID_WND_FDSTOP  = 0FFFFF002h
TMR_THREADID_WND_MS      = 0FFFFF003h

TMR_FLAGS_PREEMPT = 1
TMR_FLAGS_MS = 2

[dalign 32]
uns4 tmr_len, tmr_t_ofs
uns1 tmr_flags, tmr_ms_seconds

// Set Timer
// IN: dx = number of ticks
h_timer_set:
mov al, 30h
out 43h, al
mov al, dl
out 40h, al
mov al, dh
out 40h, al
ret

// Read Timer
// OUT: ax = number of ticks
h_timer_read:
mov al, 0
out 43h, al
in al, 40h
xchg al, ah
in al, 40h
xchg al, ah
ret

// IN: ecx = ticks, edx = threadid_wnd, ebx = id, tmr_t_ofs = ofs
// OUT: al = 0 || errorcode
// DESTROY: eax, esi, edi
h_timer_add_inner:
mov eax, tmr_len  // eax = len
cmp eax, TMR_MAX * sizeof TmrRec
jb l_h_timer_add_inner_1
  mov al, ERC_TIMER_FULL
  ret

l_h_timer_add_inner_1:
mov esi, PA_TMR
mov edi, esi
add edi, eax  // edi = base + len

cmp edi, esi
jz l_h_timer_add_inner_6	// first and only

// Insert to delta queue
l_h_timer_add_inner_2:
  cmp edi, esi
  jng l_h_timer_add_inner_6
    // edi > esi
    sub edi, sizeof TmrRec
    mov eax, [edi]  // eax = ticks
    cmp ecx, eax
    jna l_h_timer_add_inner_5
      // new_ms > old_ms: [i+1] = [i]
      sub ecx, eax  // new_ms -= old_ms
      mov [edi + sizeof TmrRec + offset TmrRec.ticks], eax
      
      mov eax, [edi + offset TmrRec.threadid_wnd]
      mov [edi + sizeof TmrRec + offset TmrRec.threadid_wnd], eax
      
      mov eax, [edi + offset TmrRec.id]
      mov [edi + sizeof TmrRec + offset TmrRec.id], eax
      
      mov eax, [edi + offset TmrRec.ofs]
      mov [edi + sizeof TmrRec + offset TmrRec.ofs], eax
      
      jmp l_h_timer_add_inner_2
      
    l_h_timer_add_inner_5:
    sub [edi + offset TmrRec.ticks], ecx  // old_ms -= new_ms
    add edi, sizeof TmrRec
    
l_h_timer_add_inner_6:
// Proper space found at edi: store new rec
mov [edi + offset TmrRec.ticks], ecx
mov [edi + offset TmrRec.threadid_wnd], edx
mov [edi + offset TmrRec.id], ebx
mov eax, tmr_t_ofs
mov [edi + offset TmrRec.ofs], eax
// tmr_len++
add tmr_len, sizeof TmrRec

mov al, 0
ret

// IN: tmr_len
// OUT: tmr_len, tmr_flags
// DESTROY: eax, ecx, edx, esi, edi
h_timer_process:
mov esi, PA_TMR
mov edi, tmr_len
mov tmr_flags, 0
add edi, esi  // edi = esi + len

l_h_timer_process_1:
  cmp edi, esi
  jg l_h_timer_process_2

l_h_timer_process_8:
ret

  l_h_timer_process_2:
    // edi > esi
    sub edi, sizeof TmrRec
    mov eax, [edi + offset TmrRec.ticks]
    test eax, eax
    jnz l_h_timer_process_8
      // last.ms == 0
      sub tmr_len, sizeof TmrRec  // tmr_len--
      mov eax, [edi + offset TmrRec.threadid_wnd]
      cmp ax, 0F000h
      jb l_h_timer_process_5

        // * System timers *

        cmp ax, TMR_THREADID_WND_PREEMPT
        jnz l_h_timer_process_31

          // Preempt
          or tmr_flags, TMR_FLAGS_PREEMPT
          jmp l_h_timer_process_1
          
        l_h_timer_process_31:
        cmp ax, TMR_THREADID_WND_WAKE
        jnz l_h_timer_process_32
                  
          // Wake
          push esi
           push edi
            mov edi, [edi + offset TmrRec.id]
            and byte ptr [es:edi + offset ThreadRec.flags], -1 - THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
            call p_start  // edi = thread VA
           pop edi
          pop esi
          jmp l_h_timer_process_1
          
        l_h_timer_process_32:
        cmp ax, TMR_THREADID_WND_FDSTOP
        jnz l_h_timer_process_33
        
          // Stop FD motor
          call h_fd_stop_motor_mask
          jmp l_h_timer_process_1
          
        l_h_timer_process_33:
        cmp ax, TMR_THREADID_WND_MS
        jnz l_h_timer_process_34
        
          // inc ms
          inc tmr_ms
          mov al, 0
          out 70h, al  // RTC seconds
          in al, 71h
          cmp al, tmr_ms_seconds
          jz l_h_timer_process_331
            mov tmr_ms_seconds, al
            xor eax, eax
            mov tmr_ms, ax
            
          l_h_timer_process_331:
          or tmr_flags, TMR_FLAGS_MS
          jmp l_h_timer_process_1
          
        l_h_timer_process_34:
        //... error
        jmp l_h_timer_process_1
        
      l_h_timer_process_5:
      
      // * Window timer *
      
      // data at [edi + offset TmrRec.x]
      // Send message(ebx = wnd:threadid, ecx = msg, edx = wp, esi = lp)
      push ecx
       push ebx
        push esi
         push edi
          mov ebx, eax  // ebx = threadid:wnd
          mov edx, eax
          shr ebx, 16
          shl edx, 16
          or ebx, 16384
          or ebx, edx   // ebx = wnd:(threadid+16384)
          mov ecx, WM_TIMER
          mov edx, [edi + offset TmrRec.id]
          xor esi, esi  // lp = 0
          xor edi, edi  // sender = 0 (system)
          call p_msg_send
         pop edi
        pop esi
       pop ebx
      pop ecx
      jmp l_h_timer_process_1
      
// <-- h_timer_process

// IN: tmr_len, tmr_total
// OUT: tmr_total
// DESTROY: eax, edx, ebx, esi, edi
h_timer_set_first:

// Make ticks

mov esi, PA_TMR
mov edi, tmr_len  // edi = len
or edi, edi
jnz l_h_timer_set_first_2

  // No record
  mov ax, TMR_MAX_MS * 1193
  jmp short l_h_timer_set_first_6
  
l_h_timer_set_first_2:
add edi, esi
sub edi, sizeof TmrRec  // edi = esi + len - 1
mov eax, [edi + offset TmrRec.ticks]  // eax = last.ticks
cmp eax, TMR_MAX_MS * 1193
ja l_h_timer_set_first_4

  // ms <= 50; eax = ticks
  xor ebx, ebx
  mov [edi + offset TmrRec.ticks], ebx  // last.ticks = 0
  jmp short l_h_timer_set_first_6

l_h_timer_set_first_4:
  // ms > 50; eax = ticks
  sub eax, TMR_MAX_MS * 1193
  mov [edi + offset TmrRec.ticks], eax  // last.ticks -= max
  mov ax, TMR_MAX_MS * 1193

l_h_timer_set_first_6:

// Set timer by ticks; IN: ax = ticks
movzx edx, ax
call h_timer_set  // KEEP edx

// Add ticks to CurrentThread and total
mov edi, p_current
add [es:edi + offset ThreadRec.tmr_spent], edx

add tmr_total, edx

ret

// BEFORE: p_init
// IN: PA_TMR, SIZE_TMR
h_timer_init:
xor eax, eax
mov tmr_flags, al  // flags = 0
mov tmr_len, eax   // len = 0
mov tmr_total, eax // total = 0
mov tmr_ms, ax
mov tmr_ms_seconds, al

mov ecx, TMR_PREEMPT_MS * 1193
mov edx, TMR_THREADID_WND_PREEMPT
xor ebx, ebx
mov tmr_t_ofs, ebx
call h_timer_add_inner

mov ecx, 1194
mov edx, TMR_THREADID_WND_MS
xor ebx, ebx
mov tmr_t_ofs, ebx
call h_timer_add_inner

call h_timer_set_first

ret

// IN: ecx = ticks, edx = threadid_wnd, ebx = id, edi = ofs
// OUT: al = 0 || errorcode, esi = base
h_timer_add:
mov tmr_t_ofs, edi

pushfd
cli

mov eax, tmr_len
cmp eax, TMR_MAX * sizeof TmrRec
jb l_h_timer_add_1
  
  popfd
  
  mov al, ERC_TIMER_FULL
  
  ret

l_h_timer_add_1:
mov esi, PA_TMR  // esi = base

test eax, eax
jz l_h_timer_add_6 // first and only
  
  mov edi, esi
  add edi, eax     // edi = base + len
  
  // Update last.ticks by timer
  xor eax, eax
  call h_timer_read
  add [edi - sizeof TmrRec + offset TmrRec.ticks], eax
  
l_h_timer_add_6:
// Insert to delta queue
call h_timer_add_inner

// Process 0s
call h_timer_process

// Set timer by last.ticks
call h_timer_set_first

popfd

mov al, 0
ret

// IN: edx = threadid_wnd, ebx = id
// OUT: al = 0 || errorcode
h_timer_remove:

pushfd
cli

mov esi, PA_TMR  // esi = base
mov eax, tmr_len

mov edi, esi
add edi, eax     // edi = base + len
// find edx, ebx
l_h_timer_remove_2:
  cmp edi, esi
  jng l_h_timer_remove_6
    // edi > esi
    sub edi, sizeof TmrRec
    cmp edx, [edi + offset TmrRec.threadid_wnd]
    jnz l_h_timer_remove_2
      cmp ebx, [edi + offset TmrRec.id]
      jnz l_h_timer_remove_2

l_h_timer_remove_5:
// Found, esi = base
mov eax, tmr_len
sub eax, sizeof TmrRec
mov tmr_len, eax  // tmr_len--
mov ebx, esi
add ebx, eax      // ebx = base + new_len

cmp edi, esi
jna l_h_timer_remove_52
  // edi > base
  mov ecx, [edi + offset TmrRec.ticks]
  add [edi - sizeof TmrRec + offset TmrRec.ticks], ecx

l_h_timer_remove_52:
cmp edi, ebx
jnb l_h_timer_remove_7
    // edi < ebx: [i] = [i+1]
    mov ecx, [edi + sizeof TmrRec + offset TmrRec.ticks]
    mov eax, [edi + sizeof TmrRec + offset TmrRec.threadid_wnd]
    mov [edi + offset TmrRec.ticks], ecx
    mov [edi + offset TmrRec.threadid_wnd], eax
    mov ecx, [edi + sizeof TmrRec + offset TmrRec.id]
    mov eax, [edi + sizeof TmrRec + offset TmrRec.ofs]
    mov [edi + offset TmrRec.id], ecx
    mov [edi + offset TmrRec.ofs], eax
  
    add edi, sizeof TmrRec
    jmp l_h_timer_remove_52
  
  l_h_timer_remove_6:
  mov al, ERC_TIMER_NOT_FOUND
  jmp short l_h_timer_remove_9
  
l_h_timer_remove_7:
mov al, 0

l_h_timer_remove_9:

popfd

ret

// IN: edi = threadptr
// KEEP: edi
h_timer_remove_all:
push edi
 pushfd
  cli
  
  // threadptr -> threadid
  mov edx, edi
  sub edx, VA_THREADS
  shr edx, 12 // assert sizeof ThreadRec = 4096
  
  mov esi, PA_TMR
  mov edi, esi
  mov ebx, tmr_len
  add ebx, esi  // ebx = base + len
/*  
  cmp ebx, esi
  jz h_timer_remove_all_5
    
    // Update last.ticks by timer
    xor eax, eax
    call h_timer_read
    add [ebx - sizeof TmrRec + offset TmrRec.ticks], eax
*/    
  h_timer_remove_all_5:
    cmp esi, ebx
    jnb h_timer_remove_all_8
      cmp word ptr [esi + offset TmrRec.threadid_wnd + 2], dx
      jz h_timer_remove_all_6
        add edi, sizeof TmrRec
        jmp short h_timer_remove_all_7
        
      h_timer_remove_all_6:
      cmp edi, PA_TMR
      jna h_timer_remove_all_7
        mov eax, [esi + offset TmrRec.ticks]
        add [edi + offset TmrRec.ticks - sizeof TmrRec], eax
        
      h_timer_remove_all_7:
      add esi, sizeof TmrRec
      cmp esi, edi
      jz h_timer_remove_all_5
        mov eax, [esi + 0]
        mov ecx, [esi + 4]
        mov [edi + 0], eax
        mov [edi + 4], ecx
        mov eax, [esi + 8]
        mov ecx, [esi + 12]
        mov [edi + 8], eax
        mov [edi + 12], ecx
        jmp h_timer_remove_all_5
      
  h_timer_remove_all_8:
  sub edi, PA_TMR
  mov tmr_len, edi
/*  
  // Process 0s
  call h_timer_process
  
  // Set timer by last.ticks
  call h_timer_set_first
*/
 popfd
pop edi
ret

IRQ0:
pusha
 push ds
  push es
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx  // es = ALLMEM

    // Process ms == 0
    mov esi, PA_TMR
    call h_timer_process

    // System timer of preemption
    test tmr_flags, TMR_FLAGS_PREEMPT
    jz l_IRQ0_6
      mov ebx, p_current
      mov edi, [es:ebx + offset ThreadRec.next]
      mov ecx, [es:edi + offset ThreadRec.priority]
      mov edx, TMR_THREADID_WND_PREEMPT
      xor ebx, ebx
      mov tmr_t_ofs, ebx
      call h_timer_add_inner

    l_IRQ0_6:
    // ms
    test tmr_flags, TMR_FLAGS_MS
    jz l_IRQ0_7
      mov ecx, 1194
      mov edx, TMR_THREADID_WND_MS
      xor ebx, ebx
      mov tmr_t_ofs, ebx
      call h_timer_add_inner
    
    l_IRQ0_7:
    // Set timer by last.ticks, IN: es:esi
    call h_timer_set_first

    // End of ISR
    mov al, 0x20
    out 0x20, al

    // Preempt?
    test tmr_flags, TMR_FLAGS_PREEMPT
    jz l_IRQ0_8

      mov esi, p_current
      mov edi, [es:esi + offset ThreadRec.next]
      call p_switch_task

    l_IRQ0_8:

  pop es
 pop ds
popa
iretd

KBD_LED_SCROLL = 1
KBD_LED_NUM    = 2
KBD_LED_CAPS   = 4

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000

KBD_KCTRL = 0x1D
KBD_KLSH  = 0x2A
KBD_KRSH  = 0x36
KBD_KALT  = 0x38
KBD_KCPSLK = 0x3A
KBD_KNUMLK = 0x45
KBD_KSCRLK = 0x46

uns1 kbd_special

[dalign 16]
uns2 kbd_shifts

// IN: ah = LEDs bitmap
// DESTROY: al
h_kbd_set_leds:
call empty_8042
mov al, 0xED
out 0x60, al
call empty_8042
mov al, ah
out 0x60, al
ret

// IN: al = scan code, ch & 0x80 = key dropped,
//     ah = 1 || 2, kbd_shifts
// DESTROY: eax, ecx, edx, ebx, esi, edi
h_kbd_send_message:
test ch, 0x80
jz l_h_kbd_send_message5
  mov ecx, WM_KEYUP	// ecx = WM_KEYUP
  jmp short l_h_kbd_send_message6

l_h_kbd_send_message5:
mov ecx, WM_KEYDOWN	// ecx = WM_KEYDOWN

l_h_kbd_send_message6:
// Send Message
// IN: ebx = wnd:target, ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
mov ebx, 16384
movzx edx, al          // edx = scan code + ((0 || 1) * 100h)
test ah, 2
jz l_h_kbd_send_message7
  or dx, 256

l_h_kbd_send_message7:
movzx esi, kbd_shifts  // esi = kbd_shifts
call p_msg_send

l_h_kbd_send_message8:
ret

// IN: ds
h_kbd_init:
xor eax, eax
mov kbd_special, al
mov kbd_shifts, ax

push es

 push ds
 pop es
 mov edi, offset kbd_state
 mov ecx, 128
 cld
 rep stosb

pop es

ret

IRQ1:
pushad
 push ds
  push es
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx	// ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx	// es = ALLMEM
    
    in al, 0x60
    cmp al, 0xE0
    jnz l_IRQ1_0
      // Special
      mov kbd_special, 1
      jmp short l_IRQ1_99

    l_IRQ1_0:
    cmp al, 0xE1
    jnz l_IRQ1_1
      mov kbd_special, 2
    
    l_IRQ1_99:
  mov al, 0x20
  out 0x20, al
  pop es
 pop ds
popad
iretd

l_IRQ1_1:
mov ch, al
and al, 127
movzx ebx, al
mov ah, 1
mov cl, kbd_special
shl ah, cl
test ch, 0x80
jnz l_IRQ1_5
  or kbd_state[ebx], ah
  jmp short l_IRQ1_6

l_IRQ1_5:
  not ah
  and kbd_state[ebx], ah
  not ah

l_IRQ1_6:
cmp al, KBD_KCTRL
jz l_IRQ1_71
 cmp al, KBD_KALT
 jz l_IRQ1_72
  cmp al, KBD_KLSH
  jz l_IRQ1_73
   cmp al, KBD_KRSH
   jz l_IRQ1_74
    jmp l_IRQ1_8

// Shifts
l_IRQ1_71:
test ah, 4
jz l_IRQ_715
  mov dx, KBD_VCTRL
  jmp short l_IRQ1_7x

l_IRQ_715:
mov dx, KBD_CTRL
test ah, 2
jz l_IRQ1_7x
  or dx, KBD_RCTRL
  jmp short l_IRQ1_7x

l_IRQ1_72:
mov dx, KBD_ALT
test ah, 2
jz l_IRQ1_7x
  or dx, KBD_RALT
  jmp short l_IRQ1_7x

l_IRQ1_73:
mov dx, KBD_LSH
jmp short l_IRQ1_7x

l_IRQ1_74:
mov dx, KBD_RSH

l_IRQ1_7x:
test ch, 0x80
jnz l_IRQ1_7x5
  or kbd_shifts, dx
  jmp short l_IRQ1_9

l_IRQ1_7x5:
  not dx
  and kbd_shifts, dx
  jmp short l_IRQ1_9

// Locks
l_IRQ1_8:
test ch, 0x80
jnz l_IRQ1_9
  cmp al, KBD_KNUMLK
  jnz l_IRQ1_81
    test kbd_shifts, KBD_VCTRL
    jnz l_IRQ1_9
      xor byte kbd_shifts, KBD_NUMLK
      jmp short l_IRQ1_8x

  l_IRQ1_81:
  cmp al, KBD_KCPSLK
  jnz l_IRQ1_82
    xor byte kbd_shifts, KBD_CPSLK
    jmp short l_IRQ1_8x

  l_IRQ1_82:
  cmp al, KBD_KSCRLK
  jnz l_IRQ1_9
    xor byte kbd_shifts, KBD_SCRLK
    jmp short l_IRQ1_8x

l_IRQ1_8x:
xchg eax, ebx	// ebx = eax

 mov al, 0x20	// End of ISR
 out 0x20, al

 sti

 mov ah, byte kbd_shifts
 shr ah, 4
 and ah, 7
 call h_kbd_set_leds

xchg eax, ebx	// eax = ebx
jmp short l_IRQ1_95

l_IRQ1_9:
xchg eax, ebx	// ebx = eax

 mov al, 0x20	// End of ISR
 out 0x20, al

xchg eax, ebx	// eax = ebx

l_IRQ1_95:
call h_kbd_send_message
mov kbd_special, 0

  pop es
 pop ds
popa
iretd

uns1 ms_packetsize, ms_resolution, ms_samplerate

[dalign 32]
uns4 ms_packet
uns1 ms_cnt, ms_btn   // keep order
uns2 ms_x, ms_y, ms_z // keep order

uns1 ms_btn_old
uns2 ms_x_old, ms_y_old, ms_z_old

// dl=1 read, dl=2 write
h_ps2mouse_wait:
mov ecx, 1000
// (*
l_h_ps2mouse_wait_1:
in al, 64h
and al, dl
jnz l_h_ps2mouse_wait_2
  dec ecx
  jnz l_h_ps2mouse_wait_1
// *)
l_h_ps2mouse_wait_2:
ret

h_ps2mouse_write:
mov dh, al
mov dl, 2
call h_ps2mouse_wait
mov al, 0D4h
out 64h, al
call h_ps2mouse_wait
mov al, dh
out 60h, al
// no ret, fall into read code to read ack
h_ps2mouse_read:
mov dl, 1
call h_ps2mouse_wait
in al, 60h
ret

h_ps2mouse_init:
mov  ms_resolution, 3
mov  ms_samplerate, 200
// initialize legacy ps2 user input
xor  eax, eax
mov  dl, 2
call h_ps2mouse_wait
mov  al, 0A8h
out  64h, al
// get ack
call h_ps2mouse_read
// some compaq voodoo magic to enable irq12
mov  dl, 2
call h_ps2mouse_wait
mov  al, 020h
out  64h, al
mov  dl, 1
call h_ps2mouse_wait
in   al, 60h
bts  ax, 1
btr  ax, 5
mov  bl, al
mov  dl, 2
call h_ps2mouse_wait
mov  al, 060h
out  64h, al
call h_ps2mouse_wait
mov  al, bl
out  60h, al
// get optional ack
mov  dl, 1
call h_ps2mouse_wait

// restore to defaults
mov  al, 0F6h
call h_ps2mouse_write
// enable Z axis
mov  al, 0F3h
call h_ps2mouse_write
mov  al, 200
call h_ps2mouse_write
mov  al, 0F3h
call h_ps2mouse_write
mov  al, 100
call h_ps2mouse_write
mov  al, 0F3h
call h_ps2mouse_write
mov  al, 80
call h_ps2mouse_write
mov  al, 0F2h
call h_ps2mouse_write
call h_ps2mouse_read
mov  ms_packetsize, 3
or   al, al
jz l_h_ps2mouse_init_noZaxis
  mov ms_packetsize, 4
l_h_ps2mouse_init_noZaxis:
// enable 4th and 5th buttons
mov  al, 0F3h
call h_ps2mouse_write
mov  al, 200
call h_ps2mouse_write
mov  al, 0F3h
call h_ps2mouse_write
mov  al, 200
call h_ps2mouse_write
mov  al, 0F3h
call h_ps2mouse_write
mov  al, 80
call h_ps2mouse_write
mov  al, 0F2h
call h_ps2mouse_write
call h_ps2mouse_read

// set sample rate
mov  al, 0F3h
call h_ps2mouse_write
mov  al, ms_samplerate // 200
call h_ps2mouse_write
// set resolution
mov  al, 0E8h
call h_ps2mouse_write
mov  al, ms_resolution  // 3
call h_ps2mouse_write
// set scaling 1:1
mov  al, 0E6h
call h_ps2mouse_write
// enable
mov  al, 0F4h
call h_ps2mouse_write

// reset variables
xor eax, eax
mov dword ms_cnt, eax
mov dword ms_y, eax
ret

IRQ12:
pushad
 push ds
  push es
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx  // es = ALLMEM
    
    mov ecx, 255
    xor eax, eax
    
    l_IRQ12_waitkey:
    in  al, 64h
    dec cl
    jnz l_IRQ12_2
    
   l_IRQ12_9:
   mov al, 20h
   out 20h, al
   
  pop es
 pop ds
popad
iretd

l_IRQ12_2:
test al, 20h
jz l_IRQ12_waitkey

in  al, 60h
mov cl, al
in  al, 61h
out 61h, al
xor ebx, ebx
mov bl, ms_cnt
add ebx, offset ms_packet
mov byte [ebx], cl
inc byte ms_cnt
mov bl, ms_cnt
cmp bl, ms_packetsize
jb l_IRQ12_9
mov ms_cnt, 0

// get buttons state
l_IRQ12_5:
mov al, byte ms_packet
and al, 7
mov cl, byte [offset ms_packet+3]
and cl, 0F0h
cmp cl, 0F0h
je l_IRQ12_no45btn
  shr cl, 1
  or  al, cl
l_IRQ12_no45btn:
mov ms_btn, al
// get delta X
movsx eax, byte [offset ms_packet+1]
add ms_x, ax
// get delta Y
movsx eax, byte [offset ms_packet+2]
add ms_y, ax
// get delta Z
mov cl, byte [offset ms_packet+3]
and cl, 0Fh
cmp cl, 8
jb l_IRQ12_z5
  or cl, 0F0h
l_IRQ12_z5:
movsx eax, cl
add   ms_z, ax

// Send message(s)
mov ax, ms_x
cmp ax, ms_x_old
jnz l_IRQ12_m1
  mov ax, ms_y
  cmp ax, ms_y_old
  jz l_IRQ12_m2

l_IRQ12_m1:
//... send message WM_MOUSE_MOVE
mov ax, ms_x
mov ms_x_old, ax
mov ax, ms_y
mov ms_y_old, ax

l_IRQ12_m2:
mov al, ms_btn
cmp al, ms_btn_old
jz l_IRQ12_m3
  //... send message WM_MOUSE_BUTTON
  mov al, ms_btn
  mov ms_btn_old, al

l_IRQ12_m3:
jmp l_IRQ12_9

DMA_MODE_DEMAND   = 0
DMA_MODE_SINGLE   = 40h
DMA_MODE_BLOCK    = 80h
DMA_MODE_CASCADE  = 0C0h
DMA_MODE_INC      = 0
DMA_MODE_DEC      = 20h
DMA_MODE_AUTOINIT = 10h
DMA_MODE_VERIFY   = 0
DMA_MODE_READ     = 6
DMA_MODE_WRITE    = 0Ah

DMA_PORTOFS_MODE    = 0
DMA_PORTOFS_MASK    = 1
DMA_PORTOFS_CLEARFF = 2
DMA_PORTOFS_PAGE    = 3
DMA_PORTOFS_ADR     = 4
DMA_PORTOFS_COUNT   = 5

dma_ports_const:
// mode, mask, clear flip-flop, page, address, count, -, -
// DMA 0
db 0Bh, 0Ah, 0Ch, 87h, 0, 1, 0, 0
// DMA 1
db 0Bh, 0Ah, 0Ch, 83h, 2, 3, 0, 0
// DMA 2
db 0Bh, 0Ah, 0Ch, 81h, 4, 5, 0, 0
// DMA 3
db 0Bh, 0Ah, 0Ch, 82h, 6, 7, 0, 0
// DMA 4
db 0D6h, 0D4h, 0D8h, 8Fh, 0C0h, 0C2h, 0, 0
// DMA 5
db 0D6h, 0D4h, 0D8h, 8Bh, 0C4h, 0C6h, 0, 0
// DMA 6
db 0D6h, 0D4h, 0D8h, 89h, 0C8h, 0CAh, 0, 0
// DMA 7
db 0D6h, 0D4h, 0D8h, 8Ah, 0CCh, 0CEh, 0, 0

h_dma_init:
ret

// IN: al = channel, ah = mode
//     ecx = count, ebx = memory addr
// DESTROY: edx, esi
// OUT: al = 0 || errorcode
l_h_dma_read_xchn:
mov al, ERC_INVALID_CHANNEL_NUMBER
ret

l_h_dma_read_xmemadr:
mov al, ERC_INVALID_MEMORY_ADDRESS
ret

l_h_dma_read_xcount:
mov al, ERC_INVALID_COUNT
ret


h_dma_read:
or ah, DMA_MODE_READ

l_h_dma_common:
cmp al, 8
jnb l_h_dma_read_xchn

movzx esi, al
shl esi, 3     // esi = channel offset

cmp ebx, 0xFFFFFF
ja l_h_dma_read_xmemadr

dec ecx
cmp ecx, 65536
jnb l_h_dma_read_xcount

pushfd
cli

// Disable Channel
and al, 3
xor edx, edx
or al, 4	// al = 4 + (channel & 3)
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_MASK]
out dx, al

// Set Transfer Count
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_CLEARFF]
out dx, al
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_COUNT]
mov al, cl
out dx, al
call delay
mov al, ch
out dx, al

// Set Memory Address
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_CLEARFF]
out dx, al
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_ADR]
mov al, bl
out dx, al
call delay
mov al, bh
out dx, al
shr ebx, 16
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_PAGE]
mov al, bl
out dx, al

// Set Mode
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_MODE]
mov al, ah
out dx, al

// Enable Channel
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_MASK]
mov eax, esi
shr eax, 3
and al, 3
out dx, al

popfd

mov al, 0
ret

// IN: al = channel, ah = mode
//     ecx = count, ebx = memory addr
// DESTROY: edx, esi
// OUT: al = 0 || errorcode
h_dma_write:
or ah, DMA_MODE_WRITE

jmp l_h_dma_common

// IN: al = channel
// DESTROY: eax, edx, esi
h_dma_release:
and al, 7
movzx esi, al
shl esi, 3     // esi = channel offset
and al, 3
xor edx, edx
or al, 4       // al = 4 + (channel & 3)
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_MASK]
out dx, al
ret

// IN: ch = bus(0..255), cl = slot/device(0..31),
//     dh = function(0..8), dl = offset(%4=0)
// OUT: eax = value
h_pci_get:
push edx
  movzx eax, ch
  shl eax, 5
  or al, cl
  shl eax, 3
  or al, dh
  shl eax, 8
  or al, dl
  or eax, 0x80000000
  pushfd
    cli
    mov dx, 0xCF8
    out dx, eax
    mov dx, 0xCFC
    in eax, dx
  popfd
pop edx
ret

// IN: eax = value, ch = bus(0..255), cl = slot/device(0..31),
//     dh = function(0..8), dl = offset(%4=0)
h_pci_set:
push edx
 push ecx
  push eax 
    movzx eax, ch
    shl eax, 5
    or al, cl
    shl eax, 3
    or al, dh
    shl eax, 8
    or al, dl
    or eax, 0x80000000
  pop ecx
  pushfd
    cli    
    mov dx, 0xCF8
    out dx, eax
    mov dx, 0xCFC
    mov eax, ecx
    out dx, eax
  popfd
 pop ecx
pop edx
ret

DISK_TYPE_FD = 2
DISK_TYPE_CD = 3
DISK_TYPE_HD = 4
DISK_TYPE_RD = 5

DISK_FLAGS_DIRTY = 1

ATA_CMD_READ         = 0x20
ATA_CMD_WRITE        = 0x30
ATA_CMD_READ_EX      = 0x24
ATA_CMD_WRITE_EX     = 0x34
ATA_CMD_FLUSH        = 0xE7
ATA_CMD_READ_DMA     = 0xC8
ATA_CMD_READ_DMA_EX  = 0x25
ATA_CMD_WRITE_DMA    = 0xCA
ATA_CMD_WRITE_DMA_EX = 0x35
ATA_CMD_PACKET       = 0xA0
ATA_CMD_IDENTIFYP    = 0xA1
ATA_CMD_FLUSH_EX     = 0xEA
ATA_CMD_IDENTIFY     = 0xEC
ATA_CMD_DIAGNOSTIC   = 0x90 // 0x90 / 0x1Dh

SCSI_COMMAND_READ10   = 28h
SCSI_COMMAND_CAPACITY = 25h

ATA_DEV_BUSY = 0x80
ATA_DEV_DRQ  = 0x08

[dalign 32]
uns4 abar, sd_base, sd_port_n, sd_port_ebx
uns4 rd_base, rd_size

[dalign 64]
uns8 sd_sect

uns1 rd_ldiskn

struct FdInfoRec{
  uns1 state, tracklen, gap3, gap3format
  uns4 size
}

struct FdCacheRec{
  uns4 sectn
  uns1 dirty, diskn
  uns2 usg
  uns1 data[512]
}

FD_CACHE_PA    = PA_DMA_BUFFERS
FD_CACHE_SIZE  = 0x8000
FD_CACHE_COUNT = FD_CACHE_SIZE / sizeof FdCacheRec

FD_STOPMOTORMS = 1000

uns1 fd_curdisk, fd_curtrack, fd_motor, fdt_pdiskn, fd_ro
bool fdt_end

[dalign 16]
uns2 fdt_relofs, fdt_endrelofs

[dalign 32]
uns4 fdt_sectn, fdt_count

FdInfoRec fd_info[2]

uns4 fdt_savecount
uns4 fdt_saveofs[FD_CACHE_COUNT]

uns1 fd_buffer[512]  // also used by cd

fd_geometries:
// valid, sectors per track, gap3, gap3format, size
// 0 - none
db 0, 18, 1Bh, 6Ch
dd 0
// 1 - 360
db 1,  9, 2Ah, 50h
dd 720
// 2 - 1.2
db 1, 15, 1Bh, 54h
dd 2400
// 3 - 720
db 1,  9, 2Ah, 50h
dd 1440
// 4 - 1.44
db 1, 18, 1Bh, 6Ch
dd 2880
// 5 - 2.88
db 1, 36, 1Bh, 54h
dd 5760

FD_COMMAND_SEEK        = 0Fh
FD_COMMAND_WRITESECTOR = 45h
FD_COMMAND_READSECTOR  = 46h
FD_COMMAND_READID      = 4Ah
FD_COMMAND_FORMATTRACK = 4Dh

FD_COMMAND_RECALIBRATE = 7
FD_COMMAND_CHECKSTATUS = 8

// Reset Controller
// DESTROY: ax, dx
h_fd_p_reset:
mov al, 0
mov dx, 3F2h
out dx, al
ret

// Start Motor
// IN: al = pdiskn
// DESTROY: al, cl, dx
h_fd_p_start_motor:
and al, 3
mov cl, al
mov al, 10h
shl al, cl
or al, 8 + 4
or al, cl
mov dx, 3F2h
out dx, al
ret

// Stop Motor
// DESTROY: al, dx
h_fd_p_stop_motor:
mov al, 8 + 4
mov dx, 3F2h
out dx, al
ret

// Wait
// DESTROY: ax, dx
h_fd_p_wait0:
mov dx, 3F4h
l_h_fd_p_wait0_1:
	//... noop(); infinite loop => throw
	in al, dx
	and al, 0C0h
	cmp al, 80h
	jnz l_h_fd_p_wait0_1
ret

// Wait
// DESTROY: ax, dx
h_fd_p_wait1:
mov dx, 3F4h
l_h_fd_u_wait1_1:
	//... noop(); infinite loop => throw
	in al, dx
	and al, 0C0h
	cmp al, 0C0h
	jnz l_h_fd_u_wait1_1
ret

// Make Type - set floppy disk geometry for given type
// IN: al & 15 = type, esi -> FdInfoRec
// OUT: esi -> fd_info[diskn]
// DESTROY: eax, ebx
h_fd_p_mktype:
and al, 15
cmp al, 6
jb l_h_fd_p_mktype_5
  mov al, 0
l_h_fd_p_mktype_5:
movzx ebx, al
shl ebx, 3
add ebx, offset fd_geometries
mov al, [cs:ebx]  // valid
mov [esi + offset FdInfoRec.state], al
inc ebx
mov al, [cs:ebx]  // sectors per track
mov [esi + offset FdInfoRec.tracklen], al
inc ebx
mov al, [cs:ebx]  // gap3
mov [esi + offset FdInfoRec.gap3], al
inc ebx
mov al, [cs:ebx]  // gap3format
mov [esi + offset FdInfoRec.gap3format], al
inc ebx
mov eax, [cs:ebx] // size
mov [esi + offset FdInfoRec.size], eax
ret

// Seek Track
// BEFORE: motor started
// IN: fdt_pdiskn, bh = head, cl = cylinder
// DESTROY: ax, dx
h_fd_p_seek:
mov dx, 3F5h
mov al, FD_COMMAND_SEEK
out dx, al	// out 0Fh

call h_fd_p_wait0

mov dx, 3F5h
mov ah, fdt_pdiskn	// ah = diskn
mov al, bh
and al, 1
shl al, 2	// al = (bh & 1) << 2
or al, ah
out dx, al	// out head << 2 + diskn

call h_fd_p_wait0

mov dx, 3F5h
mov al, cl
out dx, al	// out cylinder
ret

// IO Command - common part for read sector, write sector
// BEFORE: motor started
// IN: al = command, fdt_pdiskn, cl = cylinder,
//     bh = head, bl = sector, fd_info[fdt_pdiskn]
// OUT: al = 0 || errorcode
// DESTROY: ax, dx, bx, esi
h_fd_p_iocommand:

mov dx, 3F5h
out dx, al   // out command byte

call h_fd_p_wait0
mov dx, 3F5h
mov ah, fdt_pdiskn  // ah = diskn
mov al, bh
and al, 1
shl al, 2    // al = (bh & 1) << 2
or al, ah
out dx, al   // out head << 2 + diskn

call h_fd_p_wait0
mov dx, 3F5h
mov al, cl
out dx, al   // out cylinder

call h_fd_p_wait0
mov dx, 3F5h
mov al, bh
out dx, al   // out head

call h_fd_p_wait0
mov dx, 3F5h
mov al, bl
out dx, al   // out sector

call h_fd_p_wait0
mov dx, 3F5h
mov al, 2
out dx, al   // out 2 (sector size code for 512)

movzx esi, byte fdt_pdiskn
shl esi, 3   // esi = diskn * 8 (assert sizeof FdInfoRec == 8)
add esi, offset fd_info  // esi -> fd_info[diskn]

call h_fd_p_wait0
mov dx, 3F5h
mov al, [esi + offset FdInfoRec.tracklen]
out dx, al   // out track_length (18)

call h_fd_p_wait0
mov dx, 3F5h
mov al, [esi + offset FdInfoRec.gap3]
out dx, al   // out gap3 (1Bh = 27)

call h_fd_p_wait0
mov dx, 3F5h
mov al, 0FFh
out dx, al   // out 255 (data_length)

//... wait for IRQ6

// Wait, read result
call h_fd_p_wait1
mov dx, 3F5h
in al, dx
mov ah, al   // ah = st0

call h_fd_p_wait1
mov dx, 3F5h
in al, dx
mov bl, al   // bl = st1

call h_fd_p_wait1
mov dx, 3F5h
in al, dx
mov bh, al   // bh = st2

call h_fd_p_wait1
mov dx, 3F5h
in al, dx    // cylinder

call h_fd_p_wait1
mov dx, 3F5h
in al, dx    // head

call h_fd_p_wait1
mov dx, 3F5h
in al, dx    // sector

call h_fd_p_wait1
mov dx, 3F5h
in al, dx    // sector size code

// write protected?
test bl, 2
jz l_h_fd_p_iocommand_8
  mov al, fdt_pdiskn
  inc al
  or fd_ro, al
  mov al, ERC_READ_ONLY
  jmp short l_h_fd_p_iocommand_9

l_h_fd_p_iocommand_8:
mov al, 0

l_h_fd_p_iocommand_9:
ret

// Read Sector
// BEFORE: motor started
// IN: fdt_pdiskn, cl = cylinder, bh = head, bl = sector
//     edi = buffer PA, fd_info[diskn]
// OUT: al = 0 | errorcode
// DESTROY: ax, dx, bx, esi
h_fd_p_read0:

// Prepare DMA
push ebx
 push ecx
  mov al, 2
  mov ah, DMA_MODE_SINGLE | DMA_MODE_READ
  mov ebx, edi
  mov ecx, 512
  call h_dma_read
 pop ecx
pop ebx
test al, al
jnz l_h_fd_p_read0_x

// Read sector
mov al, FD_COMMAND_READSECTOR
jmp h_fd_p_iocommand  // !!

l_h_fd_p_read0_x:  // also from h_fd_p_write0
ret

// Write Sector
// BEFORE: motor started
// IN: fdt_pdiskn, cl = cylinder, bh = head, bl = sector
//     edi = buffer PA, fd_info[diskn]
// OUT: al = 0 | errorcode
// DESTROY: ax, dx, bx, esi
h_fd_p_write0:

// Prepare DMA
push ebx
 push ecx
  mov al, 2
  mov ah, DMA_MODE_SINGLE | DMA_MODE_WRITE
  mov ebx, edi
  mov ecx, 512
  call h_dma_write
 pop ecx
pop ebx
test al, al
jnz l_h_fd_p_read0_x  // !!

// Write sector
mov al, FD_COMMAND_WRITESECTOR
jmp h_fd_p_iocommand  // !!
//ret

// Translate logical sector to CHS using floppy disk geometry
// IN: ebx = sector, esi -> fd_info[diskn]
// OUT: bl = CHSSector, bh = CHSHead, ecx = CHSCylinder
// DESTROY: eax, edx
h_fd_p_translate:
mov eax, ebx
xor edx, edx
movzx ecx, byte fd_info.tracklen[esi]
div ecx
mov bl, dl
inc bl     // bl = ls % sectors + 1 = CHSsector
mov bh, al
and bh, 1  // bh = (ls / sectors) % 2 = CHSHead
shr eax, 1
xchg eax, ecx  // ecx = (ls / sectors) / 2 = CHSCylinder
ret

h_fd_p_recalibrate:
call h_fd_p_wait0

mov al, FD_COMMAND_RECALIBRATE
mov dx, 3F5h
out dx, al   // out command byte

call h_fd_p_wait0

mov al, 0
mov dx, 3F5h
out dx, al

call h_fd_p_wait0
ret

// IN: fdt_pdiskn
// KEEP: ecx, esi
h_fd_remove_from_cache:
xor eax, eax
dec eax       // eax = -1
xor edx, edx  // edx = 0
mov edi, FD_CACHE_PA

push es
  push ds
  pop es
  
  l_h_fd_test_disk_changed_4:
    mov bl, [edi + offset FdCacheRec.diskn]
    cmp bl, fdt_pdiskn
    jnz l_h_fd_test_disk_changed_41
      stosd  // save -1 (sectn)
      xchg eax, edx
      stosd  // save 0 (dirty, diskn, usg)
      xchg eax, edx
      add edi, sizeof FdCacheRec - 8
      jmp short l_h_fd_test_disk_changed_48
      
    l_h_fd_test_disk_changed_41:
    add edi, sizeof FdCacheRec
    
    l_h_fd_test_disk_changed_48:
    cmp edi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
    jb l_h_fd_test_disk_changed_4

pop es

ret

// IN: fdt_pdiskn, fd_motor
// OUT: fd_motor
// KEEP: ecx, ebx, edi
h_fd_test_disk_changed:
// check disk changed
mov dx, 3F7h
in al, dx
test al, 80h
jz near l_h_fd_test_disk_changed_8
  
  push edi
   push ebx
    push ecx
    
    // remove from the cache
    call h_fd_remove_from_cache
    
    // seek & recalibrate
    mov bh, 0
    mov cl, 1
    call h_fd_p_seek
    mov fd_curtrack, 255
    call h_fd_p_recalibrate
    
    // ejected? - start motor
    mov ah, fdt_pdiskn
    mov al, fd_motor
    inc ah  // ah = diskn + 1 = mask
    or al, ah
    mov fd_motor, al
    and al, 3
    dec ah  // ah = mask - 1 = diskn
    shl al, 4
    or al, ah
    or al, 8 + 4  // al = (fd_motor << 4) + diskn + 8 + 4
    mov dx, 3F2h
    out dx, al
    // wait until motor started
    call h_fd_p_wait0
    
    // ejected?
    mov dx, 3F7h
    in al, dx
    test al, 80h
    jz l_h_fd_test_disk_changed_6
      // ejected
      mov al, ERC_DISK_REMOVED
      jmp short l_h_fd_test_disk_changed_7
    
    l_h_fd_test_disk_changed_6:
    // not ejected - doesn't work with 5.25"
    
    mov al, fdt_pdiskn
    inc al
    not al
    and fd_ro, al
    
    // send to all
    mov ecx, WM_DEVICECHANGE
    movzx edx, fdt_pdiskn
    inc edx  // edx = ldiskn
    mov esi, 1  // 1 - inserted, 0 - ejected
    call p_msg_send_to_all
    
    mov al, ERC_DISK_CHANGED
    
    l_h_fd_test_disk_changed_7:
    
    pop ecx
   pop ebx
  pop edi

  jmp short l_h_fd_test_disk_changed_9
  
l_h_fd_test_disk_changed_8:

mov al, 0

l_h_fd_test_disk_changed_9:
ret

// IN: fdt_pdiskn, fdt_end, fd_curdisk, fd_curtrack, fd_motor
// OUT: fdt_end, fd_curdisk, fd_curtrack, fd_motor
h_fd_begin:
cmp fdt_end, 0
jnz l_h_fd_begin_9

pushad

// remove stop_motor from the timer_queue
mov edx, TMR_THREADID_WND_FDSTOP
xor ebx, ebx
call h_timer_remove

// select drive & start motor, assert fdt_pdiskn < 2
mov ah, fdt_pdiskn
cmp ah, fd_curdisk
jz l_h_fd_prepare_1

  mov fd_curdisk, ah
  mov fd_curtrack, 255

l_h_fd_prepare_1:
mov al, fd_motor
inc ah  // ah = diskn + 1 = mask
test al, ah
jnz l_h_fd_prepare_2

  or al, ah
  mov fd_motor, al

l_h_fd_prepare_2:
and al, 3
dec ah  // ah = mask - 1 = diskn
shl al, 4
or al, ah
or al, 8 + 4  // al = (fd_motor << 4) + diskn + 8 + 4
mov dx, 3F2h
out dx, al

// wait until motor started
call h_fd_p_wait0

popad

mov fdt_end, 1

l_h_fd_begin_9:
ret

// IN: fdt_end
// OUT: fdt_end
// KEEP: eax
h_fd_end:
cmp fdt_end, 0
jz l_h_fd_end_9

// add stop_motor to the timer queue
push eax
  mov ecx, FD_STOPMOTORMS * 1193
  mov edx, TMR_THREADID_WND_FDSTOP
  xor ebx, ebx
  call h_timer_add
pop eax

mov fdt_end, 0

l_h_fd_end_9:
ret

// IN: ebx = ofs, ecx = size, ds
// OUT: al = 0 || errorcode, ebx = sectn, ecx = sectcount,
//      fdt_relofs, fdt_endrelofs, fdt_sectn, fdt_count
// DESTROY: eax

h_fd_prepare_values:
// prepare relofs*, sector number & count
mov eax, ebx
and ax, 511
mov fdt_relofs, ax     // fdt_relofs = ebx & 511
mov eax, ebx
add eax, ecx
dec eax
mov ecx, eax
and ax, 511
mov fdt_endrelofs, ax  // fdt_endrelofs = (ebx + ecx - 1) & 511
shr ebx, 9             // ebx = first sector
shr ecx, 9
sub ecx, ebx
inc ecx                // ecx = sector count

mov fdt_sectn, ebx
mov fdt_count, ecx
/*
//$$$
push edx
mov ax, fdt_relofs
mov dx, fdt_endrelofs
call wregs
pop edx
*/
mov al, 0
ret

// OUT: fd_motor
// DESTROY: al, dx
h_fd_stop_motor_mask:
call h_fd_p_stop_motor
mov fd_motor, 0
ret

// BEFORE: motor started
// IN: ebx = sectn, fdt_pdiskn, fd_curtrack, fd_curdisk
// OUT: esi -> disk info, bl = CHSS, bh = CHSH, cl = CHSC
//      fd_curdisk, fd_curtrack
// DESTROY: eax, edx, ebx, ecx
h_fd_seek_track:
movzx esi, fdt_pdiskn
shl esi, 3	// assert sizeof FdInfoRec = 8

// IN: ebx = sector, esi -> fd_info[diskn]
// OUT: bl = CHSSector, bh = CHSHead, ecx = CHSCylinder
// DESTROY: eax, edx
call h_fd_p_translate

call h_fd_p_wait0

// Seek track
mov al, fdt_pdiskn
cmp cl, fd_curtrack
jnz l_h_fd_seek_track_yes
  cmp al, fd_curdisk
  jz l_h_fd_seek_track_no
l_h_fd_seek_track_yes:

// BEFORE: motor started
// IN: fdt_pdiskn, bh = head, cl = cylinder
// DESTROY: ax, dx
mov fd_curdisk, al
mov fd_curtrack, cl
call h_fd_p_seek

call h_fd_p_wait0

l_h_fd_seek_track_no:
ret

// IN: ah = 0:only usg 0, 1:all, fdt_pdiskn
// BEFORE: motor started
// OUT: al = 0 || errorcode, fd_motor
// DESTROY: eax, fdt_save*
h_fd_flush:
push edx
 push ebx

xor edx, edx
mov fdt_savecount, edx
mov ebx, FD_CACHE_PA

push edi

l_h_fd_flush_1:
  mov al, [ebx + offset FdCacheRec.dirty]  // dirty
  test al, 1
  jnz l_h_fd_flush_5

  l_h_fd_flush_2:  // next buffer
  add ebx, sizeof FdCacheRec
  cmp ebx, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
  jb l_h_fd_flush_1

pop edi

mov edx, fdt_savecount
test edx, edx
jnz l_h_fd_flush_8

  mov al, 0

l_h_fd_flush_9:

 pop ebx
pop edx
ret


// Dirty Buffer Found
l_h_fd_flush_5:

test ah, 1
jnz l_h_fd_flush_6
  mov al, [ebx + offset FdCacheRec.usg]  // usg
  test al, al
  jnz l_h_fd_flush_2

l_h_fd_flush_6:
mov al, [ebx + offset FdCacheRec.diskn]  // diskn
cmp al, fdt_pdiskn
jnz l_h_fd_flush_2

call h_fd_begin

// AddSort to list of buffers to save
mov edi, fdt_savecount
shl edi, 2
add edi, offset fdt_saveofs

l_h_fd_flush_61:
cmp edi, offset fdt_saveofs
jna l_h_fd_flush_62
  mov edx, [edi - 4]   // edx = ofs to fs
  mov [edi], edx
  mov edx, [edx]       // edx = sector number
  cmp [ebx], edx
  jna l_h_fd_flush_62  // greater first
    sub edi, 4
    jmp short l_h_fd_flush_61

l_h_fd_flush_62:
mov [edi], ebx
inc fdt_savecount
jmp l_h_fd_flush_2


// Save fdt_save*
l_h_fd_flush_8:
push ecx
 push esi
  push edi

mov edi, fdt_savecount
shl edi, 2
add edi, offset fdt_saveofs  // read from the end, last saved first

l_h_fd_flush_81:
cmp edi, offset fdt_saveofs
jna l_h_fd_flush_88

sub edi, 4
mov ebx, [edi]

push ebx
 push edi

  // write protection
  mov ah, fdt_pdiskn
  inc ah
  test fd_ro, ah
  jz l_h_fd_flush_82
    mov al, ERC_READ_ONLY
    jmp short l_h_fd_flush_83
  
  l_h_fd_flush_82:

  // Save buffer[ebx+8](512) to disk[ebx+5](1)[ebx](4)

  mov edi, ebx
  add edi, offset FdCacheRec.data           // edi -> data
  mov ebx, [ebx + offset FdCacheRec.sectn]  // ebx = sectn

  // BEFORE: motor started
  // IN: ebx = sectn, fdt_pdiskn, fd_curtrack, fd_curdisk
  // OUT: esi -> disk info, bl = CHSS, bh = CHSH, cl = CHSC
  //      fd_curdisk, fd_curtrack
  // DESTROY: eax, edx, ebx, ecx
  call h_fd_seek_track

  // BEFORE: motor started
  // IN: fdt_pdiskn, cl = cylinder, bh = head, bl = sector
  //     edi = source DMA, fd_*
  // OUT: al = 0 | errorcode
  // DESTROY: ax, cx, dx, esi
  call h_fd_p_write0
  // al <> 0 => error

  l_h_fd_flush_83:

 pop edi
pop ebx

test al, al
jnz l_h_fd_flush_86
  mov byte [ebx + offset FdCacheRec.dirty], 0  // dirty = false
  jmp l_h_fd_flush_81

l_h_fd_flush_86:
// Error
mov byte [ebx + offset FdCacheRec.dirty], 2    // dirty = error
jmp short l_h_fd_flush_89  // al = errorcode

l_h_fd_flush_88:
  // All done
  xor eax, eax

l_h_fd_flush_89:

  pop edi
 pop esi
pop ecx
jmp l_h_fd_flush_9

// IN: fdt_pdiskn, fd_motor
// OUT: al = 0 || errorcode, fd_motor
// DESTROY: eax, fdt_save*
h_fd_shrusg:
push edx
 push ebx

mov esi, FD_CACHE_PA

l_h_fd_shrusg_1:
  shr byte [esi + offset FdCacheRec.usg], 1  // usg
  add esi, sizeof FdCacheRec
  cmp esi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
  jb l_h_fd_shrusg_1

// Flush all disks
mov al, fdt_pdiskn

push eax

  mov fdt_end, 0
  mov fdt_pdiskn, 0
  mov ah, 0
  call h_fd_flush  // flush disk 0

  mov fdt_end, 0
  mov fdt_pdiskn, 1
  mov ah, 0
  call h_fd_flush  // flush disk 1

pop eax

mov fdt_pdiskn, al
mov fdt_end, 0
call h_fd_begin

 pop ebx
pop edx
ret

// IN: ds:esi -> source buffer data, es:edi -> target,
//     ecx = sector count, fdt_relofs, fdt_endrelofs
// OUT: edi++*, fdt_relofs
// DESTROY: eax, esi
h_fd_rcopy:
mov eax, 511
test ecx, ecx
jnz l_h_fd_rcopy_1
  movzx eax, word fdt_endrelofs  // Last sector
l_h_fd_rcopy_1:

push ecx

  xchg eax, ecx
  movzx eax, word fdt_relofs
  sub ecx, eax
  add esi, eax  // esi += fdt_relofs
  inc ecx       // ecx = bytes count
  test eax, eax
  jz l_h_fd_rcopy_4
    xor eax, eax
    mov fdt_relofs, ax  // Next fdt_relofs = 0
  l_h_fd_rcopy_4:
  cld
  cmp ecx, 512
  jz l_h_fd_rcopy_5
    rep movsb
    jmp short l_h_fd_rcopy_8  
  l_h_fd_rcopy_5:
    shr ecx, 2
    rep movsd
  l_h_fd_rcopy_8:

pop ecx

ret

// IN: ds:esi -> target buffer data, es:edi -> source,
//     ecx = sector count, fdt_relofs, fdt_endrelofs
// OUT: edi++*, fdt_relofs
// DESTROY: eax, edx, esi
h_fd_wcopy:
mov byte[esi - offset FdCacheRec.data + offset FdCacheRec.dirty], 1  // dirty
mov eax, 511
test ecx, ecx
jnz l_h_fd_wcopy_1
  movzx eax, word fdt_endrelofs  // Last sector
l_h_fd_wcopy_1:

push ecx

  xchg eax, ecx
  movzx eax, word fdt_relofs
  sub ecx, eax
  add esi, eax  // esi += fdt_relofs
  inc ecx       // ecx = bytes count
  test eax, eax
  jz l_h_fd_wcopy_4
    xor eax, eax
    mov fdt_relofs, ax  // Next fdt_relofs = 0
  l_h_fd_wcopy_4:

  xchg esi, edi

  push ds

    push ds
      push es
      pop ds  // ds = es0
    pop es    // es = ds0

    cld
    cmp ecx, 512
    jz l_h_fd_wcopy_5
    rep movsb
    jmp short l_h_fd_wcopy_8

    l_h_fd_wcopy_5:
    shr ecx, 2
    rep movsd

    l_h_fd_wcopy_8:

    push ds
    pop es

  pop ds

  xchg esi, edi

pop ecx

ret

// IN: ebx = sectn, ecx = sectcount, fdt_pdiskn, fdt_relofs, fdt_endrelofs
// OUT: al = 0 || ERC_NOT_FOUND_IN_CACHE || errorcode, esi -> FdCacheRec.data
// DESTROY: eax, edx
h_fd_srchbuf:
mov esi, FD_CACHE_PA

l_h_fd_srchbuf_1:
  cmp ebx, dword [esi + offset FdCacheRec.sectn]   // sectn
  jnz l_h_fd_srchbuf_12
    mov al, byte [esi + offset FdCacheRec.diskn]   // diskn
    cmp al, fdt_pdiskn
    jnz l_h_fd_srchbuf_12
      // Sector found
      // usg++
      cmp byte [esi + offset FdCacheRec.usg], 255  // usg
      jz l_h_fd_srchbuf_15
        inc byte [esi + offset FdCacheRec.usg]  // usg
        jmp short l_h_fd_srchbuf_15

  l_h_fd_srchbuf_12:
  add esi, sizeof FdCacheRec
  cmp esi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
  jb l_h_fd_srchbuf_1

// return not found
mov al, ERC_NOT_FOUND_IN_CACHE
ret

// Found
l_h_fd_srchbuf_15:
add esi, offset FdCacheRec.data         // esi -> sector_buffer

// return ok
mov al, 0
ret

// IN: ds
// OUT: al = 0 || errorcode, edi -> FdCacheRec (victim PA)
// DESTROY: ax
h_fd_find_victim:

l_h_fd_find_victim_0:
mov edi, FD_CACHE_PA

l_h_fd_find_victim_1:
cmp edi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
jnb l_h_fd_find_victim_6
  mov al, [edi + offset FdCacheRec.usg]  // usg
  test al, al
  jz l_h_fd_find_victim_8
    add edi, sizeof FdCacheRec
    jmp l_h_fd_find_victim_1

l_h_fd_find_victim_6:
call h_fd_shrusg
test al, al
jz l_h_fd_find_victim_0
ret  // al = errorcode

l_h_fd_find_victim_8:
mov al, 0
ret

// IN: ds, ebx = sectn, fdt_pdiskn, fd_curtrack, fd_curdisk
// OUT: al = 0 || errorcode, esi -> FdCacheRec.data
// DESTROY: eax, edx
h_fd_read_sector:

push ecx
push ebx
push edi

movzx esi, byte fdt_pdiskn
shl esi, 3  // assert sizeof FdInfoRec == 8

cmp ebx, fd_info.size[esi]
jb h_fd_read_sector_2
  
  mov al, ERC_OUT_OF_RANGE
  jmp h_fd_read_sector_x
  
h_fd_read_sector_2:

// IN: ds
// OUT: al = 0 || errorcode, edi -> FdCacheRec (victim PA)
// DESTROY: ax
call h_fd_find_victim
or al, al
jnz h_fd_read_sector_x

mov al, fdt_pdiskn
mov dword[edi + offset FdCacheRec.sectn], ebx  // sectn
mov byte[edi + offset FdCacheRec.dirty], 0     // dirty
mov byte[edi + offset FdCacheRec.diskn], al    // diskn
mov byte[edi + offset FdCacheRec.usg], 1       // usg

// BEFORE: motor started
// IN: ebx = sectn, fdt_pdiskn, fd_curtrack, fd_curdisk
// OUT: esi -> fd_info[diskn], bl = CHSS, bh = CHSH, cl = CHSC
//      fd_curdisk, fd_curtrack
// DESTROY: eax, ecx, edx, ebx
call h_fd_seek_track  // keep edi

add edi, offset FdCacheRec.data

// BEFORE: motor started
// IN: fdt_pdiskn, cl = cylinder, bh = head, bl = sector
//     edi = target buffer PA, fd_info[diskn]
// OUT: al = 0 || errorcode
// DESTROY: ax, cx, dx, esi
call h_fd_p_read0  // keep edi

mov esi, edi  // esi -> data

sub edi, offset FdCacheRec.data

or al, al
jnz h_fd_read_sector_x2

h_fd_read_sector_x:

pop edi
pop ebx
pop ecx

ret

h_fd_read_sector_x2:
xor ebx, ebx
dec ebx
mov dword[edi + offset FdCacheRec.sectn], ebx  // sectn
mov byte[edi + offset FdCacheRec.usg], 0       // usg
jmp h_fd_read_sector_x

// IN: ds, es
h_fd_init:

// Prepare cache
xor eax, eax
dec eax       // eax = -1
xor edx, edx  // edx = 0
mov edi, FD_CACHE_PA

push es
  push ds
  pop es

  l_h_fd_init_2:
    stosd  // save -1 (sectn)
    xchg eax, edx
    stosd  // save 0 (dirty, diskn, usg)
    xchg eax, edx
    add edi, sizeof FdCacheRec - 8
    cmp edi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
    jb l_h_fd_init_2

pop es

// Get floppy disk types
mov al, 10h
out 70h, al
in al, 71h
push eax

 shr al, 4
 mov esi, offset fd_info
 call h_fd_p_mktype

pop eax
mov esi, offset fd_info + sizeof FdInfoRec
call h_fd_p_mktype

// Configure
//mov ebx, 100
//call busywait
//call h_fd_p_configure

// Init vars
mov fd_curdisk, 255
mov fd_curtrack, 255
mov fd_motor, 0
mov fd_ro, 0

// Return OK
mov al, 0
ret

l_h_fd_read_x:
mov al, ERC_INVALID_DISK_NUMBER
ret

// IN: al = pdiskn, ebx = ofs, ecx = size, es:edi -> target
// DESTROY: eax, ecx, edx, ebx, esi, edi
h_fd_read:
cmp al, 2
jnb l_h_fd_read_x

mov fdt_pdiskn, al
mov fdt_end, 0
call h_fd_begin

call h_fd_test_disk_changed
test al, al
jnz l_h_fd_read_8

call h_fd_prepare_values

l_h_fd_read_5:
  dec fdt_count
  mov ebx, fdt_sectn
  mov ecx, fdt_count
  call h_fd_srchbuf
  or al, al
  jnz l_h_fd_read_6
    
    l_h_fd_read_51:
    // found
    call h_fd_rcopy
    inc fdt_sectn
    cmp fdt_count, 0
    jz l_h_fd_read_7
      jmp short l_h_fd_read_5
  
l_h_fd_read_6:
cmp al, ERC_NOT_FOUND_IN_CACHE
jnz l_h_fd_read_8

// not found
call h_fd_read_sector
or al, al
jz l_h_fd_read_51

jmp short l_h_fd_read_8

l_h_fd_read_7:
mov al, 0

l_h_fd_read_8:

call h_fd_end  // keep eax

ret

l_h_fd_write_x:
mov al, ERC_INVALID_DISK_NUMBER

l_h_fd_write_x2:
ret

/*l_h_fd_write_x3:
mov al, ERC_READ_ONLY
ret*/

// IN: al = pdiskn, ebx = ofs, ecx = size, es:edi -> source
h_fd_write:
cmp al, 2
jnb l_h_fd_write_x
/*
mov ah, al
inc ah
test fd_ro, ah
jnz l_h_fd_write_x3
*/
movzx esi, al
inc esi
shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
or byte ptr disk_info.flags[esi], DISK_FLAGS_DIRTY

mov fdt_pdiskn, al
mov fdt_end, 0
call h_fd_begin

call h_fd_test_disk_changed
test al, al
jnz l_h_fd_read_8

call h_fd_prepare_values

l_h_fd_write_5:
  dec fdt_count
  mov ebx, fdt_sectn
  mov ecx, fdt_count
  call h_fd_srchbuf
  or al, al
  jnz l_h_fd_write_6
    
    l_h_fd_write_51:
    // found
    call h_fd_wcopy
    inc fdt_sectn
    cmp fdt_count, 0
    jz l_h_fd_write_7
      jmp short l_h_fd_write_5

l_h_fd_write_6:
cmp al, ERC_NOT_FOUND_IN_CACHE
jnz l_h_fd_write_8

// not found
jmp short l_h_fd_write_52


l_h_fd_write_7:
mov al, 0

l_h_fd_write_8:

call h_fd_end  // keep eax

ret

  l_h_fd_write_52:
  // Don't load if writing whole sector
  mov ax, fdt_relofs
  test ax, ax
  jz l_h_fd_write_62

    l_h_fd_write_54:
    // Load missing sector to cache, assert fdt_pdiskn < 2
    call h_fd_read_sector
    test al, al
    jz l_h_fd_write_51
      jmp l_h_fd_write_x2

l_h_fd_write_62:
cmp ecx, 1
ja l_h_fd_write_64
  cmp fdt_endrelofs, 511
  jnz l_h_fd_write_54

l_h_fd_write_64:
// fdt_relofs == 0 && (ecx > 1 || fdt_endrelofs == 511)

push edi
 push ecx
  push ebx

    movzx esi, byte fdt_pdiskn
    shl esi, 3  // assert sizeof FdInfoRec == 8
    // IN: ds
    // OUT: al = 0 || errorcode, edi -> FdCacheRec (victim PA)
    // DESTROY: ax
    call h_fd_find_victim
    mov esi, edi
  
  pop ebx
 pop ecx
pop edi

test al, al
jnz near l_h_fd_write_x

mov al, fdt_pdiskn
mov dword[esi + offset FdCacheRec.sectn], ebx  // sectn
mov byte[esi + offset FdCacheRec.dirty], 0     // dirty
mov byte[esi + offset FdCacheRec.diskn], al    // diskn
mov byte[esi + offset FdCacheRec.usg], 1       // usg
add esi, offset FdCacheRec.data
jmp l_h_fd_write_51

// IN: ah = operation, al = ldiskn
h_fd_main:
dec al  // 0 = A:, 1 = B:, else error (ldiskn -> pdiskn)

cmp ah, 2
jnz l_h_fd_main_3
  // read (al = pdiskn, ebx = ofs, ecx = size, es:edi -> buffer)
  jmp h_fd_read

l_h_fd_main_3:
cmp ah, 3
jnz l_h_fd_main_4
  // write (al = pdiskn, ebx = ofs, ecx = size, es:edi -> buffer)
  jmp h_fd_write

l_h_fd_main_4:
cmp ah, 4
jnz l_h_fd_main_5
  // get disk size (al = diskn)
  cmp al, 2
  jb l_h_fd_main_45
  
    l_h_fd_main_44:
    xor edx, edx
    xor eax, eax
    ret
  
  l_h_fd_main_45:
  movzx esi, al
  shl esi, 3  // esi = diskn * 8 (assert sizeof FdInfoRec == 8)
  add esi, offset fd_info  // esi -> fd_info[diskn]
  mov eax, [esi + offset FdInfoRec.size]
  shl eax, 9  // fd_size * 512
  xor edx, edx
  ret

l_h_fd_main_5:
cmp ah, 5
jnz l_h_fd_main_7
  // flush (al = diskn)
  cmp al, 2
  jb l_h_fd_main_55
    mov al, ERC_INVALID_DISK_NUMBER
    ret
  
  l_h_fd_main_55:
  mov fdt_pdiskn, al
  mov fdt_end, 0

    mov ah, 1  // flush all
    call h_fd_flush

  call h_fd_end
  ret

l_h_fd_main_7:
/*cmp ah, 7
jnz l_h_fd_main_1
	// format
	jmp h_fd_format
*/
l_h_fd_main_1:
cmp ah, 1
jnz l_h_fd_main_0
  // reset
  mov fdt_pdiskn, 0
  call h_fd_remove_from_cache
  mov fdt_pdiskn, 1
  call h_fd_remove_from_cache
  
  //call h_fd_p_reset
  
  and fd_info.state, 1
  and fd_info.state[sizeof FdInfoRec], 1
  mov fd_curdisk, 255
  mov fd_curtrack, 255
  mov fd_motor, 0
  mov al, 0
  ret

l_h_fd_main_0:
cmp ah, 0
jnz l_h_fd_main_x
  // init
  jmp h_fd_init

l_h_fd_main_x:
// error
mov al, ERC_NOT_IMPLEMENTED
ret

//msg6: db 5, " IRQ6"

IRQ6:
/*
push ds
 pushad
  push SELECTOR_KERNEL_DATA
  pop ds
  mov esi, offset msg6
  call writec
 popad
pop ds
*/
iretd

struct HdCacheRec{
  uns8 sectn
  uns2 usg
  uns1 diskn, dirty
  uns4 padding
  uns1 data[4096]
}

HD_CACHE_PA    = PA_DMA_BUFFERS + 0x10000
HD_CACHE_SIZE  = 0x10000
HD_CACHE_COUNT = HD_CACHE_SIZE / sizeof HdCacheRec

HD_PORT_DATA      = 0x1F0
HD_PORT_FEATURES  = 0x1F1
HD_PORT_ERROR     = 0x1F1
HD_PORT_COUNT     = 0x1F2
HD_PORT_SECTOR    = 0x1F3
HD_PORT_CYLLOW    = 0x1F4
HD_PORT_CYLHIGH   = 0x1F5
HD_PORT_DRIVEHEAD = 0x1F6
HD_PORT_COMMAND   = 0x1F7
HD_PORT_STATUS    = 0x1F7

HD_STATUS_BUSY      = 0x80
HD_STATUS_DATAREADY = 8
HD_STATUS_ERROR     = 1
HD_STATUS_FAULT     = 0x20

uns1 hd_busy, hdt_ldiskn, hdt_pdiskn, hd_irqs

[dalign 16]
uns2 hdt_relofs, hdt_endrelofs

[dalign 32]
uns1 hd_buffer[512]  // also used by cd

[dalign 32]
uns4 hdt_count_remain, hdt_high

[dalign 32]
uns1 hd_state[4]

uns4 hdt_savecount
uns4 hdt_saveofs[15]

uns8 hdt_tmp1, hdt_min

// IN: edx:ebx = sector, ecx = count,
//     hdt_slave_bit, hdt_port_base
// OUT: al = command_base, dx = port_base,
//      hdt_count_remain, ecx = semi count
// DESTROY: eax, edx, hdt_high
h_hd_p_mklba:
test edx, edx
jnz l_h_hd_p_mklba_48
 cmp ebx, 0x10000000		// 1 << 28
 jnb l_h_hd_p_mklba_48

// 28
mov eax, ebx
shr eax, 24
and al, 15
or al, hdt_slave_bit  // hdt_slave_bit 0 || 10h
or al, 0xE0
mov dx, hdt_port_base
or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
out dx, al
mov eax, ecx
cmp eax, 256
jb l_h_hd_p_mklba_281
  mov eax, 255

l_h_hd_p_mklba_281:
sub ecx, eax
mov hdt_count_remain, ecx
mov ecx, eax
sub dl, 4  // dx = HD_PORT_COUNT (2)
out dx, al

mov al, bl
inc dl  // dx = HD_PORT_SECTOR (3) / LBA low
out dx, al

mov al, bh
inc dl  // dx = HD_PORT_CYLLOW (4) / LBA mid
out dx, al

mov eax, ebx
shr eax, 16
inc dl  // dx = HD_PORT_CYLHIGH (5) / LBA high
out dx, al

sub dl, 5  // dx = PORT_BASE (0)

mov al, 0
ret

// 48
l_h_hd_p_mklba_48:
mov eax, ebx
shr eax, 24
shl edx, 8
or eax, edx
mov hdt_high, eax

mov al, 0xE0
or al, hdt_slave_bit  // hdt_slave_bit 0 || 10h
mov dx, hdt_port_base
or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
out dx, al

mov eax, ecx
cmp eax, 65536
jb l_h_hd_p_mklba_481
  mov eax, 65535

l_h_hd_p_mklba_481:
sub ecx, eax
mov hdt_count_remain, ecx
mov ecx, eax
mov al, ah
sub dl, 4  // dx = HD_PORT_COUNT (2)
out dx, al

mov eax, hdt_high
inc dl  // dx = HD_PORT_SECTOR (3) / LBA low
out dx, al
shr eax, 8
inc dl  // dx = HD_PORT_CYLLOW (4) / LBA mid
out dx, al
mov al, ah
inc dl  // dx = HD_PORT_CYLHIGH (5) / LBA high
out dx, al

mov al, cl
sub dl, 3  // dx = HD_PORT_COUNT (2)
out dx, al

mov eax, ebx
inc dl  // dx = HD_PORT_SECTOR (3)
out dx, al
shr eax, 8
inc dl  // dx = HD_PORT_CYLLOW (4)
out dx, al
mov al, ah
inc dl  // dx = HD_PORT_CYLHIGH (5)
out dx, al

sub dl, 5  // dx = PORT_BASE (0)

mov al, 4
ret

// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_pdiskn, hdt_slave_bit, hdt_port_base
// OUT: edx:ebx = next sector
// KEEP: esi
// USES: hdt_high, hdt_count_remain
h_hd_p_read:
test hdt_pdiskn, 40h
jnz near h_sd_p_read

l_h_hd_p_read0:

push edx

 call h_hd_p_mklba
 or al, ATA_CMD_READ
 or dl, 7		// dx = HD_PORT_COMMAND (7)
 out dx, al

 push ecx

// (*
 l_h_hd_p_read5:
	or dl, 7	// dx = HD_PORT_STATUS (7)
	in al, dx
	test al, HD_STATUS_BUSY
	jz l_h_hd_p_read6
		//... noop();
		jmp l_h_hd_p_read5

	l_h_hd_p_read6:
	test al, HD_STATUS_ERROR | HD_STATUS_FAULT
	jnz l_h_hd_p_error0

	push ecx
	 and dl, 0F8h	// dx = HD_PORT_DATA (0)
	 mov ecx, 512/4
	 cld
	 rep insd
	pop ecx
	loop l_h_hd_p_read5
// *)

 pop ecx
pop edx

add ebx, ecx
adc edx, 0
mov ecx, hdt_count_remain
test ecx, ecx
jnz l_h_hd_p_read0

xor eax, eax
ret


  l_h_hd_p_error0:
 pop ecx
pop edx

l_h_hd_p_error:		// write and cd jump here too
mov dx, hdt_port_base
or dl, 1	// dx = HD_PORT_ERROR (1)
in al, dx
mov ah, al
mov al, ERC_HARDWARE
ret

// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_pdiskn, hdt_slave_bit, hdt_port_base
// OUT: edx:ebx = next sector
// KEEP: esi
// USES: hdt_high, hdt_count_remain
h_hd_p_write:
test hdt_pdiskn, 40h
jnz near h_sd_p_write

l_h_hd_p_write0:

push edx

 call h_hd_p_mklba
 or al, ATA_CMD_WRITE
 or dl, 7		// dx = HD_PORT_COMMAND (7)
 out dx, al

 push ecx
  push ds
   push esi

	mov ax, es
	mov esi, edi
	mov ds, ax
// (*
	l_h_hd_p_write5:
		or dl, 7	// dx = HD_PORT_STATUS (7)
		in al, dx
		test al, HD_STATUS_BUSY
		jz l_h_hd_p_write6
			//... noop();
			jmp l_h_hd_p_write5

		l_h_hd_p_write6:
		test al, HD_STATUS_ERROR | HD_STATUS_FAULT
		jnz l_h_hd_p_write_error

		push ecx
	 	 and dl, 0F8h	// dx = HD_PORT_DATA (0)
		 mov ecx, 512/4
		 cld

		 l_h_hd_p_write71:
		  outsd
		  jmp short l_h_hd_p_write76
		  l_h_hd_p_write76:
		  loop l_h_hd_p_write71

		pop ecx
		loop l_h_hd_p_write5
// *)
	mov edi, esi

   pop esi
  pop ds
 pop ecx
pop edx

add ebx, ecx
adc edx, 0
mov ecx, hdt_count_remain
test ecx, ecx
jnz l_h_hd_p_write0

xor eax, eax
ret


l_h_hd_p_write_error:
   pop esi
  pop ds
 pop ecx
pop edx
jmp l_h_hd_p_error

// IN: hdt_port_base, hdt_slave_bit
h_hd_p_flush:  // E7/EA
mov dx, hdt_port_base

mov al, hdt_slave_bit  // hdt_slave_bit 0 || 10h
or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
out dx, al

or dl, 7  // dx = HD_PORT_COMMAND (7)
mov al, ATA_CMD_FLUSH_EX
out dx, al

l_h_hd_p_flush5:
  //or dl, 7  // dx = HD_PORT_STATUS (7)
  in al, dx
  test al, HD_STATUS_BUSY
  jnz l_h_hd_p_flush5

ret

// IN: hdt_slave_bit, hdt_port_base, es:edi -> buffer
h_hd_p_identify:
push edx

  mov dx, hdt_port_base

  mov al, hdt_slave_bit
  or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
  out dx, al
  
  mov al, ATA_CMD_IDENTIFY
  or dl, 7  // dx = HD_PORT_COMMAND (7)
  out dx, al
  
  in al, dx
  or al, al
  jz h_hd_p_identify_e
  
  h_hd_p_identify5:
    or dl, 7  // dx = HD_PORT_STATUS (7)
    in al, dx
    test al, HD_STATUS_BUSY
    jz h_hd_p_identify6
      //... noop();
      jmp h_hd_p_identify5
  
  h_hd_p_identify6:
  test al, HD_STATUS_ERROR | HD_STATUS_FAULT
  jnz l_h_hd_p_identifyerror
  
  push ecx
   and dl, 0F8h  // dx = HD_PORT_DATA (0)
   mov ecx, 512/4
   cld
   rep insd
  pop ecx
  
pop edx

xor eax, eax
ret

l_h_hd_p_identifyerror:
pop edx
jmp l_h_hd_p_error

h_hd_p_identify_e:
pop edx
mov al, ERC_INVALID_DISK_NUMBER
ret

// IN: al = pdiskn
// OUT: hdt_slave_bit, hdt_port_base
h_hd_prepare_port_slave:
push eax
  and al, 1
  shl al, 4
  mov hdt_slave_bit, al  // hdt_slave_bit = (pdn & 1) << 4
pop eax
test al, 2
jz l_h_hd_prepare_port_slave_2
  mov hdt_port_base, 170h
  jmp short l_h_hd_prepare_port_slave_3

l_h_hd_prepare_port_slave_2:
  mov hdt_port_base, 1F0h

l_h_hd_prepare_port_slave_3:
ret

// IN: al = pdiskn
// OUT: al = 0 || errorcode, hdt_pdiskn
//      hdt_slave_bit, hdt_port_base
// DESTROY: eax, esi
h_hd_partitions:
mov hdt_pdiskn, al
call h_hd_prepare_port_slave

// Prepare all partitions of physical disk esi

push edi
 push ecx
  push edx
   push ebx

// Read LBA 1
xor edx, edx
xor ebx, ebx
inc ebx
xor ecx, ecx
inc ecx
mov edi, VA_SYSTEM + offset hd_buffer
call h_hd_p_read	// keep esi
or al, al
jnz near l_h_hd_partitions_8

l_h_hd_partitions_21:

// GPT/MBR?
mov eax, dword hd_buffer[0]
mov edx, dword hd_buffer[4]
cmp eax, "EFI "
jnz near l_h_hd_partitions_mbr
cmp edx, "PART"
jnz near l_h_hd_partitions_mbr


// *** GPT ***

mov ecx, dword hd_buffer[80]
cmp ecx, 32
jna l_h_hd_partitions_31
  mov ecx, 32

l_h_hd_partitions_31:  // ecx = number of partitions
xor esi, esi           // esi = 0
xor ebx, ebx
inc ebx                // ebx = 1

// (*
l_h_hd_partitions_32:
  or esi, esi
  jnz l_h_hd_partitions_33
    // Read LBA 2++ (IN: es == ds)
    inc ebx  // ebx++
    push edi
     push ecx
      push ebx
        xor edx, edx
        mov edi, VA_SYSTEM + offset hd_buffer
        xor ecx, ecx
        inc ecx
        call h_hd_p_read  // keep esi
      pop ebx
     pop ecx
    pop edi
    or al, al
    jnz near l_h_hd_partitions_8

  l_h_hd_partitions_33:  // keep ebx, ecx
  push esi
   push ecx
    call h_disks_new
    mov edi, esi
   pop ecx
  pop esi
  or al, al
  jnz near l_h_hd_partitions_8

  // Store partition info
  mov byte ptr [edi + offset DiskInfoRec.type], DISK_TYPE_HD
  mov al, hdt_pdiskn
  mov [edi + offset DiskInfoRec.number], al
  mov eax, esi
  shr eax, 7  // div 128
  mov [edi + offset DiskInfoRec.partition], al
  mov dword ptr [edi + offset DiskInfoRec.main], offset h_hd_main
  
  add edi, VA_SYSTEM + offset DiskInfoRec.base_sectors

  mov eax, dword hd_buffer[esi+32]
  stosd
  mov eax, dword hd_buffer[esi+36]
  stosd  // store base8

  mov eax, dword hd_buffer[esi+40]
  mov edx, dword hd_buffer[esi+44]
  sub eax, dword hd_buffer[esi+32]
  sbb edx, dword hd_buffer[esi+36]
  add eax, 1
  adc edx, 0
  and al, -8  // align 8 (4096)
  stosd
  xchg eax, edx
  stosd  // store size8

  mov eax, dword hd_buffer[esi+48]
  stosd
  mov eax, dword hd_buffer[esi+52]
  stosd  // store attributes8

  // Next partition info
  add esi, 128
  and esi, 511
  dec ecx
  jecxz l_h_hd_partitions_38
    jmp l_h_hd_partitions_32
// *)

l_h_hd_partitions_38:
mov al, 0
jmp l_h_hd_partitions_8


// *** MBR ***

l_h_hd_partitions_mbr:
// Read LBA 0 (IN: es == ds, edi -> current physical disk info)
push edi
  xor edx, edx
  xor ebx, ebx
  xor ecx, ecx
  inc ecx
  mov edi, VA_SYSTEM + offset hd_buffer
  call h_hd_p_read  // keep es, esi
pop edi
test al, al
jnz l_h_hd_partitions_8

l_h_hd_partitions_41:
mov esi, 1BEh  // esi = 1BEh
mov ecx, 4     // ecx = 4
xor edx, edx   // edx = 0

// (*
l_h_hd_partitions_42:
 mov eax, dword hd_buffer[esi+12]
 or eax, eax
 jz l_h_hd_partitions_8
 
 push esi
  push ecx
   call h_disks_new
   mov edi, esi
  pop ecx
 pop esi

 mov byte ptr [edi + offset DiskInfoRec.type], DISK_TYPE_HD
 mov al, hdt_pdiskn
 mov [edi + offset DiskInfoRec.number], al
 mov eax, esi
 sub eax, 1BEh
 shr eax, 4  // div 16
 mov [edi + offset DiskInfoRec.partition], al
 mov dword ptr [edi + offset DiskInfoRec.main], offset h_hd_main
 //mov al, hd_buffer[esi+4] // partition type
 //mov [edi + offset DiskInfoRec.fsid], al
 
 add edi, VA_SYSTEM + offset DiskInfoRec.base_sectors
 
 xor edx, edx
 mov eax, dword hd_buffer[esi+8] // start of partition in sectors
 stosd
 xchg eax, edx
 stosd       // store base8
 xchg eax, edx
 mov eax, dword hd_buffer[esi+12] // size of partition in sectors
 and al, -8  // align 8 (4096)
 stosd
 xchg eax, edx
 stosd       // store size8
 xchg eax, edx

 // Next partition info
 add esi, 16
 loop l_h_hd_partitions_42
// *)

mov al, 0


l_h_hd_partitions_8:  // IN: al = 0 || errorcode

   pop ebx
  pop edx
 pop ecx
pop edi

ret

// IN: edx:ebx = ofs, ecx = size, hdt_ldiskn
// OUT: edx:ebx = sector number, ecx = sector count (both aligned 4096),
//      al = 0 || errorcode, hdt_relofs, hdt_endrelofs
// DESTROY: eax, esi
h_hd_prepare_values:
// relofs*
mov eax, ebx
and eax, 4095
mov hdt_relofs, ax
add eax, ecx
mov esi, eax  // esi = hdt_relofs + size
dec eax
and ax, 4095
mov hdt_endrelofs, ax
// sector count
xchg eax, esi
add eax, 4095
shr eax, 9    // log2(512)
and al, -8    // align 8
xchg ecx, eax
// sector number
mov eax, edx
shr ebx, 9    // log2(512)
shr edx, 9
shl eax, 32 - 9
or ebx, eax
and bl, -8    // align 8

// check sectn to disk size
movzx esi, byte hdt_ldiskn
cmp si, DISK_MAX
jb l_h_hd_prepare_values_2
  mov al, ERC_INVALID_DISK_NUMBER
  ret

l_h_hd_prepare_values_2:
shl esi, 5    // 5 = log2(sizeof(DiskInfoRec))
add esi, offset disk_info
push edi
  mov eax, ebx
  mov edi, edx
  add eax, ecx
  adc edi, 0  // edi:eax = after sector
  cmp edi, dword[esi + offset DiskInfoRec.size_sectors + 4]
  ja l_h_hd_prepare_values_outofrange
  jb l_h_hd_prepare_values_ok
    cmp eax, dword[esi + offset DiskInfoRec.size_sectors]
    jna l_h_hd_prepare_values_ok

  l_h_hd_prepare_values_outofrange:
pop edi
mov al, ERC_OUT_OF_RANGE
ret

 l_h_hd_prepare_values_ok:
 // add partition base
 add ebx, dword[esi + offset DiskInfoRec.base_sectors]
 adc edx, dword[esi + offset DiskInfoRec.base_sectors + 4]

pop edi

mov al, 0
ret

// IN: ah = 0: zero usg only, 1: all, hdt_ldiskn, hdt_pdiskn
// OUT: al = 0 || errorcode
// DESTROY: eax, esi
h_hd_flush:
push edi
 push edx
  push ebx
   push ecx

    xor edx, edx
    mov hdt_savecount, edx
    
    mov edi, HD_CACHE_PA
// (*
    l_h_hd_flush_1:
      mov al, [edi + offset HdCacheRec.dirty]  // dirty
      test al, 1
      jz l_h_hd_flush_next
        mov al, [edi + offset HdCacheRec.diskn]  // ldiskn
        cmp al, hdt_ldiskn
        jnz l_h_hd_flush_next
          test ah, 1
          jnz l_h_hd_flush_block
            mov dx, [edi + offset HdCacheRec.usg]  // usg
            or dx, dx
            jz l_h_hd_flush_block
      
      l_h_hd_flush_next:
      add edi, 16 + 4096
      cmp edi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
      jb l_h_hd_flush_1
// *)
    mov ecx, hdt_savecount
    test ecx, ecx
    jnz l_h_hd_flush_81

    l_h_hd_flush_7:
    
    mov al, 0
    
    l_h_hd_flush_8:

   pop ecx
  pop ebx
 pop edx
pop edi
ret


l_h_hd_flush_block:
// keep ah
mov esi, hdt_savecount
shl esi, 2
add esi, offset hdt_saveofs
// (*
l_h_hd_flush_61:
  cmp esi, offset hdt_saveofs
  jna l_h_hd_flush_65
    mov ebx, [esi - 4]  // ebx = ofs
    mov [esi], ebx
    mov edx, [ebx + 4]  // edx = sector number hw
    cmp [edi + 4], edx
    jnz l_h_hd_flush_62
      mov edx, [ebx]  // edx = sector number lw
      cmp [edi], edx
    
    l_h_hd_flush_62:
    jna l_h_hd_flush_65	// greater first
      sub esi, 4
      jmp short l_h_hd_flush_61
// *)
l_h_hd_flush_65:
mov [esi], edi
inc hdt_savecount
jmp l_h_hd_flush_next


l_h_hd_flush_81:
// IN: ecx = hdt_savecount
mov al, hdt_pdiskn
call h_hd_prepare_port_slave

mov esi, offset hdt_saveofs
shl ecx, 2
add esi, ecx

l_h_hd_flush_82:
 sub esi, 4
 mov edi, [esi]

 mov ebx, [edi + 0]
 mov edx, [edi + 4]
 push edi
   add edi, 16 + VA_SYSTEM
   mov ecx, 8
   call h_hd_p_write
 pop edi
 test al, al
 jnz l_h_hd_flush_8
   mov byte[edi + offset HdCacheRec.dirty], 0  // dirty = false
   cmp esi, offset hdt_saveofs
   ja l_h_hd_flush_82

jmp l_h_hd_flush_7

// OUT: al = 0 || errorcode
// DESTROY: eax
h_hd_shr_usg:
push edi
 push edx

  l_h_hd_shr_usg_0:
  mov edi, HD_CACHE_PA
  and ah, 15
// (*
  l_h_hd_shr_usg_1:
    shr word[edi + offset HdCacheRec.usg], 1  // usg
    mov dx, word[edi + offset HdCacheRec.usg] // usg == 0?
    or dx, dx
    jnz l_h_hd_shr_usg_5
      or ah, 10h

    l_h_hd_shr_usg_5:
    add edi, 16 + 4096
    cmp edi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_shr_usg_1
// *)
  test ah, 10h
  jz l_h_hd_shr_usg_0  // repeat until some usg is zero

  // Flush all disks
  mov al, hdt_pdiskn
  mov ah, hdt_ldiskn
  push eax
   mov edi, HD_CACHE_PA
// (*
   l_h_hd_shr_usg_61:
    mov al, [edi + offset HdCacheRec.dirty]  // dirty
    test al, 1
    jz l_h_hd_shr_usg_68
      mov ax, [edi + offset HdCacheRec.usg]  // usg
      or ax, ax
      jnz l_h_hd_shr_usg_68
        push esi
          mov al, [edi + offset HdCacheRec.diskn]  // ldiskn
          mov hdt_ldiskn, al
          movzx esi, al
          shl esi, 5  // assert sizeof DiskInfoRec = 32
          mov al, disk_info.number[esi]
          mov hdt_pdiskn, al
          call h_hd_prepare_port_slave
          mov ah, 0
          call h_hd_flush
        pop esi
        test al, al
        jnz l_h_hd_shr_usg_691
        
    l_h_hd_shr_usg_68:
    add edi, 16 + 4096
    cmp edi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_shr_usg_61
// *)
  pop eax
  mov hdt_ldiskn, ah
  mov hdt_pdiskn, al
  call h_hd_prepare_port_slave
  mov al, 0
  jmp short l_h_hd_shr_usg_692

   l_h_hd_shr_usg_691:
  pop edx
  mov hdt_ldiskn, dh
  mov hdt_pdiskn, dl

  l_h_hd_shr_usg_692:
 pop edx
pop edi
ret

// OUT: al = 0 || errorcode, esi -> block cache
// DESTROY: eax
h_hd_find_victim:

l_h_hd_find_victim_0:
mov esi, HD_CACHE_PA
// (*
l_h_hd_find_victim_1:
  mov ax, [esi + offset HdCacheRec.usg]  // usg
  or ax, ax
  jz l_h_hd_find_victim_81
    add esi, 16 + 4096
    cmp esi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_find_victim_1
// *)

call h_hd_shr_usg
or al, al
jnz l_h_hd_find_victim_84
  jmp short l_h_hd_find_victim_0

l_h_hd_find_victim_81:

mov al, 0

l_h_hd_find_victim_84:
ret

// IN: edx:ebx = sector, hdt_ldiskn
// OUT: al = 0 || errorcode, esi -> block cache
// DESTROY: eax
h_hd_get_block:
mov esi, HD_CACHE_PA
// (*
l_h_hd_get_block_1:
  cmp [esi + offset HdCacheRec.sectn], ebx  // sector number lw
  jnz l_h_hd_get_block_next
    cmp [esi + offset HdCacheRec.sectn + 4], edx  // sector number hw
    jnz l_h_hd_get_block_next
      mov al, [esi + offset HdCacheRec.diskn]  // ldiskn
      cmp al, hdt_ldiskn
      jnz l_h_hd_get_block_next
        // block found at esi
        cmp word[esi + offset HdCacheRec.usg], 65535  // usg
        jz l_h_hd_get_block_2
        
          inc word[esi + offset HdCacheRec.usg]  // usg++
        
        l_h_hd_get_block_2:

        mov al, 0

        ret
        
  l_h_hd_get_block_next:
  add esi, 16 + 4096
  cmp esi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
  jb l_h_hd_get_block_1
// *)

call h_hd_find_victim
or al, al
jnz l_h_hd_get_block_8
  mov [esi + offset HdCacheRec.sectn], ebx
  mov [esi + offset HdCacheRec.sectn + 4], edx  // sectn
  mov byte[esi + offset HdCacheRec.dirty], 0  // dirty = false
  mov al, -1
  mov [esi + offset HdCacheRec.diskn], al  // diskn, for case of error
  push esi
   push edx
    push ebx
     push ecx
  
      xchg esi, edi
      add edi, 16 + VA_SYSTEM
      mov ecx, 8
      
      // IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
      //     hdt_slave_bit, hdt_port_base
      // OUT: edx:ebx = next sector
      // DESTROY: eax, ecx, hdt_high, hdt_count_remain
      call h_hd_p_read
      xchg esi, edi
      
     pop ecx
    pop ebx
   pop edx
  pop esi
  test al, al
  jnz l_h_hd_get_block_8
    mov al, hdt_ldiskn
    mov [esi + offset HdCacheRec.diskn], al  // ldiskn
    xor eax, eax
    inc eax
    mov [esi + offset HdCacheRec.usg], ax  // usg = 1
    mov byte [esi + offset HdCacheRec.dirty], 0  // dirty = false
    
    mov al, 0

l_h_hd_get_block_8:
ret

h_hd_init:

// Zero hd_busy, hd_cache

xor eax, eax
mov hd_busy, al

push es
  push ds
  pop es
  
  mov hdt_slave_bit, al
  mov hdt_port_base, 1F0h
  mov hd_busy, al
  
  // Init hd_cache
  
  mov edi, HD_CACHE_PA  // es:edi -> hd_cache
  xor eax, eax          // eax = 0
  
  l_h_hd_init_51:
    dec eax  // eax = -1
    stosd
    stosd
    inc eax  // eax = 0
    stosd
    stosd
    add edi, sizeof HdCacheRec - 16
    cmp edi, HD_CACHE_PA + (HD_CACHE_COUNT * sizeof HdCacheRec)
    jb l_h_hd_init_51
  
pop es

ret

l_h_hd_read_x:
mov al, 0
ret

// IN: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// OUT: al = 0 || erc
h_hd_read:
mov hdt_ldiskn, al
movzx esi, al
shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
mov al, disk_info.number[esi]
mov hdt_pdiskn, al
jecxz l_h_hd_read_x

call h_hd_prepare_port_slave
// prepared: hdt_pdiskn, hdt_slave_bit, hdt_port_base

l_h_hd_read_11:
// IN: edx:ebx = ofs, ecx = size
// OUT: edx:ebx = sector number, ecx = sector count (both aligned 4096),
//      al = 0 || errorcode, hdt_relofs, hdt_endrelofs
// DESTROY: eax, esi
call h_hd_prepare_values
or al, al
jz l_h_hd_read_111

  ret  // error

l_h_hd_read_111:

mov ax, hdt_relofs
or ax, ax
jz l_h_hd_read_20

// * Read unaligned first block *

// IN: edx:ebx = sector
// OUT: al = 0 || errorcode, esi -> block cache
// DESTROY: eax
call h_hd_get_block  // esi -> block cache
or al, al
jnz near l_h_hd_read_88

add esi, offset HdCacheRec.data
movzx eax, word hdt_relofs  // eax = hdt_relofs
add esi, eax  // esi += 16 + relofs
sub ecx, 8    // ecx - 8
push ecx
  jecxz l_h_hd_read_12
    mov ecx, 4095  // ecx = 4095
    jmp short l_h_hd_read_13

  l_h_hd_read_12:
    movzx ecx, word hdt_endrelofs  // ecx = endrelofs

  l_h_hd_read_13:
  inc ecx
  sub ecx, eax  // ecx + 1 - relofs
  cld
  rep movsb  // edi += ecx
pop ecx
add ebx, 8
adc edx, 0  // sectn + 8
// as for other blocks, relofs is always 0

l_h_hd_read_20:
or ecx, ecx
jz near l_h_hd_read_85

// * Read aligned blocks *

cmp hdt_endrelofs, 4095
jz l_h_hd_read_21
  sub ecx, 8  // ecx - 8
  or ecx, ecx
  jz near l_h_hd_read_26

// (*
l_h_hd_read_21:

// Is any sector dirty in cache?
mov esi, HD_CACHE_PA

push edi

  xor eax, eax
  dec eax  // eax = -1
  mov dword hdt_min[0], eax
  mov dword hdt_min[4], eax   // hdt_min = maxuns
  mov eax, ebx
  mov edi, edx
  add eax, ecx
  adc edi, 0
  mov dword hdt_tmp1[0], eax
  mov dword hdt_tmp1[4], edi  // hdt_tmp1 = edx:ebx + ecx

  // (*
  l_h_hd_read_22:
    mov al, [esi + offset HdCacheRec.diskn]  // ldiskn
    cmp al, hdt_ldiskn
    jnz l_h_hd_read_2_next
      test byte[esi + offset HdCacheRec.dirty], 1  // dirty
      jz l_h_hd_read_2_next
    // sectn + 8 > edx:ebx && sectn < edx:ebx + ecx
    mov eax, [esi + offset HdCacheRec.sectn]
    mov edi, [esi + offset HdCacheRec.sectn + 4]
    add eax, 8
    adc edi, 0  // edi:eax = sectn + 8
    cmp edi, edx
    jb l_h_hd_read_2_next
    ja l_h_hd_read_23
      cmp eax, ebx
      jna l_h_hd_read_2_next

    l_h_hd_read_23:  // ja: edi:eax > edx:ebx
    sub eax, 8
    sbb edi, 0       // edi:eax = sectn
    cmp edi, dword hdt_tmp1[4]
    ja l_h_hd_read_2_next
    jb l_h_hd_read_24
      cmp eax, dword hdt_tmp1[0]
      jnb l_h_hd_read_2_next

    l_h_hd_read_24:	// jb: edi:eax < edx:ebx + ecx
    // if edi:eax < hdt_min => hdt_min=edi:eax
    cmp edi, dword hdt_min[4]
    jb l_h_hd_read_24t
    ja l_h_hd_read_24f
      cmp eax, dword hdt_min[0]
      jnb l_h_hd_read_24f

    l_h_hd_read_24t:
    mov dword hdt_min[0], eax
    mov dword hdt_min[4], edi

    l_h_hd_read_24f:
    
    l_h_hd_read_2_next:
    add esi, 16 + 4096
    cmp esi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_read_22
  // *)

pop edi

// if(hdt_min != -1){ hdt_x = ecx, ecx = hdt_min - edx:ebx,
//  hdt_x -= ecx, p_read, ecx = hdt_x
//  if(ecx != 0){ copy blk; jmp l_h_hd_read_21; } }
// else p_read
xor eax, eax
dec eax  // eax = -1
cmp eax, dword hdt_min[0]
jnz l_h_hd_read_251
  cmp eax, dword hdt_min[4]
  jnz l_h_hd_read_251
    jmp l_h_hd_read_258

l_h_hd_read_251:
mov dword hdt_tmp1, ecx
mov eax, dword hdt_min[0]
sub eax, ebx
xchg ecx, eax  // ecx = hdt_min - ebx
sub dword hdt_tmp1, ecx
or ecx, ecx
jz l_h_hd_read_252
  call h_hd_p_read  // edx:ebx = next sector
  or eax, eax
  jnz l_h_hd_read_88

l_h_hd_read_252:
  mov ecx, dword hdt_tmp1
  or ecx, ecx
  jz l_h_hd_read_26
    // IN: edx:ebx = sector, fs = ALLMEM
    // OUT: al = 0 || errorcode, esi -> block cache
    // DESTROY: eax
    call h_hd_get_block  // fs:esi -> block cache
    or al, al
    jnz l_h_hd_read_88

add esi, 16
push ecx
  mov ecx, 4096 / 4
  cld
  rep movsd  //edi+=ecx
pop ecx
add ebx, 8
adc edx, 0  // sectn + 8
sub ecx, 8  // ecx - 8
or ecx, ecx
jz l_h_hd_read_26
  jmp l_h_hd_read_21
// *)

l_h_hd_read_258:
// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_slave_bit, hdt_port_base
// OUT: edx:ebx = next sector
// DESTROY: eax, ecx, hdt_high, hdt_count_remain
call h_hd_p_read
or al, al
jnz l_h_hd_read_88

// * Read unaligned last block *

l_h_hd_read_26:
movzx ecx, word hdt_endrelofs
cmp cx, 4095
jz l_h_hd_read_85
  // IN: edx:ebx = sector
  // OUT: al = 0 || errorcode, esi -> block cache
  // DESTROY: eax
  call h_hd_get_block   // esi -> block cache
  or al, al
  jnz l_h_hd_read_88
    add esi, 16
    inc ecx
    cld
    rep movsb
  
l_h_hd_read_85:
mov al, 0

l_h_hd_read_88:

ret

l_h_hd_write_x:
mov al, 0
ret

// IN: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// OUT: al = 0 || erc
h_hd_write:
mov hdt_ldiskn, al
movzx esi, al
shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
mov al, disk_info.number[esi]
mov hdt_pdiskn, al
jecxz l_h_hd_write_x

or byte ptr disk_info.flags[esi], DISK_FLAGS_DIRTY
call h_hd_prepare_port_slave
// prepared: hdt_pdiskn, hdt_slave_bit, hdt_port_base

// IN: edx:ebx = ofs, ecx = size
// OUT: edx:ebx = sector number, ecx = sector count (both aligned 4096),
//      al = 0 || errorcode, hdt_relofs, hdt_endrelofs
// DESTROY: eax, esi
call h_hd_prepare_values
or al, al
jz l_h_hd_write_111

  ret  // error

l_h_hd_write_111:

mov ax, hdt_relofs
or ax, ax
jz l_h_hd_write_20

// * Write unaligned first block *

// IN: edx:ebx = sector
// OUT: al = 0 || errorcode, esi -> block cache
// DESTROY: eax
call h_hd_get_block  // esi -> block cache
xchg esi, edi        // edi -> block cache, es:esi -> buffer
or al, al
jnz near l_h_hd_write_88

or byte[edi + offset HdCacheRec.dirty], 1  // dirty = true
add edi, offset HdCacheRec.data
movzx eax, word hdt_relofs  // eax = hdt_relofs
add edi, eax  // edi += 16 + relofs
sub ecx, 8    // ecx - 8
push ecx
  jecxz l_h_hd_write_12
    mov ecx, 4095  // ecx = 4095
    jmp short l_h_hd_write_13

  l_h_hd_write_12:
    movzx ecx, word hdt_endrelofs  // ecx = endrelofs

  l_h_hd_write_13:
  inc ecx
  sub ecx, eax  // ecx + 1 - relofs

  push ds
   push es
   pop ds
  pop es  // es<->ds

  cld
  rep movsb

  push ds
   push es
   pop ds
  pop es  // es<->ds

pop ecx
xchg esi, edi  // es:edi -> buffer+
add ebx, 8
adc edx, 0     // sectn + 8
// as for other blocks, relofs is always 0

l_h_hd_write_20:
or ecx, ecx
jz near l_h_hd_write_85

// * Write aligned blocks *

cmp hdt_endrelofs, 4095
jz l_h_hd_write_21
  sub ecx, 8  // ecx - 8
  jecxz l_h_hd_write_26

l_h_hd_write_21:
// Invalidate overwritten blocks in cache
mov esi, HD_CACHE_PA

push edi

  mov eax, ebx
  mov edi, edx
  add eax, ecx
  adc edi, 0
  mov dword hdt_tmp1[0], eax
  mov dword hdt_tmp1[4], edi  // hdt_tmp1 = edx:ebx + ecx

  // (*
  l_h_hd_write_22:
    mov al, [esi + offset HdCacheRec.diskn]  // diskn
    cmp al, hdt_ldiskn
    jnz l_h_hd_write_2_next
      // sectn + 8 > edx:ebx && sectn < edx:ebx + ecx
      mov eax, [esi + offset HdCacheRec.sectn]
      mov edi, [esi + offset HdCacheRec.sectn + 4]
      add eax, 8
      adc edi, 0  // edi:eax = sectn + 8
      cmp edi, edx
      jb l_h_hd_write_2_next
      ja l_h_hd_write_23
        cmp eax, ebx
        jna l_h_hd_write_2_next

      l_h_hd_write_23:  // ja: edi:eax > edx:ebx
      sub eax, 8
      sbb edi, 0        // edi:eax = sectn
      cmp edi, dword hdt_tmp1[4]
      ja l_h_hd_write_2_next
      jb l_h_hd_write_24
        cmp eax, dword hdt_tmp1[0]
        jnb l_h_hd_write_2_next

      l_h_hd_write_24:  // jb: edi:eax < edx:ebx + ecx
      xor eax, eax
      dec eax             // eax = -1
      mov [esi + offset HdCacheRec.sectn], eax
      mov [esi + offset HdCacheRec.sectn + 4], eax  // sectn = -1
      inc eax             // eax = 0
      mov [esi + offset HdCacheRec.usg], ax  // usg = 0
      mov [esi + offset HdCacheRec.dirty], al // dirty = false
    
    l_h_hd_write_2_next:
    add esi, 16 + 4096
    cmp esi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_write_22
  // *)

pop edi

// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_slave_bit, hdt_port_base
// OUT: edx:ebx = next sector
// DESTROY: eax, ecx, hdt_high, hdt_count_remain
call h_hd_p_write
or eax, eax
jnz l_h_hd_write_88

// * Write unaligned last block *

l_h_hd_write_26:
movzx ecx, word hdt_endrelofs
cmp cx, 4095
jz l_h_hd_write_85
  // IN: edx:ebx = sector
  // OUT: al = 0 || errorcode, esi -> block cache
  // DESTROY: eax
  call h_hd_get_block  // esi -> block cache
  xchg esi, edi        // edi -> block cache, es:esi -> buffer
  or al, al
  jnz l_h_hd_write_88
    or byte[edi + offset HdCacheRec.dirty], 1  // dirty = true
    add edi, 16
    inc ecx
    
    push ds
     push es
     pop ds
    pop es  // es<->ds

    cld
    rep movsb

    push ds
     push es
     pop ds
    pop es  // es<->ds

l_h_hd_write_85:
mov al, 0

l_h_hd_write_88:
 
ret

// IN: ah = operation
// ah = 0: al = ldiskn
// ah = 2: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// ah = 3: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// ah = 4: al = ldiskn
// ah = 5: al = ldiskn
h_hd_main:

cmp ah, 2
jnz l_h_hd_main_3
  // read
  jmp h_hd_read

l_h_hd_main_3:
cmp ah, 3
jnz l_h_hd_main_4
  // write
  jmp h_hd_write

l_h_hd_main_4:
cmp ah, 4
jnz l_h_hd_main_5
  // get disk size (al = ldiskn)
  movzx esi, al
  shl esi, 5  // log2(DiskInfoRec)
  cmp al, 32
  jb l_h_hd_main_44
    xor edx, edx
    xor eax, eax
    ret
  
  l_h_hd_main_44:
  add esi, offset disk_info.size_sectors
  mov eax, dword[esi]
  mov edx, dword[esi+4]
  mov esi, eax
  shl eax, 9
  shl edx, 9
  shr esi, 32-9
  or edx, esi
  ret

l_h_hd_main_5:
cmp ah, 5
jnz l_h_hd_main_7
  // flush (al = ldiskn)
  cmp al, 32
  jnb l_h_hd_main_58
    mov hdt_ldiskn, al
    movzx esi, al
    shl esi, 5  // log2(sizeof(DiskInfoRec))
    cmp disk_info.fsid[esi], FSID_EXT2
    jnz l_h_hd_main_52
      // backup EXT2
      push esi
        call e2_backup
      pop esi
      mov al, hdt_ldiskn
      
    l_h_hd_main_52:
    mov al, disk_info.number[esi]
    mov hdt_pdiskn, al
    mov ah, 1  // flush all
    call h_hd_flush
    
    // hardware flush
    mov al, hdt_pdiskn
    test al, 40h
    jnz l_h_hd_main_54
      call h_hd_prepare_port_slave
      call h_hd_p_flush
      jmp short l_h_hd_main_58
      
    l_h_hd_main_54:
    call h_sd_p_flush
    
  l_h_hd_main_58:
  ret

l_h_hd_main_7:
cmp ah, 7
jnz l_h_hd_main_1
  // format
  //...
  mov al, ERC_NOT_IMPLEMENTED
  ret

l_h_hd_main_1:
cmp ah, 1
jnz l_h_hd_main_0
  // reset
  xor eax, eax
  mov dword hd_state, eax
  mov hd_busy, al
  ret

l_h_hd_main_0:
cmp ah, 0
jnz l_h_hd_main_x
  // init
  jmp h_hd_init

l_h_hd_main_x:
// error
mov al, ERC_NOT_IMPLEMENTED
ret

//hdirq1: db "HD INT\0"

IRQ14:
IRQ15:
/*
pushad
 push ds
  push es
    push SELECTOR_KERNEL_DATA
    pop ds  // ds = KERNEL_DATA
    push SELECTOR_ALL_DATA
    pop es  // es = ALL
    
    //inc hd_irqs
    
    //mov esi, offset hdirq1
    //call writec
    
    mov al, 20h
    out 20h, al
  pop es
 pop ds
popad
*/
iretd

uns1 cd_packet[12], cd_buffer[2048]
uns4 cd_lba

// IN: hdt_slave_bit, hdt_port_base, es:edi -> buffer
h_hd_p_identifyp:
push edx

  mov dx, hdt_port_base

  mov al, hdt_slave_bit
  or dl, 6
  out dx, al

  mov al, ATA_CMD_IDENTIFYP
  or dl, 7		// dx = HD_PORT_COMMAND (7)
  out dx, al

  h_hd_p_identifyp5:
    or dl, 7	// dx = HD_PORT_STATUS (7)
    in al, dx
    test al, HD_STATUS_BUSY
    jz h_hd_p_identifyp6
      //... noop();
      jmp h_hd_p_identifyp5
  
  h_hd_p_identifyp6:
  test al, HD_STATUS_ERROR | HD_STATUS_FAULT
  jnz l_h_hd_p_identifyperror
  
  push ecx
   and dl, 0F8h	// dx = HD_PORT_DATA (0)
   mov ecx, 512/4
   cld
   rep insd
  pop ecx
  
pop edx

xor eax, eax
ret

l_h_hd_p_identifyperror:
pop edx
jmp l_h_hd_p_error

// IN: ebx = sector number, hdt_pdiskn, hdt_port_base, hdt_slave_bit
// KEEP: ebx, ecx, edi
h_cd_p_read:
mov word ptr cd_packet[0], SCSI_COMMAND_READ10

mov eax, ebx
shr eax, 16
mov byte ptr cd_packet[2], ah
mov byte ptr cd_packet[3], al
mov byte ptr cd_packet[4], bh
mov byte ptr cd_packet[5], bl

mov byte ptr cd_packet[6], 0

mov byte ptr cd_packet[7], 1 / 256
mov byte ptr cd_packet[8], 1 & 255

mov byte ptr cd_packet[9], 0
mov word ptr cd_packet[10], 0

test hdt_pdiskn, 40h
jnz near h_sd_p_cd_read

push ebx
 push ecx
  
  mov dx, hdt_port_base
  
  mov al, hdt_slave_bit
  or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
  out dx, al
  
  sub dl, 5 // dx = 1
  mov al, 0 // 0: PIO, 1:DMA
  out dx, al
  
  add dl, 3 // dx = 4
  mov al, 2048 & 255
  out dx, al
  inc dl    // dx = 5
  mov al, 2048 >> 8
  out dx, al
  
  mov al, ATA_CMD_PACKET
  or dl, 7  // dx = HD_PORT_COMMAND (7)
  out dx, al
  
  l_h_cd_p_read_5:
    or dl, 7  // dx = HD_PORT_STATUS (7)
    in al, dx
    test al, HD_STATUS_BUSY
    jz l_h_cd_p_read_6
      //... noop();
      jmp l_h_cd_p_read_5
  
  l_h_cd_p_read_6:
  test al, HD_STATUS_ERROR | HD_STATUS_FAULT
  jnz l_h_cd_p_read_error

  //mov bl, hd_irqs
  
  // write packet
  and dl, 0F8h  // dx = HD_PORT_DATA (0)
  mov esi, offset cd_packet
  mov ecx, 6
/*
  movzx eax, byte ptr cd_packet[8]
  call wregs//$$$
  mov ebx, 500
  call busywait
*/
  cld
  rep outsw
  
  // wait
  l_h_cd_p_read_7:
    or dl, 7  // dx = HD_PORT_STATUS (7)
    in al, dx
    test al, HD_STATUS_BUSY
    jz l_h_cd_p_read_8
      call p_noop
      jmp l_h_cd_p_read_7

  l_h_cd_p_read_8:
  test al, HD_STATUS_ERROR | HD_STATUS_FAULT
  jnz l_h_cd_p_read_error

  // read byte count
  and dl, 0F8h
  add dl, 4  // dx = HD_PORT_CYLLOW (4) / LBA mid
  in al, dx
  mov cl, al
  inc dl  // dx = HD_PORT_CYLHIGH (5) / LBA high
  in al, dx
  mov ch, al
  movzx ecx, cx  // assert ecx = 2048
  cmp ecx, 800h
  jz l_h_cd_p_read_85
    mov al, ERC_UNKNOWN_GEOMETRY
     pop ecx
    pop ebx
    jmp short l_h_cd_p_read_9

  l_h_cd_p_read_85:

  //mov bl, hd_irqs

  // read data
  push edi
    and dl, 0F8h  // dx = HD_PORT_DATA (0)
    mov edi, VA_SYSTEM + offset cd_buffer
    shr ecx, 2
    rep insd
  pop edi
/*
  // wait for irq
  l_h_cd_p_read_85:
  cmp bl, hd_irqs
  jnz l_h_cd_p_read_88
    call p_noop
    jmp short l_h_cd_p_read_85

  l_h_cd_p_read_88:
*/
 pop ecx
pop ebx

mov al, 0

l_h_cd_p_read_9:
ret

l_h_cd_p_read_error:
 pop ecx
pop ebx
jmp l_h_hd_p_error

h_cd_init:
mov cd_lba, -1
ret

// IN: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
h_cd_read:
mov hdt_ldiskn, al
movzx esi, al
shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
mov al, disk_info.number[esi]
mov hdt_pdiskn, al
call h_hd_prepare_port_slave

// Prepare values
// relofs*
mov eax, ebx
and eax, 2047
mov hdt_relofs, ax
add eax, ecx
mov esi, eax  // esi = hdt_relofs + size
dec eax
and ax, 2047
mov hdt_endrelofs, ax
// sector count
xchg eax, esi
add eax, 2047
shr eax, 11    // log2(2048)
xchg ecx, eax
// sector number
mov eax, edx
shr ebx, 11    // log2(2048)
shr edx, 11
shl eax, 32 - 11
or ebx, eax

l_h_cd_read_5:
jecxz l_h_cd_read_8
  dec ecx
  
  cmp ebx, cd_lba
  jz l_h_cd_read_6
    call h_cd_p_read  // keep ebx, ecx, edi
    mov cd_lba, ebx
    
  l_h_cd_read_6:
  mov eax, offset cd_buffer
  push ecx

    movzx esi, hdt_relofs
    add esi, eax
    or ecx, ecx
    jnz l_h_cd_read_7
      movzx ecx, hdt_endrelofs
      inc ecx
      jmp short l_h_cd_read_72
    
    l_h_cd_read_7:
      mov ecx, 2048
  
    l_h_cd_read_72:
    sub cx, hdt_relofs
    cld
    rep movsb

  pop ecx
  inc ebx
  mov hdt_relofs, 0
  jmp l_h_cd_read_5

l_h_cd_read_8:
mov al, 0
ret

// IN: ah = operation
// ah = 2: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// ah = 4: al = ldiskn
h_cd_main:
and al, 31
cmp ah, 2
jnz l_h_cd_main_2
  jmp h_cd_read
  
l_h_cd_main_2:
cmp ah, 4
jnz l_h_cd_main_8
  movzx esi, al
  shl esi, 5  // assert sizeof DiskInfoRec = 32
  add esi, offset disk_info.size_sectors
  mov eax, dword[esi]
  mov edx, dword[esi+4]
  mov esi, eax
  shl eax, 9
  shl edx, 9
  shr esi, 32-9
  or edx, esi
  jmp short l_h_cd_main_9
  
l_h_cd_main_8:
mov al, ERC_NOT_IMPLEMENTED

l_h_cd_main_9:
ret

FIS_TYPE_REG_H2D   = 0x27	// Register FIS - host to device
FIS_TYPE_REG_D2H   = 0x34	// Register FIS - device to host
FIS_TYPE_DMA_ACT   = 0x39	// DMA activate FIS - device to host
FIS_TYPE_DMA_SETUP = 0x41	// DMA setup FIS - bidirectional
FIS_TYPE_DATA      = 0x46	// Data FIS - bidirectional
FIS_TYPE_BIST      = 0x58	// BIST activate FIS - bidirectional
FIS_TYPE_PIO_SETUP = 0x5F	// PIO setup FIS - device to host
FIS_TYPE_DEV_BITS  = 0xA1	// Set device bits FIS - device to host

HBA_PxCMD_CR  = (1 << 15) /* CR - Command list Running */
HBA_PxCMD_FR  = (1 << 14) /* FR - FIS receive Running */
HBA_PxCMD_FRE = (1 <<  4) /* FRE - FIS Receive Enable */
HBA_PxCMD_SUD = (1 <<  1) /* SUD - Spin-Up Device */
HBA_PxCMD_ST  = (1 <<  0) /* ST - Start (command processing) */

HBA_PxIS_TFES = 1 << 30

RA_SD_BUFFER = (256 * 32) + (1024 * 32) + (256 * 32)

struct HbaMemRec{
  // 0x00 - 0x2B, Generic Host Control
  uns4 cap		// 0x00, Host capability
  uns4 ghc		// 0x04, Global host control
  uns4 is		// 0x08, Interrupt status
  uns4 pi		// 0x0C, Port implemented
  uns4 vs		// 0x10, Version
  uns4 ccc_ctl	// 0x14, Command completion coalescing control
  uns4 ccc_pts	// 0x18, Command completion coalescing ports
  uns4 em_loc	// 0x1C, Enclosure management location
  uns4 em_ctl	// 0x20, Enclosure management control
  uns4 cap2		// 0x24, Host capabilities extended
  uns4 bohc		// 0x28, BIOS/OS handoff control and status
   
  // 0x2C - 0x9F, Reserved
  uns1 rsv[0xA0-0x2C];
   
  // 0xA0 - 0xFF, Vendor specific registers
  uns1 vendor[0x100-0xA0];
}

struct HbaPortRec{
  uns4 clb		// 0x00, command list base address, 1K-byte aligned
  uns4 clbu		// 0x04, command list base address upper 32 bits
  uns4 fb		// 0x08, FIS base address, 256-byte aligned
  uns4 fbu		// 0x0C, FIS base address upper 32 bits
  uns4 is		// 0x10, interrupt status
  uns4 ie		// 0x14, interrupt enable
  uns4 cmd		// 0x18, command and status
  uns4 rsv0		// 0x1C, Reserved
  uns4 tfd		// 0x20, task file data
  uns4 sig		// 0x24, signature
  uns4 ssts		// 0x28, SATA status (SCR0:SStatus)
  uns4 sctl		// 0x2C, SATA control (SCR2:SControl)
  uns4 serr		// 0x30, SATA error (SCR1:SError)
  uns4 sact		// 0x34, SATA active (SCR3:SActive)
  uns4 ci		// 0x38, command issue
  uns4 sntf		// 0x3C, SATA notification (SCR4:SNotification)
  uns4 fbs		// 0x40, FIS-based switch control
  uns4 rsv1[11]	// 0x44 ~ 0x6F, Reserved
  uns4 vendor[4]	// 0x70 ~ 0x7F, vendor specific
}

struct HbaCmdHeader{
  // DWORD 0
  uns1 cflawp
  // 0-4: Command FIS length in DWORDS, 2 ~ 16
  // 5: ATAPI
  // 6: Write
  // 7: Prefetchable
  uns1 rbcpmp
  // 0: reset
  // 1: BIST
  // 2: Clear busy upon R_OK
  // 4-7: port multiplier
  uns2 prdtl	// Physical region descriptor table length in entries
  
  // DWORD 1
  uns4 prdbc	// Physical region descriptor byte count transferred
  
  // DWORD 2, 3
  uns4 ctba		// Command table descriptor base address
  uns4 ctbau	// Command table descriptor base address upper 32 bits
  
  // DWORD 4 - 7
  uns4 rsv[4];	// Reserved
}

struct HbaCmdTbl{
  uns1 cfis[64]	// 0x00, Command FIS
  uns1 acmd[16]	// 0x40, ATAPI command, 12 or 16 bytes
  uns1 rsv[48]	// 0x50, Reserved
  // 0x80, HbaPrdtEntry prdt_entry[prdtl]
  // Physical region descriptor table entries, 0..65535
}

struct HbaPrdtEntry{
  uns4 dba	// Data base address
  uns4 dbau	// Data base address upper 32 bits
  uns4 rsv	// Reserved 
  uns4 dbci
  // 0 - 21: Byte count - 1, 4M max, always odd
  // 22-30: reserved
  // 31: Interrupt on completion
}

struct FisRegH2D{
  // DWORD 0
  uns1 fis_type  // FIS_TYPE_REG_H2D
  uns1 pmportc
  // 0-4: Port multiplier
  // 80h: Command, 0: Control
  uns1 command   // Command register
  uns1 featurel  // Feature register, 7:0
  
  // DWORD 1
  uns1 lba0		// LBA low register, 7:0
  uns1 lba1		// LBA mid register, 15:8
  uns1 lba2		// LBA high register, 23:16
  uns1 device	// Device register
  
  // DWORD 2
  uns1 lba3		// LBA register, 31:24
  uns1 lba4		// LBA register, 39:32
  uns1 lba5		// LBA register, 47:40
  uns1 featureh	// Feature register, 15:8
  
  // DWORD 3
  uns1 countl	// Count register, 7:0
  uns1 counth	// Count register, 15:8
  uns1 icc		// Isochronous command completion
  uns1 control	// Control register
  
  // DWORD 4
  uns1 rsv[4]	// Reserved
}

// IN: hdt_pdiskn, edx:ebx = sector, ecx = count, es:edi -> buffer
// OUT: al = erc, edx:ebx = next sector
// KEEP: esi
// USES: hdt_count_remain, sd_sect
h_sd_p_read:
push esi
 push ecx
  mov dword ptr sd_sect[0], ebx
  mov dword ptr sd_sect[4], edx
  mov esi, edi
  
  l_h_sd_p_read_1:
  xor eax, eax
  cmp ecx, 8
  jna l_h_sd_p_read_11
    mov eax, ecx
    sub eax, 8
    mov ecx, 8
    
  l_h_sd_p_read_11:
  mov hdt_count_remain, eax
  
  mov al, hdt_pdiskn
  and al, 31
  movzx eax, al
  mov sd_port_n, eax
  shl eax, 7  // * 80h
  add eax, abar
  add eax, 100h
  mov sd_port_ebx, eax
  
  mov ebx, eax
  add ebx, offset HbaPortRec.is
  mov eax, -1
  push ecx
    call m_phys_set  // destroys ecx
  pop ecx
  
  mov eax, sd_port_n
  shl eax, 10  // * 1024
  add eax, 256 * 32 + VA_SD
  mov edi, eax  // es:edi -> cmdheader
  
  mov al, sizeof FisRegH2D / 4
  //or al, 20h  // ATAPI
  //or al, 40h  // write
  or al, 80h  // Prefetch
  mov [es:edi + offset HbaCmdHeader.cflawp], al
  mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1  // prdtl - prdt count
  mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], 4095  // byte count - 1
  
  mov edi, [es:edi + offset HbaCmdHeader.ctba]
  sub edi, sd_base
  add edi, VA_SD
  
  mov al, FIS_TYPE_REG_H2D
  mov [es:edi + offset FisRegH2D.fis_type], al
  mov al, 80h  // command
  mov [es:edi + offset FisRegH2D.pmportc], al
  mov al, ATA_CMD_READ_DMA_EX
  mov [es:edi + offset FisRegH2D.command], al
  
  mov al, byte ptr sd_sect[0]
  mov [es:edi + offset FisRegH2D.lba0], al
  mov al, byte ptr sd_sect[1]
  mov [es:edi + offset FisRegH2D.lba1], al
  mov al, byte ptr sd_sect[2]
  mov [es:edi + offset FisRegH2D.lba2], al
  mov al, 1 << 6  // LBA mode
  mov [es:edi + offset FisRegH2D.device], al
  mov al, byte ptr sd_sect[3]
  mov [es:edi + offset FisRegH2D.lba3], al
  mov al, byte ptr sd_sect[4]
  mov [es:edi + offset FisRegH2D.lba4], al
  mov al, byte ptr sd_sect[5]
  mov [es:edi + offset FisRegH2D.lba5], al
  
  mov [es:edi + offset FisRegH2D.countl], cx  // sector count
  
  add edi, 80h  // es:edi -> PRDT
  mov eax, sd_base
  add eax, RA_SD_BUFFER
  mov [es:edi + offset HbaPrdtEntry.dba], eax
  mov eax, ecx
  shl eax, 9
  dec eax
  //or eax, 1 << 31  // int on completion
  mov [es:edi + offset HbaPrdtEntry.dbci], eax
  
  // wait not busy
  l_h_sd_p_read_65:
    mov ebx, sd_port_ebx
    add ebx, offset HbaPortRec.tfd
    call m_phys_get
    test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
    jnz l_h_sd_p_read_65
  
  // issue command
  mov eax, 1  // 1 << slot
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.ci
  push ecx
    call m_phys_set  // destroys ecx
  pop ecx
  
  // wait for completion
  l_h_sd_p_read_75:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.ci
  call m_phys_get
  test eax, 1  // 1 << slot
  jz l_h_sd_p_read_78
    mov ebx, sd_port_ebx
    add ebx, offset HbaPortRec.is
    call m_phys_get
    test eax, HBA_PxIS_TFES
    jz l_h_sd_p_read_75
      // error
      mov al, ERC_DISK_IO
      jmp short l_h_sd_p_read_9
      
  l_h_sd_p_read_78:
  // copy
  shl ecx, 9 - 2  // 512 / 4
  mov edi, esi
  mov esi, RA_SD_BUFFER + VA_SD
  push ds
    push es
    pop ds
    cld
    rep movsd
  pop ds
  mov esi, edi
  
  // remaining sectors
  mov ecx, hdt_count_remain
  or ecx, ecx
  jnz near l_h_sd_p_read_1
  
  mov al, 0
  
  l_h_sd_p_read_9:
 pop ecx
pop esi
mov ebx, dword ptr sd_sect[0]
mov edx, dword ptr sd_sect[4]
add ebx, ecx
adc edx, 0
ret

// IN: hdt_pdiskn, edx:ebx = sector, ecx = count, es:edi -> buffer
// OUT: al = erc, edx:ebx = next sector
// KEEP: esi
// USES: hdt_count_remain, sd_sect
h_sd_p_write:
push esi
 push ecx
  mov dword ptr sd_sect[0], ebx
  mov dword ptr sd_sect[4], edx
  mov esi, edi
  
  l_h_sd_p_write_1:
  xor eax, eax
  cmp ecx, 8
  jna l_h_sd_p_write_11
    mov eax, ecx
    sub eax, 8
    mov ecx, 8
    
  l_h_sd_p_write_11:
  mov hdt_count_remain, eax
  
  // copy
  push ecx
    shl ecx, 9 - 2  // 512 / 4
    mov edi, RA_SD_BUFFER + VA_SD
    push ds
      push es
      pop ds
      cld
      rep movsd
    pop ds
  pop ecx
  
  // prepare IO
  mov al, hdt_pdiskn
  and al, 31
  movzx eax, al
  mov sd_port_n, eax
  shl eax, 7  // * 80h
  add eax, abar
  add eax, 100h
  mov sd_port_ebx, eax
  
  mov ebx, eax
  add ebx, offset HbaPortRec.is
  mov eax, -1
  push ecx
    call m_phys_set  // destroys ecx
  pop ecx
  
  mov eax, sd_port_n
  shl eax, 10  // * 1024
  add eax, 256 * 32 + VA_SD
  mov edi, eax  // es:edi -> cmdheader
  
  mov al, sizeof FisRegH2D / 4
  //or al, 20h  // ATAPI
  or al, 40h  // write
  //or al, 80h  // Prefetch
  mov [es:edi + offset HbaCmdHeader.cflawp], al
  mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1  // prdtl - prdt count
  mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], 4095  // byte count - 1
  
  mov edi, [es:edi + offset HbaCmdHeader.ctba]
  sub edi, sd_base
  add edi, VA_SD
  
  mov al, FIS_TYPE_REG_H2D
  mov [es:edi + offset FisRegH2D.fis_type], al
  mov al, 80h  // command
  mov [es:edi + offset FisRegH2D.pmportc], al
  mov al, ATA_CMD_WRITE_DMA_EX
  mov [es:edi + offset FisRegH2D.command], al
  
  mov al, byte ptr sd_sect[0]
  mov [es:edi + offset FisRegH2D.lba0], al
  mov al, byte ptr sd_sect[1]
  mov [es:edi + offset FisRegH2D.lba1], al
  mov al, byte ptr sd_sect[2]
  mov [es:edi + offset FisRegH2D.lba2], al
  mov al, 1 << 6  // LBA mode
  mov [es:edi + offset FisRegH2D.device], al
  mov al, byte ptr sd_sect[3]
  mov [es:edi + offset FisRegH2D.lba3], al
  mov al, byte ptr sd_sect[4]
  mov [es:edi + offset FisRegH2D.lba4], al
  mov al, byte ptr sd_sect[5]
  mov [es:edi + offset FisRegH2D.lba5], al
  
  mov [es:edi + offset FisRegH2D.countl], cx  // sector count
  
  add edi, 80h  // es:edi -> PRDT
  mov eax, sd_base
  add eax, RA_SD_BUFFER
  mov [es:edi + offset HbaPrdtEntry.dba], eax
  mov eax, ecx
  shl eax, 9
  dec eax
  //or eax, 1 << 31  // int on completion
  mov [es:edi + offset HbaPrdtEntry.dbci], eax
  
  // wait not busy
  l_h_sd_p_write_65:
    mov ebx, sd_port_ebx
    add ebx, offset HbaPortRec.tfd
    call m_phys_get
    test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
    jnz l_h_sd_p_write_65
  
  // issue command
  mov eax, 1  // 1 << slot
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.ci
  push ecx
    call m_phys_set  // destroys ecx
  pop ecx
  
  // wait for completion
  l_h_sd_p_write_75:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.ci
  call m_phys_get
  test eax, 1  // 1 << slot
  jz l_h_sd_p_write_78
    mov ebx, sd_port_ebx
    add ebx, offset HbaPortRec.is
    call m_phys_get
    test eax, HBA_PxIS_TFES
    jz l_h_sd_p_write_75
      // error
      mov al, ERC_DISK_IO
      jmp short l_h_sd_p_write_9
      
  l_h_sd_p_write_78:
  // remaining sectors
  mov ecx, hdt_count_remain
  or ecx, ecx
  jnz near l_h_sd_p_write_1
  
  mov al, 0
  
  l_h_sd_p_write_9:
 pop ecx
pop esi
mov ebx, dword ptr sd_sect[0]
mov edx, dword ptr sd_sect[4]
add ebx, ecx
adc edx, 0
ret

SCD_BUFFER_SIZE = 800h

// IN: hdt_pdiskn, cd_packet
// KEEP: ebx, ecx, edi
h_sd_p_cd_read:
push ebx
 push ecx
  push edi
  
mov al, hdt_pdiskn
and al, 31
movzx eax, al
mov sd_port_n, eax
shl eax, 7  // * 80h
add eax, abar
add eax, 100h
mov sd_port_ebx, eax

mov ebx, eax
add ebx, offset HbaPortRec.is
mov eax, -1
call m_phys_set  // destroys ecx

mov eax, sd_port_n
shl eax, 10  // * 1024
add eax, 256 * 32 + VA_SD
mov edi, eax  // es:edi -> cmdheader

mov al, sizeof FisRegH2D / 4
or al, 20h  // ATAPI
//or al, 40h  // write
or al, 80h  // Prefetch
mov [es:edi + offset HbaCmdHeader.cflawp], al
mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1  // prdtl - prdt count
mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], SCD_BUFFER_SIZE - 1  // byte count - 1

mov edi, [es:edi + offset HbaCmdHeader.ctba]
sub edi, sd_base
add edi, VA_SD

mov al, FIS_TYPE_REG_H2D
mov [es:edi + offset FisRegH2D.fis_type], al
mov al, 80h  // command
mov [es:edi + offset FisRegH2D.pmportc], al
mov al, ATA_CMD_PACKET
mov [es:edi + offset FisRegH2D.command], al

add edi, 40h // es:edi -> acmd
mov eax, dword ptr cd_packet[0]
mov [es:edi + 0], eax
mov eax, dword ptr cd_packet[4]
mov [es:edi + 4], eax
mov eax, dword ptr cd_packet[8]
mov [es:edi + 8], eax

add edi, 40h  // es:edi -> PRDT
mov eax, offset cd_buffer  // physical adr
mov [es:edi + offset HbaPrdtEntry.dba], eax
mov eax, SCD_BUFFER_SIZE - 1
//or eax, 1 << 31  // int on completion
mov [es:edi + offset HbaPrdtEntry.dbci], eax

// wait not busy
l_h_sd_p_cd_read_65:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.tfd
  call m_phys_get
  test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
  jnz l_h_sd_p_cd_read_65

// issue command
mov eax, 1  // 1 << slot
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_set  // destroys ecx

// wait for completion
l_h_sd_p_cd_read_75:
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_get
test eax, 1  // 1 << slot
jz l_h_sd_p_cd_read_78
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.is
  call m_phys_get
  test eax, HBA_PxIS_TFES
  jz l_h_sd_p_cd_read_75
    // error
    mov al, ERC_DISK_IO
    jmp short l_h_sd_p_cd_read_9
    
l_h_sd_p_cd_read_78:

mov al, 0

l_h_sd_p_cd_read_9:
  pop edi
 pop ecx
pop ebx
ret

// IN: ecx = port no, abar, sd_base, VA_SD
h_sd_rebase_port:
mov eax, ecx
shl eax, 8
add eax, sd_base //VA_SD
mov esi, eax  // esi = portno * 256 + sd_base

mov eax, ecx
shl eax, 10
add eax, 32 * 256
add eax, sd_base  //VA_SD
mov edi, eax  // edi = portno * 1024 + (32 * 256) + sd_base

/*
// stop
mov ebx, abar
add ebx, offset HbaMemRec.ghc
mov eax, 1 << 31
call m_phys_set
mov eax, 1 << 0
call m_phys_set
mov eax, 1 << 31
call m_phys_set
mov eax, 1 << 1
call m_phys_set
*/

push ecx

  mov ebx, ecx
  shl ebx, 7  // * 80h
  add ebx, 100h
  add ebx, abar
  mov edx, ebx  // edx -> port
  
  add ebx, offset HbaPortRec.cmd
  call m_phys_get
  and eax, -1 - HBA_PxCMD_ST - HBA_PxCMD_FRE
  call m_phys_set
  
  l_h_sd_rebase_port_1:
    call m_phys_get
    test eax, HBA_PxCMD_FR | HBA_PxCMD_CR
    jnz l_h_sd_rebase_port_1
  
  and eax, -1 - HBA_PxCMD_CR - HBA_PxCMD_FR - HBA_PxCMD_FRE - HBA_PxCMD_ST
  call m_phys_set
  
  // set fb = esi
  mov ebx, edx
  add ebx, offset HbaPortRec.fb
  mov eax, esi  
  call m_phys_set
  add ebx, 4
  xor eax, eax
  call m_phys_set
  
  // set clb = edi
  mov ebx, edx
  add ebx, offset HbaPortRec.clb
  mov eax, edi
  call m_phys_set
  add ebx, 4
  xor eax, eax
  call m_phys_set

pop ecx
  
// make ctb
mov eax, ecx
shl eax, 8
add eax, 32 * 256 + (32 * 1024)
add eax, sd_base
mov esi, eax  // esi = portno * 256 + (32 * 256) + (32 * 1024) + sd_base

// slot 0
sub edi, sd_base
add edi, VA_SD
mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1
mov dword ptr [es:edi + offset HbaCmdHeader.ctba], esi
xor eax, eax  // eax = 0
mov dword ptr [es:edi + offset HbaCmdHeader.ctbau], eax  
add edi, sizeof HbaCmdHeader

// slots 1..31
mov ecx, 31 * 32 / 4
cld
rep stosd

// zero ctb
mov edi, esi
sub edi, sd_base
add edi, VA_SD
mov ecx, 256 / 4
rep stosd

// start
mov ebx, edx
add ebx, offset HbaPortRec.cmd

l_h_sd_rebase_port_3:
  call m_phys_get
  test eax, HBA_PxCMD_CR
  jnz l_h_sd_rebase_port_3

or eax, HBA_PxCMD_FRE | HBA_PxCMD_ST
call m_phys_set

// port.is = 0
mov ebx, edx
add ebx, offset HbaPortRec.is
xor eax, eax
call m_phys_set

// port.ie = -1
mov ebx, edx
add ebx, offset HbaPortRec.ie
xor eax, eax
dec eax
call m_phys_set

ret

// IN: hdt_pdiskn
// OUT: al = erc
h_sd_p_flush:

mov al, hdt_pdiskn
and al, 31
movzx eax, al
mov sd_port_n, eax
shl eax, 7  // * 80h
add eax, abar
add eax, 100h
mov sd_port_ebx, eax

mov ebx, eax
add ebx, offset HbaPortRec.is
mov eax, -1
call m_phys_set  // destroys ecx

mov eax, sd_port_n
shl eax, 10  // * 1024
add eax, 256 * 32 + VA_SD
mov edi, eax  // es:edi -> cmdheader

mov al, sizeof FisRegH2D / 4
//or al, 20h  // ATAPI
//or al, 40h  // write
//or al, 80h  // Prefetch
mov [es:edi + offset HbaCmdHeader.cflawp], al
mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 0  // prdtl - prdt count
//mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], 4095  // byte count - 1

mov edi, [es:edi + offset HbaCmdHeader.ctba]
sub edi, sd_base
add edi, VA_SD

mov al, FIS_TYPE_REG_H2D
mov [es:edi + offset FisRegH2D.fis_type], al
mov al, 80h  // command
mov [es:edi + offset FisRegH2D.pmportc], al
mov al, ATA_CMD_FLUSH_EX
mov [es:edi + offset FisRegH2D.command], al
mov byte ptr [es:edi + offset FisRegH2D.device], 0
mov word ptr [es:edi + offset FisRegH2D.countl], 0

// wait not busy
l_h_sd_p_flush_65:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.tfd
  call m_phys_get
  test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
  jnz l_h_sd_p_flush_65

// issue command
mov eax, 1  // 1 << slot
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_set  // destroys ecx

// wait for completion
l_h_sd_p_flush_75:
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_get
test eax, 1  // 1 << slot
jz l_h_sd_p_flush_78
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.is
  call m_phys_get
  test eax, HBA_PxIS_TFES
  jz l_h_sd_p_flush_75
    // error
    mov al, ERC_DISK_IO
    jmp short l_h_sd_p_flush_9
    
l_h_sd_p_flush_78:

mov al, 0

l_h_sd_p_flush_9:
ret

// IN: al = pdiskn, es:edi -> buffer
// OUT: al = erc
h_sd_p_identify:
mov esi, edi

mov hdt_pdiskn, al
and al, 31
movzx eax, al
mov sd_port_n, eax
shl eax, 7  // * 80h
add eax, abar
add eax, 100h
mov sd_port_ebx, eax

mov ebx, eax
add ebx, offset HbaPortRec.is
mov eax, -1
call m_phys_set  // destroys ecx

mov eax, sd_port_n
shl eax, 10  // * 1024
add eax, 256 * 32 + VA_SD
mov edi, eax  // es:edi -> cmdheader

mov al, sizeof FisRegH2D / 4
//or al, 20h  // ATAPI
//or al, 40h  // write
//or al, 80h  // Prefetch
mov [es:edi + offset HbaCmdHeader.cflawp], al
mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1  // prdtl - prdt count
mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], 511  // byte count - 1

mov edi, [es:edi + offset HbaCmdHeader.ctba]
sub edi, sd_base
add edi, VA_SD

mov al, FIS_TYPE_REG_H2D
mov [es:edi + offset FisRegH2D.fis_type], al
mov al, 80h  // command
mov [es:edi + offset FisRegH2D.pmportc], al
mov al, ATA_CMD_IDENTIFY
mov [es:edi + offset FisRegH2D.command], al
mov byte ptr [es:edi + offset FisRegH2D.device], 0
mov word ptr [es:edi + offset FisRegH2D.countl], 1  // sector count

add edi, 80h  // es:edi -> PRDT
mov eax, sd_base
add eax, RA_SD_BUFFER
mov [es:edi + offset HbaPrdtEntry.dba], eax
mov eax, 1  // sector count
shl eax, 9
dec eax
//or eax, 1 << 31  // int on completion
mov [es:edi + offset HbaPrdtEntry.dbci], eax

// wait not busy
l_h_sd_p_identify_65:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.tfd
  call m_phys_get
  test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
  jnz l_h_sd_p_identify_65

// issue command
mov eax, 1  // 1 << slot
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_set  // destroys ecx

// wait for completion
l_h_sd_p_identify_75:
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_get
test eax, 1  // 1 << slot
jz l_h_sd_p_identify_78
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.is
  call m_phys_get
  test eax, HBA_PxIS_TFES
  jz l_h_sd_p_identify_75
    // error
    mov al, ERC_DISK_IO
    jmp short l_h_sd_p_identify_9
    
l_h_sd_p_identify_78:
// copy
mov ecx, 512 / 4
mov edi, esi
mov esi, RA_SD_BUFFER + VA_SD
push ds
  push es
  pop ds
  cld
  rep movsd
pop ds
mov esi, edi

mov al, 0

l_h_sd_p_identify_9:
ret

h_sd_init:

ret

// IN: ch = bus
// OUT: abar
h_sd_find:
mov cl, 0
mov dh, 0

l_h_sd_find_1:
  mov dl, 0  // vendor/device
  call h_pci_get
  cmp eax, -1
  jz l_h_sd_find_next
    mov dl, 0Ch  // HeaderType
    call h_pci_get
    shr eax, 16
    test al, 80h  // MultiFn
    jnz l_h_sd_find_fn
      cmp al, 1
      jz l_h_sd_find_p2p
        cmp al, 0
        jnz l_h_sd_find_next
          // HeaderType = 0
          mov dl, 8  // class
          call h_pci_get
          shr eax, 16
          cmp ax, 0106h
          jnz l_h_sd_find_next
            
            l_h_sd_find_found:
            // found
            mov dl, 24h  // BAR5
            call h_pci_get
            mov abar, eax
            
            ret
        
      l_h_sd_find_p2p:
      // PCI to PCI
      push ecx
       push edx
        mov dl, 18h  // secondary bus
        call h_pci_get
        mov ch, ah
        call h_sd_find
       pop edx
      pop ecx
      jmp l_h_sd_find_next
      
    l_h_sd_find_fn:
      // Functions
      mov dl, 0  // vendor/device
      call h_pci_get
      cmp eax, -1
      jz l_h_sd_find_fn_next      
        mov dl, 8  // class
        call h_pci_get
        shr eax, 16
        cmp ax, 0106h
        jz l_h_sd_find_found
                
      l_h_sd_find_fn_next:
      inc dh
      cmp dh, 8
      jb l_h_sd_find_fn
    
  l_h_sd_find_next:
  mov dh, 0
  inc cl
  cmp cl, 32
  jb near l_h_sd_find_1

ret

h_sd_setup_mapping:
cmp sd_base, 0
jnz near l_h_sd_setup_mapping_9
  mov cl, 1  // 64 KiB
  call m_alloc_dma
  test al, al
  jnz near l_h_sd_setup_mapping_9
  
  mov sd_base, esi
  or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
  
  mov dword ptr [PA_PD0 + (VA_SD >> 20)], PA_PT_SD | PG_MASK_P | PG_MASK_G
  
  mov ecx, 16  // 64 KiB / 4096
  xor edi, edi
  
  l_h_sd_setup_mapping_5:
    mov [PA_PT_SD + edi], esi
    mov eax, edi
    shl eax, 10  // * 4096 / 4
    invlpg [es:VA_SD + eax]
    
    add esi, 4096
    add edi, 4
    loop l_h_sd_setup_mapping_5
  
  // Zero memory
  mov edi, VA_SD
  xor eax, eax
  mov ecx, 64 * 1024 / 4  // 64 KiB / 4
  cld
  rep stosd
  
  // Rebase ports
  xor ecx, ecx
  
  l_sd_setup_mapping_5:
    push ecx
      call h_sd_rebase_port
    pop ecx
    inc ecx
    cmp cl, 32
    jb l_sd_setup_mapping_5
  
l_h_sd_setup_mapping_9:
ret

h_rd_init:
xor eax, eax
mov rd_base, eax
mov rd_size, eax
mov rd_ldiskn, al
ret

// IN: ecx = size
// OUT: al = ldiskn
h_rd_create:
mov al, 0
cmp ecx, 0x10000000
ja l_h_rd_create_9

mov ebx, VA_RAMDISK
mov rd_base, ebx
mov rd_size, ecx
add ecx, 4095
shr ecx, 12

mov edx, PG_MASK_P | PG_MASK_W
call m_pages_alloc_edx
test al, al
jz l_h_rd_create_6
  mov al, 0
  jmp short l_h_rd_create_9
  
l_h_rd_create_6:
// OUT: al = disk letter, ds:esi -> DiskInfoRec
// DESTROY: ecx
call h_disks_new
mov rd_ldiskn, al
test al, al
jz l_h_rd_create_9
  mov byte ptr [esi + offset DiskInfoRec.type], DISK_TYPE_RD
  mov byte ptr [esi + offset DiskInfoRec.fsid], FSID_EXT2
  mov [esi + offset DiskInfoRec.number], al
  mov dword ptr [esi + offset DiskInfoRec.main], offset h_rd_main
  
l_h_rd_create_9:
ret

// IN: ah = operation
// ah = 2: ebx = ofs, ecx = size, es:edi -> buffer
// ah = 3: ebx = ofs, ecx = size, es:edi -> buffer
// ah = 4: edx:eax = disk size
h_rd_main:
cmp ah, 2
jnz l_h_rd_main_2
  // read
  mov esi, rd_base
  cmp ebx, rd_size
  jb l_h_rd_main_12
    
    l_h_rd_main_11:
    mov al, ERC_OUT_OF_RANGE
    jmp l_h_rd_main_9
    
  l_h_rd_main_12:
  mov eax, ebx
  add eax, ecx
  cmp eax, rd_size
  ja l_h_rd_main_11
  
  cmp eax, ebx
  jb l_h_rd_main_11
  /*
  cmp edi, VA_ACCESS
  jnb l_h_rd_main_11
  
  mov eax, edi
  add eax, ecx
  cmp eax, VA_ACCESS
  ja l_h_rd_main_11
  */
  add esi, ebx
  jecxz l_h_rd_main_16
  
  l_h_rd_main_15:
    mov al, [es:esi]
    mov [es:edi], al
    inc esi
    inc edi
    loop l_h_rd_main_15
  
  l_h_rd_main_16:
  mov al, 0
  jmp l_h_rd_main_9
  
l_h_rd_main_2:
cmp ah, 3
jnz l_h_rd_main_3
  // write
  mov al, rd_ldiskn
  movzx esi, al
  shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
  or byte ptr disk_info.flags[esi], DISK_FLAGS_DIRTY
  
  mov esi, rd_base
  cmp ebx, rd_size
  jnb l_h_rd_main_11
    
  mov eax, ebx
  add eax, ecx
  cmp eax, rd_size
  ja l_h_rd_main_11
  
  cmp eax, ebx
  jb l_h_rd_main_11
  /*
  cmp edi, VA_ACCESS
  jnb l_h_rd_main_11
  
  mov eax, edi
  add eax, ecx
  cmp eax, VA_ACCESS
  ja l_h_rd_main_11
  */
  add esi, ebx
  jecxz l_h_rd_main_16
  
  l_h_rd_main_25:
    mov al, [es:edi]
    mov [es:esi], al
    inc edi
    inc esi
    loop l_h_rd_main_25
  
  jmp short l_h_rd_main_16
  
l_h_rd_main_3:
cmp ah, 4
jnz l_h_rd_main_4
  // disk size
  xor edx, edx
  mov eax, rd_size
  jmp short l_h_rd_main_9
  
l_h_rd_main_4:
// other
mov al, ERC_NOT_IMPLEMENTED

l_h_rd_main_9:
ret

// IN: boot_disk, al = ldiskn
// DESTROY: ebx, (al)
h_disks_bootcd:
cmp boot_disk, 0x300
jnz l_h_disks_bootcd_9
  mov byte ptr boot_disk, al
  mov ebx, p_current
  mov [es:ebx + offset ThreadRec.curdisk], al
  or al, 64
  mov [es:ebx + offset ThreadRec.curdirtext], al
  and al, 31

l_h_disks_bootcd_9:
ret

h_disks_init:
xor eax, eax
mov sd_base, eax
mov rd_base, eax
mov rd_size, eax
//ret - fall through

h_disks_reset:
mov users_disk, 0

// Zero all
push es
  push ds
  pop es
  
  mov edi, offset disk_info
  mov ecx, sizeof DiskInfoRec * DISK_MAX / 4
  xor eax, eax
  cld
  rep stosd
pop es

// Boot CD reset
cmp byte ptr boot_disk[1], 3
jnz l_h_disks_reset_1
  mov byte ptr boot_disk[0], 0
  
l_h_disks_reset_1:

// Init by types
call h_fd_init
call h_hd_init
call h_cd_init
call h_sd_init
call h_rd_init
//... other types: VD, ND, UD

// FD
mov esi, offset fd_info
mov eax, [esi + offset FdInfoRec.size]
mov edi, sizeof DiskInfoRec
or eax, eax
jnz l_h_disks_reset_22

l_h_disks_reset_2:
mov esi, offset fd_info + sizeof FdInfoRec
add edi, sizeof DiskInfoRec
mov eax, [esi + offset FdInfoRec.size]
or eax, eax
jz l_h_disks_reset_25
  
  l_h_disks_reset_22:
  mov disk_info[edi + offset DiskInfoRec.type], DISK_TYPE_FD
  mov disk_info[edi + offset DiskInfoRec.main], offset h_fd_main
  shr eax, 9
  mov dword ptr disk_info[edi + offset DiskInfoRec.size_sectors], eax
  mov byte ptr disk_info[edi + offset DiskInfoRec.fsid], FSID_FAT12

l_h_disks_reset_25:

// HD: IDE ATA/ATAPI
xor eax, eax

l_h_disks_reset_26:
  
  push eax
  
    call h_hd_prepare_port_slave
    
    mov dx, hdt_port_base
    or dx, 7
    in al, dx
    cmp al, 0FFh
    jz near l_h_disks_reset_28
    
    mov edi, VA_SYSTEM + offset hd_buffer
    call h_hd_p_identify
    or eax, eax
    jnz l_h_disks_reset_27
      // HD
      pop eax
      push eax
      call h_hd_partitions
      jmp l_h_disks_reset_28
      
    l_h_disks_reset_27:
    cmp al, ERC_INVALID_DISK_NUMBER
    jz l_h_disks_reset_28
      // CD/other (erc = 104h)
      mov edi, VA_SYSTEM + offset hd_buffer
      call h_hd_p_identifyp
      
      pop eax
      push eax
      mov hdt_pdiskn, al
      
      call h_disks_new
      or al, al
      jz l_h_disks_reset_28
        
        call h_disks_bootcd  // KEEP esi

        // Store disk info
        mov byte ptr [esi + offset DiskInfoRec.type], DISK_TYPE_CD
        mov byte ptr [esi + offset DiskInfoRec.fsid], FSID_CD
        mov al, hdt_pdiskn
        mov [esi + offset DiskInfoRec.number], al
        mov dword ptr [esi + offset DiskInfoRec.main], offset h_cd_main
        xor eax, eax
        mov dword ptr [esi + offset DiskInfoRec.flags], eax
        mov dword ptr [esi + offset DiskInfoRec.flags + 4], eax
        
        // Size: max(LBA28, LBA48)
        add esi, offset DiskInfoRec.size_sectors
        /*
        mov ebx, dword ptr hd_buffer[120]
        mov eax, dword ptr hd_buffer[204]
        mov edx, dword ptr hd_buffer[208]
        or edx, edx
        jnz l_h_disks_reset_275
          cmp eax, ebx
          ja l_h_disks_reset_275
            mov eax, ebx
          
        l_h_disks_reset_275:
        */
        xor eax, eax
        xor edx, edx
        
        mov [esi], eax
        mov [esi + 4], edx
    
    l_h_disks_reset_28:
    
  pop eax
  
  inc eax
  cmp eax, 4
  jb near l_h_disks_reset_26

// SD: AHCI SATA/SATAPI
xor eax, eax
mov abar, eax

mov ch, 0
call h_sd_find

mov ebx, abar
or ebx, ebx
jz near l_h_disks_reset_38
  
  // * sd_base *
  push ebx
    call h_sd_setup_mapping
  pop ebx
  
  // * find SATA/SATAPI disks *
  mov edi, ebx
  add edi, 100h
  mov ecx, 32
  mov hdt_pdiskn, 40h
  
  l_h_disks_reset_32:
    mov ebx, edi
    add ebx, offset HbaPortRec.ssts
    call m_phys_get
    and eax, 0F0Fh
    cmp eax, 0103h  // present, active
    jnz l_h_disks_reset_36
      mov ebx, edi
      add ebx, offset HbaPortRec.sig
      call m_phys_get

      cmp eax, 0EB140101h  // SATAPI
      jnz l_h_disks_reset_34
        // CD/DVD
        push ecx
          call h_disks_new  // KEEP: edi
        pop ecx
        or al, al
        jz l_h_disks_reset_36
        
        call h_disks_bootcd  // KEEP: ecx, edi
        
        // Store disk info
        mov byte ptr [esi + offset DiskInfoRec.type], DISK_TYPE_CD
        mov byte ptr [esi + offset DiskInfoRec.fsid], FSID_CD
        mov al, hdt_pdiskn
        or al, 20h
        mov [esi + offset DiskInfoRec.number], al
        mov dword ptr [esi + offset DiskInfoRec.main], offset h_cd_main
        xor eax, eax
        mov dword ptr [esi + offset DiskInfoRec.flags], eax
        mov dword ptr [esi + offset DiskInfoRec.flags + 4], eax
        jmp short l_h_disks_reset_36
        
      l_h_disks_reset_34:
      cmp eax, 101h  // SATA
      jnz l_h_disks_reset_36
        // HD
        mov al, hdt_pdiskn
        push ecx
         push edi
          call h_hd_partitions
         pop edi
        pop ecx
        
    l_h_disks_reset_36:
    add edi, 80h
    inc hdt_pdiskn
    loop l_h_disks_reset_32
  
l_h_disks_reset_38:
ret

// OUT: al = disk letter, ds:esi -> DiskInfoRec
// DESTROY: ecx
h_disks_new:
pushfd
  cli
  mov esi, offset disk_info + (sizeof DiskInfoRec * 3)
  
  l_h_disks_new_1:
    mov al, [esi + offset DiskInfoRec.type]
    or al, al
    jz l_h_disks_new_8
      add esi, sizeof DiskInfoRec
      cmp esi, offset disk_info + (sizeof DiskInfoRec * DISK_MAX)
      jb l_h_disks_new_1

        mov esi, offset disk_info
        mov al, 0
        jmp l_h_disks_new_9
  
  l_h_disks_new_8:
  mov eax, esi
  sub eax, offset disk_info
  xor edx, edx
  mov ecx, sizeof DiskInfoRec
  div ecx
  
  l_h_disks_new_9:
popfd
ret

// IN: al = diskn, es = allmem
h_disks_remove:
pushfd
  cli
  and al, 31
  movzx eax, al
  mov ecx, sizeof DiskInfoRec
  mul ecx
  add eax, offset disk_info + VA_SYSTEM
  mov edi, eax
  mov ecx, sizeof DiskInfoRec / 4
  xor eax, eax
  rep stosd
popfd
ret

HEAP_START = 0x80000000
HEAP_END   = 0xC0000000

HEAP_START_GLOBAL = 0xC0000000
HEAP_END_GLOBAL   = 0xC0000000 + (4096 * 1024)

[dalign 32]
uns4 m_first_free  // PA of the first free frame

m_init:
mov eax, m_first_alloc
mov m_first_free, eax

mov m_pages_busy, 0
mov m_heap_busy, 0

// free memory
mov m_free, 0
mov ebx, m_bitmap_base
mov ecx, m_bitmap_size

l_m_init_5:
  mov al, [ebx]
  cmp al, 255
  jz l_m_init_52
    cmp al, 0
    jnz l_m_init_51
      add m_free, 8
      jmp short l_m_init_52
      
    l_m_init_51:
    mov dl, 0
    
    l_m_init_515:
      test al, 1
      jnz l_m_init_516
        inc m_free
        
      l_m_init_516:
      shr al, 1
      inc dl
      cmp dl, 8
      jb l_m_init_515
    
  l_m_init_52:
  inc ebx
  loop l_m_init_5

ret

// Allocate Frame
// OUT: al = 0 || errorcode, esi = PA || 0
// DESTROY: eax, ecx, ebx
m_alloc1:
mov esi, m_bitmap_base  // esi = bitmap_base

mov ecx, m_bitmap_size
add ecx, esi            // ecx = bitmap_base + bitmap_size

mov eax, m_first_free
shr eax, 15
add eax, esi            // eax = first_alloc_bitmap_byte_PA
// (*
l_m_alloc1_1:
cmp eax, ecx
jnb l_m_alloc1_notfound
  cmp byte[eax], 255
  jnz l_m_alloc1_found
    inc eax
    jmp l_m_alloc1_1
// *)

l_m_alloc1_notfound:
mov eax, m_lastbyte
mov m_first_free, eax
xor esi, esi
mov al, ERC_NOT_ENOUGH_MEMORY
jmp short l_m_alloc1_9

l_m_alloc1_found:
mov ebx, eax   // ebx = bitmap_byte_PA
sub eax, esi
shl eax, 15
mov m_first_free, eax
mov esi, eax   // esi = frame_8_PA (aligned down to 8 frames)
mov al, [ebx]  // al = [ebx]
mov ah, 1
xor ecx, ecx
// (*
l_m_alloc1_5:
  test al, ah
  jz l_m_alloc1_foundbit
    inc cl
    shl ah, 1
    cmp cl, 8
    jb l_m_alloc1_5
// *)
jmp short l_m_alloc1_notfound

l_m_alloc1_foundbit:
or al, ah      // al |= ah
shl ecx, 12
mov [ebx], al  // [ebx] = al
add esi, ecx   // esi += frame_0_7

dec m_free

// Zero page - keep esi, edi
mov eax, esi
push edi
  or al, PG_MASK_P | PG_MASK_W
  mov ecx, 4096 / 4
  mov [PA_PT_VAR], eax
  mov edi, VA_VAR
  xor eax, eax
  cld
  rep stosd
pop edi

xor eax, eax

l_m_alloc1_9:
ret

// Allocate Contiguous Block for DMA Transfers
// IN: cl = 0: 32 KiB, 1: 64, 2: 128, 3: 256
// OUT: al = 0 || errorcode, esi = PA || 0
// DESTROY: eax, ecx, ebx, esi
m_alloc_dma:
//... enter(qmem)
mov esi, m_bitmap_base  // esi = bitmap_base

mov ebx, m_bitmap_size
mov eax, 0x1000000 / 0x8000  // 512 (max 16 MiB)
cmp ebx, eax
jna l_m_alloc_dma_0
  mov ebx, eax
  
l_m_alloc_dma_0:
add ebx, esi            // ebx = bitmap_base + min(bitmap_size, 512)

mov eax, m_first_free
shr eax, 15
add eax, esi            // eax = first_alloc_bitmap_byte_PA

mov esi, 1
shl esi, cl             // esi = 1 << cl

// (*
l_m_alloc_dma_1:

// Align eax to esi
mov ecx, esi
dec ecx  // ecx = esi - 1
dec eax
or eax, ecx
inc eax

// Assert eax + esi <= ebx
inc ecx
add ecx, eax
cmp ecx, ebx
ja l_m_alloc_dma_notfound

  cmp byte[eax], 0
  jz l_m_alloc_dma_5

    l_m_alloc_dma_next:
    inc eax
    jmp short l_m_alloc_dma_1
// *)

  l_m_alloc_dma_5:
  mov ecx, esi

// (*
  l_m_alloc_dma_51:
  dec ecx
  jecxz l_m_alloc_dma_6
    cmp byte[eax + ecx], 0
    jnz l_m_alloc_dma_next

      jmp short l_m_alloc_dma_51
// *)

l_m_alloc_dma_6:
mov ecx, esi

mov ebx, ecx
shl ebx, 3  // * 8
sub m_free, ebx

// (*
l_m_alloc_dma_61:
dec ecx
mov byte[eax + ecx], 255
jecxz l_m_alloc_dma_62
  jmp short l_m_alloc_dma_61
// *)

l_m_alloc_dma_62:
sub eax, m_bitmap_base
shl eax, 15
mov esi, eax
mov al, 0

l_m_alloc_dma_9:
//... leave(qmem)
ret

l_m_alloc_dma_notfound:
xor esi, esi
mov al, ERC_NOT_ENOUGH_MEMORY
jmp short l_m_alloc_dma_9

// Deallocate Frame
// IN: esi = PA
// OUT: al = 0 || errorcode
// DESTROY: eax, ecx, ebx
m_free1:
mov eax, esi
test ax, 0xFFF
jnz l_m_free1_xalign

cmp eax, m_first_alloc
jb l_m_free1_xunder

cmp eax, m_first_free
jnb l_m_free1_1
  mov m_first_free, eax
  
l_m_free1_1:
shr eax, 12
mov cl, al
shr eax, 3    // eax = frame_n / 8
and cl, 7     // cl = frame_n & 7
cmp eax, m_bitmap_size
jnb l_m_free1_xsize

add eax, m_bitmap_base
mov ebx, eax  // ebx = bitmap_byte_PA
mov ah, 1
mov al, [ebx] // al = [ebx]
shl ah, cl    // ah = 1 << cl
test al, ah
jz l_m_free1_xalready

not ah
and al, ah
mov [ebx], al // [ebx] = al & !ah

inc m_free

l_m_free1_ok:
xor eax, eax

l_m_free1_9:
ret


// also used from m_free_dma
l_m_free1_xalign:
mov al, ERC_ALIGN
jmp short l_m_free1_9

l_m_free1_xunder:
mov al, ERC_UNDERFLOW
jmp short l_m_free1_9

l_m_free1_xsize:
mov al, ERC_OVERFLOW
jmp short l_m_free1_9

l_m_free1_xalready:
mov al, ERC_ALREADY_FREE
jmp short l_m_free1_9

// Deallocate DMA Block
// IN: esi = PA, cl = 0: 32 KiB, 1: 64, 2: 128, 3: 256
// OUT: al = 0 || errorcode
// DESTROY: eax, ecx, ebx
m_free_dma:
//... enter(qmem)
test esi, esi
jz l_m_free_dma_ok

mov eax, esi
test ax, 0x7FFF
jnz l_m_free1_xalign

cmp eax, m_first_alloc
jb l_m_free1_xunder

cmp eax, m_first_free
jnb l_m_free_dma_1
  mov m_first_free, eax
  
l_m_free_dma_1:
mov ebx, 1
shr eax, 15
shl ebx, cl
add eax, ebx

  cmp eax, m_bitmap_size
  ja l_m_free1_xsize

sub eax, ebx
mov ecx, ebx
add eax, m_bitmap_base

// (*
l_m_free_dma_51:
dec ecx
cmp byte[eax + ecx], 255
jnz l_m_free1_xalready
jecxz l_m_free_dma_6
  jmp short l_m_free_dma_51
// *)

l_m_free_dma_6:
mov ecx, ebx

shl ebx, 3  // * 8
add m_free, ebx

// (*
l_m_free_dma_61:
dec ecx
mov byte[eax + ecx], 0
jecxz l_m_free_dma_ok
  jmp short l_m_free_dma_61
// *)

l_m_free_dma_ok:
mov al, 0

l_m_free_dma_9:
//... leave(qmem)
ret

m_pages_enter:
push eax
  l_pages_enter_1:
    mov al, 1
    xchg al, m_pages_busy
    or al, al
    jz l_pages_enter_9
      call p_noop
      jmp l_pages_enter_1
  
  l_pages_enter_9:
  mov eax, p_current
  or byte ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_M_PAGES_BUSY
pop eax
ret

m_pages_leave:
push eax
  mov eax, p_current
  mov m_pages_busy, 0
  and byte ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_M_PAGES_BUSY
pop eax
ret

m_pages_alloc_x1:
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_pages_alloc_9

// IN: ebx = user ofs, ecx = page count
// OUT: al = 0 || ERC
m_pages_alloc:
mov edx, PG_MASK_P | PG_MASK_W | PG_MASK_U

m_pages_alloc_edx:

// Round ebx to 4096
and ebx, -1 - 4095

call m_pages_enter

// cr3 - page directory
mov eax, cr3
or eax, PG_MASK_P | PG_MASK_W

mov [PA_PT_VAR + 8], eax
invlpg [es:VA_VAR + (8 / 4 * 4096)]

l_pages_alloc_1:
mov edi, ebx
shr edi, 22  // bits 22..31 * 4
shl edi, 2
mov esi, [es:edi + VA_VAR + (8 / 4 * 4096)]
or esi, esi
jnz l_pages_alloc_2

  push ebx
   push ecx
    push edx
     call m_alloc1  // keep edi
    pop edx
   pop ecx
  pop ebx
  or al, al
  jnz m_pages_alloc_x1  // not enough memory
  
  // Update memused
  cmp ebx, VA_GLOBAL
  jnb l_pages_alloc_12
    mov eax, p_current
    mov eax, [es:eax + offset ThreadRec.process]
    add dword[es:eax + offset ProcessRec.memused], 4096
  
  l_pages_alloc_12:  
  or esi, edx
  mov [es:edi + VA_VAR + (8 / 4 * 4096)], esi
  
  invlpg [es:VA_VAR + (8 / 4 * 4096)]
  
l_pages_alloc_2:

// esi = Page Table
mov [PA_PT_VAR + 4], esi
invlpg [es:VA_VAR + (4 / 4 * 4096)]

mov edi, ebx
shr edi, 12  // bits 12..21 * 4
shl edi, 2
and edi, 4095
mov esi, [es:edi + VA_VAR + (4 / 4 * 4096)]
or esi, esi
jnz l_pages_alloc_3

  push ebx
   push ecx
    push edx
     call m_alloc1  // keep edi
    pop edx
   pop ecx
  pop ebx
  or al, al
  jnz near m_pages_alloc_x1  // not enough memory
  
  // Update memused
  cmp ebx, VA_GLOBAL
  jnb l_pages_alloc_22
    mov eax, p_current
    mov eax, [es:eax + offset ThreadRec.process]
    add dword[es:eax + offset ProcessRec.memused], 4096
  
  l_pages_alloc_22:
  or esi, edx
  mov [es:edi + VA_VAR + (4 / 4 * 4096)], esi
  
  invlpg [es:VA_VAR + (4 / 4 * 4096)]
  
l_pages_alloc_3:
dec ecx
jecxz l_pages_alloc_8

  add ebx, 4096
  jmp l_pages_alloc_1

l_pages_alloc_8:
xor eax, eax

l_pages_alloc_9:
call m_pages_leave
ret

m_pages_alloc_hard_x1:
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_m_pages_alloc_hard_9

// IN: ebx = user ofs, ecx = page count, edx = physical address
// OUT: al = 0 || ERC
m_pages_alloc_hard:
// Round ebx to 4096
and ebx, -1 - 4095

call m_pages_enter

// cr3 - page directory
mov eax, cr3
or eax, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 8], eax
invlpg [es:VA_VAR + (8 / 4 * 4096)]

l_m_pages_alloc_hard_1:
and edx, -1 - 4095

mov edi, ebx
shr edi, 22  // bits 22..31 * 4
shl edi, 2
mov esi, [es:edi + VA_VAR + (8 / 4 * 4096)]
or esi, esi
jnz l_m_pages_alloc_hard_2

  push ebx
   push ecx
    push edx
     call m_alloc1  // keep edi
    pop edx
   pop ecx
  pop ebx
  or al, al
  jnz m_pages_alloc_hard_x1  // not enough memory
  
  or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
  mov [es:edi + VA_VAR + (8 / 4 * 4096)], esi

  invlpg [es:VA_VAR + (8 / 4 * 4096)]
  
l_m_pages_alloc_hard_2:

// esi = Page Table
mov [PA_PT_VAR + 4], esi
invlpg [es:VA_VAR + (4 / 4 * 4096)]

mov edi, ebx
shr edi, 12  // bits 12..21 * 4
shl edi, 2
and edi, 4095

or edx, PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [es:edi + VA_VAR + (4 / 4 * 4096)], edx
  
l_m_pages_alloc_hard_3:
dec ecx
jecxz l_m_pages_alloc_hard_8

  add ebx, 4096
  add edx, 4096
  jmp l_m_pages_alloc_hard_1

l_m_pages_alloc_hard_8:
xor eax, eax

l_m_pages_alloc_hard_9:
call m_pages_leave
ret

// IN: ebx = cr3
m_pages_free_all:
call m_pages_enter

// page directory
or ebx, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 8], ebx
xor edx, edx

l_pages_free_all_1:
  mov eax, [es:edx + VA_VAR + (8 / 4 * 4096)]
  or eax, eax
  jz l_pages_free_all_2

    push edx

      // page table
      mov [PA_PT_VAR + 4], eax
      xor ecx, ecx
  
      l_pages_free_all_11:
        mov esi, [es:ecx + VA_VAR + (4 / 4 * 4096)]
        and esi, -1 - 0xFFF
        or esi, esi
        jz l_pages_free_all_15
        
          push ecx
            // free frame
            call m_free1
          pop ecx
  
        l_pages_free_all_15:
        add ecx, 4
        cmp ecx, 4096
        jb l_pages_free_all_11
      
      // free table
      mov esi, [PA_PT_VAR + 4]
      and esi, -1 - 0xFFF
      call m_free1
    
    pop edx

  l_pages_free_all_2:
  add edx, 4
  cmp edx, VA_GLOBAL >> 24 * 4096 / 256
  jb l_pages_free_all_1

// free page directory
mov esi, [PA_PT_VAR + 8]
and esi, -1 - 0xFFF
call m_free1

call m_pages_leave
ret

// IN: ebx = virtual adr
// OUT: ebx = physical adr
// KEEP: eax, ecx, edx
m_pages_getphysadr:
// cr3 - page directory
mov edi, cr3
or edi, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 8], edi
invlpg [es:VA_VAR + (8 / 4 * 4096)]

mov edi, ebx
shr edi, 22  // bits 22..31 * 4
shl edi, 2
mov esi, [es:edi + VA_VAR + (8 / 4 * 4096)]
or esi, esi
jz l_m_pages_getphysadr_x

// esi = Page Table
or esi, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 4], esi
invlpg [es:VA_VAR + (4 / 4 * 4096)]

mov edi, ebx
shr edi, 12  // bits 12..21 * 4
shl edi, 2
and edi, 4095
mov esi, [es:edi + VA_VAR + (4 / 4 * 4096)]
or esi, esi
jz l_m_pages_getphysadr_x

// output
and esi, -1 - 4095
and ebx, 4095
or ebx, esi
ret

l_m_pages_getphysadr_x:
xor ebx, ebx
ret

// page fault
isr0E:
// error code in stack
pushad

 mov ebx, cr2

 mov edx, esp
 mov ecx, [ss:edx + (8 * 4)] // error code

 push ds
  push es

    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov ax, SELECTOR_ALL_DATA
    mov es, ax  // es = ALL
    
    //$$$
    /*
    mov eax, ecx
    mov ecx, 16
    call writen  // error code
    */
    
    test cl, 1  // PF_P - protection fault
    jnz l_isr0E_6
    
    cmp ebx, HEAP_END_GLOBAL
    jnb l_isr0E_5  // too hign address

    cmp ebx, HEAP_START
    jb l_isr0E_5  // too low address

    and ebx, -1 - 4095
    mov edi, p_current
    cmp ebx, [es:edi + offset ThreadRec.stack3_aligned]
    jz l_isr0E_7  // stack fault
    
    mov ecx, 1
    call m_pages_alloc
    or al, al
    jz l_isr0E_9
      
      // alloc error - not enough memory
      mov bl, al
      mov edx, cr2
      jmp fault2
      
      l_isr0E_5:
      // LA error
      mov edx, cr2
      mov bl, ERC_INVALID_MEMORY_LOCATION
      jmp fault2
      
      l_isr0E_6:
      // Protection fault
      mov edx, cr2
      mov bl, 8Eh
      jmp fault2
      
      l_isr0E_7:
      // stack fault
      mov edx, ebx
      mov bl, ERC_STACK_OVERFLOW
      jmp fault2
    
    l_isr0E_9:

  pop es
 pop ds

popad
add esp, 4  // error word
iretd

m_heap_init:
/*
mov ebx, HEAP_START
mov ecx, 1
call m_pages_alloc
*/
mov ebx, HEAP_START
xor eax, eax
mov [es:ebx + offset HeapRec.last], eax
mov dword ptr [es:ebx + offset HeapRec.next], HEAP_END
mov [es:ebx + offset HeapRec.size], eax
mov [es:ebx + offset HeapRec.type], eax
ret

m_heap_init_global:
/*
mov ebx, HEAP_START_GLOBAL
mov ecx, 1
call m_pages_alloc
*/
mov ebx, HEAP_START_GLOBAL
xor eax, eax
mov [es:ebx + offset HeapRec.last], eax
mov dword ptr [es:ebx + offset HeapRec.next], HEAP_END_GLOBAL
mov [es:ebx + offset HeapRec.size], eax
mov [es:ebx + offset HeapRec.type], eax
ret

m_heap_enter:
push eax
  l_heap_enter_1:
    mov al, 1
    xchg al, m_heap_busy
    or al, al
    jz l_heap_enter_9
      call p_noop
      jmp l_heap_enter_1
  
  l_heap_enter_9:
  mov eax, p_current
  or byte ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_M_HEAP_BUSY
pop eax
ret

m_heap_leave:
push eax
  mov eax, p_current
  mov m_heap_busy, 0
  and byte ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_M_HEAP_BUSY
pop eax
ret

// IN: ecx = size, ebx = type, esi = heap_start, edi = heap_end
// OUT: al = 0 || erc, ebx = ptr to block
m_heap_alloc:
dec ecx
or cl, 15
inc ecx  // align ecx to 16

l_m_heap_alloc_1:
mov eax, esi
add eax, 32
add eax, [es:esi + offset HeapRec.size]
add eax, ecx
mov edx, [es:esi + offset HeapRec.next]
cmp eax, edx
jna l_m_heap_alloc_5
  cmp esi, edx
  jnb l_m_heap_alloc_2
    mov esi, edx
    cmp esi, edi
    jb l_m_heap_alloc_1

l_m_heap_alloc_2:
xor ebx, ebx
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_m_heap_alloc_9

l_m_heap_alloc_5:
// free space found, edx = next
mov eax, ebx
mov ebx, esi
add ebx, [es:esi + offset HeapRec.size]
add ebx, sizeof HeapRec
mov [es:ebx + offset HeapRec.last], esi
mov [es:ebx + offset HeapRec.next], edx
mov [es:ebx + offset HeapRec.size], ecx
mov [es:ebx + offset HeapRec.type], eax

mov [es:esi + offset HeapRec.next], ebx
cmp edx, edi
jnb l_m_heap_alloc_6
  mov [es:edx + offset HeapRec.last], ebx

l_m_heap_alloc_6:

add ebx, 16
mov al, 0

l_m_heap_alloc_9:
ret

// IN: ebx = ptr to block, esi = heap_start, edi = heap_end
m_heap_free:
test ebx, ebx
jz l_m_heap_free_5
  sub ebx, sizeof HeapRec
  mov eax, [es:ebx + offset HeapRec.last]
  mov edx, [es:ebx + offset HeapRec.next]
  cmp eax, esi
  jb l_m_heap_free_5
    
    cmp eax, edi
    jnb l_m_heap_free_4
    
      cmp [es:eax + offset HeapRec.next], ebx
      jnz l_m_heap_free_4
      
        mov [es:eax + offset HeapRec.next], edx
  
    l_m_heap_free_4:
    cmp edx, edi
    jnb l_m_heap_free_5
    
      cmp [es:edx + offset HeapRec.last], ebx
      jnz l_m_heap_free_5
  
        mov [es:edx + offset HeapRec.last], eax
    
l_m_heap_free_5:
ret

// IN: ecx = size
// OUT: al = 0 || erc, ebx = ptr to block, edx = ptr to aligned
m_heap_alloc_aligned:
mov esi, HEAP_START
mov edi, HEAP_END

dec ecx
or cx, 4095
inc ecx  // align ecx to 4096

l_m_heap_alloc_aligned_1:
mov eax, esi
add eax, 32
add eax, [es:esi + offset HeapRec.size]

dec eax
or ax, 4095
inc eax

add eax, ecx
mov edx, [es:esi + offset HeapRec.next]
cmp eax, edx
jna l_m_heap_alloc_aligned_5
  cmp esi, edx
  jnb l_m_heap_alloc_aligned_2
    mov esi, edx
    cmp esi, edi
    jb l_m_heap_alloc_aligned_1

l_m_heap_alloc_aligned_2:
xor ebx, ebx
xor edx, edx
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_m_heap_alloc_aligned_9

l_m_heap_alloc_aligned_5:
// free space found, edx = next, eax = aligned + ecx
sub eax, ecx
mov ebx, esi
add ebx, [es:esi + offset HeapRec.size]
add ebx, 16
mov [es:ebx + offset HeapRec.last], esi
mov [es:ebx + offset HeapRec.next], edx

push eax
  sub eax, ebx
  sub eax, 16
  add ecx, eax
  mov [es:ebx + offset HeapRec.size], ecx
  xor eax, eax
  mov [es:ebx + offset HeapRec.type], eax
  
  mov [es:esi + offset HeapRec.next], ebx
  cmp edx, edi
  jnb l_m_heap_alloc_aligned_6
    mov [es:edx + offset HeapRec.last], ebx
  
  l_m_heap_alloc_aligned_6:
pop edx

add ebx, 16
mov al, 0

l_m_heap_alloc_aligned_9:
ret

// IN: ecx = size
// OUT: al = 0 || erc, ebx = ptr to block
m_heap_alloc_local:
mov esi, HEAP_START
mov edi, HEAP_END
xor ebx, ebx
call m_heap_alloc
ret

// IN: ecx = size
// OUT: al = 0 || erc, ebx = ptr to block
m_heap_alloc_global:
mov esi, HEAP_START_GLOBAL
mov edi, HEAP_END_GLOBAL
call m_heap_enter

  mov ebx, p_current
  mov ebx, [es:ebx + offset ThreadRec.process]
  call m_heap_alloc

call m_heap_leave
ret

// IN: ebx = ptr to block
m_heap_free_local:
mov esi, HEAP_START
mov edi, HEAP_END
call m_heap_free
ret

// IN: ebx = ptr to block
m_heap_free_global:
mov esi, HEAP_START_GLOBAL
mov edi, HEAP_END_GLOBAL
call m_heap_enter
call m_heap_free
call m_heap_leave
ret

// IN: ebx = PA
// OUT: eax = [PA]
m_phys_get:
mov eax, ebx
and eax, -1 - 4095
or eax, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 40h], eax
//invlpg [PA_PT_VAR + 40h] 
mov eax, ebx
and eax, 4095
invlpg [es:eax + VA_VAR + (40h / 4 * 4096)]
mov eax, [es:eax + VA_VAR + (40h / 4 * 4096)]
ret

// IN: ebx = PA
// OUT: al = [PA]
m_phys_getbyte:
mov eax, ebx
and eax, -1 - 4095
or eax, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 40h], eax
//invlpg [PA_PT_VAR + 40h] 
mov eax, ebx
and eax, 4095
invlpg [es:eax + VA_VAR + (40h / 4 * 4096)]
mov al, [es:eax + VA_VAR + (40h / 4 * 4096)]
ret

// IN: ebx = PA, eax = value
// DESTROY: ecx
m_phys_set:
mov ecx, ebx
and ecx, -1 - 4095
or ecx, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 40h], ecx
//invlpg [PA_PT_VAR + 40h]
mov ecx, ebx
and ecx, 4095
invlpg [es:ecx + VA_VAR + (40h / 4 * 4096)]
mov [es:ecx + VA_VAR + (40h / 4 * 4096)], eax
ret

// IN: ebx = PA, al = value
// DESTROY: ecx
m_phys_setbyte:
mov ecx, ebx
and ecx, -1 - 4095
or ecx, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 40h], ecx
//invlpg [PA_PT_VAR + 40h]
mov ecx, ebx
and ecx, 4095
invlpg [es:ecx + VA_VAR + (40h / 4 * 4096)]
mov [es:ecx + VA_VAR + (40h / 4 * 4096)], al
ret

SIZE_THREADREC = 4096
PRIORITY0 = 10 * 1193

struct SectionEntry{
  char Name[8]
  uns4 VirtualSize, VirtualAddress, SizeOfRawData, PointerToRawData
  uns4 PointerToRelocations, PointerToLinenumbers
  uns2 NumberOfRelocations, NumberOfLinenumbers
  uns4 Characteristics
}

uns4 p_kill_current, p_clip, p_clip_type

SectionEntry section

l_p_msg_send_x1:  // also usr_send
popfd
mov al, ERC_MSG_QUEUE_FULL
ret

l_p_msg_send_x2:  // also usr_send
popfd
mov al, ERC_MSG_INVALID_TARGET
ret

// Send Message
// IN: ebx = wnd:threadid, ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
p_msg_send:
pushfd
  cli
  // Get threadid
  mov edi, ebx
  test edi, 16384
  jnz l_p_msg_send_2
  
    // edi = ProcessID
    movzx edi, di
    shl edi, 9  // assert sizeof ProcessRec = 512
    cmp edi, p_procs_max_size
    jnb l_p_msg_send_x2
    
    add edi, VA_PROCS
    mov edi, [es:edi + offset ProcessRec.mainthread]
  
  l_p_msg_send_2:
  // edi = ThreadID
  and edi, 16383
  shl edi, 12   // assert sizeof ThreadRec = 4096 (2^12)
  cmp edi, p_threads_max_size
  jnb l_p_msg_send_x2
  
  add edi, VA_THREADS
  
  mov eax, [es:edi + offset ThreadRec.msgw]
  add eax, sizeof MsgRec
  and eax, 511  // assert sizeof MsgQueue = 512
  cmp eax, [es:edi + offset ThreadRec.msgr]
  jz l_p_msg_send_x1
  
  mov [es:edi + offset ThreadRec.msgw], eax
  
  push edi
  
    add edi, offset ThreadRec.msg
    sub eax, sizeof MsgRec
    and eax, 511
    add edi, eax
    
    mov eax, p_current
    sub eax, VA_THREADS
    shr eax, 12  // assert sizeof ThreadRec = 4096
    and ebx, 0xFFFF0000
    or ebx, eax
    
    mov [es:edi + offset MsgRec.sender], ebx
    mov [es:edi + offset MsgRec.msg], ecx
    mov [es:edi + offset MsgRec.wp], edx
    mov [es:edi + offset MsgRec.lp], esi
  
  pop edi
  
  // Wake?
  test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
  jnz l_p_msg_send_8
  
    call p_start
  
  l_p_msg_send_8:
  
  // End
  mov al, 0

popfd
ret

// Send User Message
// IN: ebx = wnd:threadid, ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
p_msg_usr_send:
pushfd
  cli
  // Get threadid
  mov edi, ebx
  test edi, 16384
  jnz l_p_msg_usr_send_2
  
    // edi = ProcessID
    movzx edi, di
    shl edi, 9  // assert sizeof ProcessRec = 512
    cmp edi, p_procs_max_size
    jnb near l_p_msg_send_x2
    
    add edi, VA_PROCS
    mov edi, [es:edi + offset ProcessRec.mainthread]
  
  l_p_msg_usr_send_2:
  // edi = ThreadID
  and edi, 16383
  shl edi, 12   // assert sizeof ThreadRec = 4096 (2^12)
  cmp edi, p_threads_max_size
  jnb near l_p_msg_send_x2
  
  add edi, VA_THREADS
  
  mov eax, [es:edi + offset ThreadRec.msgusrw]
  add eax, sizeof MsgRec
  and eax, 511  // assert sizeof MsgUsrQueue = 512
  cmp eax, [es:edi + offset ThreadRec.msgusrr]
  jz near l_p_msg_send_x1
  
  mov [es:edi + offset ThreadRec.msgusrw], eax
  
  push edi
  
    add edi, offset ThreadRec.msgusr
    sub eax, sizeof MsgRec
    and eax, 511
    add edi, eax
    
    mov eax, p_current
    sub eax, VA_THREADS
    shr eax, 12  // assert sizeof ThreadRec = 4096
    and ebx, 0xFFFF0000
    or ebx, eax
    
    mov [es:edi + offset MsgRec.sender], ebx
    mov [es:edi + offset MsgRec.msg], ecx
    mov [es:edi + offset MsgRec.wp], edx
    mov [es:edi + offset MsgRec.lp], esi
  
  pop edi
  
  // Wake?
  test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
  jnz l_p_msg_usr_send_8
  
    call p_start
  
  l_p_msg_usr_send_8:
  
  // End
  mov al, 0

popfd
ret

l_p_msg_get_x:
popfd
mov al, ERC_MSG_QUEUE_EMPTY  // also usr_get
ret

// Get Message
// OUT: al = 0 || errorcode, ebx = wnd:sender, ecx = msg, edx = wp, esi = lp
p_msg_get:
pushfd
  cli
  mov edi, p_current
  mov esi, edi
  
  mov eax, [es:esi + offset ThreadRec.msgr]
  cmp eax, [es:esi + offset ThreadRec.msgw]
  jz l_p_msg_get_x
  
  add edi, offset ThreadRec.msg
  add edi, eax
  add eax, sizeof MsgRec
  and eax, 511  // assert sizeof MsgUsrQueue = 512
  mov [es:esi + offset ThreadRec.msgr], eax
  
  mov ebx, [es:edi + offset MsgRec.sender]
  mov ecx, [es:edi + offset MsgRec.msg]
  mov edx, [es:edi + offset MsgRec.wp]
  mov esi, [es:edi + offset MsgRec.lp]
  
  mov al, 0
popfd
ret

// Get Message
// OUT: al = 0 || errorcode, ebx = wnd:sender, ecx = msg, edx = wp, esi = lp
p_msg_usr_get:
pushfd
  cli
  
  mov edi, p_current
  mov esi, edi
  
  mov eax, [es:esi + offset ThreadRec.msgusrr]
  cmp eax, [es:esi + offset ThreadRec.msgusrw]
  jz l_p_msg_get_x
  
  add edi, offset ThreadRec.msgusr
  add edi, eax
  add eax, sizeof MsgRec
  and eax, 511  // assert sizeof MsgUsrQueue = 512
  mov [es:esi + offset ThreadRec.msgusrr], eax
  
  mov ebx, [es:edi + offset MsgRec.sender]
  mov ecx, [es:edi + offset MsgRec.msg]
  mov edx, [es:edi + offset MsgRec.wp]
  mov esi, [es:edi + offset MsgRec.lp]
  
  mov al, 0
popfd
ret

// IN: ecx = WM_DEVICECHANGE, edx = ldiskn, esi = 0 removed | 1 inserted
p_msg_send_to_all:
xor ebx, ebx

l_p_msg_send_to_all_1:
  cmp ebx, p_procs_max_size
  jnb l_p_msg_send_to_all_8
    mov eax, [es:ebx + VA_PROCS + offset ProcessRec.cr3]
    test eax, eax
    jz l_p_msg_send_to_all_6
      push ecx
       push ebx
        push edx
         push esi
          shr ebx, 9 // assert sizeof ProcessRec = 512
          call p_msg_send
         pop esi
        pop edx
       pop ebx
      pop ecx
    
    l_p_msg_send_to_all_6:
    add ebx, sizeof ProcessRec
    jmp l_p_msg_send_to_all_1
    
l_p_msg_send_to_all_8:
ret

// IN: esi -> old TCB, edi -> new TCB
p_switch_task:
cmp esi, edi
jz l_p_switch_task_8

// FPU
test byte ptr [es:esi + offset ThreadRec.flags], THREAD_FLAGS_USE_FPU
jz l_p_switch_task_2

  fwait
  fnsave [es:esi + offset ThreadRec.fstate]

l_p_switch_task_2:

// Timer
call h_timer_read
sub [es:esi + offset ThreadRec.tmr_spent], eax
add [es:edi + offset ThreadRec.tmr_spent], eax

// Switch
mov p_current, edi
mov eax, [es:edi + offset TssRec.cr3]
mov cr3, eax

// Stack 0
mov [es:esi + offset TssRec.esp0], esp
mov esp, [es:edi + offset TssRec.esp0]

// tss - stack
mov eax, edi
add eax, offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov tss.tss.esp0, eax
mov tss.tss.ss0, ss

// FPU
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_USE_FPU
jz l_p_switch_task_6

  frstor [es:edi + offset ThreadRec.fstate]

l_p_switch_task_6:

// GO
mov dword ptr [es:esi + offset TssRec.eip], offset l_p_switch_task_8
mov eax, [es:edi + offset TssRec.eip]
jmp eax

l_p_switch_task_8:
ret

// IN: esi = current task, edi = next task
p_set_next_preempt:
call h_timer_read
movzx eax, ax
push eax
  // Remove preempt
  mov edx, TMR_THREADID_WND_PREEMPT
  xor ebx, ebx
  push esi
   push edi
    call h_timer_remove
   pop edi
   // Add new preempt
   push edi
    mov ecx, [es:edi + offset ThreadRec.priority]
    mov edx, TMR_THREADID_WND_PREEMPT
    xor ebx, ebx
    mov edi, ebx
    call h_timer_add
   pop edi
  pop esi
  // Correct time
  call h_timer_read
  movzx eax, ax
pop edx
sub edx, eax  // edx = new_time - old_time
add [es:esi + offset ThreadRec.tmr_spent], edx
add tmr_total, edx

ret

p_idle_thread:
sti
p_idle_thread_5:
  call p_noop
  jmp short p_idle_thread_5

// IN: ecx = stack size, es:edi -> ThreadRec
// KEEP: edi
p_alloc_stack3:
add ecx, 4096

push ecx
 push edi

  call m_heap_alloc_aligned

 pop edi
pop ecx

or al, al
jnz l_p_alloc_stack3_9

  mov [es:edi + offset ThreadRec.stack3_ptr], ebx
  mov [es:edi + offset ThreadRec.stack3_aligned], edx
  add ecx, edx
  mov [es:edi + offset TssRec.esp], ecx
  mov word[es:edi + offset TssRec.ss], SELECTOR_USER_DATA
  
  mov al, 0

l_p_alloc_stack3_9:
ret

l_p_create_thread_inner_x1:
popfd
mov al, ERC_TOO_MANY_THREADS
ret

l_p_create_thread_inner_x2:
popfd
mov al, ERC_NOT_ENOUGH_MEMORY
ret

// OUT: al = 0 || errorcode, [es:edi] = new ThreadRec
p_create_thread_inner:

pushfd

  cli

  // Find place in process table at VA_THREADS + (MAX_THREADS * sizeof ThreadRec)
  xor edi, edi
  l_p_create_thread_inner_11:
    cmp edi, p_threads_max_size
    jnb l_p_create_thread_inner_16
      mov eax, [es:edi + VA_THREADS + offset ThreadRec.flags]
      or eax, eax
      jz l_p_create_thread_inner_foundfree
        add edi, SIZE_THREADREC
        jmp l_p_create_thread_inner_11
  
  l_p_create_thread_inner_16:
  // Allocate a new page?
  cmp edi, MAX_THREADS * SIZE_THREADREC
  jnb l_p_create_thread_inner_x1
  
  push edi
    call m_alloc1
  pop edi
  or esi, esi
  jz l_p_create_thread_inner_x2
  
  or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
  shr edi, 10  // log2 4096 - log2 4
  mov [PA_PT_THREADS + edi], esi
  shl edi, 10
  add p_threads_max_size, 4096
  
  l_p_create_thread_inner_foundfree:
  // Free slot at VA_THREADS + edi
  add edi, VA_THREADS
  push edi
    // Copy ThreadRec
    mov esi, p_current
    push ds
      push es
      pop ds
      mov ecx, SIZE_THREADREC / 4
      cld
      rep movsd
    pop ds
  pop edi
  
  mov dword [es:edi + offset ThreadRec.flags], THREAD_FLAGS_VALID | THREAD_FLAGS_USE_FPU

popfd
  
// Update new ThreadRec
xor eax, eax
mov [es:edi + offset ThreadRec.next], eax
mov [es:edi + offset ThreadRec.last], eax
mov [es:edi + offset ThreadRec.msgw], eax
mov [es:edi + offset ThreadRec.msgr], eax
mov [es:edi + offset ThreadRec.msgusrr], eax
mov [es:edi + offset ThreadRec.msgusrw], eax
mov [es:edi + offset ThreadRec.catch.flags], eax

mov word ptr [es:edi + offset TssRec.cs], cs
mov word ptr [es:edi + offset TssRec.ds], ds
mov word ptr [es:edi + offset TssRec.es], es
mov word ptr [es:edi + offset TssRec.fs], fs
mov word ptr [es:edi + offset TssRec.gs], gs

mov word ptr [es:edi + offset TssRec.ss0], es
mov eax, edi
add eax, offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov [es:edi + offset TssRec.esp0], eax
mov word ptr [es:edi + offset TssRec.ss], SELECTOR_USER_DATA

mov al, 0
ret

l_p_create_process_inner_x1:
popfd
mov al, ERC_TOO_MANY_PROCS
ret

l_p_create_process_inner_x2:
mov al, ERC_NOT_ENOUGH_MEMORY

l_p_create_process_inner_x3:
popfd
ret

// OUT: al = 0 || errorcode, es:edi -> process
p_create_process_inner:

pushfd

  cli
  
  // Find place in process table at VA_PROCS
  xor edi, edi
  l_p_create_process_inner_11:
    cmp edi, p_procs_max_size
    jnb l_p_create_process_inner_16
      mov eax, [es:edi + VA_PROCS + offset ProcessRec.cr3]
      or eax, eax
      jz l_p_create_process_inner_foundfree
        add edi, sizeof ProcessRec
        jmp l_p_create_process_inner_11
  
  l_p_create_process_inner_16:
  // Allocate a new page?
  cmp edi, MAX_PROCS * sizeof ProcessRec
  jnb l_p_create_process_inner_x1
  
  push edi
    call m_alloc1
  pop edi
  or esi, esi
  jz l_p_create_process_inner_x2
  
  or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
  shr edi, 10  // log2 4096 - log2 4
  mov [PA_PT_PROCS + edi], esi
  shl edi, 10
  add p_procs_max_size, 4096
  
  // Zero new page - auto in m_alloc1
  /*
  push edi
    xor eax, eax
    add edi, VA_PROCS
    mov ecx, 4096 / 4
    cld
    rep stosd
  pop edi
  */
  
  l_p_create_process_inner_foundfree:
  // Free slot at VA_PROCS + edi
  add edi, VA_PROCS
  
  push edi
    // Zero ProcessRec
    xor eax, eax
    mov ecx, sizeof ProcessRec / 4
    cld
    rep stosd
    // Create main thread
    call p_create_thread_inner
    mov esi, edi
  pop edi
  or al, al
  jnz l_p_create_process_inner_x3
  
  // PrevInstance
  mov ebx, p_current
  mov ebx, [es:ebx + offset ThreadRec.process]
  mov [es:edi + offset ProcessRec.previnstance], ebx
  
  // Update memused
  mov dword[es:edi + offset ProcessRec.memused], 2 * 4096
  
  // MainThread, process
  mov [es:edi + offset ProcessRec.mainthread], esi
  mov [es:esi + offset ThreadRec.process], edi
  
  // eip
  mov dword [es:esi + offset TssRec.eip], offset p_new_proc
  
  // Allocate page directory
  push edi
    push esi
      call m_alloc1
    pop ebx
  pop edi
  mov [es:ebx + offset TssRec.cr3], esi
  
  or esi, esi
  jz near l_p_create_process_inner_x2
  
  // Set new cr3
  mov [es:edi + offset ProcessRec.cr3], esi
  
popfd

// Copy the common part of the page directory
push edi

  or esi, PG_MASK_P | PG_MASK_W
  mov [PA_PT_VAR], esi
  mov edi, VA_VAR + (VA_GLOBAL / 100000)
  mov esi, PA_PD0 + (VA_GLOBAL / 100000)
  mov ecx, (4096 - (VA_GLOBAL / 100000)) / 4
  cld
  rep movsd

pop edi

xor eax, eax
ret

// IN: edi = threadptr
// KEEP: edi
p_kill_thread_inner:
mov ebx, edi
call fs_release_thread  // keep edi
call h_timer_remove_all // keep edi

// release m_pages_busy
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_M_PAGES_BUSY
jz l_p_kill_thread_inner_1
  mov m_pages_busy, 0
  
l_p_kill_thread_inner_1:

// release m_heap_busy
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_M_HEAP_BUSY
jz l_p_kill_thread_inner_2
  mov m_heap_busy, 0
  
l_p_kill_thread_inner_2:

// release fs_busy
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DISK_BUSY
jz l_p_kill_thread_inner_3
  mov fs_busy, 0
  
l_p_kill_thread_inner_3:

// release p_load_busy
test word ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_P_LOAD_BUSY
jz l_p_kill_thread_inner_4
  mov p_load_busy, 0
  
l_p_kill_thread_inner_4:

// release g_busy
test word ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_G_BUSY
jz l_p_kill_thread_inner_5
  mov g_busy, 0
  
l_p_kill_thread_inner_5:

// release thread
xor eax, eax
mov [es:edi + offset ThreadRec.flags], eax
//... release unused ThreadRecs at the end

cmp edi, p_current
jnz l_p_kill_thread_inner_8
  
    mov p_kill_current, edi
    jmp short l_p_kill_thread_inner_9

  l_p_kill_thread_inner_8:
  push edi
    call p_stop
  pop edi
  
l_p_kill_thread_inner_9:
ret

// IN: ebx = processptr
p_kill_process_inner:

pushfd
  cli

  xor eax, eax
  mov p_kill_current, eax

  // release threads
  mov edi, VA_THREADS
  
  l_p_kill_process_inner_1:
    cmp [es:edi + offset ThreadRec.process], ebx
    jnz l_p_kill_process_inner_2

      push ebx
        call p_kill_thread_inner  // keep edi
      pop ebx
  
    l_p_kill_process_inner_2:  
    add edi, 4096  // assert sizeof ThreadRec = 4096
    mov eax, p_threads_max_size
    add eax, VA_THREADS
    cmp edi, eax
    jb l_p_kill_process_inner_1
  
  // release memory
  push ebx
    mov ebx, [es:ebx + offset ProcessRec.cr3]
    call m_pages_free_all
  pop ebx
  
  // release memory global
  mov esi, HEAP_START_GLOBAL
  
  l_p_kill_process_inner_5:
    cmp esi, HEAP_END_GLOBAL
    jnb l_p_kill_process_inner_6
      mov eax, [es:esi + offset HeapRec.type]
      cmp eax, ebx
      jnz l_p_kill_process_inner_58
        push ebx
         push esi
          mov ebx, esi
          add ebx, sizeof HeapRec
          call m_heap_free_global
         pop esi
        pop ebx
        
      l_p_kill_process_inner_58:
      mov eax, [es:esi + offset HeapRec.next]
      cmp eax, esi
      jna l_p_kill_process_inner_6
        mov esi, eax
        jmp l_p_kill_process_inner_5
  
  l_p_kill_process_inner_6:

  // send message to prev
  push ebx
    mov edx, ebx
    sub edx, VA_PROCS
    shr edx, 9  // assert sizeof ProcessRec == 512
    mov ebx, [es:ebx + offset ProcessRec.previnstance]
    sub ebx, VA_PROCS
    shr ebx, 9  // assert sizeof ProcessRec == 512
    mov ecx, WM_TERMINATED
    xor esi, esi
    // IN: ebx = wnd:threadid, ecx = msg, edx = wp, esi = lp
    call p_msg_send
  pop ebx
  
  // mark as unused
  xor eax, eax
  mov [es:ebx + offset ProcessRec.cr3], eax
  
  //... release unused ProcessRecs at the end
  
  // stop?
  mov edi, p_kill_current
  or edi, edi
  jz l_p_kill_process_inner_8

    call p_stop
    
  l_p_kill_process_inner_8:
  mov al, 0
  
popfd

l_p_kill_process_inner_9:
ret

p_load_x:
mov al, ERC_INVALID_HEADER
jmp p_load_9

// IN: es:edx -> filenamez
// OUT: al = 0 || erc, esi = new eip, ecx = stack size
p_load:
push ebp
mov ebp, esp
sub esp, 32

  //mov edx, p_current
  //mov edx, [es:edx + offset ThreadRec.process]
  //add edx, offset ProcessRec.filename
  mov al, FOPEN_READ
  call fs_fopen
  mov [ss:ebp - 4], esi  // ebp - 4 == fhandle
  or al, al
  jnz near p_load_9

  // CPARHDR
  xor edx, edx
  mov ebx, 8
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 8  // assert ss == es
  mov ecx, 2
  call fs_fread
  cmp word[ss:ebp - 8], 4
  jnz p_load_x

  // LFANEW
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, 60
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 8  // assert ss == es, ebp - 8 == lfanew
  mov ecx, 4
  call fs_fread

  // number of sections
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 6
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 28  // assert ss == es, ebp - 28 = number of sections
  mov ecx, 2
  call fs_fread

  // size of optional header
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 14h
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 24  // assert ss == es, ebp - 24 = size of OH
  mov ecx, 2
  call fs_fread
  cmp word[ss:ebp - 24], 224
  jb near p_load_x

  // size of optional header
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 34h
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 12  // assert ss == es, ebp - 12 == ImageBase
  mov ecx, 4
  call fs_fread

  // entry point from imagebase
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 28h
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 16  // assert ss == es, ebp - 16 == new_eip
  mov ecx, 4
  call fs_fread

  // stack size
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 60h
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 20  // assert ss == es, ebp - 20 == stack_size
  mov ecx, 4
  call fs_fread

  // sections
  movzx ecx, word[ss:ebp - 28]
  xor eax, eax
  mov [ss:ebp - 28], eax  // ebp - 28 == section offset
  
  p_load_5:
  
   push ecx
   
    mov esi, [ss:ebp - 4]
    xor edx, edx
    mov ebx, [ss:ebp - 8]
    add ebx, 18h
    movzx eax, word[ss:ebp - 24]
    add ebx, eax
    add ebx, [ss:ebp - 28]
    call fs_fsetpos
    
    mov esi, [ss:ebp - 4]
    mov edi, VA_SYSTEM + offset section
    mov ecx, sizeof SectionEntry
    add [ss:ebp - 28], ecx
    call fs_fread
    
    mov eax, [ss:ebp - 12]  // image base
    mov ebx, section.VirtualAddress
    add ebx, eax
    
    push ebx
    
      mov ecx, section.VirtualSize
      add ecx, 4095
      shr ecx, 12
      jecxz l_p_load_6

        call m_pages_alloc

      l_p_load_6:
      mov esi, [ss:ebp - 4]
      xor edx, edx
      mov ebx, section.PointerToRawData
      call fs_fsetpos
    
    pop edi    
    
    mov esi, [ss:ebp - 4]
    mov ecx, section.SizeOfRawData
    call fs_fread
    
   pop ecx
  
  loop p_load_5
  
  // fclose
  mov esi, [ss:ebp - 4]
  call fs_fclose
  
  // output
  mov eax, [ss:ebp - 12]  // image base
  mov esi, [ss:ebp - 16]  // new eip
  add esi, eax
  mov ecx, [ss:ebp - 20]  // stack size
  
  mov al, 0

p_load_9:
mov esp, ebp
pop ebp
ret

p_new_proc_error:

//... MessageBox(erc);

movzx eax, al
mov ecx, 16
call writen

mov edi, p_current
mov ebx, [es:edi + offset ThreadRec.process]
sub ebx, VA_PROCS
shr ebx, 9  // assert sizeof ProcessRec = 512
call p_kill_process

p_new_proc_error_9:
jmp p_new_proc_error_9


// new process
p_new_proc:
call m_heap_init

mov edx, p_current
mov edx, [es:edx + offset ThreadRec.process]
add edx, offset ProcessRec.filename

call p_load
or al, al
jnz p_new_proc_error

mov edi, p_current
mov [es:edi + offset ThreadRec.new_eip], esi

call p_alloc_stack3 // keep edi
or al, al
jnz p_new_proc_error

//ret - fall through

p_new_thread:
mov edi, p_current
xor edx, edx

// stack0
mov eax, edi
add eax, offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov esp, eax
mov tss.tss.ss0, ss
mov tss.tss.esp0, eax

// stack3
push SELECTOR_USER_DATA | 3
push dword ptr [es:edi + offset TssRec.esp]

// flags
push 0x200 //pushfd

// cs:eip
push SELECTOR_USER_CODE | 3
push dword ptr [es:edi + offset ThreadRec.new_eip]

// selectors
mov dx, SELECTOR_USER_DATA | 3
mov ds, dx
mov es, dx
mov fs, dx
mov gs, dx

xor eax, eax

iretd

//ret

// IN: ebx = global memory block, edx = type
p_clip_set:
cmp ebx, HEAP_START_GLOBAL
jb l_p_clip_set_9
cmp ebx, HEAP_END_GLOBAL
jnb l_p_clip_set_9

push ebx
 push edx
  mov ebx, p_clip
  call m_heap_free_global
 pop edx
pop ebx

xor eax, eax
dec eax
mov p_clip, ebx
mov [es:ebx - sizeof HeapRec + offset HeapRec.type], eax  // -1
mov p_clip_type, edx

mov ecx, WM_NEW_CLIP
xor edx, edx
xor esi, esi
call p_msg_send_to_all

l_p_clip_set_9:
ret

// OUT: ebx = global memory block, ecx = size, edx = type
p_clip_get:
mov ebx, p_clip
mov edx, p_clip_type
xor ecx, ecx
test ebx, ebx
jz l_p_clip_get_9
  mov ecx, [es:ebx - sizeof HeapRec + offset HeapRec.size]
  
l_p_clip_get_9:
ret

msg_p_init_x: db 29, "Process initialization failed"

l_p_init_x:
mov esi, offset msg_p_init_x
jmp fdie

p_init:
mov p_load_busy, 0

// Zero PT_PROCS, PT_THREADS
push es
  push ds
  pop es
  mov edi, PA_PT_PROCS
  mov ecx, 4096 / 4  // assert page_size = 4096
  xor eax, eax
  cld
  rep stosd

  mov edi, PA_PT_THREADS
  mov ecx, 4096 / 4  // assert page_size = 4096
  rep stosd
pop es

// Alloc 2 blocks: at VA_PROCS and at VA_THREADS
call m_alloc1
or al, al
jnz l_p_init_x
or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [PA_PT_PROCS], esi

call m_alloc1
or al, al
jnz l_p_init_x
or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [PA_PT_THREADS], esi

// Add proc_table to page_directory
mov eax, PA_PT_PROCS | PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [PA_PD0 + (VA_PROCS >> 20)], eax
mov eax, PA_PT_THREADS | PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [PA_PD0 + (VA_THREADS >> 20)], eax

// Init variables
mov eax, 4096
mov p_threads_max_size, eax
mov p_procs_max_size, eax

mov p_current, VA_THREADS

// Init ProcessRec
mov edi, VA_PROCS
mov ecx, sizeof ProcessRec / 4
xor eax, eax
rep stosd

mov eax, cr3
mov [es:VA_PROCS + offset ProcessRec.cr3], eax

// Init ThreadRec
mov edi, VA_THREADS
mov ecx, (4096 - 512) / 4
xor eax, eax
cld
rep stosd
dec eax
mov ecx, 512 / 4
rep stosd

mov word [es:VA_THREADS + offset TssRec.portsofs], 4096 - 512
mov ax, SELECTOR_TSS
ltr ax

mov dx, SELECTOR_LDT
mov [es:VA_THREADS + offset TssRec.ldt], dx
lldt dx

mov eax, cr3
mov [es:VA_THREADS + offset TssRec.cr3], eax

mov eax, VA_THREADS
mov [es:VA_THREADS + offset ThreadRec.next], eax
mov [es:VA_THREADS + offset ThreadRec.last], eax
mov eax, 1 | THREAD_FLAGS_USE_FPU
mov [es:VA_THREADS + offset ThreadRec.flags], eax
mov eax, VA_PROCS
mov [es:VA_THREADS + offset ThreadRec.process], eax
mov eax, PRIORITY0
mov [es:VA_THREADS + offset ThreadRec.priority], eax

// curdir
mov al, byte ptr boot_disk
and al, 31
mov [es:VA_THREADS + offset ThreadRec.curdisk], al
or al, 64
mov edi, VA_THREADS + offset ThreadRec.curdirtext
cld
stosb
mov al, ':'
stosb
mov al, '/'
stosb
xor eax, eax
stosb
mov [es:VA_THREADS + offset ThreadRec.curdir], eax

// stack
mov dx, SELECTOR_USER_DATA
mov [es:VA_THREADS + offset TssRec.ss], dx

mov dx, SELECTOR_ALL_DATA
mov [es:VA_THREADS + offset TssRec.ss0], dx
mov eax, VA_THREADS + offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov [es:VA_THREADS + offset TssRec.esp0], eax
pop ebx  // :KLUDGE:
  mov ss, dx
  mov esp, eax
push ebx

// selectors
mov word[es:VA_THREADS + offset TssRec.cs], cs
mov word[es:VA_THREADS + offset TssRec.ds], ds
mov word[es:VA_THREADS + offset TssRec.es], es
mov word[es:VA_THREADS + offset TssRec.fs], fs
mov word[es:VA_THREADS + offset TssRec.gs], gs

// Idle thread
call p_create_thread_inner
or al, al
jnz near l_p_init_x

mov p_idle, edi
mov dword ptr [es:edi + offset TssRec.eip], offset p_idle_thread
mov dword ptr [es:edi + offset ThreadRec.next], edi
mov dword ptr [es:edi + offset ThreadRec.last], edi

// Create global heap
call m_heap_init_global

// Create local heap
call m_heap_init

ret

p_noop:
pushad
 pushfd
  cli
  mov esi, p_current
  mov edi, [es:esi + offset ThreadRec.next]
  cmp esi, edi
  jz l_p_noop_8
    cmp esi, p_idle
    jnz l_p_noop_5
      // Remove idle
      mov ebx, [es:esi + offset ThreadRec.last]
      mov [es:ebx + offset ThreadRec.next], edi
      mov [es:edi + offset ThreadRec.last], ebx
    
      mov [es:esi + offset ThreadRec.last], esi
      mov [es:esi + offset ThreadRec.next], esi

    l_p_noop_5:
    // Next preempt
    call p_set_next_preempt  // keep esi, edi
    // Do switch
    call p_switch_task


  l_p_noop_8:
 popfd
popad
ret

// IN: ecx = stack size, esi = new eip
// OUT: al = 0 || errorcode, ebx = threadid, es:edi -> ThreadRec
p_create_thread:
push ecx
 push esi
  call p_create_thread_inner
 pop esi
pop ecx
xor ebx, ebx
or al, al
jnz l_p_create_thread_9

  mov [es:edi + offset ThreadRec.new_eip], esi
  
  call p_alloc_stack3 // keep edi
  or al, al
  jnz l_p_create_thread_9

    mov word[es:edi + offset TssRec.eip], offset p_new_thread

    mov ebx, edi
    sub ebx, VA_THREADS
    shr ebx, 12 // assert sizeof ThreadRec = 4096
    
    mov al, 0

l_p_create_thread_9:
ret

// IN: es:edx -> filenamez
// OUT: al = 0 || errorcode, ebx = pid, es:edi -> ProcessRec
p_create_process:
push edx
  call p_create_process_inner
pop edx
xor ebx, ebx
or al, al
jnz l_p_create_process_9
  
  // copy filename
  push edi
    mov esi, [es:edi + offset ProcessRec.mainthread]
    add esi, offset ThreadRec.curdirtext
    
    add edi, offset ProcessRec.filename
    
    call fs_merge
  pop edi
  //or al, al
  //jnz l_p_create_process_9

  // alloc stack3, set new eip - see p_new_proc
  
  mov ebx, edi
  sub ebx, VA_PROCS
  shr ebx, 9  // assert sizeof ProcessRec = 512

  mov al, 0

l_p_create_process_9:
ret

// IN: edi = thread VA
p_start:
pushfd
  cli
  mov esi, [es:edi + offset ThreadRec.next]
  or esi, esi
  jnz l_p_start_8
    mov ebx, p_current
    mov esi, [es:ebx + offset ThreadRec.next]
    mov [es:ebx + offset ThreadRec.next], edi
    mov [es:esi + offset ThreadRec.last], edi
    mov [es:edi + offset ThreadRec.next], esi
    mov [es:edi + offset ThreadRec.last], ebx
  l_p_start_8:
popfd
mov al, 0
ret

// IN: edi = thread VA
p_stop:
push ebp

mov esi, edi
or esi, esi
jz l_p_stop_9
pushfd
  cli
  mov edi, [es:esi + offset ThreadRec.next]
  or edi, edi
  jz l_p_stop_8
  
  cmp edi, esi
  jnz l_p_stop_2
    mov edi, p_idle
    jmp short l_p_stop_3
  
  l_p_stop_2:
  mov ebx, [es:esi + offset ThreadRec.last]
  mov [es:ebx + offset ThreadRec.next], edi
  mov [es:edi + offset ThreadRec.last], ebx

  l_p_stop_3:
  xor eax, eax
  mov [es:esi + offset ThreadRec.next], eax
  mov [es:esi + offset ThreadRec.last], eax
  
  cmp esi, p_current
  jnz l_p_stop_8
  
    // Next preempt
    call p_set_next_preempt  // keep esi, edi
    // Do switch
    call p_switch_task
  
  l_p_stop_8:
popfd

l_p_stop_9:
mov al, 0

pop ebp
ret

// IN: ecx = delay_ms
p_sleep:
pushfd
  cli
  
  // Set timer
  mov eax, 1193
  mul ecx
  xchg eax, ecx
  
  mov edx, TMR_THREADID_WND_WAKE
  mov ebx, p_current
  
  mov eax, ebx
  sub eax, VA_THREADS
  shr eax, 12 // assert sizeof ThreadRec = 4096
  shl eax, 16
  or edx, eax
  
  xor edi, edi
  call h_timer_add // IN: ecx = ticks, edx = threadid_wnd, ebx = id, edi = ofs

  
  // Sleep thread
  mov edi, p_current
  or byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
  call p_stop
  
popfd
ret

// IN: ebx = threadid
// OUT: al = 0 || erc
p_kill_thread:
mov edi, ebx
shl edi, 12  // assert sizeof ThreadRec = 4096
cmp edi, p_threads_max_size
jb l_p_kill_thread_2

  l_p_kill_thread_1:
  mov al, ERC_INVALID_THREAD
  jmp short l_p_kill_thread_9

l_p_kill_thread_2:
add edi, VA_THREADS

cmp dword ptr [es:edi + offset ThreadRec.flags], 0
jz l_p_kill_thread_1
  
  // mainthread => kill_process
  mov esi, [es:edi + offset ThreadRec.process]
  cmp [es:esi + offset ProcessRec.mainthread], edi
  jnz l_p_kill_thread_5

    mov ebx, esi
    sub ebx, VA_PROCS
    shr ebx, 9  // assert sizeof ProcessRec = 512    
    call p_kill_process
    jmp short l_p_kill_thread_9

  l_p_kill_thread_5:
  // same process?
  mov eax, p_current
  cmp esi, [es:eax + offset ThreadRec.process]
  jnz l_p_kill_thread_1

  // release stack3
  mov ebx, [es:edi + offset ThreadRec.stack3_ptr]
  call m_heap_free_local
  
  // inner  
  xor eax, eax
  mov p_kill_current, eax
  
  call p_kill_thread_inner

  // p_kill_current  
  mov edi, p_kill_current
  or edi, edi
  jz l_p_kill_thread_8

    call p_stop
    
  l_p_kill_thread_8:
  mov al, 0
  
l_p_kill_thread_9:
ret

// IN: ebx = pid
// OUT: al = 0 || erc
p_kill_process:
shl ebx, 9  // assert sizeof ProcessRec = 512
cmp ebx, p_procs_max_size
jb l_p_kill_process_5

  l_p_kill_process_3:
  mov al, ERC_INVALID_PID
  jmp short l_p_kill_process_9

l_p_kill_process_5:
add ebx, VA_PROCS

cmp dword ptr [es:ebx + offset ProcessRec.cr3], 0
jz l_p_kill_process_3

  call p_kill_process_inner

l_p_kill_process_9:
ret

MAX_WIN = 256

WINFLAGS_FULLSCREEN = 100h
WINFLAGS_MINIMALIZED = 200h

// see shared kernel variables

[dalign 32]
uns4 g_tmp, g_bg, g_base, g_base2, g_line, g_line2
int2 g_x1, g_y1, g_x2, g_y2, g_x, g_y, g_w, g_x1b, g_y1b, g_x2b, g_y2b

uns1 wcount
uns1 wpos[MAX_WIN]

[dalign 32]
WinRec win[MAX_WIN]

g_init:
mov g_busy, 0
mov wcount, 0

// Alloc LFB (VA_GRAPHICS -> physbase)
movzx eax, g_info.pitch
movzx ecx, g_info.yres
mul ecx
mov ecx, eax
add ecx, 4095
shr ecx, 12

mov edx, g_info.physbase
mov ebx, VA_GRAPHICS
push ecx
 push ebx
  call m_pages_alloc_hard
 pop ebx
pop ecx
shl ecx, 12
add ebx, ecx

// Alloc g_tmp
mov g_tmp, ebx

movzx eax, g_info.xres
movzx ecx, g_info.yres
mul ecx
shl eax, 2  // bits 32
mov ecx, eax
add ecx, 8 + 4095  // 8 = uns4 w, h
shr ecx, 12

push ecx
 push ebx
  mov edx, PG_MASK_P | PG_MASK_W | PG_MASK_G
  call m_pages_alloc_edx
 pop ebx
pop ecx
shl ecx, 12
add ebx, ecx

// Alloc g_bg
mov g_bg, ebx
shr ecx, 12
mov edx, PG_MASK_P | PG_MASK_W | PG_MASK_G | PG_MASK_U
call m_pages_alloc_edx

// Set sizes
movzx eax, g_info.xres
movzx ecx, g_info.yres
mov ebx, g_tmp
mov [es:ebx], eax
mov [es:ebx + 4], ecx
mov ebx, g_bg
mov [es:ebx], eax
mov [es:ebx + 4], ecx

// Set default bg
mov edi, g_bg
add edi, 8
xor ebx, ebx

l_g_init_1:
  mov eax, ebx
  movzx ecx, g_info.yres
  cmp eax, ecx
  jnb l_g_init_2
    mov edx, 255
    mul edx
    div ecx  // eax = ebx * 255 / yres
    mov ah, al
    xor al, 255
    
    movzx ecx, g_info.xres
    cld
    rep stosd

    inc ebx
    jmp short l_g_init_1
    
l_g_init_2:
/*
mov edi, VA_GRAPHICS
xor ebx, ebx

l_g_init_3:
  mov eax, ebx
  movzx ecx, g_info.yres
  cmp eax, ecx
  jnb l_g_init_4
    movzx edx, g_info.pitch
    mul edx
    add eax, VA_GRAPHICS
    mov edi, eax  // edi = ebx * pitch + VA_GRAPHICS
    
    mov eax, ebx
    movzx edx, g_info.xres
    mul edx
    shl eax, 2
    add eax, g_bg
    mov esi, eax  // esi = ebx * xres * 4 + g_bg
    
    movzx ecx, g_info.xres
    push ds
     push es
     pop ds
     rep movsd
    pop ds
    
    inc ebx
    jmp short l_g_init_3

l_g_init_4:
*/
ret

g_enter:
push eax
  l_g_enter_1:
    mov al, 1
    xchg al, g_busy
    or al, al
    jz l_g_enter_9
      call p_noop
      jmp l_g_enter_1
  
  l_g_enter_9:
  mov eax, p_current
  or word ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_G_BUSY
pop eax
ret

g_leave:
push eax
  mov eax, p_current
  mov g_busy, 0
  and word ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_G_BUSY
pop eax
ret

// IN: esi -> bitmap, g_x1, g_y1, g_x2, g_y2
g_full2scr:
test esi, esi
jz near l_g_full2scr_8  // esi == null

movzx eax, g_info.xres
movzx ecx, g_y1  // ecx = g_y1
mul ecx

movzx ebx, g_x1  // ebx = g_x1
add eax, ebx
shl eax, 2
add eax, esi
add eax, 8
mov g_base, eax  // g_base = (xres * g_y1 + g_x1) * 4 + esi + 8

movzx eax, g_x2
sub eax, ebx
inc eax
mov g_w, ax  // g_w = g_x2 - g_x1 + 1
cmp eax, 0
jng l_g_full2scr_8
  
  movzx eax, g_info.pitch
  mul ecx
  shl ebx, 2
  add eax, ebx
  add eax, VA_GRAPHICS
  mov g_base2, eax  // g_base2 = (pitch * g_y1) + (g_x1 * 4) + VA_GRAPHICS
  
  mov cx, g_y1
  
  cld
  
  l_g_full2scr_5:
    cmp cx, g_y2
    jg l_g_full2scr_8
      
      mov esi, g_base
      mov edi, g_base2
      push ecx
        movzx eax, g_info.xres
        shl eax, 2
        add g_base, eax
        
        movzx eax, g_info.pitch
        add g_base2, eax
        
        movzx ecx, g_w
        push ds
          push es
          pop ds
          rep movsd
        pop ds
      pop ecx
      inc ecx
      jmp short l_g_full2scr_5
      
l_g_full2scr_8:
ret

// IN: g_x1, g_y1, g_x2, g_y2
g_copybg:
mov esi, g_bg
mov edi, g_tmp

movzx ebx, g_x1  // ebx = g_x1
movzx eax, g_x2
sub eax, ebx
inc eax
mov g_w, ax  // g_w = g_x2 - g_x1 + 1

movzx ecx, g_y1  // ecx = g_y1
movzx eax, g_info.xres
mul ecx
add eax, ebx
shl eax, 2  // eax = (g_y1 * xres + g_x1) * 4
add esi, eax
add edi, eax
add esi, 8
add edi, 8
mov g_base, esi
mov g_base2, edi

movzx eax, g_info.xres
shl eax, 2
mov g_line, eax

l_g_copybg_5:
  cmp cx, g_y2
  jg l_g_copybg_8
    mov esi, g_base
    mov edi, g_base2
    push ecx
      mov eax, g_line
      add g_base, eax
      add g_base2, eax
      movzx ecx, g_w
      push ds
        push es
        pop ds
        rep movsd
      pop ds
    pop ecx
    inc ecx
    jmp short l_g_copybg_5
  
l_g_copybg_8:
ret

// IN: g_x1, g_y1, g_x2, g_y2, es:esi -> winbitmap, g_x = winx, g_y = winy
g_merge:
test esi, esi
jz near l_g_merge_9  // esi == null

// calc intersection
mov ax, g_x1
cmp ax, g_x
jg l_g_merge_11
  mov ax, g_x

l_g_merge_11:
mov g_x1b, ax  // g_x1b = max(g_x1, g_x)

mov ax, g_y1
cmp ax, g_y
jg l_g_merge_12
  mov ax, g_y
  
l_g_merge_12:
mov g_y1b, ax  // g_y1b = max(g_y1, g_y)

mov ax, g_x
add ax, [es:esi]
dec ax
cmp ax, g_x2
jl l_g_merge_13
  mov ax, g_x2
  
l_g_merge_13:
mov g_x2b, ax  // g_x2b = min(winx2, g_x2)

mov ax, g_y
add ax, [es:esi + 4]
dec ax
cmp ax, g_x2
jl l_g_merge_14
  mov ax, g_x2
  
l_g_merge_14:
mov g_y2b, ax  // g_y2b = min(winy2, g_y2)

// check any
mov ax, g_x2b
sub ax, g_x1b
jl near l_g_merge_9
  inc ax
  mov g_w, ax  // g_w = g_x2b - g_x1b + 1

mov ax, g_y2b
cmp ax, g_y1b
jl near l_g_merge_9

// calc bases and lines
movsx eax, g_x1b
movsx edx, g_x
sub eax, edx
mov ebx, eax  // ebx = g_x1b - g_x (>=0)

movsx eax, g_y1b
movsx edx, g_y
sub eax, edx
movzx edx, word ptr [es:esi]
mov g_line, edx
shl g_line, 2  // g_line = winw * 4
mul edx
add eax, ebx
shl eax, 2
add eax, esi
add eax, 8
mov g_base, eax  // g_base = ((g_y1b - g_y) * winw + ebx) * 4 + esi + 8

movzx eax, g_info.xres
shl eax, 2
mov g_line2, eax  // g_line2 = xres * 4
movzx edx, g_y1b
mul edx
movzx edx, g_x1b
shl edx, 2
add eax, edx
add eax, g_tmp
add eax, 8
mov g_base2, eax  // g_base2 = (g_line2 * g_y1b) + (g_x1b * 4) + g_tmp + 8

// main loop
mov cx, g_y1b

l_g_merge_5:
  cmp cx, g_y2b
  jg near l_g_merge_9
    mov esi, g_base
    mov edi, g_base2
    push ecx
      mov eax, g_line
      mov edx, g_line2
      add g_base, eax
      add g_base2, edx
      movzx ecx, g_w
      push ds
        push es
        pop ds
        
        l_g_merge_51:
          lodsd
          test eax, eax
          jnz l_g_merge_52
            // argb = 0: empty
            add edi, 4
            loop l_g_merge_51
              jmp short l_g_merge_58
              
          l_g_merge_52:
          cmp eax, 0xFF000000
          jb l_g_merge_53
            // argb = full
            stosd
            loop l_g_merge_51
              jmp short l_g_merge_58
            
          l_g_merge_53:
          // merge
          push ecx
            mov ebx, eax  // ebx = argb
            mov ecx, eax
            shr ecx, 24  // cl = a
            mov ch, cl
            xor ch, 255  // ch = 255 - a
            
            mul cl
            mov dx, ax  // dx = b * cl
            mov al, [edi]
            mul ch
            add ax, dx  // ax = dx + (b2 * ch)
            shr eax, 8
            stosb
            
            mov al, bh
            mul cl
            mov dx, ax  // dx = g * cl
            mov al, [edi]
            mul ch
            add ax, dx  // ax = dx + (g2 * ch)
            shr eax, 8
            stosb
            
            mov eax, ebx
            shr eax, 16
            mul cl
            mov dx, ax  // dx = r * cl
            mov al, [edi]
            mul ch
            add ax, dx  // ax = dx + (r2 * ch)
            shr eax, 8
            stosb
          pop ecx
          
          inc edi // a
          loop l_g_merge_51
        
        l_g_merge_58:
      pop ds      
    pop ecx
    inc ecx
    jmp l_g_merge_5

l_g_merge_9:
ret

// IN: ecx = x1, ebx = y1, esi = x2, edi = y2
g_paint:
call g_enter

xor eax, eax
cmp cx, ax
jnl l_g_paint_11
  mov cx, ax

l_g_paint_11:
mov g_x1, cx  // g_x1 = max(cx,0)

cmp bx, ax
jnl l_g_paint_12
  mov bx, ax
  
l_g_paint_12:
mov g_y1, bx  // g_y1 = max(bx,0)

movzx eax, g_info.xres
dec eax
cmp esi, eax
jl l_g_paint_13
  mov esi, eax
  
l_g_paint_13:
mov g_x2, si  // g_x2 = min(esi,xres-1)

movzx eax, g_info.yres
dec eax
cmp edi, eax
jl l_g_paint_14
  mov edi, eax
  
l_g_paint_14:
mov g_y2, di  // g_y2 = min(edi,yres-1)

// full screen?
mov al, wcount
cmp al, 0
jz l_g_paint_3
  dec al
  movzx esi, al
  mov dl, wpos[esi]
  movzx esi, dl
  shl esi, 5  // assert sizeof WinRec = 32
  mov eax, win.flags[esi]
  test eax, WINFLAGS_FULLSCREEN
  jnz l_g_paint_3
    // switch to window address space
    mov edx, cr3
    push edx
      mov eax, win.cr3[esi]
      mov ebx, p_current
      mov [es:ebx + offset ThreadRec.tss.cr3], eax
      mov cr3, eax
      
      // paint fullscreen window
      mov esi, win.pbitmap[esi]
      call g_full2scr
      
    pop edx
    // restore address space
    mov ebx, p_current
    mov [es:ebx + offset ThreadRec.tss.cr3], edx
    mov cr3, edx
    
    jmp l_g_paint_9

l_g_paint_3:
// not full screen
call g_copybg

// foreach window
xor ecx, ecx

l_g_paint_31:
  cmp cl, wcount
  jnb l_g_paint_39
    movzx esi, cl
    mov al, wpos[esi]
    movzx esi, al
    shl esi, 5  // assert sizeof WinRec = 32
    mov eax, win.flags[esi]
    test eax, WINFLAGS_MINIMALIZED
    jz l_g_paint_32
      loop l_g_paint_31
        jmp short l_g_paint_39
    
    l_g_paint_32:
    mov ax, win.x[esi]
    mov g_x, ax
    mov dx, win.y[esi]
    mov g_y, dx
    
    // switch to window address space
    mov edx, cr3
    push ecx
     push edx
      mov eax, win.cr3[esi]
      mov ebx, p_current
      mov [es:ebx + offset ThreadRec.tss.cr3], eax
      mov cr3, eax
      
      // paint window
      mov esi, win.pbitmap[esi]
      call g_merge
      
     pop edx
    pop ecx
    // restore address space
    mov ebx, p_current
    mov [es:ebx + offset ThreadRec.tss.cr3], edx
    mov cr3, edx
    loop l_g_paint_31

l_g_paint_39:
// paint tmp to scr
mov esi, g_tmp
call g_full2scr

l_g_paint_9:
call g_leave
ret

// OUT: eax = old_flags, ebx = old_eip, edx = old_esp, ecx = old_ebp
x_get:
mov edi, p_current
mov eax, [es:edi + offset ThreadRec.catch.flags]
mov ebx, [es:edi + offset ThreadRec.catch.eip]
mov edx, [es:edi + offset ThreadRec.catch.esp]
mov ecx, [es:edi + offset ThreadRec.catch.ebp]
ret

// IN: eax = flags, ebx = catch_eip, edx = esp, ebp = ebp
// OUT: eax = old_flags, ebx = old_eip, edx = old_esp, ebp = old_ebp
x_set:
mov edi, p_current
xchg eax, [es:edi + offset ThreadRec.catch.flags]
xchg ebx, [es:edi + offset ThreadRec.catch.eip]
xchg edx, [es:edi + offset ThreadRec.catch.esp]
xchg ebp, [es:edi + offset ThreadRec.catch.ebp]
ret

x_throw:
mov edi, p_current
mov eax, [es:edi + offset ThreadRec.catch.flags]
mov ebx, [es:edi + offset ThreadRec.catch.eip]
mov edx, [es:edi + offset ThreadRec.catch.esp]
mov ebp, [es:edi + offset ThreadRec.catch.ebp]

test al, X_FLAG_VALID
jnz l_x_throw_valid
  
  //... write error message: uncatched error
  
  l_x_throw_11: jmp l_x_throw_11

l_x_throw_valid:
test al, X_FLAG_SYSTEM
jz l_x_throw_user
  // system
  mov esp, edx
  jmp ebx
  
l_x_throw_user:
// stack0
mov eax, edi
add eax, offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov esp, eax
mov tss.tss.ss0, ss
mov tss.tss.esp0, eax

// stack3
push SELECTOR_USER_DATA | 3
push edx

// flags
push 0x200 //pushfd

// cs:eip
push SELECTOR_USER_CODE | 3
push ebx

// selectors
mov dx, SELECTOR_USER_DATA | 3
mov ds, dx
mov es, dx

iretd

uns8 t_time, t_time2
SystemTime t_system

t_systime2ftime_months:
dw 0,31,59,90,120,151,181,212,243,273,304,334

t_systime2ftime_months_leap:
dw 0,31,60,91,121,152,182,213,244,274,305,335

// IN: eax = date (year << 9 + month << 5 + day)
// OUT: eax = days
// KEEP: esi, edi
t_systime2ftime_days:
push eax
  shr eax, 9  
  sub eax, 1600
  
  mov ebx, eax
  mov ecx, 365
  mul ecx
  
  push ebx
    shr ebx, 2
    add ebx, eax // ebx = (year - 1600) * 365 + ((year - 1600) / 4)
  pop eax
  mov ecx, 100
  xor edx, edx
  div ecx
  sub ebx, eax // ebx -= (year - 1600) / 100
  
  shr eax, 2
  add eax, ebx // eax = ebx + (year - 1600) / 400
  
  sub eax, 365 // eax -= 365 (1600->1601)
pop ebx
push ebx

  push eax

    mov eax, ebx
    shr eax, 9  // eax = date >> 9 (year)
    
    shr ebx, 5
    dec ebx
    and ebx, 15
    shl ebx, 1  // ebx = pointer to months
    
    test al, 3
    jnz l_t_systime2ftime_days_notleap
      mov ecx, 100
      xor edx, edx
      div ecx
      or edx, edx
      jnz l_t_systime2ftime_days_leap
        test al, 3
        jnz l_t_systime2ftime_days_notleap
      
    l_t_systime2ftime_days_leap:
    movzx edx, word ptr [cs:ebx + offset t_systime2ftime_months_leap]
    dec edx
    jmp short l_t_systime2ftime_days_6
    
    l_t_systime2ftime_days_notleap:
    movzx edx, word ptr [cs:ebx + offset t_systime2ftime_months]

    l_t_systime2ftime_days_6:
  
  pop eax

  add eax, edx // eax += days[month-1]
pop ebx
push ebx
  and ebx, 31
  dec ebx
  add eax, ebx  // eax += day-1
pop ebx
ret

// IN: eax = days
// OUT: eax = date (year << 9 + month << 5 + day)
// KEEP: esi, edi
t_ftime2systime_days:
add eax, 366
mov ecx, 400
mul ecx
mov ecx, 146097
div ecx
add eax, 1600
xchg eax, ebx  // ebx = year
xchg eax, edx
mov ecx, 400
xor edx, edx
div ecx  // eax = day of year

push eax

  mov eax, ebx
  test al, 3
  jnz l_t_ftime2systime_days_notleap
    mov ecx, 100
    xor edx, edx
    div ecx
    or edx, edx
    jnz l_t_ftime2systime_days_leap
      test al, 3
      jnz l_t_ftime2systime_days_notleap

l_t_ftime2systime_days_leap:

pop eax

mov ecx, 22

l_t_ftime2systime_days_leap1:
  movzx edx, word ptr [cs:ecx + offset t_systime2ftime_months_leap]
  cmp eax, edx
  jnb l_t_ftime2systime_days_8
    sub ecx, 2
    jmp short l_t_ftime2systime_days_leap1
  

l_t_ftime2systime_days_notleap:

pop eax

mov ecx, 22

l_t_ftime2systime_days_notleap1:
  movzx edx, word ptr [cs:ecx + offset t_systime2ftime_months]
  cmp eax, edx
  jnb l_t_ftime2systime_days_8
    sub ecx, 2
    jmp short l_t_ftime2systime_days_notleap1

l_t_ftime2systime_days_8:
shr ecx, 1
inc ecx
shl ebx, 4
or ebx, ecx  // ebx << 4 + month

sub eax, edx
inc eax
shl ebx, 5
or ebx, eax  // ebx << 5 + day

mov eax, ebx
ret

// IN: eax = index, OUT: eax = value
t_getlocal_get:
out 70h, al
in al, 71h
mov cl, al
shr al, 4
and cl, 15
mov dl, 10
mul dl
add al, cl
ret

// IN: al = value, OUT: dl = hex
t_setlocal_calc:
movzx eax, al
mov ecx, 10
xor edx, edx
div ecx
shl al, 4
add dl, al
ret

// IN: ax = new hour, es:edi -> SystemTime
// OUT: eax = days
t_getsystem_makedays:
mov word ptr [es:edi + offset SystemTime.wHour], ax  // new hour
movzx eax, word ptr [es:edi + offset SystemTime.wYear]
shl eax, 4
or ax, word ptr [es:edi + offset SystemTime.wMonth]
shl eax, 5
or ax, word ptr [es:edi + offset SystemTime.wDay]
call t_systime2ftime_days
ret

// IN: eax = days, es:edi -> SystemTime
t_getsystem_makedate:
call t_ftime2systime_days
mov ecx, eax
shr eax, 9
mov word ptr [es:edi + offset SystemTime.wYear], ax
mov eax, ecx
shr eax, 5
and eax, 15
mov word ptr [es:edi + offset SystemTime.wMonth], ax
mov eax, ecx
and eax, 31
mov word ptr [es:edi + offset SystemTime.wDay], ax
ret

// IN: es:edi -> systemtime, es:esi -> ftime, max year = 32767
t_systime2ftime:
movzx eax, word ptr [es:edi + offset SystemTime.wYear]
movzx ecx, word ptr [es:edi + offset SystemTime.wMonth]
shl eax, 4
or eax, ecx
movzx ecx, word ptr [es:edi + offset SystemTime.wDay]
shl eax, 5
or eax, ecx
call t_systime2ftime_days
push eax
  movzx eax, word ptr [es:edi + offset SystemTime.wHour]
  mov ecx, 60
  mul ecx
  movzx ecx, word ptr [es:edi + offset SystemTime.wMinute]
  add eax, ecx
  mov ecx, 60
  mul ecx
  movzx ecx, word ptr [es:edi + offset SystemTime.wSecond]
  add eax, ecx
  xchg ebx, eax  // ebx = hms
pop eax
mov ecx, 86400
mul ecx
add eax, ebx
adc edx, 0

pushfd
  cli
  mov dword ptr t_time[0], eax
  xchg eax, edx
  mov ecx, 10000000
  mul ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  mul ecx
  mov dword ptr t_time[0], eax
  add dword ptr t_time[4], edx  // t_time = edx:eax * 10000000
  
  movzx eax, word ptr [es:edi + offset SystemTime.wMilliseconds]
  mov ecx, 10000000 / 1000
  mul ecx
  add dword ptr t_time[0], eax
  adc dword ptr t_time[4], edx
  mov eax, dword ptr t_time[0]
  mov edx, dword ptr t_time[4]
popfd

mov [es:esi], eax
mov [es:esi + 4], edx
ret

// IN: es:esi -> ftime, es:edi -> systemtime
t_ftime2systime:
pushfd
  cli
  mov eax, [es:esi + 4]
  mov ecx, 10000000
  xor edx, edx
  div ecx
  mov dword ptr t_time[4], eax
  mov eax, [es:esi]
  div ecx
  mov dword ptr t_time[0], eax
  
  xchg eax, edx  // eax = ftime % 10000000
  mov ecx, 10000
  xor edx, edx
  div ecx
  mov [es:edi + offset SystemTime.wMilliseconds], ax
  
  mov eax, dword ptr t_time[4]
  mov ecx, 86400
  xor edx, edx
  div ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  div ecx
  mov dword ptr t_time[0], eax  // t_time = days
  
  xchg eax, edx  // eax = ftime / 10000000 % 86400
  mov ecx, 60
  xor edx, edx
  div ecx
  mov [es:edi + offset SystemTime.wSecond], dx
  xor edx, edx
  div ecx
  mov [es:edi + offset SystemTime.wMinute], dx
  mov [es:edi + offset SystemTime.wHour], ax
  
  // day of week
  mov eax, dword ptr t_time[0]
  mov ecx, 7
  xor edx, edx
  div ecx
  xchg eax, edx
  add al, 1 // dow 1601-01-01
  cmp al, 7
  jb l_t_ftime2systime_1
    xor eax, eax
  
  l_t_ftime2systime_1:
  mov [es:edi + offset SystemTime.wDayOfWeek], ax
  
  // date
  mov eax, dword ptr t_time[0]
  call t_ftime2systime_days
  push eax
    and eax, 31
    mov [es:edi + offset SystemTime.wDay], ax
  pop eax
  push eax
    shr eax, 5
    and eax, 15
    mov [es:edi + offset SystemTime.wMonth], ax  
  pop eax
  shr eax, 9
  mov [es:edi + offset SystemTime.wYear], ax
popfd
ret

// IN: es:edi -> SystemTime
t_getlocal:
pushfd
  cli

  mov eax, 32h // century
  call t_getlocal_get
  mov ecx, 100
  mul ecx
  xchg eax, ebx
  
  mov eax, 9 // year
  call t_getlocal_get
  add bl, al
  adc bh, 0
  mov [es:edi + offset SystemTime.wYear], bx
  
  mov eax, 8 // month
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wMonth], ax
  
  mov eax, 7 // day
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wDay], ax
  
  mov eax, 6 // day of week + 1
  out 70h, al
  in al, 71h
  dec al
  mov [es:edi + offset SystemTime.wDayOfWeek], ax
  
  mov eax, 4 // hour
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wHour], ax
  
  mov eax, 2 // min
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wMinute], ax
  
  mov eax, 0 // sec
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wSecond], ax
  
  mov ax, tmr_ms // ms
  mov [es:edi + offset SystemTime.wMilliseconds], ax
  
  mov al, 0
popfd
ret

// IN: es:edi -> SystemTime
t_setlocal:
pushfd
  cli
  
  movzx eax, word ptr [es:edi + offset SystemTime.wYear]
  mov ecx, 100
  xor edx, edx
  div ecx
  mov ebx, edx
  
  call t_setlocal_calc
  mov al, 32h // century
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov al, bl
  call t_setlocal_calc
  mov al, 9 // year
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wMonth]
  call t_setlocal_calc
  mov al, 8 // month
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wDay]
  call t_setlocal_calc
  mov al, 7 // day
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wHour]
  call t_setlocal_calc
  mov al, 4 // hour
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wMinute]
  call t_setlocal_calc
  mov al, 2 // min
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wSecond]
  call t_setlocal_calc
  mov al, 0 // sec
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov al, 0
popfd
ret

// IN: es:edi -> SystemTime
t_getsystem:
call t_getlocal
movzx eax, word ptr [es:edi + offset SystemTime.wHour]
sub eax, time_zone
cmp eax, 0
jl l_t_getsystem_2
cmp eax, 24
jnl l_t_getsystem_3
mov word ptr [es:edi + offset SystemTime.wHour], ax
ret

l_t_getsystem_2:
add eax, 24
call t_getsystem_makedays
dec eax
dec byte ptr [es:edi + offset SystemTime.wDayOfWeek]
cmp byte ptr [es:edi + offset SystemTime.wDayOfWeek], 7
jb l_t_getsystem_26
  add byte ptr [es:edi + offset SystemTime.wDayOfWeek], 7

l_t_getsystem_26:
call t_getsystem_makedate
ret

l_t_getsystem_3:
sub eax, 24
call t_getsystem_makedays
inc eax
inc byte ptr [es:edi + offset SystemTime.wDayOfWeek]
cmp byte ptr [es:edi + offset SystemTime.wDayOfWeek], 7
jb l_t_getsystem_36
  sub byte ptr [es:edi + offset SystemTime.wDayOfWeek], 7

l_t_getsystem_36:
call t_getsystem_makedate
ret

// OUT: eax = local UNIX time
t_getunix:
pushfd
  cli
  mov edi, VA_SYSTEM + offset t_system
  call t_getlocal
  
  movzx eax, t_system.wYear
  shl eax, 4
  mov dx, t_system.wMonth
  or al, dl
  shl eax, 5
  mov dx, t_system.wDay
  or al, dl
  
  call t_systime2ftime_days
  
  sub eax, 134774  // 1970-01-01
  
  push eax
    movzx eax, t_system.wHour
    mov ecx, 60
    mul ecx
    movzx ecx, t_system.wMinute
    add eax, ecx
    mov ecx, 60
    mul ecx
    movzx ecx, t_system.wSecond
    add eax, ecx
    xchg ebx, eax  // ebx = hms
  pop eax
  mov ecx, 86400
  mul ecx
  add eax, ebx
  adc edx, 0
  
popfd
ret

// IN: eax = UNIX time
// OUT: edx:eax = ftime
t_unix2ftime:
xor edx, edx
add eax, 134774 * 86400
adc edx, 2  // 134774 * 86400 >> 32

pushfd
  cli
  mov dword ptr t_time[0], eax
  xchg eax, edx
  mov ecx, 10000000
  mul ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  mul ecx
  add edx, dword ptr t_time[4]
popfd

ret

// IN: edx:eax = ftime
// OUT: eax = UNIX time
t_ftime2unix:
test edx, edx
jnz l_t_ftime2unix_1
  test eax, eax
  jz l_t_ftime2unix_9
    
l_t_ftime2unix_1:
pushfd
  cli
  mov dword ptr t_time[0], eax
  xchg eax, edx
  xor edx, edx
  mov ecx, 10000000
  div ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  div ecx
  add edx, dword ptr t_time[4]
popfd
sub eax, 134774 * 86400

l_t_ftime2unix_9:
ret

DELCHAR = 4  // 0E5h
MAX_MASK = 64

FILE_ATTRIBUTE_READONLY  = 0x00000001
FILE_ATTRIBUTE_HIDDEN    = 0x00000002
FILE_ATTRIBUTE_SYSTEM    = 0x00000004
FILE_ATTRIBUTE_DIRECTORY = 0x00000010
FILE_ATTRIBUTE_ARCHIVE   = 0x00000020
FILE_ATTRIBUTE_DEVICE    = 0x00000040
FILE_ATTRIBUTE_NORMAL    = 0x00000080
FILE_ATTRIBUTE_TEMPORARY     = 0x00000100
FILE_ATTRIBUTE_SPARSE_FILE   = 0x00000200
FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400
FILE_ATTRIBUTE_COMPRESSED    = 0x00000800
FILE_ATTRIBUTE_OFFLINE       = 0x00001000
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000
FILE_ATTRIBUTE_ENCRYPTED       = 0x00004000
FILE_ATTRIBUTE_VALID_FLAGS     = 0x00007fb7
FILE_ATTRIBUTE_VALID_SET_FLAGS = 0x000031a7
FILE_ATTRIBUTE_LINUX = 0x08000000
FILE_ATTRIBUTE_LINK  = 0x04000000

struct SearchRec{
  uns4 FileAttributes
  DateTime CreationTime
  DateTime LastAccessTime
  DateTime LastWriteTime
  uns8 FileSize
  uns8 Reserved
  char FileName[MAX_PATH]
  char AlternateFileName[14]
}

struct InSrchRec{
  char FileMask[MAX_MASK]
  uns8 Cluster
  uns4 Size, File, Offset
  uns2 ThreadId
  uns1 Disk, Rsv1
}

InSrchRec srch[MAX_SRCH]
char fs_utf8buf[MAX_PATH], fs_link[MAX_PATH]
uns1 fs_mode, fs_i, fs_ldiskn_format
bool fs_dosplit, fs_bigendian

[dalign 32]
uns4 fs_rec, fs_srchofs, fs_edi0, fs_edimax, fs_fsid, fs_max
uns4 fs_diskmain_format

[dalign 64]
uns8 fs_ftime

SystemTime fs_systime

fs_enter:
push eax
  l_fs_enter_1:
    mov al, 1
    xchg al, fs_busy
    or al, al
    jz l_fs_enter_2
      //call p_noop
      //jmp l_fs_enter_1
      pop eax
      pop eax
      mov al, ERC_BUSY
      ret
      
  l_fs_enter_2:
  mov eax, p_current
  or byte ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_DISK_BUSY
pop eax
ret

fs_leave:
push eax
  mov eax, p_current
  and byte ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_DISK_BUSY
  mov fs_busy, 0
pop eax
ret

fs_enter2:
push eax
  l_fs_enter2_1:
    mov al, 1
    xchg al, fs_busy
    or al, al
    jz l_fs_enter2_2
      call p_noop
      jmp l_fs_enter2_1
      
  l_fs_enter2_2:
  mov eax, p_current
  or byte ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_DISK_BUSY
pop eax
ret

// IN: es:edx -> file name
// OUT: al = ldiskn, ebx = dir cluster, es:edx -> after disk letter or '/'
// KEEP: ecx, esi, edi
fs_disk:
cmp byte ptr [es:edx], 0
jz l_fs_disk_2
  
  mov al, [es:edx+1]
  cmp al, ':'
  jnz l_fs_disk_2
  
    xor ebx, ebx
    mov al, [es:edx]
    cmp al, 'a'
    jb l_fs_disk_1
      cmp al, 'z'
      ja l_fs_disk_1
        sub al, 32
        
    l_fs_disk_1:
    add edx, 2
    mov cl, [es:edx]
    cmp cl, '/'
    jnz l_fs_disk_3
      inc edx
      jmp short l_fs_disk_3
  
l_fs_disk_2:
mov ebx, p_current
mov al, [es:ebx + offset ThreadRec.curdisk]
mov cl, [es:edx]
cmp cl, '/'
jnz l_fs_disk_25
  xor ebx, ebx
  inc edx
  jmp short l_fs_disk_3

l_fs_disk_25:
mov ebx, [es:ebx + offset ThreadRec.curdir]

l_fs_disk_3:
and al, 31
ret

// IN: edi = index to disk_info, al = ldiskn
// OUT: al = disk_info.fsid[edi]
// KEEP ebx, edx, esi, edi
fs_load_fsid:
push ebx
 push edx
  push esi
   push edi
    
    mov esi, disk_info.main[edi]
    mov ebx, 3
    xor edx, edx
    mov ecx, 4
    mov edi, VA_SYSTEM + offset fs_fsid
    
    test esi, esi
    jz l_fs_load_fsid_8
    
    mov ah, 2  // read
    call esi
    
    mov al, 0
    cmp fs_fsid, "NTFS"
    jnz l_fs_load_fsid_61
      mov al, FSID_NTFS
      jmp short l_fs_load_fsid_7
      
    l_fs_load_fsid_61:
    //...
    mov al, FSID_EXT2
    
    l_fs_load_fsid_7:
   pop edi
   push edi
    mov disk_info.fsid[edi], al
    
    l_fs_load_fsid_9:
    
   pop edi
  pop esi
 pop edx  
pop ebx
ret

l_fs_load_fsid_8:
mov al, 0
jmp l_fs_load_fsid_9

// IN: esi, edi, ecx = count
// OUT: al = 0(equal) || 1(not equal)
eqxcase:
l_eqxcase_1:
jecxz l_eqxcase_8
  dec ecx
  mov al, [esi]
  mov dl, [edi]
  cmp al, dl
  jz l_eqxcase_next
    cmp al, 'a'
    jb l_eqxcase_6
      cmp al, 'z'
      ja l_eqxcase_6
        sub al, 32

    l_eqxcase_6:
    cmp dl, 'a'
    jb l_eqxcase_7
      cmp dl, 'z'
      ja l_eqxcase_7
        sub dl, 32

    l_eqxcase_7:
    cmp al, dl
    jz l_eqxcase_next
      mov al, 1
      jmp l_eqxcase_9

  l_eqxcase_next:
  inc esi
  inc edi
  jmp l_eqxcase_1

l_eqxcase_8:
mov al, 0
l_eqxcase_9:
ret

// IN: esi, edi, ecx = count
// OUT: al = 0(equal) || 1(not equal)
eqxcase_qm:
l_eqxcase_qm_1:
jecxz l_eqxcase_qm_8
  dec ecx
  mov al, [esi]
  mov dl, [edi]
  cmp al, dl
  jz l_eqxcase_qm_next
    cmp al, 'a'
    jb l_eqxcase_qm_6
      cmp al, 'z'
      ja l_eqxcase_qm_6
        sub al, 32

    l_eqxcase_qm_6:
    cmp dl, 'a'
    jb l_eqxcase_qm_7
      cmp dl, 'z'
      ja l_eqxcase_qm_7
        sub dl, 32

    l_eqxcase_qm_7:
    cmp al, dl
    jz l_eqxcase_qm_next
      cmp al, '?'
      jz l_eqxcase_qm_next
        cmp dl, '?'
        jz l_eqxcase_qm_next
          mov al, 1
          jmp l_eqxcase_qm_9

  l_eqxcase_qm_next:
  inc esi
  inc edi
  jmp l_eqxcase_qm_1

l_eqxcase_qm_8:
mov al, 0
l_eqxcase_qm_9:
ret

// IN: eax
// OUT: eax
// KEEP: all but eax
fs_tolower:
cmp eax, 'A'
jb near l_fs_tolower_9
cmp eax, 'Z'
jna near l_fs_tolower_2
cmp eax, 0xC0
jb near l_fs_tolower_9
cmp eax, 0xD6
jna near l_fs_tolower_2
cmp eax, 0xD8
jb near l_fs_tolower_9
cmp eax, 0xDD
jna near l_fs_tolower_2
cmp eax, 0x100
jb near l_fs_tolower_9
cmp eax, 0x136
jna near l_fs_tolower_3
cmp eax, 0x139
jb near l_fs_tolower_9
cmp eax, 0x177
jna near l_fs_tolower_4
cmp eax, 0x179
jb near l_fs_tolower_9
cmp eax, 0x17E
jna near l_fs_tolower_4
cmp eax, 0x200
jb near l_fs_tolower_9
cmp eax, 0x21F
jna near l_fs_tolower_3
cmp eax, 0x224
jb near l_fs_tolower_9
cmp eax, 0x233
jna near l_fs_tolower_3
cmp eax, 0x391
jb near l_fs_tolower_9
cmp eax, 0x3AB
jna l_fs_tolower_2
cmp eax, 0x3D8
jb near l_fs_tolower_9
cmp eax, 0x3EF
jna l_fs_tolower_3
cmp eax, 0x400
jb l_fs_tolower_9
cmp eax, 0x40F
jna l_fs_tolower_5
cmp eax, 0x410
jb l_fs_tolower_9
cmp eax, 0x42F
jna l_fs_tolower_2
cmp eax, 0x460
jb l_fs_tolower_9
cmp eax, 0x481
jna l_fs_tolower_3
cmp eax, 0x488
jb l_fs_tolower_9
cmp eax, 0x4BF
jna l_fs_tolower_3
cmp eax, 0x4C1
jb l_fs_tolower_9
cmp eax, 0x4CE
jna l_fs_tolower_4
cmp eax, 0x4D0
jb l_fs_tolower_9
cmp eax, 0x52F
jna l_fs_tolower_3
//cmp eax, 0x531
//jb l_fs_tolower_9
//cmp eax, 0x556
//jna l_fs_tolower_6
//...
jmp short l_fs_tolower_9

l_fs_tolower_2:
add eax, 20h
jmp short l_fs_tolower_9

l_fs_tolower_3:
or al, 1
jmp short l_fs_tolower_9

l_fs_tolower_4:
test al, 1
jz l_fs_tolower_9
  inc eax
  jmp short l_fs_tolower_9

l_fs_tolower_5:
add eax, 50h
jmp short l_fs_tolower_9

l_fs_tolower_6:
add eax, 30h

l_fs_tolower_9:
ret

// IN: eax
// OUT: eax
// KEEP: all but eax
fs_toupper:
cmp eax, 'a'
jb near l_fs_toupper_9
cmp eax, 'z'
jna near l_fs_toupper_2
cmp eax, 0xE0
jb near l_fs_toupper_9
cmp eax, 0xF6
jna near l_fs_toupper_2
cmp eax, 0xF8
jb near l_fs_toupper_9
cmp eax, 0xFF
jna near l_fs_toupper_2
cmp eax, 0x177
jna near l_fs_toupper_3
cmp eax, 0x179
jb near l_fs_toupper_9
cmp eax, 0x17E
jna near l_fs_toupper_4
cmp eax, 0x200
jb near l_fs_toupper_9
cmp eax, 0x21F
jna near l_fs_toupper_4
cmp eax, 0x224
jb near l_fs_toupper_9
cmp eax, 0x233
jna near l_fs_toupper_4
cmp eax, 0x3B0
jb near l_fs_toupper_9
cmp eax, 0x3CB
jna l_fs_toupper_2
cmp eax, 0x3D8
jb l_fs_toupper_9
cmp eax, 0x3EF
jna l_fs_toupper_3
cmp eax, 0x430
jb l_fs_toupper_9
cmp eax, 0x44F
jna l_fs_toupper_2
cmp eax, 0x45F
jna l_fs_toupper_5
cmp eax, 0x481
jna l_fs_toupper_3
cmp eax, 0x48A
jb l_fs_toupper_9
cmp eax, 0x4BF
jna l_fs_toupper_3
cmp eax, 0x4C1
jb l_fs_toupper_9
cmp eax, 0x4CE
jna l_fs_toupper_4
cmp eax, 0x4D0
jb l_fs_toupper_9
cmp eax, 0x52F
jna l_fs_toupper_3
//cmp eax, 0x561
//jb l_fs_toupper_9
//cmp eax, 0x586
//jna l_fs_toupper_6
//...
jmp short l_fs_toupper_9

l_fs_toupper_2:
sub eax, 20h
jmp short l_fs_toupper_9

l_fs_toupper_3:
and al, 0xFE
jmp short l_fs_toupper_9

l_fs_toupper_4:
test al, 1
jnz l_fs_toupper_9
  dec eax
  jmp short l_fs_toupper_9

l_fs_toupper_5:
sub eax, 50h
jmp short l_fs_toupper_9

l_fs_toupper_6:
sub eax, 30h

l_fs_toupper_9:
ret

// IN: es:esi -> filenamez, es:edx -> path/filenamez
// OUT: al = 0 (equal) || 1 (asc) || -1 (desc) || erc
// KEEP: ebx, edx, ecx
fs_cmp:
push ebx
 push edx
  
  mov edi, edx
  
  l_fs_cmp_1:
  mov fs_i, 0
  
  l_fs_cmp_2:
    movzx eax, byte ptr [es:esi]
    cmp al, 0
    jz near l_fs_cmp_28
    cmp al, '/'
    jnz l_fs_cmp_21
      mov al, 0
      jmp l_fs_cmp_28
      
    l_fs_cmp_21:
    inc esi
    cmp al, 128
    jb near l_fs_cmp_28
      mov dl, al
      and dl, 11100000b
      cmp dl, 11000000b
      jnz l_fs_cmp_24
        // 2-byte char
        and al, 00011111b
        mov dl, [es:esi]
        cmp dl, 0
        jz l_fs_cmp_26
        cmp dl, '/'
        jz l_fs_cmp_26
        inc esi
        mov dh, dl
        and dh, 11000000b
        cmp dh, 10000000b
        jnz l_fs_cmp_26
        and dl, 00111111b
        shl eax, 6
        or al, dl
        jmp l_fs_cmp_28
        
      l_fs_cmp_24:
      mov dl, al
      and dl, 11110000b
      cmp dl, 11100000b
      jnz l_fs_cmp_26
        // 3-byte char
        and al, 00001111b
        mov dl, [es:esi]
        cmp dl, 0
        jz l_fs_cmp_26
        cmp dl, '/'
        jz l_fs_cmp_26
        inc esi
        mov dh, dl
        and dh, 11000000b
        cmp dh, 10000000b
        jnz l_fs_cmp_26
        and dl, 00111111b
        shl eax, 6
        or al, dl
        
        mov dl, [es:esi]
        cmp dl, 0
        jz l_fs_cmp_26
        cmp dl, '/'
        jz l_fs_cmp_26
        inc esi
        mov dh, dl
        and dh, 11000000b
        cmp dh, 10000000b
        jnz l_fs_cmp_26
        and dl, 00111111b
        shl eax, 6
        or al, dl
        
        jmp l_fs_cmp_28
        
      l_fs_cmp_26:
      mov al, ERC_UTF8
      jmp l_fs_cmp_9
      
    l_fs_cmp_28:
    xchg eax, ebx
    xchg esi, edi
    inc fs_i
    cmp fs_i, 2
    jb near l_fs_cmp_2
    
  cmp eax, ebx
  jz l_fs_cmp_31
    
    call fs_toupper
    xchg eax, ebx
    call fs_toupper
    cmp eax, ebx
    jz near l_fs_cmp_31  // equal - next char
      jnb l_fs_cmp_33
        mov al, -1  // not equal - desc
        jmp short l_fs_cmp_9
        
      l_fs_cmp_33:
      mov al, 1  // not equal - asc
      jmp short l_fs_cmp_9
  
  l_fs_cmp_31:
  test eax, eax
  jnz near l_fs_cmp_1

  l_fs_cmp_9:
 pop edx
pop ebx
ret

// IN: esi, edi, ecx = count
// OUT: al = 0 (equal) || 1 (asc) || -1 (desc) || erc
// USES: fs_max, fs_i
fs_cmp_ecx:
mov eax, esi
add eax, ecx
mov fs_max, eax

l_fs_cmp_ecx_1:
mov fs_i, 0
cmp esi, fs_max
jnb near l_fs_cmp_ecx_8

l_fs_cmp_ecx_2:
  movzx eax, byte ptr [esi]
  inc esi
  cmp al, 128
  jb near l_fs_cmp_ecx_28
    mov dl, al
    and dl, 11100000b
    cmp dl, 11000000b
    jnz l_fs_cmp_ecx_24
      // 2-byte char
      and al, 00011111b
      mov dl, [esi]
      cmp dl, 0
      jz l_fs_cmp_ecx_26
      cmp dl, '/'
      jz l_fs_cmp_ecx_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_cmp_ecx_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      jmp l_fs_cmp_ecx_28
      
    l_fs_cmp_ecx_24:
    mov dl, al
    and dl, 11110000b
    cmp dl, 11100000b
    jnz l_fs_cmp_ecx_26
      // 3-byte char
      and al, 00001111b
      mov dl, [esi]
      cmp dl, 0
      jz l_fs_cmp_ecx_26
      cmp dl, '/'
      jz l_fs_cmp_ecx_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_cmp_ecx_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      
      mov dl, [esi]
      cmp dl, 0
      jz l_fs_cmp_ecx_26
      cmp dl, '/'
      jz l_fs_cmp_ecx_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_cmp_ecx_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      
      jmp l_fs_cmp_ecx_28
      
    l_fs_cmp_ecx_26:
    mov al, ERC_UTF8
    jmp l_fs_cmp_ecx_9
    
  l_fs_cmp_ecx_28:
  xchg eax, ebx
  xchg esi, edi
  inc fs_i
  cmp fs_i, 2
  jb near l_fs_cmp_ecx_2
  
cmp eax, ebx
jz near l_fs_cmp_ecx_1
cmp eax, '?'
jz near l_fs_cmp_ecx_1
cmp ebx, '?'
jz near l_fs_cmp_ecx_1

  call fs_toupper
  xchg eax, ebx
  call fs_toupper
  cmp eax, ebx
  jz near l_fs_cmp_ecx_1  // equal - next char
    jnb l_fs_cmp_ecx_33
      mov al, -1  // not equal - desc
      jmp short l_fs_cmp_ecx_9
      
    l_fs_cmp_ecx_33:
    mov al, 1  // not equal - asc
    jmp short l_fs_cmp_ecx_9

l_fs_cmp_ecx_8:
mov al, 0

l_fs_cmp_ecx_9:
ret

// IN: esi, edi, ecx = count1, edx = count2
// OUT: al = 0 (equal) || 1 (asc) || -1 (desc) || erc
fs_cmp16:

l_fs_cmp16_1:
  jecxz l_fs_cmp16_8
  test edx, edx
  jz l_fs_cmp16_7

  dec ecx
  dec edx
  movzx eax, word ptr [esi]
  movzx ebx, word ptr [edi]
  add esi, 2
  add edi, 2
  
  call fs_toupper
  xchg eax, ebx
  call fs_toupper
  cmp eax, ebx
  jz l_fs_cmp16_1  // equal - next char
    jnb l_fs_cmp16_33
      mov al, -1  // not equal - desc
      jmp short l_fs_cmp16_9
      
    l_fs_cmp16_33:
    mov al, 1  // not equal - asc
    jmp short l_fs_cmp16_9

l_fs_cmp16_7:  // ecx != 0 && edx = 0
mov al, -1
jmp short l_fs_cmp16_9

l_fs_cmp16_8: // ecx = 0
test edx, edx
jz l_fs_cmp16_86
  mov al, 1
  jmp short l_fs_cmp16_9
  
l_fs_cmp16_86:
mov al, 0

l_fs_cmp16_9:
ret

// IN: es:edx -> path/filenamez
// OUT: es:edx -> next_dir/filenamez after '/'
// KEEP: ecx, ebx, esi, edi
fs_next_edx:
l_fs_next_edx_1:
  mov al, [es:edx]
  cmp al, '/'
  jz l_fs_next_edx_5
    cmp al, 0
    jz l_fs_next_edx_5
      inc edx
      jmp short l_fs_next_edx_1

l_fs_next_edx_5:
cmp al, 0
jz l_fs_next_edx_8
  inc edx
  mov al, 0
  
l_fs_next_edx_8:
ret

// IN: ds:esi -> source, es:edi -> target, ecx = size, fs_bigendian
// OUT: al = 0 || erc
// KEEP: edx
fs_toutf8:
push edx

l_fs_toutf8_1:
mov ebx, edi
add ebx, MAX_PATH - 1
shr ecx, 1

l_fs_toutf8_5:
jecxz l_fs_toutf8_97
dec ecx
lodsw
movzx eax, ax
test fs_bigendian, 1
jz l_fs_toutf8_52
  xchg al, ah // big endian

l_fs_toutf8_52:
cmp eax, 80h
jnb l_fs_toutf8_6
  stosb
  cmp edi, ebx
  jnb l_fs_toutf8_94
    jmp short l_fs_toutf8_5

l_fs_toutf8_6: // utf8
cmp eax, 2176
jnb l_fs_toutf8_7
  sub eax, 128
  mov ah, al
  shr al, 6
  or al, 11000000b
  stosb
  cmp edi, ebx
  jnb l_fs_toutf8_94
    mov al, ah
    and al, 00111111b
    or al, 128
    stosb
    cmp edi, ebx
    jnb l_fs_toutf8_94
      jmp short l_fs_toutf8_5
    
l_fs_toutf8_7:
sub eax, 2176
mov edx, eax
shr eax, 12
or al, 11100000b
stosb
cmp edi, ebx
jnb l_fs_toutf8_94
  mov eax, edx
  shr eax, 6
  and al, 00111111b
  or al, 128
  stosb
  cmp edi, ebx
  jnb l_fs_toutf8_94
    mov eax, edx
    and al, 00111111b
    or al, 128
    stosb
    cmp edi, ebx
    jnb l_fs_toutf8_94
      jmp short l_fs_toutf8_5
  
l_fs_toutf8_94:
mov al, ERC_TOO_LONG
jmp short l_fs_toutf8_9

l_fs_toutf8_96:
mov al, 1
jmp short l_fs_toutf8_9

l_fs_toutf8_97:
mov al, 0

l_fs_toutf8_98:
stosb

l_fs_toutf8_9:
pop edx
ret

l_fs_toutf16_x:
mov al, ERC_TOO_LONG
ret

l_fs_toutf16_end:  // eax = 0
stosw
ret  // al = 0

// IN: es:esi -> utf8z, es:edi -> utf16z
// OUT: al = erc, es:edi -> after utf16z
// KEEP: ebx
fs_toutf16:
mov ecx, 255

l_fs_toutf16_2:
  jecxz l_fs_toutf16_x
  dec ecx
  
  movzx eax, byte ptr [es:esi]
  inc esi
  test al, al
  jz l_fs_toutf16_end
  
  cmp al, 128
  jb near l_fs_toutf16_28
    mov dl, al
    and dl, 11100000b
    cmp dl, 11000000b
    jnz l_fs_toutf16_24
      // 2-byte char
      and al, 00011111b
      mov dl, [es:esi]
      cmp dl, 0
      jz l_fs_toutf16_26
      cmp dl, '/'
      jz l_fs_toutf16_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_toutf16_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      jmp l_fs_toutf16_28
      
    l_fs_toutf16_24:
    mov dl, al
    and dl, 11110000b
    cmp dl, 11100000b
    jnz l_fs_toutf16_26
      // 3-byte char
      and al, 00001111b
      mov dl, [es:esi]
      cmp dl, 0
      jz l_fs_toutf16_26
      cmp dl, '/'
      jz l_fs_toutf16_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_toutf16_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      
      mov dl, [es:esi]
      cmp dl, 0
      jz l_fs_toutf16_26
      cmp dl, '/'
      jz l_fs_toutf16_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_toutf16_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      
      jmp l_fs_toutf16_28
      
    l_fs_toutf16_26:
    mov al, ERC_UTF8
    jmp l_fs_toutf16_9

  l_fs_toutf16_28:
  stosw
  jmp l_fs_toutf16_2

l_fs_toutf16_9:
ret

// IN: esi = fhandle
// OUT: al = 0 || erc, esi = index to files
// DESTROY: eax
fs_check_thread_esi:
cmp esi, MAX_FILES
jnb l_fs_check_thread_x
shl esi, 5 // assert sizeof OpenFileRec = 32

cmp files.mode[esi], 0
jz l_fs_check_thread_x
  
  mov eax, p_current
  sub eax, VA_THREADS
  shr eax, 12  // assert sizeof ThreadRec = 4096
  cmp ax, files.threadid[esi]
  jz l_fs_check_thread_8
    mov al, ERC_INVALID_THREAD
    jmp short l_fs_check_thread_9
    
l_fs_check_thread_x:
mov al, ERC_INVALID_FHANDLE
jmp short l_fs_check_thread_9

l_fs_check_thread_8:
mov al, 0

l_fs_check_thread_9:
ret

// IN: ebx = threadptr
// KEEP: ebx, edi
fs_release_thread:
// Clear files
push ebx
  
  sub ebx, VA_THREADS
  shr ebx, 12  // assert sizeof ThreadRec = 4096
  xor esi, esi
  
  l_fs_release_thread_1:
    cmp files.threadid[esi], bx
    jnz l_fs_release_thread_2
      mov files.mode[esi], 0
    
    l_fs_release_thread_2:
    add esi, sizeof OpenFileRec
    cmp esi, sizeof OpenFileRec * MAX_FILES
    jb l_fs_release_thread_1
  
  // Clear srchrec  IN: bx
  xor esi, esi
  xor eax, eax
  dec eax  // eax = -1
  
  l_fs_release_thread_5:
    cmp srch.ThreadId[esi], bx
    jnz l_fs_release_thread_6
      mov srch.ThreadId[esi], ax
    
    l_fs_release_thread_6:
    add esi, sizeof InSrchRec
    cmp esi, sizeof InSrchRec * MAX_SRCH
    jb l_fs_release_thread_5
  
  // Clear disk busy
pop ebx
test byte ptr [es:ebx + offset ThreadRec.flags], THREAD_FLAGS_DISK_BUSY
jz l_fs_release_thread_7
  and byte ptr [es:ebx + offset ThreadRec.flags], -1 - THREAD_FLAGS_DISK_BUSY
  mov fs_busy, 0

l_fs_release_thread_7:
ret

// IN: es:esi -> curdirtext, es:edx -> filename, es:edi -> result
fs_merge:
mov ebx, edi
add ebx, MAX_PATH

// Full path
cmp byte[es:edx + 1], ':'
jnz l_fs_merge_1
  mov al, [es:edx]
  inc edx
  inc edx
  cmp byte[es:edx], '/'
  jnz l_fs_merge_05
    inc edx
  
  l_fs_merge_05:
  stosb
  mov al, ':'
  stosb
  mov al, '/'
  stosb
  
  l_fs_merge_06:
    mov al, [es:edx]
    inc edx
    stosb
    cmp al, 0
    jz near l_fs_merge_8
      cmp edi, ebx
      jb l_fs_merge_06
  
  l_fs_merge_07:
  dec edi
  mov al, 0
  stosb
  mov al, ERC_TOO_LONG
  jmp l_fs_merge_9

// Current disk
l_fs_merge_1:
cmp byte[es:edx], '/'
jnz l_fs_merge_2
  inc edx
  mov al, [es:esi]
  jmp l_fs_merge_05

// Merge
l_fs_merge_2:
  mov al, [es:esi]
  inc esi
  cmp al, 0
  jz l_fs_merge_28
    stosb
    cmp edi, ebx
    jb l_fs_merge_2
  
jmp l_fs_merge_07

l_fs_merge_28:
mov al, '/'
cmp byte[es:esi - 2], al
jz l_fs_merge_3
  stosb

// Curdir copied
l_fs_merge_3:
cmp byte[es:edx], '.'
jnz l_fs_merge_4
  cmp byte[es:edx + 1], '.'
  jnz l_fs_merge_38
    //..
    cmp byte[es:edx + 2], '/'
    jnz l_fs_merge_34
    
    add edx, 3
    
    l_fs_merge_30:
    cmp byte[es:edi - 2], ':'
    jnz l_fs_merge_31
      mov al, ERC_PATH_NOT_FOUND
      jmp l_fs_merge_9
      
    l_fs_merge_31:
    cmp byte[es:edi - 1], '/'
    jnz l_fs_merge_32
      dec edi
      
    l_fs_merge_32:
    dec edi
    cmp byte[es:edi], '/'
    jnz l_fs_merge_32
      inc edi
      jmp l_fs_merge_3

    l_fs_merge_34:
    cmp byte[es:edx + 2], 0
    jnz l_fs_merge_38
      add edx, 2
      jmp l_fs_merge_30
      
  l_fs_merge_38:
  cmp byte[es:edx + 1], '/'
  jnz l_fs_merge_39
    //.
    add edx, 2
    jmp l_fs_merge_3
  
  l_fs_merge_39:
  cmp byte[es:edx + 1], 0
  jnz l_fs_merge_4
    inc edx
    jmp l_fs_merge_3
  
l_fs_merge_4:
  mov al, [es:edx]
  inc edx
  stosb
  cmp al, 0
  jz l_fs_merge_8
    cmp edi, ebx
    jnb near l_fs_merge_07
      cmp al, '/'
      jz l_fs_merge_3
        jmp l_fs_merge_4

l_fs_merge_8:
mov al, 0

l_fs_merge_9:
ret

// IN: ds:esi -> maskz, ds:edi -> filenamez
// OUT: al = 0 (match), 1 (not match), erc
fs_ismatch:
mov fs_edi0, edi

// For compatibility
cmp dword ptr [esi], 0x2A2E2A // *.*
jnz l_fs_ismatch_00
  mov word ptr [esi], 0x2A    // *

l_fs_ismatch_00:
// Get filename len
xor ecx, ecx

l_fs_ismatch_01:
cmp byte ptr [edi + ecx], 0
jz l_fs_ismatch_08
  inc ecx
  cmp ecx, MAX_PATH
  jb l_fs_ismatch_01
    jmp l_fs_ismatch_91

l_fs_ismatch_08:
mov fs_edimax, ecx
add fs_edimax, edi

// begin
mov ecx, esi

l_fs_ismatch_11:
cmp byte ptr [ecx], 0
jz l_fs_ismatch_18
  cmp byte ptr [ecx], '*'
  jz l_fs_ismatch_18
    inc ecx
    jmp short l_fs_ismatch_11

l_fs_ismatch_18:
push ecx
 push edi
  sub ecx, esi
  push ecx
    call fs_cmp_ecx
  pop ecx
 pop edi
pop esi
add edi, ecx

or al, al
jnz l_fs_ismatch_9

cmp byte ptr [esi], 0
jnz l_fs_ismatch_20
  cmp byte ptr [edi], 0
  jz l_fs_ismatch_90
    jmp short l_fs_ismatch_91

l_fs_ismatch_20:
// assert byte ptr [esi] = '*'
inc esi
mov ecx, esi

l_fs_ismatch_21:
cmp byte ptr [ecx], 0
jz l_fs_ismatch_26
  cmp byte ptr [ecx], '*'
  jz l_fs_ismatch_28
    inc ecx
    jmp short l_fs_ismatch_21

l_fs_ismatch_26: // 0 - end
sub ecx, esi

mov edi, fs_edimax
sub edi, ecx
cmp edi, fs_edi0
jb l_fs_ismatch_91
  call fs_cmp_ecx
  jmp l_fs_ismatch_9

l_fs_ismatch_28: // '*'
sub ecx, esi
jecxz l_fs_ismatch_20

l_fs_ismatch_281:
  push edi
   push ecx
    push esi
     call fs_cmp_ecx
    pop esi
   pop ecx
  pop edi
  
  or al, al
  jnz l_fs_ismatch_29
    add edi, ecx
    add esi, ecx
    jmp short l_fs_ismatch_20
    
  l_fs_ismatch_29:
  inc edi
  mov eax, edi
  add eax, ecx
  cmp eax, fs_edimax
  jna l_fs_ismatch_281
    jmp short l_fs_ismatch_91
  
l_fs_ismatch_90:
mov al, 0
jmp short l_fs_ismatch_9

l_fs_ismatch_91:
mov al, 1

l_fs_ismatch_9:
ret

// IN: es:edx -> namez
// OUT: al = 0 || ERC_INVALID_CHAR
// KEEP: ecx, edx, ebx, esi, edi
fs_check_valid:
push edx
  
  cmp word ptr [es:edx], "."
  jz l_fs_check_valid_8
  cmp word ptr [es:edx], ".."
  jz l_fs_check_valid_8
  cmp dword ptr [es:edx], ".   "
  jz l_fs_check_valid_8
  
  l_fs_check_valid_5:
    mov al, [es:edx]
    inc edx
    cmp al, 0
    jz l_fs_check_valid_9
      cmp al, '/'
      jz l_fs_check_valid_8
      cmp al, '*'
      jz l_fs_check_valid_8
      cmp al, ';'
      jz l_fs_check_valid_8
      cmp al, ':'
      jz l_fs_check_valid_8
      cmp al, '<'
      jz l_fs_check_valid_8
      cmp al, '>'
      jz l_fs_check_valid_8
      cmp al, '|'
      jz l_fs_check_valid_8
      cmp al, 92
      jz l_fs_check_valid_8
      cmp al, '?'
      jz l_fs_check_valid_8
      cmp al, DELCHAR
      jz l_fs_check_valid_8
      jmp short l_fs_check_valid_5
      
  l_fs_check_valid_8:
  mov al, ERC_INVALID_CHAR
  
  l_fs_check_valid_9:
pop edx
ret

// IN: es:edx -> dirmask, fs_rec, fs_srchofs
// OUT: al = erc, edx, srch.FileMask[fs_srchofs], hd_buffer
// KEEP: ebx
fs_split:
mov esi, edx
mov ecx, MAX_PATH

// split dirmask to dir, mask  KEEP: ebx
l_fs_split_11:
  cmp byte ptr [es:esi], 0
  jz l_fs_split_18
    inc esi
    loop l_fs_split_11
  mov al, ERC_TOO_LONG
  jmp l_fs_split_9
  
l_fs_split_18:
mov ecx, esi

l_fs_split_21:
cmp esi, edx
jz l_fs_split_28
  cmp byte ptr [es:esi], '/'
  jz l_fs_split_27
    dec esi
    jmp short l_fs_split_21
  
  l_fs_split_27:
  inc esi
  
l_fs_split_28:
sub ecx, esi

push esi

  mov edi, VA_SYSTEM + offset srch.FileMask
  add edi, fs_srchofs
  inc ecx
  cmp ecx, MAX_MASK
  jb l_fs_split_31
    mov al, ERC_TOO_LONG
    pop esi
    jmp l_fs_split_9
    
  l_fs_split_31:
  jecxz l_fs_split_32
    mov al, [es:esi]
    inc esi
    stosb
    dec ecx
    jmp short l_fs_split_31
    
  l_fs_split_32:

pop ecx

l_fs_split_325:
sub ecx, edx  // assert ecx < MAX_PATH <= sizeof hd_buffer
cmp ecx, MAX_PATH
jb l_fs_split_326
  mov al, ERC_TOO_LONG
  jmp l_fs_split_9
  
l_fs_split_326:
mov edi, VA_SYSTEM + offset hd_buffer
mov esi, edx

l_fs_split_33:
jecxz l_fs_split_34
  mov al, [es:esi]
  inc esi
  stosb
  dec ecx
  jmp short l_fs_split_33

l_fs_split_34:
mov al, 0
stosb

mov edx, VA_SYSTEM + offset hd_buffer

l_fs_split_9:
ret

// IN: esi -> files, files, al = erc
// OUT: al = erc
// KEEP: ebx, edx, esi, edi
fs_not_share_write:
test al, al
jnz fs_not_share_write_9

push ebx

  xor ebx, ebx
  
  fs_not_share_write_1:
    cmp byte ptr files.mode[ebx], 0
    jz fs_not_share_write_5
      cmp ebx, esi
      jz fs_not_share_write_5
      
        mov eax, files.file[ebx]
        cmp eax, files.file[esi]
        jnz fs_not_share_write_5
          mov al, files.disk[ebx]
          cmp al, files.disk[esi]
          jnz fs_not_share_write_5
            
            mov al, files.mode[esi]
            and al, 3Fh
            cmp al, FOPEN_READ
            ja fs_not_share_write_4
              mov al, files.mode[ebx]
              and al, 3Fh
              cmp al, FOPEN_READ
              jna fs_not_share_write_5
        
        fs_not_share_write_4:
        
        pop ebx
        
        mov al, ERC_IN_USE
        jmp short fs_not_share_write_9
  
    fs_not_share_write_5:
    add ebx, sizeof OpenFileRec
    cmp ebx, MAX_FILES * sizeof OpenFileRec
    jb fs_not_share_write_1
    
pop ebx

mov al, 0

fs_not_share_write_9:
ret

// IN: al = disk, ebx = file number
// OUT: cl = erc
// KEEP: all but ecx
fs_not_used:

xor ecx, ecx

fs_not_used_1:
  cmp byte ptr files.mode[ecx], 0
  jz fs_not_used_5
    cmp ebx, files.file[ecx]
    jnz fs_not_used_5
      cmp al, files.disk[ecx]
      jnz fs_not_used_5          
        mov cl, ERC_IN_USE
        jmp short fs_not_used_9

  fs_not_used_5:
  add ecx, sizeof OpenFileRec
  cmp ecx, MAX_FILES * sizeof OpenFileRec
  jb fs_not_used_1
  
mov cl, 0

fs_not_used_9:
ret

FAT12_ATRB_READONLY = 1
FAT12_ATRB_HIDDEN = 2
FAT12_ATRB_SYSTEM = 4
FAT12_ATRB_VOLLBL = 8
FAT12_ATRB_DIR = 10h
FAT12_ATRB_ARCHIVE = 20h
FAT12_ATRB_DEV = 60h

FAT12_YEAR0 = 1980

struct DirRec{  // size = 32
  char Filename[8]
  char Ext[3]
  uns1 Attrib
  uns1 Reserved
  uns1 TimeCreatedMs
  uns2 TimeCreated
  uns2 DateCreated
  uns2 DateLastAccessed
  uns2 FirstClusterHiBytes
  uns2 LastModTime
  uns2 LastModDate
  uns2 FirstCluster
  uns4 FileSize
}

[dalign 32]
uns4 FAT12_diskmain, FAT12_data, FAT12_clusters, FAT12_next, FAT12_remain
uns4 FAT12_rootsect
uns2 FAT12_hidden, FAT12_sizeFAT, FAT12_tmp, FAT12_first_free
uns2 FAT12_valid, FAT12_first_cluster, FAT12_first_cluster2, FAT12_maxroot
uns1 FAT12_ldiskn, FAT12_clusize, FAT12_cntFAT, FAT12_tmp1
char FAT12_fname[12], FAT12_fname2[12]
bool FAT12_again
DirRec FAT12_dir
SystemTime FAT12_st

// IN: al = ldiskn
// OUT: al = erc
// KEEP: ebx, edi
FAT12_prepare:
push ebx
 push edi

  mov FAT12_ldiskn, al
  
  // diskmain
  movzx esi, al
  shl esi, 5  // log2(DiskInfoRec)
  mov esi, disk_info.main[esi]
  or esi, esi
  jnz l_FAT12_prepare_01
    mov al, ERC_INVALID_DISK_NUMBER
    jmp FAT12_prepare_9
  
  l_FAT12_prepare_01:
  mov FAT12_diskmain, esi
  
  // cluster size
  l_FAT12_prepare_05:
    mov ah, 2
    mov al, FAT12_ldiskn
    mov ebx, 13
    mov ecx, 1
    mov edi, VA_SYSTEM + offset FAT12_clusize
    call FAT12_diskmain
    
    cmp al, ERC_DISK_CHANGED
    jz l_FAT12_prepare_05
  
  test al, al
  jnz near FAT12_prepare_9
  
  mov cl, 0
  mov al, FAT12_clusize
  l_FAT12_prepare_1:
    mov ah, 1
    shl ah, cl
    test ah, al
    jnz l_FAT12_prepare_2
      inc cl
      cmp cl, 7
      jb l_FAT12_prepare_1
        mov al, ERC_FS
        jmp FAT12_prepare_9
  
  l_FAT12_prepare_2:
  mov FAT12_clusize, cl
  
  // hidden sectors
  mov ah, 2
  mov al, FAT12_ldiskn
  mov ebx, 14
  mov ecx, 2
  mov edi, VA_SYSTEM + offset FAT12_hidden
  call FAT12_diskmain
  
  // number of FATs
  mov ah, 2
  mov al, FAT12_ldiskn
  mov ebx, 16
  mov ecx, 1
  mov edi, VA_SYSTEM + offset FAT12_cntFAT
  call FAT12_diskmain
  
  // size of FAT
  mov ah, 2
  mov al, FAT12_ldiskn
  mov ebx, 22
  mov ecx, 2
  mov edi, VA_SYSTEM + offset FAT12_sizeFAT
  call FAT12_diskmain
  
  // max files in the root directory
  mov ah, 2
  mov al, FAT12_ldiskn
  mov ebx, 17
  mov ecx, 2
  mov edi, VA_SYSTEM + offset FAT12_maxroot
  call FAT12_diskmain
  
  // data
  movzx eax, FAT12_hidden
  movzx ecx, FAT12_cntFAT
  movzx edx, FAT12_sizeFAT
  
  l_FAT12_prepare_4:
    add eax, edx
    loop l_FAT12_prepare_4
  
  mov FAT12_rootsect, eax // rootsect
  
  movzx edx, FAT12_maxroot
  shl edx, 5  // * 32 = sizeof DirRec
  add edx, 511
  shr edx, 9
  add eax, edx
  
  mov FAT12_data, eax
  
  // number of clusters  IN: eax = data
  push eax
    mov ah, 4
    mov al, FAT12_ldiskn
    call FAT12_diskmain
  pop edx
  shr eax, 9
  sub eax, edx
  mov cl, FAT12_clusize
  shr eax, cl
  mov FAT12_clusters, eax
  
  // maxroot => data - 2clu
  movzx eax, FAT12_maxroot
  test eax, eax
  jz l_FAT12_prepare_8
    mov eax, 2
    mov cl, FAT12_clusize
    shl eax, cl
    sub FAT12_data, eax
    
  l_FAT12_prepare_8:
  
  // end
  mov FAT12_first_free, 0
  
  mov al, 0
  
  FAT12_prepare_9:
  
 pop edi
pop ebx
ret

// IN: al = ldiskn, ebx = cluster number
// OUT: al = 0 || error, ebx = cluster value
FAT12_get:
cmp FAT12_ldiskn, al
jz l_FAT12_get_0
  push ebx
    call FAT12_prepare
  pop ebx
  test al, al
  jnz l_FAT12_get_9

l_FAT12_get_0:
mov ecx, ebx
shl ebx, 1
add ebx, ecx
shr ebx, 1  // ebx * 3 / 2

push ecx
  movzx eax, FAT12_hidden
  shl eax, 9
  add ebx, eax
  mov ecx, 2
  mov edi, VA_SYSTEM + offset FAT12_tmp
  mov al, FAT12_ldiskn
  mov ah, 2  // read
  call FAT12_diskmain
pop ecx
or al, al
jnz l_FAT12_get_9

movzx eax, FAT12_tmp

test cl, 1
jnz l_FAT12_get_2
  and eax, 0xFFF
  jmp short l_FAT12_get_3

l_FAT12_get_2:
  shr eax, 4

l_FAT12_get_3:
mov ebx, eax

mov al, 0

l_FAT12_get_9:
ret

// IN: al = ldiskn, ebx = cluster number, edx = value
// OUT: al = 0 || error
FAT12_set:
cmp FAT12_ldiskn, al
jz l_FAT12_set_1
  push ebx
   push edx
    call FAT12_prepare
   pop edx
  pop ebx
  test al, al
  jnz near l_FAT12_set_9

l_FAT12_set_1:
mov ecx, ebx
shl ebx, 1
add ebx, ecx
shr ebx, 1  // ebx * 3 / 2

push ecx
 push edx
  movzx eax, FAT12_hidden
  shl eax, 9
  add ebx, eax
  push ebx
    mov ecx, 2
    mov edi, VA_SYSTEM + offset FAT12_tmp
    mov al, FAT12_ldiskn
    mov ah, 2  // read
    call FAT12_diskmain
  pop ebx
 pop edx
pop ecx

or al, al
jnz l_FAT12_set_9

movzx eax, FAT12_tmp

and edx, 0xFFF
test cl, 1
jnz l_FAT12_set_2
  and eax, -1 - 0xFFF
  or eax, edx
  jmp short l_FAT12_set_3
l_FAT12_set_2:
  and eax, 0xF
  shl edx, 4
  or eax, edx
l_FAT12_set_3:
mov FAT12_tmp, ax

movzx ecx, FAT12_cntFAT

l_FAT12_set_4:
  push ecx
   push ebx
    mov ecx, 2
    mov edi, VA_SYSTEM + offset FAT12_tmp
    mov al, FAT12_ldiskn
    mov ah, 3  // write
    call FAT12_diskmain
   pop ebx
  pop ecx

  or al, al
  jnz l_FAT12_set_9

  movzx eax, FAT12_sizeFAT
  shl eax, 9
  add ebx, eax
  loop l_FAT12_set_4

mov al, 0

l_FAT12_set_9:

ret

// IN: FAT12_ldiskn
// OUT: al = 0 || erc, ebx = free cluster number
FAT12_alloc:
push esi
  movzx esi, FAT12_first_free
  
  l_FAT12_alloc_5:
  mov al, FAT12_ldiskn
  push esi
    mov ebx, esi
    call FAT12_get
  pop esi
  or al, al
  jnz l_FAT12_alloc_9
    or ebx, ebx
    jz l_FAT12_alloc_8
      inc esi
      cmp esi, FAT12_clusters
      jb l_FAT12_alloc_5
        mov al, ERC_DISK_FULL
        jmp l_FAT12_alloc_9
    
    l_FAT12_alloc_8:
    mov ebx, esi
    mov FAT12_first_free, si
    mov al, 0
  
  l_FAT12_alloc_9:
pop esi
ret

// IN: FAT12_ldiskn, ebx = cluster number
// OUT: al = 0 || erc
FAT12_free:
cmp bx, FAT12_first_free
jnb l_FAT12_free_2
  mov FAT12_first_free, bx

l_FAT12_free_2:
mov al, FAT12_ldiskn
xor edx, edx
call FAT12_set

ret

// IN: ebx = first cluster number
// KEEP: esi, edi
FAT12_delete:
push esi
 push edi
  or ebx, ebx
  jz l_FAT12_delete_9
  
  l_FAT12_delete_1:
    cmp bx, FAT12_first_free
    jnb l_FAT12_delete_2
      mov FAT12_first_free, bx
    
    l_FAT12_delete_2:
    
    mov al, FAT12_ldiskn
    push ebx
      call FAT12_get
      mov esi, ebx
    pop ebx
  
    or esi, esi
    jz l_FAT12_delete_9
    
      mov al, FAT12_ldiskn
      xor edx, edx
      push esi
        call FAT12_set
      pop ebx
      cmp ebx, 0xFFF
      jnz l_FAT12_delete_1
  
  l_FAT12_delete_9:
 pop edi
pop esi
ret

// IN: al = ldiskn, ebx = cluster number of directory
// OUT: al = 0 || erc, ebx = offset of sector, edi = offset in sector
FAT12_srchdir:
mov FAT12_first_cluster, bx

cmp FAT12_ldiskn, al
jz l_FAT12_srchdir_1
  push ebx
   push esi
    call FAT12_prepare
   pop esi
  pop ebx
  test al, al
  jnz near l_FAT12_srchdir_9

l_FAT12_srchdir_1:
  test ebx, ebx
  jnz l_FAT12_srchdir_2
    movzx eax, FAT12_maxroot
    test eax, eax
    jz l_FAT12_srchdir_2
      // root
      mov ebx, FAT12_rootsect
      shl ebx, 9
      
      shl eax, 5  // 32
      add eax, ebx
      mov FAT12_next, eax
      jmp short l_FAT12_srchdir_4
      
  l_FAT12_srchdir_2:
  // not root
  mov cl, FAT12_clusize
  shl ebx, cl
  add ebx, FAT12_data
  shl ebx, 9  // 512
  
  mov eax, 512  
  shl eax, cl
  add eax, ebx
  mov FAT12_next, eax
  
  // both
  l_FAT12_srchdir_4:
    mov ah, 2
    mov al, FAT12_ldiskn
    push ebx
      mov ecx, 512
      mov edi, VA_SYSTEM + offset fd_buffer
      call FAT12_diskmain
    pop ebx
    or al, al
    jz l_FAT12_srchdir_45
      cmp al, ERC_DISK_CHANGED
      jnz near l_FAT12_srchdir_9
        // Disk changed
        push ebx
         push esi
          mov al, FAT12_ldiskn
          call FAT12_prepare
         pop esi
        pop ebx
        test al, al
        jnz near l_FAT12_srchdir_9
        jmp l_FAT12_srchdir_4
      
    l_FAT12_srchdir_45:
    mov esi, offset FAT12_fname
    mov edi, offset fd_buffer

    l_FAT12_srchdir_5:
      push esi
       push edi
        mov ecx, 11
        call eqxcase
       pop edi
      pop esi
      or al, al
      jz l_FAT12_srchdir_8
        add edi, 32  // assert sizeof DirRec == 32
        cmp edi, 512 + offset fd_buffer
        jb l_FAT12_srchdir_5  // next in sector
    
    add ebx, 512
    cmp ebx, FAT12_next
    jb l_FAT12_srchdir_4  // next sector in cluster
    
  mov cl, FAT12_clusize
  dec ebx
  shr ebx, 9
  sub ebx, FAT12_data
  shr ebx, cl
  // IN: al = ldiskn, ebx = cluster number
  // OUT: al = 0 || error, ebx = cluster value
  mov al, FAT12_ldiskn
  call FAT12_get
  or al, al
  jnz l_FAT12_srchdir_9
    cmp ebx, 0xFFF
    jnz near l_FAT12_srchdir_1
    
mov al, 1
jmp short l_FAT12_srchdir_9

l_FAT12_srchdir_8:
sub edi, offset fd_buffer
mov al, 0

l_FAT12_srchdir_9:
ret

// IN: es:edx -> fname
// OUT: FAT12_fname, es:edx -> 0 or after '/'
// KEEP: ebx
FAT12_load_fname:
mov edi, offset FAT12_fname
mov ecx, 8

mov al, [es:edx]
cmp al, '.'
jnz l_FAT12_load_fname_1
  mov [edi], al
  inc edx
  inc edi
  dec ecx

  mov al, [es:edx]
  cmp al, '.'
  jnz l_FAT12_load_fname_1
    mov [edi], al
    inc edx
    inc edi
    dec ecx

l_FAT12_load_fname_1:
mov al, [es:edx]
cmp al, 0
jz l_FAT12_load_fname_4
  cmp al, '/'
  jz l_FAT12_load_fname_4
    inc edx
    cmp al, '.'
    jz l_FAT12_load_fname_4
      // upper case filename
      cmp al, 'a'
      jb l_FAT12_load_fname_12
        cmp al, 'z'
        ja l_FAT12_load_fname_12
          sub al, 32
          
      l_FAT12_load_fname_12:
      mov [edi], al
      inc edi
      loop l_FAT12_load_fname_1

l_FAT12_load_fname_2:
mov al, [es:edx]
cmp al, 0
jz l_FAT12_load_fname_5
  cmp al, '/'
  jz l_FAT12_load_fname_5
    inc edx
    cmp al, '.'
    jz l_FAT12_load_fname_5
      jmp short l_FAT12_load_fname_2

l_FAT12_load_fname_4:
mov byte ptr [edi], ' '
inc edi
loop l_FAT12_load_fname_4

l_FAT12_load_fname_5:
mov ecx, 3

l_FAT12_load_fname_6:
mov al, [es:edx]
cmp al, 0
jz l_FAT12_load_fname_7
  cmp al, '/'
  jz l_FAT12_load_fname_7
    inc edx
    // upper case ext
    cmp al, 'a'
    jb l_FAT12_load_fname_62
      cmp al, 'z'
      ja l_FAT12_load_fname_62
        sub al, 32
        
    l_FAT12_load_fname_62:
    mov [edi], al
    inc edi
    loop l_FAT12_load_fname_6

jmp short l_FAT12_load_fname_8

l_FAT12_load_fname_7:
mov byte ptr [edi], ' '
inc edi
loop l_FAT12_load_fname_7

l_FAT12_load_fname_8:
mov al, [es:edx]
cmp al, 0
jz l_FAT12_load_fname_9
  inc edx
  cmp al, '/'
  jz l_FAT12_load_fname_9
    jmp short l_FAT12_load_fname_8

l_FAT12_load_fname_9:
ret

// IN: es:edx -> file name, al = ldiskn, ebx = cluster number of directory
// OUT: al = 0 || erc, edi = disk offset of DirRec || 0
FAT12_find_file:

FAT12_find_file_1:
push eax
  call FAT12_load_fname  // KEEP ebx
pop eax

FAT12_find_file_2:
push edx
  call FAT12_srchdir
pop edx
add edi, ebx
or al, al
jnz FAT12_find_file_6
  
  cmp byte ptr [es:edx], 0
  jz FAT12_find_file_5
    mov ah, 2  // read
    mov al, FAT12_ldiskn
    mov ebx, edi
    mov ecx, 32  // assert sizeof DirRec = 32
    mov edi, VA_SYSTEM + offset FAT12_dir
    push edx
      call FAT12_diskmain
    pop edx
    // test attrib dir
    test FAT12_dir.Attrib, FAT12_ATRB_DIR
    jz FAT12_find_file_6
    // dir
    movzx ebx, FAT12_dir.FirstCluster
    mov al, FAT12_ldiskn
    jmp short FAT12_find_file_1

FAT12_find_file_5:
mov al, 0
jmp short FAT12_find_file_9

FAT12_find_file_6:
xor edi, edi
cmp al, ERC_INVALID_DISK_NUMBER
jz FAT12_find_file_9
  
  cmp byte ptr [es:edx], 0
  jz FAT12_find_file_7
    mov al, ERC_PATH_NOT_FOUND
    jmp short FAT12_find_file_9
  
  FAT12_find_file_7:
  mov al, ERC_FILE_NOT_FOUND
  
FAT12_find_file_9:
ret

// IN: ebx = first cluster of directory
// OUT: al = 0 || erc, edi -> disk_adr_DirRec
FAT12_find_place:
test ebx, ebx
jnz l_FAT12_find_place_1
  // root
  mov ebx, FAT12_rootsect
  shl ebx, 9
  
  movzx eax, FAT12_maxroot
  shl eax, 5 // assert sizeof DirRec = 32
  add eax, ebx
  mov FAT12_next, eax
  jmp short l_FAT12_find_place_2
  
// not root
l_FAT12_find_place_1:
  mov cl, FAT12_clusize
  shl ebx, cl
  add ebx, FAT12_data
  shl ebx, 9 // 512

  mov eax, 512  
  shl eax, cl
  add eax, ebx
  mov FAT12_next, eax

// both
l_FAT12_find_place_2:
  mov ah, 2
  mov al, FAT12_ldiskn
  push ebx
    mov ecx, 512
    mov edi, VA_SYSTEM + offset fd_buffer
    call FAT12_diskmain
  pop ebx
  or al, al
  jnz near l_FAT12_find_place_9
    xor edi, edi
    
    l_FAT12_find_place_6:
    mov al, fd_buffer[edi]
    cmp al, DELCHAR
    jz near l_FAT12_find_place_8
      cmp al, 0
      jz near l_FAT12_find_place_8
        add edi, 32  // assert sizeof DirRec = 32
        cmp edi, 512
        jb l_FAT12_find_place_6
          
          add ebx, 512
          cmp ebx, FAT12_next
          jb l_FAT12_find_place_2

  mov cl, FAT12_clusize
  dec ebx
  shr ebx, 9
  sub ebx, FAT12_data
  shr ebx, cl
  // IN: al = ldiskn, ebx = cluster number
  // OUT: al = 0 || error, ebx = cluster value
  mov al, FAT12_ldiskn
  push ebx
    call FAT12_get
  pop edx
  or al, al
  jnz near l_FAT12_find_place_9
    cmp ebx, 0xFFF
    jnz near l_FAT12_find_place_1
      
      // End - alloc new cluster
      mov ebx, edx
      push ebx
        call FAT12_alloc
        mov edx, ebx
      pop ebx
      or al, al
      jnz near l_FAT12_find_place_9
      
      push edx
        mov al, FAT12_ldiskn
        call FAT12_set
      pop ebx
      mov edx, 0xFFF
      push ebx
        mov al, FAT12_ldiskn
        call FAT12_set
      pop ebx
      // Zero new cluster
      xor eax, eax
      mov edi, VA_SYSTEM + offset fd_buffer
      mov ecx, 512 / 4
      cld
      rep stosd
      
      mov cl, FAT12_clusize
      shl ebx, cl
      add ebx, FAT12_data
      shl ebx, 9
      
      push ebx

        mov eax, 1
        shl eax, cl
        mov ecx, eax

        l_FAT12_find_place_7:
          mov ah, 3
          mov al, FAT12_ldiskn
          push ecx
           push ebx
            mov ecx, 512
            mov edi, VA_SYSTEM + offset fd_buffer
            call FAT12_diskmain
           pop ebx
          pop ecx
          add ebx, 512
          loop l_FAT12_find_place_7
        
      pop ebx

      xor edi, edi

l_FAT12_find_place_8:
add edi, ebx

mov al, 0

l_FAT12_find_place_9:
ret

// Get datetime, change to DirRec format
// OUT: cx = time, dx = date
// KEEP: ebx, esi, edi
FAT12_datetime:
push ebx

 push edi
  mov edi, VA_SYSTEM + offset FAT12_st
  call t_getsystem
 pop edi
 
 mov al, byte ptr FAT12_st.wHour
 movzx ecx, al
 
 mov al, byte ptr FAT12_st.wMinute
 shl ecx, 6
 or cl, al
 
 mov al, byte ptr FAT12_st.wSecond
 shl ecx, 5
 shr al, 1
 or cl, al
 
 movzx edx, word ptr FAT12_st.wYear
 sub edx, FAT12_YEAR0  // edx = year
 
 mov al, byte ptr FAT12_st.wMonth
 shl edx, 4
 or dl, al
 
 mov al, byte ptr FAT12_st.wDay
 shl edx, 5
 or dl, al

pop ebx
ret

// [70h] addr, [71h] data
//0	Time.Seconds (0-59)
//2	Time.Minutes (0-59)
//4	Time.Hours (0-23)
//6	Day of week (1-7)
//7	Date of month (1-31)
//8	Month (1-12)
//9	Year (0-99)
//32h	Century

//Bits 0-4: Day (0-31)
//Bits 5-8: Month (0-12)
//Bits 9-15: Year

//Bits 0-4: Second
//Bits 5-10: Minute
//Bits 11-15: Hour

// IN: ebx = first cluster of directory, FAT12_fname, FAT12_first_cluster
// OUT: al = 0 || erc, edi = disk offset
FAT12_create_file:
// check valid chars
mov edx, VA_SYSTEM + offset FAT12_fname
mov byte ptr [es:edx + 11], 0
call fs_check_valid
or al, al
jnz near l_FAT12_create_file_9

// IN: ebx = first cluster of directory
// OUT: al = 0 || erc, edi -> disk_adr_DirRec
movzx ebx, FAT12_first_cluster
call FAT12_find_place
or al, al
jnz near l_FAT12_create_file_9

mov ebx, edi
push edi
  // copy file name
  mov esi, offset FAT12_fname
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ecx, 11
  cld
  rep movsb
  // size 0, first cluster 0
  xor eax, eax
  mov FAT12_dir.FileSize, eax
  mov FAT12_dir.FirstCluster, ax
  mov FAT12_dir.Attrib, al
  mov FAT12_dir.FirstClusterHiBytes, ax
  // TimeCreated, DateCreated; KEEP ebx
  call FAT12_datetime
  mov FAT12_dir.DateCreated, dx
  mov FAT12_dir.TimeCreated, cx
  // save
  mov ah, 3
  mov al, FAT12_ldiskn
  // ebx = disk offset
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
pop edi
mov al, 0

l_FAT12_create_file_9:
ret

// IN: esi = index to OpenFileRec
FAT12_postoclu:
mov eax, dword ptr files.pos[esi]
mov cl, FAT12_clusize
shr eax, 9
shr eax, cl
mov ecx, eax

movzx ebx, word ptr files.sectn[esi + 4]
mov word ptr files.sectn[esi + 6], cx
jecxz l_FAT12_postoclu_8

l_FAT12_postoclu_2:
  // IN: al = ldiskn, ebx = cluster number
  // OUT: al = 0 || error, ebx = cluster value
  mov al, files.disk[esi]
  push esi
   push ecx
    call FAT12_get
   pop ecx
  pop esi
  or al, al
  jnz l_FAT12_postoclu_9    
    loop l_FAT12_postoclu_2

l_FAT12_postoclu_8:
mov cl, FAT12_clusize
shl ebx, cl
add ebx, FAT12_data
shl ebx, 9
mov dword ptr files.sectn[esi], ebx
mov al, 0

l_FAT12_postoclu_9:
ret

FAT12_iocalc:
mov cl, FAT12_clusize
mov edx, ebx
shr edx, 9
shr edx, cl   // edx = ebx / clustersizebytes
mov eax, 512
shl eax, cl   // eax = clustersizebytes
dec eax
and ebx, eax  // ebx % clustersizebytes
inc eax

mov ecx, FAT12_remain
sub eax, ebx
ret

// IN: edx = cluster in file, esi -> files
// KEEP: esi, edi
FAT12_check_cluster:
or edx, edx
jnz near l_FAT12_check_cluster_4
  // * first cluster *
  push edi
    mov ebx, files.file[esi]
    mov al, files.disk[esi]
    mov edi, VA_SYSTEM + offset FAT12_dir
    mov ecx, 32  // assert sizeof DirRec = 32
    mov ah, 2
    push esi
      call FAT12_diskmain
    pop esi
  pop edi
  movzx eax, FAT12_dir.FirstCluster
  or eax, eax
  jz l_FAT12_check_cluster_3
    // first cluster already exists
    
    l_FAT12_check_cluster_25: // IN: eax = cluster
    mov cl, FAT12_clusize
    shl eax, cl
    add eax, FAT12_data
    shl eax, 9
    mov dword ptr files.sectn[esi], eax
    jmp l_FAT12_check_cluster_9
    
  l_FAT12_check_cluster_3:
  // first cluster needs to be allocated
  mov al, ERC_FS
  jmp short l_FAT12_check_cluster_99
  
l_FAT12_check_cluster_4:
// * next cluster *
push edi
 push esi
  mov ebx, dword ptr files.sectn[esi]
  mov cl, FAT12_clusize
  shr ebx, 9
  sub ebx, FAT12_data
  shr ebx, cl
  mov al, files.disk[esi]
  push ebx
    call FAT12_get
  pop edx
 pop esi
pop edi
mov eax, ebx
cmp eax, 0xFFF
jnz near l_FAT12_check_cluster_25

mov al, ERC_FS
jmp short l_FAT12_check_cluster_99

l_FAT12_check_cluster_9:
mov al, 0

l_FAT12_check_cluster_99:
ret

// IN: edx = cluster in file, esi -> files
// KEEP: esi, edi
FAT12_check_clusterw:
or edx, edx
jnz near l_FAT12_check_clusterw_4
  // * first cluster *
  push edi
    mov ebx, files.file[esi]
    mov al, files.disk[esi]
    mov edi, VA_SYSTEM + offset FAT12_dir
    mov ecx, 32  // assert sizeof DirRec = 32
    mov ah, 2
    push esi
      call FAT12_diskmain
    pop esi
  pop edi
  movzx eax, FAT12_dir.FirstCluster
  or eax, eax
  jz l_FAT12_check_clusterw_3
    // first cluster already exists
    
    l_FAT12_check_clusterw_25: // IN: eax = cluster
    mov cl, FAT12_clusize
    shl eax, cl
    add eax, FAT12_data
    shl eax, 9
    mov dword ptr files.sectn[esi], eax
    jmp l_FAT12_check_clusterw_9
    
  l_FAT12_check_clusterw_3:
  // first cluster needs to be allocated
  
  push edi
   push esi
    // IN: FAT12_ldiskn
    // OUT: al = 0 || erc, ebx = free cluster number
    mov al, files.disk[esi]
    mov FAT12_ldiskn, al
    call FAT12_alloc
   pop esi
   or al, al
   jnz near l_FAT12_check_clusterw_8
   push esi
    push ebx
      mov al, files.disk[esi]
      mov edx, 0xFFF
      call FAT12_set
    pop eax
   pop esi
   mov FAT12_dir.FirstCluster, ax
   mov word ptr files.sectn[esi + 4], ax  // first cluster
   push esi
    push eax
      mov ebx, files.file[esi]
      mov al, files.disk[esi]
      mov edi, VA_SYSTEM + offset FAT12_dir
      mov ecx, 32  // assert sizeof DirRec = 32
      mov ah, 3
      call FAT12_diskmain
    pop eax
   pop esi
  pop edi
  jmp short l_FAT12_check_clusterw_25
  
l_FAT12_check_clusterw_4:
// * next cluster *
push edi
 push esi
  mov ebx, dword ptr files.sectn[esi]
  mov cl, FAT12_clusize
  shr ebx, 9
  sub ebx, FAT12_data
  shr ebx, cl
  mov al, files.disk[esi]
  push ebx
    call FAT12_get
  pop edx
 pop esi
pop edi
mov eax, ebx
cmp eax, 0xFFF
jnz near l_FAT12_check_clusterw_25

push edi

 push esi
  push edx
    mov al, files.disk[esi]
    mov FAT12_ldiskn, al
    call FAT12_alloc
  pop edx
 pop esi
 or al, al
 jnz near l_FAT12_check_clusterw_8
 mov eax, edx
 
 push esi
  push ebx
    mov edx, ebx
    mov ebx, eax
    mov al, files.disk[esi]
    call FAT12_set
  pop ebx
 pop esi

 push esi  
  push ebx
    mov al, files.disk[esi]
    mov edx, 0xFFF
    call FAT12_set
  pop eax
 pop esi

pop edi
jmp l_FAT12_check_clusterw_25

l_FAT12_check_clusterw_8:
pop edi
jmp short l_FAT12_check_clusterw_99

l_FAT12_check_clusterw_9:
mov al, 0

l_FAT12_check_clusterw_99:
ret

// IN: FAT12_first_cluster
// OUT: al = 0 || erc
FAT12_reduce_dir:
movzx ebx, FAT12_first_cluster
test ebx, ebx
jz near l_FAT12_reduce_8

mov FAT12_valid, bx

l_FAT12_reduce_60:
  mov cl, FAT12_clusize
  shl ebx, cl
  add ebx, FAT12_data
  shl ebx, 9 // 512
  
  mov eax, 512  
  shl eax, cl
  add eax, ebx
  mov FAT12_next, eax

  l_FAT12_reduce_61:
  mov ah, 2  // read
  mov al, FAT12_ldiskn
  push ebx
    mov ecx, 512
    mov edi, VA_SYSTEM + offset fd_buffer
    call FAT12_diskmain
  pop ebx
  
  xor edi, edi
  l_FAT12_reduce_62:
    mov al, fd_buffer[edi]
    cmp al, 0
    jz l_FAT12_reduce_63
      cmp al, DELCHAR
      jnz l_FAT12_reduce_65

    l_FAT12_reduce_63:
    add edi, 32  // assert sizeof DirRec = 32
    cmp edi, 512
    jb l_FAT12_reduce_62
  
  add ebx, 512
  cmp ebx, FAT12_next
  jb l_FAT12_reduce_61  // next sector in cluster

l_FAT12_reduce_64:
// not valid cluster
mov cl, FAT12_clusize
dec ebx
shr ebx, 9
sub ebx, FAT12_data
shr ebx, cl

l_FAT12_reduce_645:
// IN: al = ldiskn, ebx = cluster number
// OUT: al = 0 || error, ebx = cluster value
mov al, FAT12_ldiskn
call FAT12_get
or al, al
jnz l_FAT12_reduce_8
  or ebx, ebx
  jz l_FAT12_reduce_66
    cmp ebx, 0xFFF
    jnz near l_FAT12_reduce_60
jmp short l_FAT12_reduce_7

l_FAT12_reduce_65:
// valid cluster
//mov ebx, FAT12_next
mov cl, FAT12_clusize
//dec ebx
shr ebx, 9
sub ebx, FAT12_data
shr ebx, cl

mov FAT12_valid, bx
jmp short l_FAT12_reduce_645

l_FAT12_reduce_66:
mov al, ERC_FS
jmp short l_FAT12_reduce_8

l_FAT12_reduce_7:
// delete from the last valid cluster
movzx ebx, FAT12_valid
mov al, FAT12_ldiskn
call FAT12_get
cmp ebx, 0xFFF
jz l_FAT12_reduce_8
  call FAT12_delete
  movzx ebx, FAT12_valid
  mov edx, 0xFFF
  mov al, FAT12_ldiskn
  call FAT12_set

l_FAT12_reduce_8:
ret

// IN: FAT12_fname, fs_rec, fs_srchofs
// KEEP: ebx
FAT12_fname_to_mask:
mov edi, fs_srchofs
add edi, offset InSrchRec.FileMask
mov esi, offset FAT12_fname
cmp dword ptr [esi], "*   "
jnz l_FAT12_fname_to_mask_08
  cmp byte ptr [esi + 8], ' '
  jnz l_FAT12_fname_to_mask_08
    mov byte ptr [esi + 8], '*'  // * -> *.*
    
l_FAT12_fname_to_mask_08:
mov ecx, 8

l_FAT12_fname_to_mask_1:
  lodsb
  cmp al, '*'
  jnz l_FAT12_fname_to_mask_2
    mov al, '?'
    
    l_FAT12_fname_to_mask_3:
      mov [edi], al
      inc edi
      inc esi
      loop l_FAT12_fname_to_mask_3
  
    jmp short l_FAT12_fname_to_mask_ext
    
  l_FAT12_fname_to_mask_2:
  mov [edi], al
  inc edi
  loop l_FAT12_fname_to_mask_1
  
l_FAT12_fname_to_mask_ext:
dec esi
mov ecx, 3

l_FAT12_fname_to_mask_6:
  lodsb
  cmp al, '*'
  jnz l_FAT12_fname_to_mask_7
    mov al, '?'
    
    l_FAT12_fname_to_mask_8:
      mov [edi], al
      inc edi
      loop l_FAT12_fname_to_mask_8
  
    jmp short l_FAT12_fname_to_mask_9
    
  l_FAT12_fname_to_mask_7:
  mov [edi], al
  inc edi
  loop l_FAT12_fname_to_mask_6

l_FAT12_fname_to_mask_9:
ret

// IN: eax = datetime_FAT12 (lw = time, hw = date)
// OUT: edx:eax = ftime (1.1.1601, 10 ^ -7 s)
// KEEP: edi
FAT12_datetime_to_ftime:
push eax
  
  shr eax, 16
  add eax, FAT12_YEAR0 << 9
  call t_systime2ftime_days
  mov ebx, eax  // ebx = days

pop eax
push eax  
  shr eax, 11
  and eax, 31
pop ecx
push ecx
  shr ecx, 5
  and ecx, 63
  mov edx, 60
  mul edx
  add eax, ecx  // eax = eax * 60 + minute
pop ecx

and ecx, 31
shl ecx, 1
mov edx, 60
mul edx
add eax, ecx  // eax = eax * 60 + second  

xchg eax, ebx  // eax = days, ebx = time
mov edx, 86400
mul edx
add eax, ebx
adc edx, 0  // edx:eax = days * 86400 + time

xchg ebx, eax
xchg eax, edx
mov ecx, 10000000
mul ecx
xchg ebx, eax
mul ecx
add edx, ebx
ret

// IN: al = ldiskn, FAT12_diskmain
// KEEP: esi
FAT12_doflush:
mov ah, 5 // flush
push esi
  call FAT12_diskmain
pop esi
test al, al
jz l_FAT12_doflush_8
  push eax
    call h_fd_remove_from_cache
  pop eax

l_FAT12_doflush_8:
ret

FAT12_init:
mov FAT12_ldiskn, -1
ret

// IN: es:edx -> fname, al = ldiskn, ebx = dir cluster, esi -> files
// OUT: esi = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
FAT12_fopen:
push esi
  call FAT12_find_file
pop esi
mov files.file[esi], edi

// check not share write
call fs_not_share_write

// file
or al, al
jz l_FAT12_fopen_5
  cmp al, ERC_FILE_NOT_FOUND
  jnz near l_FAT12_fopen_9
    test files.mode[esi], FOPEN_CREATE
    jnz l_FAT12_fopen_2
      test files.mode[esi], FOPEN_APPEND
      jz near l_FAT12_fopen_9
        
        l_FAT12_fopen_2:
        // create file
        mov al, files.disk[esi]
        push esi
          call FAT12_create_file
        pop esi
        or al, al
        jnz near l_FAT12_fopen_9
          mov files.file[esi], edi
          jmp l_FAT12_fopen_6
  
l_FAT12_fopen_5:
// load direntry
push edi
 push esi
  mov al, FAT12_ldiskn
  mov ah, 2 // read
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
 pop esi
pop edi

// check read only
test FAT12_dir.Attrib, FILE_ATTRIBUTE_READONLY
jz l_FAT12_fopen_50
  mov files.mode[esi], FOPEN_READ
  
l_FAT12_fopen_50:

// check system file
test FAT12_dir.Attrib, FILE_ATTRIBUTE_SYSTEM
jz l_FAT12_fopen_51
  call s_chkstarter  // keep esi, edi
  jz l_FAT12_fopen_51
    mov al, ERC_ONLY_STARTER
    jmp l_FAT12_fopen_9
  
l_FAT12_fopen_51:

// check not directory
test FAT12_dir.Attrib, FILE_ATTRIBUTE_DIRECTORY
jz l_FAT12_fopen_52
  mov al, ERC_FILE_NOT_FOUND
  jmp l_FAT12_fopen_9
  
l_FAT12_fopen_52:

test files.mode[esi], FOPEN_CREATE
jz l_FAT12_fopen_6
  // rewrite
  movzx ebx, FAT12_dir.FirstCluster
  call FAT12_delete  // keep esi, edi
  
  xor eax, eax
  mov FAT12_dir.FirstCluster, ax
  mov FAT12_dir.FileSize, eax
  
  mov al, FAT12_ldiskn
  mov ah, 3 // write
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  push edi
   push esi
    mov edi, VA_SYSTEM + offset FAT12_dir
    call FAT12_diskmain
   pop esi
  pop edi

l_FAT12_fopen_6:
// sectn
movzx eax, FAT12_dir.FirstCluster
mov word ptr files.sectn[esi + 4], ax  // first cluster
mov cl, FAT12_clusize
shl eax, 9
shl eax, cl
mov dword ptr files.sectn[esi], eax    // current cluster disk offset
xor eax, eax
dec eax
mov word ptr files.sectn[esi + 6], ax  // current cluster in file = -1

// set mtime
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_FAT12_fopen_61
  call FAT12_datetime  // keep esi, edi
  mov FAT12_dir.LastModDate, dx
  mov FAT12_dir.LastModTime, cx

  mov al, FAT12_ldiskn
  mov ah, 3 // write
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  push edi
   push esi
    mov edi, VA_SYSTEM + offset FAT12_dir
    call FAT12_diskmain
   pop esi
  pop edi

l_FAT12_fopen_61:

// size
mov eax, FAT12_dir.FileSize
xor edx, edx
mov dword ptr files.size[esi], eax
mov dword ptr files.size[esi + 4], edx

// pos
test files.mode[esi], FOPEN_APPEND
jz l_FAT12_fopen_72
  // append
  mov dword ptr files.pos[esi], eax
  call FAT12_postoclu  // KEEP edx, esi
  jmp short l_FAT12_fopen_73

l_FAT12_fopen_72:
mov dword ptr files.pos[esi], edx

l_FAT12_fopen_73:
mov dword ptr files.pos[esi + 4], edx

shr esi, 5 // assert sizeof OpenFileRec = 32
mov al, 0
jmp short l_FAT12_fopen_99

l_FAT12_fopen_9:
mov files.mode[esi], 0

l_FAT12_fopen_99:
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizeread
FAT12_fread:
mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fread_01
  push esi
   push edi
    push ecx
      call FAT12_prepare
    pop ecx
   pop edi
  pop esi

l_FAT12_fread_01:
mov ebx, dword ptr files.pos[esi]
mov edx, dword ptr files.size[esi]
cmp ebx, edx
jna l_FAT12_fread_02
  mov ebx, edx
  
l_FAT12_fread_02:
mov eax, ebx
add eax, ecx
cmp eax, edx
jna l_FAT12_fread_05
  mov ecx, edx
  sub ecx, ebx
  
l_FAT12_fread_05:
mov FAT12_remain, ecx

push ecx

  l_FAT12_fread_1:
  mov ecx, FAT12_remain
  mov ebx, dword ptr files.pos[esi]
  or ecx, ecx
  jz near l_FAT12_fread_8
    
    call FAT12_iocalc
    
    cmp ecx, eax
    jna l_FAT12_fread_2
      mov ecx, eax
  
    l_FAT12_fread_2: // ecx = remaining bytes in cluster
    cmp dx, word ptr files.sectn[esi + 6]
    jz l_FAT12_fread_3
      
      mov word ptr files.sectn[esi + 6], dx
      push ecx
       push ebx
        call FAT12_check_cluster  // keep esi, edi
       pop ebx
      pop ecx
      or al, al
      jnz l_FAT12_fread_9
      
    l_FAT12_fread_3:
  
    push esi
     push ecx
      push edi
        add ebx, dword ptr files.sectn[esi]     
        mov al, files.disk[esi]
        mov ah, 2  // read
        call FAT12_diskmain
      pop edi
     pop ecx
    pop esi
    mov eax, ecx
    
    add edi, eax
    sub FAT12_remain, eax
    add dword ptr files.pos[esi], eax
    jmp l_FAT12_fread_1
  
  l_FAT12_fread_8:
  mov al, 0
  
  l_FAT12_fread_9:
  
pop ecx

ret

l_FAT12_fwrite_x:
mov al, ERC_READ_ONLY
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizewrite
FAT12_fwrite:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_FAT12_fwrite_x

mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fwrite_01
  push esi
   push edi
    push ecx
      call FAT12_prepare
    pop ecx
   pop edi
  pop esi

l_FAT12_fwrite_01:
mov ebx, dword ptr files.pos[esi]
mov edx, dword ptr files.size[esi]
cmp ebx, edx
jna l_FAT12_fwrite_02
  mov dword ptr files.pos[esi], edx
  
l_FAT12_fwrite_02:
mov FAT12_remain, ecx

push ecx

  l_FAT12_fwrite_1:
  mov ecx, FAT12_remain
  mov ebx, dword ptr files.pos[esi]
  or ecx, ecx
  jz near l_FAT12_fwrite_8
  
    call FAT12_iocalc
  
    cmp ecx, eax
    jna l_FAT12_fwrite_2
      mov ecx, eax
  
    l_FAT12_fwrite_2: // ecx = remaining bytes in cluster
    cmp dx, word ptr files.sectn[esi + 6]
    jz l_FAT12_fwrite_3
      
      mov word ptr files.sectn[esi + 6], dx
      push ecx
       push ebx
        call FAT12_check_clusterw  // keep esi, edi
       pop ebx
      pop ecx
      or al, al
      jnz l_FAT12_fwrite_98
      
    l_FAT12_fwrite_3:
    push esi
     push ecx
      push edi
        add ebx, dword ptr files.sectn[esi]     
        mov al, files.disk[esi]
        mov ah, 3  // write
        call FAT12_diskmain
      pop edi
     pop ecx
    pop esi
    mov eax, ecx
    
    add edi, eax
    sub FAT12_remain, eax
    add dword ptr files.pos[esi], eax
  
    mov eax, dword ptr files.pos[esi]
    cmp eax, dword ptr files.size[esi]
    jna near l_FAT12_fwrite_1
      mov dword ptr files.size[esi], eax
      jmp l_FAT12_fwrite_1
      
  l_FAT12_fwrite_8:  
  mov al, 0  
  
  l_FAT12_fwrite_9:

pop ecx

l_FAT12_fwrite_91:
ret

l_FAT12_fwrite_98:
pop ecx
sub ecx, FAT12_remain
ret

// IN: esi = offset to files, ebx = file offset
FAT12_fsetpos:
mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fsetpos_01
  push esi
   push ebx
    call FAT12_prepare
   pop ebx
  pop esi

l_FAT12_fsetpos_01:
mov eax, dword ptr files.size[esi]
cmp ebx, eax
jna l_FAT12_fsetpos_1
  mov ebx, eax

l_FAT12_fsetpos_1:
mov dword ptr files.pos[esi], ebx
call FAT12_postoclu
ret

// IN: esi -> files
FAT12_fcut:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_FAT12_fcut_8

mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fcut_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_fcut_01:
mov eax, dword ptr files.pos[esi]
mov dword ptr files.size[esi], eax

mov ebx, dword ptr files.sectn[esi + 0]
mov cl, FAT12_clusize
shr ebx, cl
sub ebx, FAT12_data
shr ebx, 9
mov al, files.disk[esi]
push esi
 push ebx
  call FAT12_get
 pop edx
pop esi
cmp ebx, 0xFFF
jz l_FAT12_fcut_6

push edx
  call FAT12_delete
pop ebx

mov al, files.disk[esi]
mov edx, 0xFFF
call FAT12_set

l_FAT12_fcut_6:
mov al, 0
jmp short l_FAT12_fcut_9

l_FAT12_fcut_8:
mov al, ERC_READ_ONLY

l_FAT12_fcut_9:
ret

// IN: esi = offset to files
FAT12_fclose:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz near l_FAT12_fclose_98

mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fclose_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_fclose_01:

// read
mov ebx, files.file[esi]
mov al, files.disk[esi]
mov edi, VA_SYSTEM + offset FAT12_dir
mov ecx, 32  // assert sizeof DirRec = 32
mov ah, 2 // read
push esi
  call FAT12_diskmain
pop esi

// update
mov eax, dword ptr files.size[esi]
mov FAT12_dir.FileSize, eax
call FAT12_datetime  // keep esi
mov FAT12_dir.DateLastAccessed, dx

// write
mov ebx, files.file[esi]
mov al, files.disk[esi]
mov edi, VA_SYSTEM + offset FAT12_dir
mov ecx, 32  // assert sizeof DirRec = 32
mov ah, 3 // write
push esi
  call FAT12_diskmain
pop esi

// flush
push esi
  mov al, files.disk[esi]
  call FAT12_doflush
pop esi

l_FAT12_fclose_8:
mov files.mode[esi], 0
ret

l_FAT12_fclose_98:
mov al, 0
jmp short l_FAT12_fclose_8

// IN: es:edx -> path & dirname, al = ldiskn, ebx = dir cluster
// OUT: al = 0 || erc
FAT12_md:
call FAT12_find_file
cmp al, ERC_FILE_NOT_FOUND
jnz near l_FAT12_md_6
  // check valid chars
  mov edx, VA_SYSTEM + offset FAT12_fname
  mov byte ptr [es:edx + 11], 0
  call fs_check_valid
  or al, al
  jnz near l_FAT12_md_9
  
  // IN: ebx = first cluster of directory
  // OUT: al = 0 || erc, edi -> disk_adr_DirRec
  movzx ebx, FAT12_first_cluster
  call FAT12_find_place
  
  push edi
    // copy fname
    mov esi, offset FAT12_fname
    mov edi, VA_SYSTEM + offset FAT12_dir
    mov ecx, 11
    cld
    rep movsb
    // attrib
    mov FAT12_dir.Attrib, FAT12_ATRB_DIR
    // file size
    xor eax, eax
    mov FAT12_dir.FileSize, eax
    // first cluster
    call FAT12_alloc
    or al, al
    jnz near l_FAT12_md_7
    
    mov FAT12_dir.FirstCluster, bx
    // datetime created
    call FAT12_datetime
    mov FAT12_dir.DateCreated, dx
    mov FAT12_dir.TimeCreated, cx
  pop edi
  // write dir
  push ebx
    mov ebx, edi
    mov edi, VA_SYSTEM + offset FAT12_dir
    mov ecx, 32  // assert sizeof DirRec = 32
    mov al, FAT12_ldiskn
    mov ah, 3
    call FAT12_diskmain
  pop ebx

  // set cluster
  mov al, FAT12_ldiskn
  mov edx, 0xFFF
  push ebx
    call FAT12_set
  pop ebx

  // zero buf
  xor eax, eax
  mov ecx, 512 / 4
  mov edi, VA_SYSTEM + offset fd_buffer
  cld
  rep stosd
  
  // .
  mov fd_buffer[0], '.'
  mov al, ' '
  mov edi, VA_SYSTEM + offset fd_buffer + 1
  mov ecx, 10
  rep stosb
  // attrib
  mov byte ptr fd_buffer[offset DirRec.Attrib], FAT12_ATRB_DIR
  // first cluster
  mov word ptr fd_buffer[offset DirRec.FirstCluster], bx

  // ..
  mov fd_buffer[32], '.'  // assert sizeof DirRec = 32
  mov fd_buffer[33], '.'
  mov al, ' '
  mov edi, VA_SYSTEM + offset fd_buffer + 32 + 2
  mov ecx, 9
  rep stosb
  // attrib
  mov byte ptr fd_buffer[32 + offset DirRec.Attrib], FAT12_ATRB_DIR
  // first cluster
  mov ax, FAT12_first_cluster
  mov word ptr fd_buffer[32 + offset DirRec.FirstCluster], ax

  // save buffer
  mov cl, FAT12_clusize
  shl ebx, cl
  add ebx, FAT12_data
  shl ebx, 9
  mov ecx, 512
  mov edi, VA_SYSTEM + offset fd_buffer
  mov al, FAT12_ldiskn
  mov ah, 3 // write
  push ebx
    call FAT12_diskmain
  pop ebx
  
  // zero to end of cluster
  xor eax, eax
  mov ecx, 32 * 2 / 4
  mov edi, VA_SYSTEM + offset fd_buffer
  rep stosd
  
  mov cl, FAT12_clusize
  xor eax, eax
  inc eax
  shl eax, cl
  dec eax
  xchg eax, ecx  // ecx = count of remaining sectors
  
  l_FAT12_md_5:
  jecxz l_FAT12_md_59
    dec ecx
    push ecx
      add ebx, 512
      mov ecx, 512
      mov edi, VA_SYSTEM + offset fd_buffer
      mov al, FAT12_ldiskn
      mov ah, 3 // write
      push ebx
        call FAT12_diskmain
      pop ebx
    pop ecx
    jmp short l_FAT12_md_5
  l_FAT12_md_59:

  // flush
  mov al, FAT12_ldiskn
  call FAT12_doflush
  jmp short l_FAT12_md_9
    
l_FAT12_md_7:
pop edi
jmp l_FAT12_md_9

l_FAT12_md_6:
cmp al, 0
jnz l_FAT12_md_9
  mov al, ERC_DIR_ALREADY_EXISTS

l_FAT12_md_9:
ret

// IN: al = ldiskn, es:edx -> path
FAT12_cd:
xor ebx, ebx
call FAT12_find_file
or al, al
jnz l_FAT12_cd_9

mov ah, 2  // read
mov al, FAT12_ldiskn
mov ebx, edi
mov ecx, 32
mov edi, VA_SYSTEM + offset FAT12_dir
push ebx
  call FAT12_diskmain
pop ebx

test FAT12_dir.Attrib, FAT12_ATRB_DIR
jz l_FAT12_cd_6

  l_FAT12_cd_5:
  mov edi, p_current
  mov al, FAT12_ldiskn
  or al, 96
  mov [es:edi + offset ThreadRec.curdisk], al
  movzx ebx, FAT12_dir.FirstCluster
  mov [es:edi + offset ThreadRec.curdir], ebx
  mov al, 0
  jmp short l_FAT12_cd_9

l_FAT12_cd_6:
mov al, ERC_FILE_NOT_FOUND
jmp short l_FAT12_cd_9

l_FAT12_cd_9:
ret

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster
FAT12_rm:
call FAT12_find_file
or al, al
jnz near l_FAT12_rm_9

// Check in use
mov al, FAT12_ldiskn
call fs_not_used
test cl, cl
jnz near l_FAT12_rm_9

// read DirRec
mov al, FAT12_ldiskn
mov ebx, edi
mov ecx, 32  // assert sizeof DirRec = 32
mov edi, VA_SYSTEM + offset FAT12_dir
mov ah, 2 // read
push ebx
  call FAT12_diskmain
pop ebx

test FAT12_dir.Attrib, FAT12_ATRB_DIR
jnz l_FAT12_rm_dir

  // check system file
  test FAT12_dir.Attrib, FILE_ATTRIBUTE_SYSTEM
  jz l_FAT12_rm_21
    call s_chkstarter
    jz l_FAT12_rm_21
      mov al, ERC_ONLY_STARTER
      jmp l_FAT12_rm_9
    
  l_FAT12_rm_21:
  
  // delete file
  push ebx
    movzx ebx, FAT12_dir.FirstCluster
    call FAT12_delete
    mov FAT12_dir.Filename[0], DELCHAR
  pop ebx
  
  mov al, FAT12_ldiskn
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ah, 3 // write
  call FAT12_diskmain
  jmp l_FAT12_rm_6

l_FAT12_rm_dir:
// remove directory
cmp dword ptr FAT12_dir.Filename[4], "    "
jnz l_FAT12_rm_dir2
  cmp dword ptr FAT12_dir.Filename[0], ".   "
  jz near l_FAT12_rm_41
    cmp dword ptr FAT12_dir.Filename[0], "..  "
    jz near l_FAT12_rm_41

l_FAT12_rm_dir2:
push ebx
  movzx ebx, FAT12_dir.FirstCluster
  mov al, FAT12_ldiskn
  call FAT12_get
  mov edx, ebx
pop ebx
cmp edx, 0xFFF
jnz near l_FAT12_rm_42
  push ebx
    movzx ebx, FAT12_dir.FirstCluster  
    mov cl, FAT12_clusize
    shl ebx, cl
    add ebx, FAT12_data
    shl ebx, 9 // 512
    
    mov eax, 512  
    shl eax, cl
    add eax, ebx
    mov FAT12_next, eax
    
    l_FAT12_rm_31:
      mov ah, 2  // read
      mov al, FAT12_ldiskn
      push ebx
        mov ecx, 512
        mov edi, VA_SYSTEM + offset fd_buffer
        call FAT12_diskmain
      pop ebx
      
      xor edi, edi
      l_FAT12_rm_32:
        mov al, fd_buffer[edi]
        cmp al, DELCHAR
        jz l_FAT12_rm_33
          cmp al, 0
          jz l_FAT12_rm_33
            cmp al, '.'
            jnz l_FAT12_rm_notempty

        l_FAT12_rm_33:
          add edi, 32  // assert sizeof DirRec = 32
          cmp edi, 512
          jb l_FAT12_rm_32
      
      add ebx, 512
      cmp ebx, FAT12_next
      jb l_FAT12_rm_31  // next sector in cluster

  pop ebx

  mov FAT12_dir.Filename[0], DELCHAR

  mov al, FAT12_ldiskn
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ah, 3 // write
  call FAT12_diskmain

  movzx ebx, FAT12_dir.FirstCluster
  mov al, FAT12_ldiskn
  xor edx, edx
  call FAT12_set
  jmp l_FAT12_rm_6

l_FAT12_rm_notempty:
pop ebx
jmp short l_FAT12_rm_42

l_FAT12_rm_41:
mov al, ERC_CANT_REMOVE
jmp l_FAT12_rm_9

l_FAT12_rm_42:
mov al, ERC_DIR_NOT_EMPTY
jmp l_FAT12_rm_9

l_FAT12_rm_6:
call FAT12_reduce_dir

l_FAT12_rm_8:

// flush
mov al, FAT12_ldiskn
call FAT12_doflush

l_FAT12_rm_9:
ret

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster, es:esi -> new filename
FAT12_rename:
// IN: es:edx -> file name, al = ldiskn, ebx = cluster number of directory
// OUT: al = 0 || erc, edi = disk offset of DirRec
push esi
  call FAT12_find_file
pop edx
or al, al
jnz near l_FAT12_rename_9

cmp byte ptr FAT12_fname, '.'
jz near l_FAT12_rename_82

push edi
  call FAT12_load_fname
pop edi

push edi
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov al, FAT12_ldiskn
  mov ah, 2 // read
  call FAT12_diskmain

  mov esi, offset FAT12_dir.Filename
  mov edi, offset FAT12_fname
  mov ecx, 11
  call eqxcase
pop edi
or al, al
jz l_FAT12_rename_6

// check valid chars
mov edx, VA_SYSTEM + offset FAT12_fname
mov byte ptr [es:edx + 11], 0
call fs_check_valid
or al, al
jnz near l_FAT12_rename_9

// check system file
test FAT12_dir.Attrib, FILE_ATTRIBUTE_SYSTEM
jz l_FAT12_rename_21
  call s_chkstarter
  jz l_FAT12_rename_21
    mov al, ERC_ONLY_STARTER
    jmp l_FAT12_rename_9
  
l_FAT12_rename_21:

cmp byte ptr FAT12_fname, '.'
jz l_FAT12_rename_82

push edi
  movzx ebx, FAT12_first_cluster
  mov al, FAT12_ldiskn
  call FAT12_srchdir
pop edi
or al, al
jz l_FAT12_rename_8

  l_FAT12_rename_6:

  mov ebx, edi
  mov ecx, 11
  mov edi, VA_SYSTEM + offset FAT12_fname
  mov al, FAT12_ldiskn
  mov ah, 3 // write
  call FAT12_diskmain
  
  // flush
  mov al, FAT12_ldiskn
  call FAT12_doflush
  jmp short l_FAT12_rename_9
  
l_FAT12_rename_8:
mov al, ERC_DUPLICATE_NAME
jmp short l_FAT12_rename_9

l_FAT12_rename_82:
mov al, ERC_CANT_RENAME

l_FAT12_rename_9:
ret

l_FAT12_move_x2:
mov al, ERC_PATH_NOT_FOUND

l_FAT12_move_x1:
   pop ecx
  pop edi
pop edx
jmp l_FAT12_move_9

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster, es:esi -> new path
// OUT: al = 0 || erc
FAT12_move:
push esi
 push eax
  call FAT12_find_file
  push ebx
   push edi
    mov cx, FAT12_first_cluster
    mov FAT12_first_cluster2, cx
    mov esi, offset FAT12_fname
    mov edi, VA_SYSTEM + offset FAT12_fname2
    mov ecx, 11
    cld
    rep movsb

    // check system file
    or al, al
    jnz l_FAT12_move_22

   pop edi
   push edi      
      mov al, FAT12_ldiskn
      mov ebx, edi
      mov ecx, 32  // assert sizeof DirRec = 32
      mov edi, VA_SYSTEM + offset FAT12_dir
      mov ah, 2 // read
      call FAT12_diskmain
      
      test FAT12_dir.Attrib, FILE_ATTRIBUTE_SYSTEM
      jz l_FAT12_move_21
        call s_chkstarter
        jz l_FAT12_move_21
          mov al, ERC_ONLY_STARTER
          jmp l_FAT12_move_22
        
      l_FAT12_move_21:
      mov al, 0
    
    l_FAT12_move_22:
   pop edi
  pop ebx
 pop edx  // dl = ldiskn
pop esi
or al, al
jnz near l_FAT12_move_9

push edx
  mov edx, esi
  call fs_disk  // keep esi, edi; OUT: al = disk, ebx = first cluster
  push edi
   push eax
    cmp byte ptr [es:edx], 0
    jz l_FAT12_move_31
      call FAT12_find_file
      or al, al
      jnz near l_FAT12_move_x1
      
      mov ebx, edi
      mov edi, VA_SYSTEM + offset FAT12_dir
      mov ecx, 32
      mov al, FAT12_ldiskn
      mov ah, 2 // read
      call FAT12_diskmain
      test FAT12_dir.Attrib, FAT12_ATRB_DIR
      jz near l_FAT12_move_x2
      
      movzx ebx, FAT12_dir.FirstCluster
      
    l_FAT12_move_31:
   pop ecx  // cl = ldiskn2
  pop esi  // esi = old file dir ofs
pop edx

l_FAT12_move_5:
cmp cl, dl
jz l_FAT12_move_51
  mov al, ERC_OUT_OF_DISK
  jmp l_FAT12_move_9

l_FAT12_move_51:
push esi
  mov esi, offset FAT12_fname2
  mov edi, VA_SYSTEM + offset FAT12_fname
  mov ecx, 11
  cld
  rep movsb
  
  // IN: al = ldiskn, esi -> fname, ebx = cluster number of directory
  // OUT: al = 0 || erc, ebx = offset of sector, edi = offset in sector
  mov al, FAT12_ldiskn
  mov esi, offset FAT12_fname
  call FAT12_srchdir  // OUT: FAT12_first_cluster
pop esi
cmp al, 1
jz l_FAT12_move_52
  mov al, ERC_DUPLICATE_NAME
  jmp l_FAT12_move_9

l_FAT12_move_52:
// IN: ebx = first cluster of directory
// OUT: al = 0 || erc, edi -> disk_adr_DirRec
push esi
  movzx ebx, FAT12_first_cluster
  call FAT12_find_place
pop esi
or al, al
jnz l_FAT12_move_9

push edi
 push esi
  mov ebx, esi
  mov ecx, 32 // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ah, 2 // read
  mov al, FAT12_ldiskn
  call FAT12_diskmain
 pop esi
pop edi

push esi
  mov ebx, edi
  mov ecx, 32 // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ah, 3 // write
  mov al, FAT12_ldiskn
  call FAT12_diskmain
pop esi

mov FAT12_dir.Filename[0], DELCHAR
mov ebx, esi
mov ecx, 32 // assert sizeof DirRec = 32
mov edi, VA_SYSTEM + offset FAT12_dir
mov ah, 3 // write
mov al, FAT12_ldiskn
call FAT12_diskmain

// reduce
mov ax, FAT12_first_cluster2
mov FAT12_first_cluster, ax
call FAT12_reduce_dir

// flush
mov al, FAT12_ldiskn
call FAT12_doflush

l_FAT12_move_9:
ret

// IN: edx -> path & mask, al = ldiskn, ebx = current directory cluster
// OUT: al = 0 || erc
FAT12_find_first:
push edx
  call FAT12_prepare  // keep ebx, edi
pop edx
test al, al
jnz near l_FAT12_find_first_9

l_FAT12_find_first_1:
call FAT12_load_fname  // keep ebx

cmp byte ptr [es:edx], 0
jz l_FAT12_find_first_5
  
  l_FAT12_find_first_2:
  mov al, FAT12_ldiskn
  push edx
    call FAT12_srchdir
  pop edx
  add edi, ebx
  or al, al
  jnz l_FAT12_find_first_9
    mov ah, 2  // read
    mov al, FAT12_ldiskn
    mov ebx, edi
    mov ecx, 32  // assert sizeof DirRec = 32
    mov edi, VA_SYSTEM + offset FAT12_dir
    push edx
      call FAT12_diskmain
    pop edx
    // test attrib dir
    test FAT12_dir.Attrib, FAT12_ATRB_DIR
    jz l_FAT12_find_first_6
      // dir
      movzx ebx, FAT12_dir.FirstCluster
      jmp short l_FAT12_find_first_1

l_FAT12_find_first_5:
// fname = mask, ebx = directory cluster
call FAT12_fname_to_mask // keep ebx

mov esi, fs_srchofs

mov al, FAT12_ldiskn
mov srch.Disk[esi], al
mov dword ptr srch.Cluster[esi], ebx
xor eax, eax
mov srch.Offset[esi], eax

call FAT12_find_next
or al, al
jz l_FAT12_find_first_99
jmp short l_FAT12_find_first_9

l_FAT12_find_first_6:
mov al, ERC_PATH_NOT_FOUND

l_FAT12_find_first_9:
mov esi, fs_srchofs
mov word ptr srch.ThreadId[esi], -1

l_FAT12_find_first_99:
ret

// IN: fs_srchofs, fs_rec
// OUT: al = 0 || erc, [fs_rec]
FAT12_find_next:
mov esi, fs_srchofs

mov al, srch.Disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_find_next_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_find_next_01:
mov edi, fs_rec

l_FAT12_find_next_1:
mov ebx, dword ptr srch.Cluster[esi]
mov eax, srch.Offset[esi]

test ebx, ebx
jnz l_FAT12_find_next_2
  // root
  movzx edx, FAT12_maxroot
  shl edx, 5  // assert sizeof DirRec = 32
  jmp short l_FAT12_find_next_3
  
// not root
l_FAT12_find_next_2:
mov cl, FAT12_clusize
mov edx, 512  
shl edx, cl

// both
l_FAT12_find_next_3:
cmp eax, edx
jb l_FAT12_find_next_51
  test ebx, ebx
  jz l_FAT12_find_next_51e

  // IN: al = ldiskn, ebx = cluster number
  // OUT: al = 0 || error, ebx = cluster value
  mov al, srch.Disk[esi]
  push esi
   push edi
    call FAT12_get
   pop edi
  pop esi
  or al, al
  jnz near l_FAT12_find_next_9
    mov dword ptr srch.Cluster[esi], ebx
    xor eax, eax
    mov srch.Offset[esi], eax
      
l_FAT12_find_next_51:
cmp ebx, 0xFFF
jnz l_FAT12_find_next_52
  
  l_FAT12_find_next_51e:
  //mov word ptr srch.ThreadId[esi], -1
  mov al, 1 //ERC_FILE_NOT_FOUND
  jmp l_FAT12_find_next_9

l_FAT12_find_next_52:
// eax = Offset, ebx = Cluster
test ebx, ebx
jnz l_FAT12_find_next_53
  // root
  mov ebx, FAT12_rootsect
  jmp short l_FAT12_find_next_54
  
// not root
l_FAT12_find_next_53:
mov cl, FAT12_clusize
shl ebx, cl
add ebx, FAT12_data

// both
l_FAT12_find_next_54:
shl ebx, 9

add ebx, eax
add eax, sizeof DirRec
mov srch.Offset[esi], eax

push edi
 push esi
  mov ah, 2  // read
  mov al, srch.Disk[esi]
  mov ecx, sizeof DirRec
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
 pop esi
pop edi

mov al, FAT12_dir.Filename[0]
or al, al
jz near l_FAT12_find_next_1
cmp al, DELCHAR
jz near l_FAT12_find_next_1

push edi
 push esi
  add esi, offset InSrchRec.FileMask
  mov edi, offset FAT12_dir.Filename
  mov ecx, 11
  call eqxcase_qm
 pop esi
pop edi
or al, al
jnz near l_FAT12_find_next_1

// fname to name
mov ecx, 8

l_FAT12_find_next_71:
  dec ecx
  mov al, FAT12_dir.Filename[ecx]
  cmp al, ' '
  jnz l_FAT12_find_next_72
    or ecx, ecx
    jnz l_FAT12_find_next_71

l_FAT12_find_next_72:
inc ecx
mov ebx, edi
add ebx, offset SearchRec.FileName
xor esi, esi

l_FAT12_find_next_73:
  mov al, FAT12_dir.Filename[esi]
  // lower case filename
  cmp al, 'A'
  jb l_FAT12_find_next_731
    cmp al, 'Z'
    ja l_FAT12_find_next_731
      add al, 32
      
  l_FAT12_find_next_731:
  mov [es:ebx], al
  inc esi
  inc ebx
  loop l_FAT12_find_next_73

mov ecx, 3
mov esi, offset FAT12_dir.Ext
mov al, [esi]
cmp al, ' '
jz l_FAT12_find_next_75
  mov byte ptr [es:ebx], '.'
  inc ebx

l_FAT12_find_next_74:
  mov al, [esi]
  cmp al, ' '
  jz l_FAT12_find_next_75
    // lower case ext
    cmp al, 'A'
    jb l_FAT12_find_next_741
      cmp al, 'Z'
      ja l_FAT12_find_next_741
        add al, 32
        
    l_FAT12_find_next_741:
    mov [es:ebx], al
    inc esi
    inc ebx
    loop l_FAT12_find_next_74

l_FAT12_find_next_75:
mov byte ptr [es:ebx], 0

// name to alternate
mov ecx, ebx
sub ecx, edi
sub ecx, offset SearchRec.FileName
inc ecx

mov ebx, edi
add ebx, offset SearchRec.AlternateFileName

mov esi, edi
add esi, offset SearchRec.FileName

l_FAT12_find_next_76:
  mov al, [es:esi]
  inc esi
  mov [es:ebx], al
  inc ebx
  loop l_FAT12_find_next_76

// size
mov eax, FAT12_dir.FileSize
xor edx, edx
mov dword ptr [es:edi + offset SearchRec.FileSize], eax
mov dword ptr [es:edi + offset SearchRec.FileSize + 4], edx

// attribs
movzx eax, byte ptr FAT12_dir.Attrib
mov [es:edi + offset SearchRec.FileAttributes], eax

// times
mov eax, dword ptr FAT12_dir.TimeCreated
call FAT12_datetime_to_ftime
mov dword ptr [es:edi + offset SearchRec.CreationTime], eax
mov dword ptr [es:edi + offset SearchRec.CreationTime + 4], edx

mov eax, dword ptr FAT12_dir.LastModTime
call FAT12_datetime_to_ftime
mov dword ptr [es:edi + offset SearchRec.LastWriteTime], eax
mov dword ptr [es:edi + offset SearchRec.LastWriteTime + 4], edx

mov ax, FAT12_dir.DateLastAccessed
shl eax, 16
call FAT12_datetime_to_ftime
mov dword ptr [es:edi + offset SearchRec.LastAccessTime], eax
mov dword ptr [es:edi + offset SearchRec.LastAccessTime + 4], edx

// end
mov al, 0

l_FAT12_find_next_9:
ret

// IN: edx -> filename, esi = new atribs
FAT12_chmod:
mov FAT12_ldiskn, al

push esi
  call FAT12_find_file
pop esi
or al, al
jnz l_FAT12_chmod_9
  // edi -> DirRec
  add edi, offset DirRec.Attrib
  push esi
   push edi
    mov ebx, edi
    mov ecx, 1
    mov edi, VA_SYSTEM + offset FAT12_tmp1
    mov al, FAT12_ldiskn
    mov ah, 2  // read
    call FAT12_diskmain
   pop edi
  pop esi
  mov eax, esi
  xor al, FAT12_tmp1
/*
FAT12_ATRB_READONLY = 1
FAT12_ATRB_HIDDEN = 2
FAT12_ATRB_SYSTEM = 4
FAT12_ATRB_VOLLBL = 8
FAT12_ATRB_DIR = 10h
FAT12_ATRB_ARCHIVE = 20h
FAT12_ATRB_DEV = 60h
*/
  test al, 58h
  jz l_FAT12_chmod_51
    mov al, ERC_INVALID_ATRBS
    ret
    
  l_FAT12_chmod_51:
  test al, FAT12_ATRB_SYSTEM
  jz l_FAT12_chmod_52
    call s_chkstarter
    jz l_FAT12_chmod_52
      mov al, ERC_ONLY_STARTER
      ret
    
  l_FAT12_chmod_52:
  mov eax, esi
  mov FAT12_tmp1, al

  mov ebx, edi
  mov ecx, 1
  mov edi, VA_SYSTEM + offset FAT12_tmp1
  mov al, FAT12_ldiskn
  mov ah, 3  // write
  call FAT12_diskmain

  // flush
  mov al, FAT12_ldiskn
  call FAT12_doflush
  
l_FAT12_chmod_9:
ret

// IN: esi = offset to files
// OUT: al = erc, edx:ecx = ftime
FAT12_get_mtime:
mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_get_mtime_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_get_mtime_01:
mov edi, files.file[esi]
// load direntry
push esi
  mov al, FAT12_ldiskn
  mov ah, 2 // read
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
pop esi
// convert datetime
mov ax, FAT12_dir.LastModDate
shl eax, 16
mov ax, FAT12_dir.LastModTime
call FAT12_datetime_to_ftime
xchg eax, ecx
mov al, 0
ret

// IN: esi = offset to files, edx:ecx = ftime
// OUT: al = erc
FAT12_set_mtime:
mov dword ptr fs_ftime[0], ecx
mov dword ptr fs_ftime[4], edx

mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_set_mtime_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_set_mtime_01:
// load direntry
push esi
  mov al, FAT12_ldiskn
  mov ah, 2 // read
  mov ebx, files.file[esi]
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
pop esi
// convert datetime
push esi
  mov esi, VA_SYSTEM + offset fs_ftime
  mov edi, VA_SYSTEM + offset FAT12_st
  call t_ftime2systime
pop esi
mov al, byte ptr FAT12_st.wHour
movzx ecx, al
mov al, byte ptr FAT12_st.wMinute
shl ecx, 6
or cl, al
mov al, byte ptr FAT12_st.wSecond
shl ecx, 5
shr al, 1
or cl, al
movzx edx, word ptr FAT12_st.wYear
sub edx, FAT12_YEAR0  // edx = year
mov al, byte ptr FAT12_st.wMonth
shl edx, 4
or dl, al
mov al, byte ptr FAT12_st.wDay
shl edx, 5
or dl, al
mov FAT12_dir.LastModTime, cx
mov FAT12_dir.LastModDate, dx
// save direntry
mov al, FAT12_ldiskn
mov ah, 3 // write
mov ebx, files.file[esi]
mov ecx, 32  // assert sizeof DirRec = 32
mov edi, VA_SYSTEM + offset FAT12_dir
call FAT12_diskmain
ret

// IN: al = ldiskn
// OUT: al = erc, edx:ecx = free bytes
FAT12_diskfree:
cmp FAT12_ldiskn, al
jz l_FAT12_diskfree_01
  call FAT12_prepare

l_FAT12_diskfree_01:
xor ebx, ebx
xor ecx, ecx

l_FAT12_diskfree_5:
  cmp ebx, FAT12_clusters
  jnb l_FAT12_diskfree_8
    push ebx
     push ecx
      mov al, FAT12_ldiskn
      call FAT12_get
     pop ecx
     test ebx, ebx
     jnz l_FAT12_diskfree_6
       inc ecx
        
     l_FAT12_diskfree_6:
    pop ebx
    inc ebx
    jmp short l_FAT12_diskfree_5
    
l_FAT12_diskfree_8:
xor edx, edx
xchg eax, ecx
mov cl, FAT12_clusize
add cl, 9
shl eax, cl
xchg eax, ecx
mov al, 0
ret

CD_PATHTABLE_PA = PA_DMA_BUFFERS + 0x8000

CD_FLAGS_HIDDEN = 1
CD_FLAGS_DIRECTORY = 2
CD_FLAGS_ASSOCIATED = 4
CD_FLAGS_RECORD = 8
CD_FLAGS_PROTECTION = 16
CD_FLAGS_MULTIEXTENT = 128

CD_ESCAPE = 2F25h

struct PathTableRec{
  uns1 len_di, len_ext // size = 8+len_di
  uns4 ext_location
  uns2 parent
  char dir_ident[255]  
}

struct CdDirRec{
  uns1 len_dr, len_ext  // size = len_dr
  uns8 ext_location, len_file
  uns1 dtm[7]
  uns1 flags, unit_size, interleave_gap_size
  uns4 seq_num
  uns1 len_fi // filename length
  char filename[255]
}

uns1 cd_ldiskn, cd_ext
bool cd_udf

[dalign 32]
uns4 cd_diskmain, cd_tmp4, cd_ofs, cd_pathtable_size, cd_pathtable_ofs
uns4 cd_rootlb, cd_rootsize, cd_size

[dalign 64]
uns8 cd_pos8, cd_size8, cd_ftime

uns2 cd_dirn, cd_curdirn, cd_escape

uns1 cd_dtm[17]

// IN: al = ldiskn
cd_prepare:
mov cd_pathtable_size, 0
mov cd_rootlb, 0
mov cd_escape, 0
mov cd_ldiskn, al

movzx esi, al
shl esi, 5  // log2(DiskInfoRec)
mov esi, disk_info.main[esi]
or esi, esi
jnz cd_prepare_0
  mov al, ERC_INVALID_DISK_NUMBER
  jmp cd_prepare_9

cd_prepare_0:
mov cd_diskmain, esi

/*
mov ah, 2
mov al, cd_ldiskn
xor edx, edx
mov ebx, 16 * 2048 + 1
mov ecx, 4
mov edi, VA_SYSTEM + offset cd_tmp4
call cd_diskmain

cmp cd_tmp4, "CD00"
jnz near cd_prepare_udf
*/
  mov cd_udf, 0

  mov cd_ofs, 16 * 2048
  mov cd_pathtable_ofs, 0

  cd_prepare_11:
    mov ah, 2  // read
    mov al, cd_ldiskn
    xor edx, edx
    mov ebx, cd_ofs
    mov ecx, 1
    mov edi, VA_SYSTEM + offset cd_tmp4
    call cd_diskmain
    
    cmp byte ptr cd_tmp4, 1 // Primary
    jnz near cd_prepare_12
      
      cd_prepare_115:
      /*
      mov ah, 2
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 140 // PathTable location in blocks 2048
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_pathtable_ofs
      call cd_diskmain
      
      mov ah, 2
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 132 // PathTable size in bytes
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_pathtable_size
      call cd_diskmain
      */
      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 80 // disk size in sectors
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_tmp4
      call cd_diskmain
      mov eax, dword ptr cd_tmp4
      mov edx, eax
      shl eax, 2  // * 2048 / 512
      shr edx, 32 - 2
      movzx esi, cd_ldiskn
      and esi, 31
      shl esi, 5  // assert sizeof DiskInfoRec = 32
      mov dword ptr disk_info.size_sectors[esi + 0], eax
      mov dword ptr disk_info.size_sectors[esi + 4], edx
      
      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 156 + 2 // root.lb
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_rootlb
      call cd_diskmain
      
      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 156 + 10 // root.size
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_rootsize
      call cd_diskmain
      
      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 813  // creation dtm
      mov ecx, 17
      mov edi, VA_SYSTEM + offset cd_dtm
      call cd_diskmain
      call cd_mktime
      mov dword ptr cd_ftime[0], eax
      mov dword ptr cd_ftime[4], edx
      
      //mov ecx, p_current
      //mov eax, cd_rootsize
      //mov [es:ecx + offset ThreadRec.curdirsize], eax
      
      jmp short cd_prepare_18
      
    cd_prepare_12:
    cmp byte ptr cd_tmp4, 2 // Supplementary
    jnz cd_prepare_13

      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 58h // escapes
      mov ecx, 2
      mov edi, VA_SYSTEM + offset cd_escape
      call cd_diskmain

      jmp cd_prepare_115
      
    cd_prepare_13:
    cmp byte ptr cd_tmp4, 255 // Terminal
    jz cd_prepare_2
    
    cd_prepare_18:
    add cd_ofs, 2048
    cmp cd_ofs, 2048 * 20
    jb near cd_prepare_11
    // missing terminal
    
  cd_prepare_2:
  /*
  cmp cd_pathtable_size, 0x8000
  jna cd_prepare_21
    mov cd_pathtable_size, 0
    jmp short cd_prepare_29
    
  cd_prepare_21:
  mov ah, 2
  mov al, cd_ldiskn
  xor edx, edx
  mov ebx, cd_pathtable_ofs
  shl ebx, 11 // 2048
  mov ecx, cd_pathtable_size
  mov edi, VA_SYSTEM + CD_PATHTABLE_PA
  call cd_diskmain
  
  cd_prepare_29:
  */
  jmp cd_prepare_9
  
cd_prepare_udf:
mov cd_udf, 1
//...
mov al, ERC_NOT_IMPLEMENTED

cd_prepare_9:
ret

// IN: es:edx -> filenamez, ebx = 0 || sector, cd_ldiskn
// OUT: ebx = sector, ecx = size, al = 0 || erc
// USES: cd_pos8, cd_size8, fd_buffer
cd_find_file:
/*
cmp cd_pathtable_size, 0
jz l_cd_find_file_dir

// pathtable
mov esi, CD_PATHTABLE_PA + VA_SYSTEM
mov cd_dirn, 1
mov cd_curdirn, 1

l_cd_find_file_15:
mov eax, cd_pathtable_size
add eax, CD_PATHTABLE_PA + VA_SYSTEM
cmp esi, eax
jnb l_cd_find_file_not_found
  movzx ecx, byte ptr [es:esi]
  mov cd_ext, [es:esi + 1]
  mov ax, [es:esi + 6]
  cmp ax, cd_dirn
  jnz l_cd_find_file_next
    add esi, 8
    call cd_cmp // KEEP esi, ecx
    or al, al
    jnz l_cd_find_file_next
      mov ax, cd_curdirn
      mov cd_dirn, ax
      mov ebx, [es:esi - 8 + 2]
      
      // check dir/filename
      push edx
       push ecx
        
        mov ecx, MAX_PATH
        mov al, 0
        
        l_cd_find_file_16:
        cmp byte ptr [es:edx], 0  // zero - filename
        jz l_cd_find_file_18
          cmp byte ptr [es:edx], '/'  // slash - dirname
          jz l_cd_find_file_17
            inc edx
            loop l_cd_find_file_16
        
          l_cd_find_file_17:
          mov al, 1
        
        l_cd_find_file_18:
        
       pop ecx
      pop edx
      
      or al, al
      jnz l_cd_find_file_next
        mov ecx, //...
        jmp short l_cd_find_file_22 // find file in dir
  
  l_cd_find_file_next:
  add esi, ecx
  movzx eax, cd_ext
  add esi, eax
  inc cd_curdirn
  cmp byte ptr [es:esi], 0
  jnz l_cd_find_file_15
    inc esi
    jmp l_cd_find_file_15

l_cd_find_file_not_found:
mov al, ERC_PATH_NOT_FOUND
jmp l_cd_find_file_9
*/

// Not pathtable
l_cd_find_file_dir:
cmp byte ptr [es:edx], 0
jnz l_cd_find_file_1
  mov al, ERC_FILE_NOT_FOUND
  jmp l_cd_find_file_9
  
l_cd_find_file_1:
or ebx, ebx
jz l_cd_find_file_21
  mov ecx, p_current
  mov ecx, [es:ecx + offset ThreadRec.curdirsize]
  jmp short l_cd_find_file_22

l_cd_find_file_21:
mov ebx, cd_rootlb
mov ecx, cd_rootsize

l_cd_find_file_22:
mov eax, ebx
shl ebx, 11
shr eax, 32 - 11
mov dword ptr cd_pos8[0], ebx
mov dword ptr cd_pos8[4], eax  // cd_pos8 = offset of dir
mov dword ptr cd_size8[0], ebx
mov dword ptr cd_size8[4], eax
add dword ptr cd_size8[0], ecx
adc dword ptr cd_size8[4], 0  // cd_size8 = offset + ecx

l_cd_find_file_25:
push edx

  mov ah, 2  // read
  mov al, cd_ldiskn
  mov ebx, dword ptr cd_pos8[0]
  mov edx, dword ptr cd_pos8[4]
  mov ecx, 1
  mov edi, VA_SYSTEM + offset fd_buffer
  call cd_diskmain
  
  or al, al
  jnz near l_cd_find_file_29
  
  mov ah, 2  // read
  mov al, cd_ldiskn
  movzx ecx, byte ptr fd_buffer[0]
  dec ecx
  cmp ecx, 255
  jna l_cd_find_file_255
    mov al, ERC_FS
    jmp l_cd_find_file_29
    
  l_cd_find_file_255:
  mov ebx, dword ptr cd_pos8[0]
  mov edx, dword ptr cd_pos8[4]
  add ebx, 1
  adc edx, 0
  mov edi, VA_SYSTEM + offset fd_buffer + 1
  call cd_diskmain
  
  or al, al
  jnz near l_cd_find_file_29
  
pop edx

// Convert to UTF-8: fd_buffer -> hd_buffer
movzx ecx, byte ptr fd_buffer[32]
mov esi, offset fd_buffer + 33
mov edi, VA_SYSTEM + offset fs_utf8buf
cld
cmp cd_escape, CD_ESCAPE
jz l_l_cd_find_file_258
  // not Unicode
  rep movsb
  mov al, 0
  stosb
  jmp short l_l_cd_find_file_259
  
// Unicode
l_l_cd_find_file_258:
  mov fs_bigendian, 1
  call fs_toutf8  // keep edx

l_l_cd_find_file_259:
or al, al
jnz near l_cd_find_file_9

// compare
mov esi, VA_SYSTEM + offset fs_utf8buf
call fs_cmp  // keep edx

or al, al
jz l_cd_find_file_28

  movzx eax, byte ptr fd_buffer[0]  // LEN_DR
  cmp al, 0
  jz l_cd_find_file_26
    movzx ebx, byte ptr fd_buffer[1]  // LEN_EXT
    add eax, ebx
    add dword ptr cd_pos8[0], eax
    adc dword ptr cd_pos8[4], 0
    mov ebx, dword ptr cd_pos8[0]
    mov eax, dword ptr cd_pos8[4]
    cmp eax, dword ptr cd_size8[4]
    jb near l_cd_find_file_25
    
    ja l_cd_find_file_26
      cmp ebx, dword ptr cd_size8[0]
      jb near l_cd_find_file_25
  
  // not found
  l_cd_find_file_26:
  call fs_next_edx
  cmp byte ptr [es:edx], 0
  jz l_cd_find_file_27
    mov al, ERC_PATH_NOT_FOUND
    jmp l_cd_find_file_9
    
  l_cd_find_file_27:
  mov al, ERC_FILE_NOT_FOUND
  jmp l_cd_find_file_9

l_cd_find_file_28:
// found
mov ebx, dword ptr fd_buffer[2]
mov ecx, dword ptr fd_buffer[10]
call fs_next_edx
cmp byte ptr [es:edx], 0
jnz near l_cd_find_file_22

mov al, 0
jmp short l_cd_find_file_9

l_cd_find_file_29:
  pop edx
cmp al, ERC_FS
jz l_cd_find_file_26

l_cd_find_file_9:
ret

// IN: cd_dtm
// OUT: edx:eax = ftime
cd_mktime:
mov al, cd_dtm[0]
and al, 15
movzx eax, al
mov ecx, 10
mul ecx

movzx ebx, cd_dtm[1]
and bl, 15
add eax, ebx
mul ecx

mov bl, cd_dtm[2]
and bl, 15
add eax, ebx
mul ecx

mov bl, cd_dtm[3]
and bl, 15
add eax, ebx
mov esi, eax  // esi = year

mov al, cd_dtm[4]
and al, 15
movzx eax, al
mul ecx

mov bl, cd_dtm[5]
and bl, 15
add eax, ebx
shl esi, 4
add esi, eax  // esi = year << 4 + month

mov al, cd_dtm[6]
and al, 15
movzx eax, al
mul ecx

mov bl, cd_dtm[7]
and bl, 15
add eax, ebx
shl esi, 5
add eax, esi  // eax = (year << 4 + month) << 5 + date
call t_systime2ftime_days
mov esi, eax  // esi = days

movzx eax, byte ptr cd_dtm[8]
and al, 15
movzx eax, al
mov ecx, 10
mul ecx

movzx ebx, byte ptr cd_dtm[9]
and bl, 15
add eax, ebx
mov ebx, 60
mul ebx
mov edi, eax  // edi = hour * 60

mov al, cd_dtm[10]
and al, 15
movzx eax, al
mul ecx

mov bl, cd_dtm[11]
and bl, 15
add eax, ebx
add eax, edi
mov ebx, 60
mul ebx
mov edi, eax  // edi = (hour * 60 + min) * 60

mov al, cd_dtm[12]
and al, 15
movzx eax, al
mul ecx

mov bl, cd_dtm[13]
and bl, 15
add eax, ebx
add edi, eax  // edi = (hour * 60 + min) * 60 + second

mov eax, esi
mov ecx, 86400
mul ecx
add eax, edi
adc edx, 0

pushfd
  cli
  mov dword ptr t_time[0], eax
  xchg eax, edx
  mov ecx, 10000000
  mul ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  mul ecx
  add edx, dword ptr t_time[4]  // edx:eax = edx:eax * 10000000
popfd

ret

cd_init:
mov cd_lba, -1
mov cd_ldiskn, -1
ret

cd_devicechange:
mov cd_lba, -1
mov cd_ldiskn, -1
ret

// IN: es:edx -> filenamez, esi -> files, al = ldiskn, ebx = sector
// OUT: al = 0 || erc, esi = fhandle
cd_fopen:
cmp al, cd_ldiskn
jz l_cd_fopen_01
  push edx
   push ebx
    push esi
      call cd_prepare
    pop esi
   pop ebx
  pop edx

l_cd_fopen_01:

mov al, files.mode[esi]
and al, 3Fh
cmp al, 3
jna l_cd_fopen_05
  mov al, ERC_READ_ONLY
  
  l_cd_fopen_x:
  mov files.mode[esi], 0
  xor esi, esi
  jmp l_cd_fopen_9
  
l_cd_fopen_05:

push esi
  call cd_find_file  
pop esi
or al, al
jnz l_cd_fopen_x

mov dword ptr files.size[esi], ecx
mov files.file[esi], ebx
mov eax, ebx
shr eax, 32 - 11
shl ebx, 11
mov dword ptr files.sectn[esi], ebx // sectn = disk ofs
mov dword ptr files.sectn[esi + 4], eax
xor eax, eax
mov dword ptr files.pos[esi], eax
mov dword ptr files.pos[esi + 4], eax

shr esi, 5 // assert sizeof OpenFileRec = 32
mov al, 0

l_cd_fopen_9:
ret

// IN: esi -> files, edx:ebx = file offset
cd_fsetpos:
cmp edx, dword ptr files.size[esi + 4]
jb l_cd_fsetpos_3
ja l_cd_fsetpos_2
cmp ebx, dword ptr files.size[esi]
jna l_cd_fsetpos_3

l_cd_fsetpos_2:
mov ebx, dword ptr files.size[esi]
mov edx, dword ptr files.size[esi + 4]

l_cd_fsetpos_3:
mov dword ptr files.pos[esi], ebx
mov dword ptr files.pos[esi + 4], edx
ret

cd_fclose:
mov files.mode[esi], 0
mov al, 0
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizeread
cd_fread:
mov al, files.disk[esi]
cmp al, cd_ldiskn
jz cd_find_fread_1
  push esi
   push edi
    push ecx
      call cd_prepare
    pop ecx
   pop edi
  pop esi
  
cd_find_fread_1:
mov eax, dword ptr files.pos[esi + 0]
mov edx, dword ptr files.pos[esi + 4]
add eax, ecx
adc edx, 0
cmp edx, dword ptr files.size[esi + 4]
jb l_cd_fread_5
  ja l_cd_fread_2
    cmp eax, dword ptr files.size[esi + 0]
    jna l_cd_fread_5
    
  l_cd_fread_2:
  mov eax, dword ptr files.size[esi + 0]
  //mov edx, dword ptr files.size[esi + 4]
  sub eax, dword ptr files.pos[esi + 0]
  //sbb edx, dword ptr files.pos[esi + 0]
  mov ecx, eax

l_cd_fread_5:
mov ah, 2
mov al, cd_ldiskn
mov ebx, dword ptr files.sectn[esi + 0]
mov edx, dword ptr files.sectn[esi + 4]
add ebx, dword ptr files.pos[esi + 0]
adc edx, dword ptr files.pos[esi + 4]
add dword ptr files.pos[esi + 0], ecx
adc dword ptr files.pos[esi + 4], 0
push ecx
  call cd_diskmain
pop ecx
ret

// IN: es:edx -> pathz, al = ldiskn
cd_cd:
cmp al, cd_ldiskn
jz l_cd_cd_1
  mov cd_ldiskn, al
  push edx
    call cd_prepare
  pop edx

l_cd_cd_1:
xor ebx, ebx
call cd_find_file
or al, al
jnz l_cd_cd_9
  
  mov edx, p_current
  mov al, cd_ldiskn
  mov [es:edx + offset ThreadRec.curdisk], al
  mov [es:edx + offset ThreadRec.curdir], ebx
  mov [es:edx + offset ThreadRec.curdirsize], ecx
  mov al, 0
  
l_cd_cd_9:
ret

// IN: al = ldiskn, ebx = dir, es:edx -> dirmask, fs_rec, fs_srchofs
cd_find_first:
cmp al, cd_ldiskn
jz l_cd_find_first_01
  push edx
   push ebx
    call cd_prepare
   pop ebx
  pop edx

l_cd_find_first_01:
call fs_split  // KEEP ebx
test al, al
jnz l_cd_find_first_9

// Find dir  IN: ebx, hd_buffer
mov edx, VA_SYSTEM + offset hd_buffer

cmp byte ptr [es:edx], 0
jnz l_cd_find_first_36
  
  // no path
  test ebx, ebx
  jnz l_cd_find_first_35
    // ebx = 0 => root
    mov ebx, cd_rootlb
    mov ecx, cd_rootsize
    jmp short l_cd_find_first_38
    
  l_cd_find_first_35:
  // not root, get size
  mov ecx, p_current
  mov ecx, [es:ecx + offset ThreadRec.curdirsize]
  jmp short l_cd_find_first_38
  
l_cd_find_first_36:
// find dir
call cd_find_file
or al, al
jnz l_cd_find_first_9

l_cd_find_first_38:
// set srch[fs_srchofs]
mov esi, fs_srchofs
mov dword ptr srch.Cluster[esi], ebx
mov srch.Size[esi], ecx
xor eax, eax
mov srch.Offset[esi], eax

call cd_find_next

or al, al
jz l_cd_find_first_99

l_cd_find_first_9:
mov esi, fs_srchofs
mov word ptr srch.ThreadId[esi], -1

l_cd_find_first_99:
ret

// IN: fs_rec, fs_srchofs, cd_ldiskn, cd_diskmain
// OUT: al = 0 || erc
cd_find_next:
mov esi, fs_srchofs
mov al, srch.Disk[esi]
cmp al, cd_ldiskn
jz cd_find_next_1
  call cd_prepare

// Prepare values
cd_find_next_1:
  mov esi, fs_srchofs
  mov ebx, dword ptr srch.Cluster[esi]
  mov edx, ebx
  shr edx, 32 - 11
  shl ebx, 11
  mov eax, srch.Offset[esi]
  cmp eax, dword ptr srch.Size[esi]
  jb cd_find_next_18
    mov al, 1
    jmp cd_find_next_9
    
  cd_find_next_18:
  add ebx, eax
  adc edx, 0
  
  // Load LEN_DR  IN: esi  OUT: fd_buffer, ldiskn
  mov ah, 2
  mov al, srch.Disk[esi]
  mov cd_ldiskn, al
  mov ecx, 1
  mov edi, offset fd_buffer + VA_SYSTEM
  push ebx
   push edx
    call cd_diskmain
   pop edx
  pop ebx
  
  or al, al
  jnz near cd_find_next_9
  
  // Load DirRec
  mov ah, 2
  mov al, cd_ldiskn
  movzx ecx, byte ptr fd_buffer[0]
  dec ecx
  cmp ecx, 255
  jna cd_find_next_255
    mov al, 1 // ERC_FS
    jmp cd_find_next_9
    
  cd_find_next_255:
  add ebx, 1
  adc edx, 0
  mov edi, offset fd_buffer + 1 + VA_SYSTEM
  call cd_diskmain
  
  or al, al
  jnz near cd_find_next_9
  
  // Convert to UTF-8: fd_buffer -> hd_buffer
  movzx ecx, byte ptr fd_buffer[32]
  mov esi, offset fd_buffer + 33
  mov edi, VA_SYSTEM + offset hd_buffer
  cld
  cmp cd_escape, CD_ESCAPE
  jz cd_find_next_3
    // not Unicode
    rep movsb
    mov al, 0
    stosb
    jmp cd_find_next_4
    
  // Unicode
  cd_find_next_3:
    mov fs_bigendian, 1
    call fs_toutf8  // keep edx
  
  cd_find_next_4:
  
  or al, al
  jnz cd_find_next_56
  
    // self, parent
    mov al, 1  // not found
    cmp byte ptr hd_buffer[0], 32 // space
    jb cd_find_next_56
    
      // IsMatch?
      mov esi, fs_srchofs
      add esi, offset srch.FileMask
      mov edi, offset hd_buffer
      call fs_ismatch
    
  cd_find_next_56:
  // LEN_DR
  movzx ecx, byte ptr fd_buffer[0]
  // LEN_EXT
  movzx ebx, byte ptr fd_buffer[1]
  add ecx, ebx
  
  mov esi, fs_srchofs
  add srch.Offset[esi], ecx  // Offset + LEN_DR + LEN_EXT
  
  or al, al
  jnz near cd_find_next_1
  
// Found
mov edi, fs_rec
xor eax, eax
push edi
  mov ecx, 7
  rep stosd
pop edi

// File size
mov ecx, dword ptr fd_buffer[10]
mov [es:edi + offset SearchRec.FileSize], ecx
xor edx, edx
mov [es:edi + offset SearchRec.FileSize + 4], edx

// File attributes
movzx eax, byte ptr fd_buffer[25]
and al, 2  // directory
shl al, 3
mov [es:edi + offset SearchRec.FileAttributes], eax

// File times
mov eax, dword ptr cd_ftime[0]
mov edx, dword ptr cd_ftime[4]
mov [es:edi + offset SearchRec.CreationTime], eax
mov [es:edi + offset SearchRec.CreationTime + 4], edx
mov [es:edi + offset SearchRec.LastAccessTime], eax
mov [es:edi + offset SearchRec.LastAccessTime + 4], edx
mov [es:edi + offset SearchRec.LastWriteTime], eax
mov [es:edi + offset SearchRec.LastWriteTime + 4], edx

// File name
mov esi, offset hd_buffer
mov edi, fs_rec
add edi, offset SearchRec.FileName
mov ecx, MAX_PATH

cd_find_next_61:
  lodsb
  stosb
  cmp al, 0
  jz cd_find_next_68
    loop cd_find_next_61

mov al, ERC_TOO_LONG

cd_find_next_68:
  
//mov al, 0

cd_find_next_9:
ret

// IN: esi = offset to files
// OUT: al = erc, edx:ecx = ftime
cd_get_mtime:
mov edx, dword ptr cd_ftime[4]
mov ecx, dword ptr cd_ftime[0]
ret

EXT2_BAD_INO         = 1
EXT2_ROOT_INO        = 2
EXT2_ACL_IDX_INO     = 3
EXT2_ACL_DATA_INO    = 4
EXT2_BOOT_LOADER_INO = 5
EXT2_UNDEL_DIR_INO   = 6
EXT2_FIRST_INO       = 11

EXT2_FT_UNKNOWN  = 0
EXT2_FT_REG_FILE = 1
EXT2_FT_DIR      = 2
EXT2_FT_CHRDEV   = 3
EXT2_FT_BLKDEV   = 4
EXT2_FT_FIFO     = 5
EXT2_FT_SOCK     = 6
EXT2_FT_SYMLINK  = 7

EXT2_S_IFSOCK = 0xC000 //socket (i_mode)
EXT2_S_IFLNK  = 0xA000 //symbolic link
EXT2_S_IFREG  = 0x8000 //regular file
EXT2_S_IFBLK  = 0x6000 //block device
EXT2_S_IFDIR  = 0x4000 //directory
EXT2_S_IFCHR  = 0x2000 //character device
EXT2_S_IFIFO  = 0x1000

MAX_LINK_DEPTH = 64

SINGLE_INDIRECT = 12 * 4
DOUBLE_INDIRECT = 13 * 4
TRIPLE_INDIRECT = 14 * 4

EXT2_S_ISUID = 0x0800 //Set process User ID
EXT2_S_ISGID = 0x0400 //Set process Group ID
EXT2_S_ISVTX = 0x0200 //sticky bit
EXT2_S_IFSYS = 0x0200 //system file (only starter)

EXT2_S_IRUSR = 0x0100 //user read
EXT2_S_IWUSR = 0x0080 //user write
EXT2_S_IXUSR = 0x0040 //user execute
EXT2_S_IRGRP = 0x0020 //group read
EXT2_S_IWGRP = 0x0010 //group write
EXT2_S_IXGRP = 0x0008 //group execute
EXT2_S_IROTH = 0x0004 //others read
EXT2_S_IWOTH = 0x0002 //others write
EXT2_S_IXOTH = 0x0001 //others execute

ACCESS_R = 4 //read
ACCESS_W = 2 //write
ACCESS_X = 1 //execute

ACCESS_DEFAULT = (ACCESS_R|ACCESS_W|ACCESS_X)<<6 | ((ACCESS_R|ACCESS_X)<<3) | ACCESS_R|ACCESS_X

struct SuperBlock{
  uns4 s_inodes_count, s_blocks_count, s_r_blocks_count, s_free_blocks_count
  uns4 s_free_inodes_count, s_first_data_block, s_log_block_size
  uns4 s_log_frag_size, s_blocks_per_group, s_frags_per_group
  uns4 s_inodes_per_group, s_mtime, s_wtime
  uns2 s_mnt_count, s_max_mnt_count, s_magic, s_state, s_errors
  uns2 s_minor_rev_level
  uns4 s_lastcheck, s_checkinterval, s_creator_os, s_rev_level
  uns2 s_def_resuid, s_def_resgid
  uns4 s_first_ino
  uns2 s_inode_size, s_block_group_nr
  uns4 s_feature_compat, s_feature_incompat, s_feature_ro_compat
  //...
}

struct GroupBlock{
  uns4 bg_block_bitmap, bg_inode_bitmap, bg_inode_table
  uns2 bg_free_blocks_count, bg_free_inodes_count
  uns2 bg_used_dirs_count, bg_pad
  uns1 bg_reserved[12]
}

struct INode{
  uns2 i_mode, i_uid
  uns4 i_size, i_atime, i_ctime, i_mtime, i_dtime
  uns2 i_gid, i_links_count
  uns4 i_blocks, i_flags, i_osd1
  uns4 i_block[15]
  uns4 i_generation, i_file_acl, i_dir_acl/*size 32-63*/, i_faddr
  uns1 i_osd[12]
}

struct E2DirEntry{
  uns4 ino
  uns2 rec_len
  uns1 name_len, file_type
}

uns1 e2_ldiskn, e2_ldiskn2, e2_diflink, e2_isdir, e2_islink
char e2_name2[MAX_PATH]

[dalign 32]
uns4 e2_diskmain, e2_relofs, e2_endrelofs, e2_block, e2_count, e2_tmp
uns4 e2_parentino, e2_parentino2, e2_ofs_bm, e2_group, e2_group0, e2_group1
uns4 e2_first1, e2_first2, e2_first3, e2_i1, e2_i2, e2_i3, e2_mid
uns4 e2_len, e2_ofs, e2_ofs2, e2_nameofs, e2_fileino, e2_inon
uns4 e2_groups, e2_gblocks

SuperBlock e2_sb
GroupBlock e2_gb
INode e2_inode
E2DirEntry e2_dir, e2_dir2

[dalign 64]
uns8 e2_inoa, e2_disksize

// IN: al = ldiskn
// OUT: al = erc, e2_ldiskn, e2_sb, e2_diskmain
e2_prepare:
mov e2_ldiskn, al

// diskmain
movzx esi, al
shl esi, 5  // log2(DiskInfoRec)
mov esi, disk_info.main[esi]
or esi, esi
jnz l_e2_prepare_0
  mov al, ERC_INVALID_DISK_NUMBER
  jmp short l_e2_prepare_9

l_e2_prepare_0:
mov e2_diskmain, esi

// super block
mov ah, 2  // read
mov al, e2_ldiskn
xor edx, edx
mov ebx, 1024
mov ecx, sizeof SuperBlock
mov edi, VA_SYSTEM + offset e2_sb
call e2_diskmain

test al, al
jnz l_e2_prepare_9
  mov eax, e2_sb.s_blocks_per_group
  test eax, eax
  jnz l_e2_prepare_8
    mov al, ERC_FS
    jmp short l_e2_prepare_9

l_e2_prepare_8:
mov al, 0

l_e2_prepare_9:
ret

// IN: ebx = groupn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, e2_gb, e2_group
e2_load_group:
mov eax, ebx
mov e2_group, eax
shl eax, 5  // group block size log
mov cl, byte ptr e2_sb.s_log_block_size
cmp cl, 0
jnz l_e2_load_group_2
  // 1024
  add eax, 2048
  jmp short l_e2_load_group_3
  
l_e2_load_group_2:
// 2048, 4096, 8192
mov ebx, 1024
shl ebx, cl
add eax, ebx

l_e2_load_group_3:
// load group descriptor
xor edx, edx
mov ebx, eax
mov ecx, 1 << 5  // group block size log
mov edi, VA_SYSTEM + offset e2_gb
mov ah, 2  // read
mov al, e2_ldiskn
call e2_diskmain
ret

// IN: ebx = groupn, e2_gb, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
e2_save_group_and_super:
mov eax, ebx
shl eax, 5  // group block size log
mov cl, byte ptr e2_sb.s_log_block_size
cmp cl, 0
jnz l_e2_save_group_and_super_2
  // 1024
  add eax, 2048
  jmp short l_e2_save_group_and_super_3
  
l_e2_save_group_and_super_2:
// 2048, 4096, 8192
mov ebx, 1024
shl ebx, cl
add eax, ebx

l_e2_save_group_and_super_3:
// save group descriptor
xor edx, edx
mov ebx, eax
mov ecx, 6
mov edi, VA_SYSTEM + offset e2_gb + offset GroupBlock.bg_free_blocks_count
add ebx, offset GroupBlock.bg_free_blocks_count
mov ah, 3  // write
mov al, e2_ldiskn
call e2_diskmain
test al, al
jnz l_e2_save_group_and_super_9

// save superblock
xor edx, edx
mov ebx, 1024
mov ecx, 8
mov edi, VA_SYSTEM + offset e2_sb + offset SuperBlock.s_free_blocks_count
add ebx, offset SuperBlock.s_free_blocks_count
mov ah, 3  // write
mov al, e2_ldiskn
call e2_diskmain

l_e2_save_group_and_super_9:
ret

// IN: ebx = bitmap blockn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, e2_ofs_bm = rel
e2_add_to_bitmap:
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, ebx
shl ebx, cl
xor cl, 31
inc cl  // cl = 32 - cl
shr edx, cl

xor eax, eax
mov e2_ofs_bm, eax

l_e2_add_to_bitmap_5:
mov cl, byte ptr e2_sb.s_log_block_size
mov eax, 1024
shl eax, cl
cmp e2_ofs_bm, eax
jnb near l_e2_add_to_bitmap_7

mov edi, VA_SYSTEM + offset hd_buffer
mov ecx, 512
mov ah, 2  // read
mov al, e2_ldiskn
push edx
 push ebx
  call e2_diskmain
 pop ebx
pop edx
test al, al
jnz near l_e2_add_to_bitmap_9

xor esi, esi

l_e2_add_to_bitmap_55:  // KEEP edx, ebx
cmp byte ptr hd_buffer[esi], 255
jnz l_e2_add_to_bitmap_6
  inc esi
  cmp esi, 512
  jb l_e2_add_to_bitmap_55
    add e2_ofs_bm, 512
    
    add ebx, 512
    adc edx, 0
    
    jmp short l_e2_add_to_bitmap_5  // not found

l_e2_add_to_bitmap_6: // free place found
add e2_ofs_bm, esi
mov ah, hd_buffer[esi]
mov al, 1
xor ecx, ecx

l_e2_add_to_bitmap_61:
  test al, ah
  jz l_e2_add_to_bitmap_64
    inc cl
    shl al, 1
    jmp short l_e2_add_to_bitmap_61

l_e2_add_to_bitmap_64:
or ah, al
mov hd_buffer[esi], ah
shl e2_ofs_bm, 3
add e2_ofs_bm, ecx  // e2_ofs_bm * 8 + cl

// write hd_buffer[esi], DESTROY ebx, edx
mov edi, VA_SYSTEM + offset hd_buffer
add edi, esi
add ebx, esi
adc edx, 0
mov ecx, 1
mov ah, 3  // write
mov al, e2_ldiskn
call e2_diskmain
jmp short l_e2_add_to_bitmap_9

l_e2_add_to_bitmap_7:
mov al, ERC_OUT_OF_RANGE

l_e2_add_to_bitmap_9:
ret

// IN: esi = relative number, edx = bitmap blockn
// OUT: al = erc
e2_rm_from_bitmap:
mov ebx, esi
shr ebx, 3
// read bitmap
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov eax, edx
shl eax, cl
xor cl, 31
inc cl
shr edx, cl
or ebx, eax
mov edi, VA_SYSTEM + offset e2_tmp
mov ecx, 1
mov ah, 2  // read
mov al, e2_ldiskn
push ebx
 push edx
  push esi
    call e2_diskmain
  pop ecx  // ecx = rel
 pop edx
pop ebx
test al, al
jnz l_e2_rm_from_bitmap_9

// free bitmap, KEEP edx, ebx
and cl, 7
mov al, 1
shl al, cl
test byte ptr e2_tmp, al
jnz l_e2_rm_from_bitmap_6
  mov al, ERC_FS
  jmp short l_e2_rm_from_bitmap_9
  
l_e2_rm_from_bitmap_6:
not al
and byte ptr e2_tmp, al

// write bitmap
mov edi, VA_SYSTEM + offset e2_tmp
mov ecx, 1
mov ah, 3  // write
mov al, e2_ldiskn
call e2_diskmain

l_e2_rm_from_bitmap_9:
ret

// IN: ebx = groupn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = new block
e2_alloc:
mov e2_group0, ebx
mov e2_group, ebx

mov eax, e2_sb.s_blocks_count
mov ecx, e2_sb.s_blocks_per_group
dec eax
dec eax
xor edx, edx
div ecx
inc eax  // eax = groups
mov e2_groups, eax

l_e2_alloc_1:
call e2_load_group
test al, al
jnz near l_e2_alloc_9

movzx eax, e2_gb.bg_free_blocks_count
test eax, eax
jz near l_e2_alloc_7  // next group

mov ebx, e2_gb.bg_block_bitmap
call e2_add_to_bitmap  // out e2_ofs_bm
test al, al
jnz near l_e2_alloc_9

// free place
dec e2_gb.bg_free_blocks_count
dec e2_sb.s_free_blocks_count

// write gb
mov ebx, e2_group
call e2_save_group_and_super
test al, al
jnz l_e2_alloc_9

// ebx = e2_ofs_bm + first_block_in_group
// first_block_in_group = (s_inodes_per_group * s_inode_size)
//   >> (s_log_block_size + 10) + bg_inode_table
mov eax, e2_sb.s_inodes_per_group
movzx ecx, e2_sb.s_inode_size
mul ecx
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
shr eax, cl
add eax, e2_gb.bg_inode_table
add eax, e2_ofs_bm
mov ebx, eax
xor eax, eax
jmp l_e2_alloc_9

l_e2_alloc_7:
// next group
inc e2_group
mov ebx, e2_group
cmp ebx, e2_group0
jnz l_e2_alloc_71
  
  l_e2_alloc_70:
  mov al, ERC_DISK_FULL
  xor ebx, ebx
  jmp short l_e2_alloc_9
  
l_e2_alloc_71:
cmp ebx, e2_groups
jb near l_e2_alloc_1

xor ebx, ebx
cmp ebx, e2_group0
jz l_e2_alloc_70

jmp l_e2_alloc_1

l_e2_alloc_9:
mov edx, e2_group0
cmp edx, e2_group
jz l_e2_alloc_99
  push eax
   push ebx
    mov ebx, edx
    call e2_load_group
   pop ebx
  pop eax

l_e2_alloc_99:
ret

// IN: ebx = groupn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = new block
e2_alloc_zero:
call e2_alloc
test al, al
jnz l_e2_alloc_zero_9
  push ebx
    // zero buffer
    xor eax, eax
    mov edi, VA_SYSTEM + offset hd_buffer
    mov ecx, 512 / 4
    cld
    rep stosd
    // calc sectn
    mov edx, ebx
    mov cl, byte ptr e2_sb.s_log_block_size
    add cl, 10
    shl ebx, cl
    xor cl, 31
    inc cl
    shr edx, cl
    // write buffer
    mov cl, byte ptr e2_sb.s_log_block_size
    mov eax, 2 // 1024/512
    shl eax, cl
    xchg eax, ecx
    
    l_e2_alloc_zero_5:
      push ecx
       push edx
        push ebx
          mov edi, VA_SYSTEM + offset hd_buffer
          mov ecx, 512
          mov ah, 3  // write
          mov al, e2_ldiskn
          call e2_diskmain
        pop ebx
       pop edx
      pop ecx
      test al, al
      jnz l_e2_alloc_zero_59

      add ebx, 512
      adc edx, 0
      loop l_e2_alloc_zero_5
    
    l_e2_alloc_zero_59:
  pop ebx
  
l_e2_alloc_zero_9:
ret

// IN: ebx = blockn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
// KEEP: ebx
e2_free:
push ebx
  mov eax, ebx
  test eax, eax
  jz near l_e2_free_9
  
  dec eax
  xor edx, edx
  div dword ptr e2_sb.s_blocks_per_group
  // eax = groupn, edx = blockn in group
  xchg eax, ebx
  push eax
    call e2_load_group
  pop ebx  // ebx = blockn
  test al, al
  jnz near l_e2_free_9

  mov eax, e2_sb.s_inodes_per_group
  movzx edx, e2_sb.s_inode_size
  mul edx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  shr eax, cl
  add eax, e2_gb.bg_inode_table
  sub ebx, eax
  mov esi, ebx  // esi = relative block number
  
  mov edx, e2_gb.bg_block_bitmap
  call e2_rm_from_bitmap
  test al, al
  jnz l_e2_free_9
  
  // inc
  inc e2_sb.s_free_blocks_count
  inc e2_gb.bg_free_blocks_count
  mov ebx, e2_group
  call e2_save_group_and_super
  
  l_e2_free_9:
pop ebx
ret

// IN: e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = inon
e2_alloc_inode:
mov eax, e2_sb.s_blocks_count
dec eax
xor edx, edx
div e2_sb.s_blocks_per_group
inc eax
mov esi, eax  // esi = blocks
xor ebx, ebx

l_e2_alloc_inode_1:
cmp ebx, esi
jnb l_e2_alloc_inode_6
  push esi
    call e2_load_group  // OUT e2_group
    mov ebx, e2_group
  pop esi
  cmp e2_gb.bg_free_inodes_count, 0
  jz l_e2_alloc_inode_next
    cmp e2_gb.bg_free_blocks_count, 0
    jz l_e2_alloc_inode_next
      // found
      mov ebx, e2_gb.bg_inode_bitmap
      call e2_add_to_bitmap  // OUT e2_ofs_bm
      test al, al
      jnz l_e2_alloc_inode_9
      
      // free place
      dec e2_gb.bg_free_inodes_count
      dec e2_sb.s_free_inodes_count
      
      // write gb
      mov ebx, e2_group
      call e2_save_group_and_super
      test al, al
      jnz l_e2_alloc_inode_9
      
      // out
      mov eax, e2_sb.s_inodes_per_group
      mul e2_group
      inc eax
      mov ebx, eax
      add ebx, e2_ofs_bm
      xor eax, eax
      jmp short l_e2_alloc_inode_9
      
  l_e2_alloc_inode_next:
  inc ebx
  jmp l_e2_alloc_inode_1

l_e2_alloc_inode_6:
xor ebx, ebx
mov al, ERC_DISK_FULL

l_e2_alloc_inode_9:
ret

// IN: ebx = inon, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
// KEEP: ebx
e2_free_inode:
push ebx
  mov eax, ebx
  test eax, eax
  jz near l_e2_free_inode_9
  
  dec eax
  xor edx, edx
  div dword ptr e2_sb.s_inodes_per_group
  // eax = groupn, edx = inode in group
  xchg eax, ebx
  push edx
    call e2_load_group
  pop edx
  test al, al
  jnz near l_e2_free_inode_9
  
  mov esi, edx  // esi = relative inode number
  mov edx, e2_gb.bg_inode_bitmap
  call e2_rm_from_bitmap
  test al, al
  jnz l_e2_free_inode_9
  
  // inc
  inc e2_sb.s_free_inodes_count
  inc e2_gb.bg_free_inodes_count
  mov ebx, e2_group
  call e2_save_group_and_super
  
  l_e2_free_inode_9:
pop ebx
ret

l_e2_load_inode_x:
mov al, ERC_FS
ret

// IN: ebx = ino, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, e2_inode, e2_inoa = disk offset of inode, e2_inon
e2_load_inode:
mov eax, ebx
mov e2_inon, eax
dec eax
mov ecx, e2_sb.s_inodes_per_group
xor edx, edx
jecxz l_e2_load_inode_x

div ecx  // eax = group, edx = inode in group
mov ebx, eax
push edx
  call e2_load_group
pop edi
test al, al
jnz l_e2_load_inode_9

// load inode
mov ebx, e2_gb.bg_inode_table
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, ebx
shl ebx, cl
xor cl, 31 // cl = 32 - cl
inc cl
shr edx, cl

mov ax, e2_sb.s_inode_size
cmp ax, 128
jnz l_e2_load_inode_4
  // inode size = 128
  shl edi, 7
  jmp short l_e2_load_inode_5
  
l_e2_load_inode_4:
// inode size = 256
shl edi, 8

l_e2_load_inode_5:
add ebx, edi
adc edx, 0

mov ecx, sizeof INode
mov edi, VA_SYSTEM + offset e2_inode
mov ah, 2  // read
mov al, e2_ldiskn
mov dword ptr e2_inoa[0], ebx
mov dword ptr e2_inoa[4], edx
call e2_diskmain

l_e2_load_inode_9:
ret

// IN: e2_inoa, e2_inode, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc
// KEEP: edx, edi
e2_save_inode:
push edx
 push edi
  mov ecx, sizeof INode
  mov edi, VA_SYSTEM + offset e2_inode
  mov ah, 3  // write
  mov al, e2_ldiskn
  mov ebx, dword ptr e2_inoa[0]
  mov edx, dword ptr e2_inoa[4]
  call e2_diskmain
 pop edi
pop edx
ret

// IN: ebx = disk blockn, eax = subblockn, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = disk blockn
// KEEP: edi
e2_read_blockn:
push edi
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  shl eax, 2
  add ebx, eax
  adc edx, 0
  
  mov ecx, 4
  mov ah, 2  // read
  mov al, e2_ldiskn
  mov edi, VA_SYSTEM + offset e2_tmp
  call e2_diskmain
pop edi
mov ebx, e2_tmp
ret

// IN: ebx = disk blockn, eax = subblockn, ch = zero, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = disk blockn
// KEEP: edi
e2_rw_blockn:
push edi
 push ecx

  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  shl eax, 2
  add ebx, eax
  adc edx, 0
  
  mov ecx, 4
  mov ah, 2  // read
  mov al, e2_ldiskn
  mov edi, VA_SYSTEM + offset e2_tmp
  push edx
   push ebx
    call e2_diskmain
   pop ebx
  pop edx

 pop ecx
pop edi
test al, al
jnz l_e2_rw_blockn_9

mov esi, e2_tmp
test esi, esi
jnz l_e2_rw_blockn_9
  push edi

   push edx
    push ebx
      mov ebx, e2_group
      test ch, ch
      jnz l_e2_rw_blockn_6
        // zero
        call e2_alloc_zero
        jmp short l_e2_rw_blockn_7
      
      l_e2_rw_blockn_6:
      // not zero
      call e2_alloc
    
      l_e2_rw_blockn_7:
      mov e2_tmp, ebx
    pop ebx
   pop edx
   
   test al, al
   jnz l_e2_rw_blockn_8
     mov ecx, 4
     mov ah, 3  // write
     mov al, e2_ldiskn
     mov edi, VA_SYSTEM + offset e2_tmp
     call e2_diskmain
     
   l_e2_rw_blockn_8:
  pop edi
  
l_e2_rw_blockn_9:
mov ebx, e2_tmp
ret

// IN: ebx = disk blockn, eax = subblockn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
// KEEP: ebx
e2_zero_blockn:
push ebx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  shl eax, 2
  add ebx, eax
  adc edx, 0
  
  xor eax, eax
  mov e2_tmp, eax
  
  mov ecx, 4
  mov ah, 3  // write
  mov al, e2_ldiskn
  mov edi, VA_SYSTEM + offset e2_tmp
  call e2_diskmain
pop ebx
ret

// IN: e2_block(block in file), e2_sb, e2_inode, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, ebx = disk block
// KEEP: edi
e2_get_blockn:
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl  // esi = block_size / 4

l_e2_get_blockn_11:
mov eax, e2_block
cmp eax, 12
jnb l_e2_get_blockn_12
  // e2_block < 12
  shl eax, 2
  mov ebx, e2_inode.i_block[eax]
  mov al, 0
  ret

l_e2_get_blockn_12:
sub eax, 12
cmp eax, esi
jnb l_e2_get_blockn_13
  // single indirect
  mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
  call e2_read_blockn
  ret
  
l_e2_get_blockn_13:
sub eax, esi
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov edx, esi
shl edx, cl
cmp eax, edx
jnb near l_e2_get_blockn_14
  // double indirect
  push eax
   shr eax, cl
   mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
   call e2_read_blockn
  pop edx
  test al, al
  jnz l_e2_get_blockn_9
  
  xchg eax, edx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  mov esi, 1
  shl esi, cl
  dec esi
  and eax, esi
  call e2_read_blockn
  ret
  
l_e2_get_blockn_14:
// triple indirect
sub eax, edx
push eax
 mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
 mov cl, byte ptr e2_sb.s_log_block_size
 add cl, 10 - 2
 shr eax, cl
 shr eax, cl
 call e2_read_blockn
pop edx
test al, al
jnz l_e2_get_blockn_9

xchg eax, edx
push eax
 mov cl, byte ptr e2_sb.s_log_block_size
 add cl, 10 - 2
 mov esi, 1
 shl esi, cl
 dec esi
 shr eax, cl
 and eax, esi
 call e2_read_blockn
pop edx
test al, al
jnz l_e2_get_blockn_9

xchg eax, edx 
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl
dec esi
and eax, esi
call e2_read_blockn

l_e2_get_blockn_9:
ret

// IN: e2_block(block in file), e2_sb, e2_inode, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, ebx = disk block, requires e2_save_inode
// KEEP: edi
e2_set_blockn:
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl  // esi = block_size / 4

l_e2_set_blockn_11:
mov eax, e2_block
cmp eax, 12
jnb l_e2_set_blockn_12
  // e2_block < 12
  shl eax, 2
  mov ebx, e2_inode.i_block[eax]
  test ebx, ebx
  jnz near l_e2_set_blockn_8
    push eax
     push edi
      mov ebx, e2_group
      call e2_alloc
     pop edi
    pop edx
    test al, al
    jnz near l_e2_set_blockn_9
      mov e2_inode.i_block[edx], ebx
      ret

l_e2_set_blockn_12:
sub eax, 12
cmp eax, esi
jnb l_e2_set_blockn_13
  // single indirect
  mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
  test ebx, ebx
  jnz l_e2_set_blockn_126
    push eax
     push edi
      mov ebx, e2_group
      call e2_alloc_zero
     pop edi
    pop edx
    test al, al
    jnz near l_e2_set_blockn_9
      mov e2_inode.i_block[SINGLE_INDIRECT], ebx
      xchg eax, edx
    
  l_e2_set_blockn_126:
  mov ch, 1
  call e2_rw_blockn
  ret
  
l_e2_set_blockn_13:
sub eax, esi
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov edx, esi
shl edx, cl
cmp eax, edx
jnb near l_e2_set_blockn_14
  // double indirect
  push eax
    shr eax, cl
    mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
    test ebx, ebx
    jnz l_e2_set_blockn_136
      push eax
       push edi
        mov ebx, e2_group
        call e2_alloc_zero
       pop edi
      pop edx
      test al, al
      jnz l_e2_set_blockn_134
        mov e2_inode.i_block[DOUBLE_INDIRECT], ebx
        xchg eax, edx
        jmp short l_e2_set_blockn_136
    
      l_e2_set_blockn_134:
      pop edx
      jmp l_e2_set_blockn_9
      
    l_e2_set_blockn_136:
    mov ch, 0
    call e2_rw_blockn
  pop edx
  test al, al
  jnz near l_e2_set_blockn_9
  
  xchg eax, edx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  mov esi, 1
  shl esi, cl
  dec esi
  and eax, esi
  mov ch, 1
  call e2_rw_blockn
  ret
  
l_e2_set_blockn_14:
// triple indirect
sub eax, edx
push eax
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  shr eax, cl
  shr eax, cl
  
  // check overflow
  cmp eax, esi
  jb l_e2_set_blockn_141
    mov al, ERC_FILE_TOO_BIG
    xor ebx, ebx
    jmp l_e2_set_blockn_9
    
  l_e2_set_blockn_141:
  
  mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
  test ebx, ebx
  jnz l_e2_set_blockn_146
    push eax
     push edi
      mov ebx, e2_group
      call e2_alloc_zero
     pop edi
    pop edx
    test al, al
    jnz l_e2_set_blockn_144
      mov e2_inode.i_block[TRIPLE_INDIRECT], ebx
      xchg eax, edx
      jmp short l_e2_set_blockn_146
  
  l_e2_set_blockn_144:
  pop edx
  jmp l_e2_set_blockn_9
  
  l_e2_set_blockn_146:
  mov ch, 0
  call e2_rw_blockn
pop edx
test al, al
jnz l_e2_set_blockn_9

xchg eax, edx
push eax
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  mov esi, 1
  shl esi, cl
  dec esi
  shr eax, cl
  and eax, esi
  mov ch, 0
  call e2_rw_blockn
pop edx
test al, al
jnz l_e2_set_blockn_9

xchg eax, edx 
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl
dec esi
and eax, esi
mov ch, 1
call e2_rw_blockn
jmp short l_e2_set_blockn_9

l_e2_set_blockn_8:
mov al, 0

l_e2_set_blockn_9:
ret

// IN: edx:ebx = file offset, ecx = size, e2_sb
// OUT: e2_block, e2_count, e2_relofs, e2_endrelofs
// KEEP: edi
e2_prepare_values:
push edi
 push ecx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov esi, 1
  shl esi, cl
  dec esi  // esi = block_size - 1
  mov eax, ebx
  and eax, esi
  mov e2_relofs, eax

  mov eax, ebx
  shr eax, cl
  xor cl, 31
  inc cl
  mov edi, edx
  shl edi, cl
  or eax, edi
  mov e2_block, eax  // e2_block = file offset >> log_block_size
 pop ecx
 dec ecx
 add ebx, ecx
 adc edx, 0
 mov eax, ebx
 and eax, esi
 mov e2_endrelofs, eax

 mov cl, byte ptr e2_sb.s_log_block_size
 add cl, 10
 mov eax, ebx
 shr eax, cl
 xor cl, 31
 inc cl
 mov edi, edx
 shl edi, cl
 or eax, edi
 sub eax, e2_block
 inc eax
 mov e2_count, eax  // e2_count = (fofs + size - 1) >> log_bs - e2_block + 1
pop edi
ret

e2_read_x0:
mov al, 0
ret

// IN: e2_inode, edx:ebx = file offset, ecx = size, es:edi -> data
// OUT: al = 0 || erc
e2_read:
jecxz e2_read_x0

call e2_prepare_values  // KEEP edi

l_e2_read_2:
// read blocks
mov eax, e2_count
test eax, eax
jz l_e2_read_8
  call e2_get_blockn  // KEEP edi
  test al, al
  jnz l_e2_read_9
  
  test ebx, ebx
  jnz l_e2_read_21
    mov al, ERC_FS
    jmp short l_e2_read_9
    
  l_e2_read_21:
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov esi, 1
  shl esi, cl
  
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  
  mov eax, e2_count
  dec eax
  test eax, eax
  jnz l_e2_read_26  
    mov ecx, e2_endrelofs
    inc ecx
    jmp short l_e2_read_27
    
  l_e2_read_26:
  mov ecx, esi
  
  l_e2_read_27:
  mov eax, e2_relofs
  add ebx, eax
  adc edx, 0
  sub ecx, eax
  
  mov ah, 2
  mov al, e2_ldiskn
  push edi
   push ecx
    call e2_diskmain
   pop ecx
  pop edi
  test al, al
  jnz l_e2_read_9
  
  add edi, ecx
  
  xor eax, eax
  mov e2_relofs, eax
  inc e2_block
  dec e2_count
  jmp l_e2_read_2
  
l_e2_read_8:
mov al, 0

l_e2_read_9:
ret

e2_write_x0:
mov al, 0
ret

// IN: e2_inode, edx:ebx = file offset, ecx = size, es:edi -> data
// OUT: al = 0 || erc
e2_write:
jecxz e2_write_x0

call e2_prepare_values  // KEEP edi
  
l_e2_write_2:
// write blocks
mov eax, e2_count
test eax, eax
jz l_e2_write_8
  call e2_set_blockn  // KEEP edi
  test al, al
  jnz l_e2_write_9
  
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov esi, 1
  shl esi, cl
  
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  
  mov eax, e2_count
  dec eax
  test eax, eax
  jnz l_e2_write_26  
    mov ecx, e2_endrelofs
    inc ecx
    jmp short l_e2_write_27
    
  l_e2_write_26:
  mov ecx, esi
  
  l_e2_write_27:
  mov eax, e2_relofs
  add ebx, eax
  adc edx, 0
  sub ecx, eax
  
  mov ah, 3  // write
  mov al, e2_ldiskn
  push edi
   push ecx
    call e2_diskmain
   pop ecx
  pop edi
  test al, al
  jnz l_e2_write_9

  add edi, ecx
  
  xor eax, eax
  mov e2_relofs, eax
  inc e2_block
  dec e2_count
  jmp l_e2_write_2
  
l_e2_write_8:
mov al, 0

l_e2_write_9:
ret

// IN: edx:ebx = file pos, e2_inode, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
e2_delete:
mov e2_inode.i_size, ebx
mov e2_inode.i_dir_acl, edx

mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov esi, 1
shl esi, cl
dec esi
add ebx, esi
adc edx, 0

shr ebx, cl
xor cl, 31
inc cl
shl edx, cl
or ebx, edx  // ebx = file blockn

mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl  // esi = block_size / 4

mov eax, ebx
cmp eax, 12
jnb l_e2_delete_1
  mov edx, eax
  shl edx, 2
  
  l_e2_delete_05:
    mov ebx, e2_inode.i_block[edx]
    push edx
      call e2_free
    pop edx
    test al, al
    jnz near l_e2_delete_9
    
    xor eax, eax
    mov e2_inode.i_block[edx], eax
    add edx, 4
    cmp edx, 12 * 4
    jb l_e2_delete_05
  
  // eax = 0
  jmp short l_e2_delete_11
  
l_e2_delete_1:
sub eax, 12
cmp eax, esi
jnb near l_e2_delete_2
  // single indirect
  l_e2_delete_11:
  mov e2_first1, eax
  
  l_e2_delete_15:
    mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
    test ebx, ebx
    jz near l_e2_delete_18
    
    push eax
      call e2_read_blockn
    pop edx
    test al, al
    jnz near l_e2_delete_9
    
    push edx
      call e2_free
    pop edx
    test al, al
    jnz near l_e2_delete_9
    
    mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
    mov eax, edx
    push edx
      call e2_zero_blockn
    pop edx
    test al, al
    jnz near l_e2_delete_9
    
    xchg eax, edx
    inc eax
    
    mov cl, byte ptr e2_sb.s_log_block_size
    add cl, 10 - 2
    mov edx, 1
    shl edx, cl
    cmp eax, edx
    jb l_e2_delete_15
    
  cmp e2_first1, 0
  jnz l_e2_delete_18
    mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
    call e2_free
    test al, al
    jnz near l_e2_delete_9
    
    xor eax, eax
    mov e2_inode.i_block[SINGLE_INDIRECT], eax
    
  l_e2_delete_18:
  xor eax, eax
  jmp short l_e2_delete_21
  
l_e2_delete_2:
sub eax, esi
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov edx, esi
shl edx, cl
cmp eax, edx
jnb near l_e2_delete_3
  // double indirect
  l_e2_delete_21:
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  push eax
    shr eax, cl
    mov e2_first1, eax
    mov e2_i1, eax
  pop eax
  mov esi, 1
  shl esi, cl
  dec esi
  and eax, esi
  mov e2_first2, eax
  mov e2_i2, eax
  
  l_e2_delete_22:
    mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
    test ebx, ebx
    jz near l_e2_delete_27
    
    mov eax, e2_i1
    call e2_read_blockn
    test al, al
    jnz near l_e2_delete_9
    test ebx, ebx
    jz l_e2_delete_26
    
    l_e2_delete_24:
      push ebx
        mov eax, e2_i2
        call e2_read_blockn
      pop edx
      test al, al
      jnz near l_e2_delete_9
      
      push edx
        call e2_free
      pop ebx
      test al, al
      jnz near l_e2_delete_9
      
      mov eax, e2_i2
      call e2_zero_blockn
      test al, al
      jnz near l_e2_delete_9
      
      inc e2_i2
      mov cl, byte ptr e2_sb.s_log_block_size
      add cl, 10 - 2
      mov esi, 1
      shl esi, cl  // esi = block_size / 4
      cmp e2_i2, esi
      jb l_e2_delete_24
      
    cmp e2_first2, 0
    jnz l_e2_delete_26
      call e2_free
      test al, al
      jnz near l_e2_delete_9
      
      mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
      mov eax, e2_i1
      call e2_zero_blockn
      
    l_e2_delete_26:
    mov cl, byte ptr e2_sb.s_log_block_size
    add cl, 10 - 2
    mov esi, 1
    shl esi, cl  // esi = block_size / 4
    
    inc e2_i1
    xor eax, eax
    mov e2_i2, eax
    mov e2_first2, eax
    cmp e2_i1, esi
    jb near l_e2_delete_22
    
  cmp e2_first1, 0
  jnz l_e2_delete_27
    mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
    call e2_free
    test al, al
    jnz near l_e2_delete_9
    
    xor eax, eax
    mov e2_inode.i_block[DOUBLE_INDIRECT], eax
    
  l_e2_delete_27:
  xor eax, eax
  jmp short l_e2_delete_31

l_e2_delete_3:
// triple indirect
sub eax, edx

l_e2_delete_31:
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
push eax
  shr eax, cl
  shr eax, cl
  mov e2_first1, eax
  mov e2_i1, eax
pop eax
push eax
  shr eax, cl
  mov esi, 1
  shl esi, cl
  dec esi
  and eax, esi
  mov e2_first2, eax
  mov e2_i2, eax
pop eax
and eax, esi
mov e2_first3, eax
mov e2_i3, eax

  l_e2_delete_32:
  mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
  test ebx, ebx
  jz near l_e2_delete_37
  
  mov eax, e2_i1
  call e2_read_blockn
  test al, al
  jnz near l_e2_delete_9
  test ebx, ebx
  jz near l_e2_delete_36
  
  mov e2_mid, ebx
  
  l_e2_delete_33:
    mov ebx, e2_mid
    mov eax, e2_i2
    call e2_read_blockn
    test al, al
    jnz near l_e2_delete_9
    test ebx, ebx
    jz near l_e2_delete_35
    
    l_e2_delete_34:
      push ebx
        mov eax, e2_i3
        call e2_read_blockn
      pop edx
      test al, al
      jnz near l_e2_delete_9
      
      push edx
        call e2_free
      pop ebx
      test al, al
      jnz near l_e2_delete_9
      
      mov eax, e2_i3
      call e2_zero_blockn
      test al, al
      jnz near l_e2_delete_9
      
      // next i3
      inc e2_i3
      mov cl, byte ptr e2_sb.s_log_block_size
      add cl, 10 - 2
      mov esi, 1
      shl esi, cl  // esi = block_size / 4
      cmp e2_i3, esi
      jb l_e2_delete_34
      
    cmp e2_first3, 0
    jnz l_e2_delete_35
      call e2_free
      test al, al
      jnz near l_e2_delete_9
  
      mov ebx, e2_mid
      mov eax, e2_i2
      call e2_zero_blockn
    
    l_e2_delete_35:  // next i2
    mov cl, byte ptr e2_sb.s_log_block_size
    add cl, 10 - 2
    mov esi, 1
    shl esi, cl  // esi = block_size / 4
    
    inc e2_i2
    xor eax, eax
    mov e2_i3, eax
    mov e2_first3, eax
    cmp e2_i2, esi
    jb near l_e2_delete_33
    
  cmp e2_first2, 0
  jnz l_e2_delete_36
    mov ebx, e2_mid
    call e2_free
    test al, al
    jnz near l_e2_delete_9

    mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
    mov eax, e2_i1
    call e2_zero_blockn
  
  l_e2_delete_36:  // next i1
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  mov esi, 1
  shl esi, cl  // esi = block_size / 4
  
  inc e2_i1
  xor eax, eax
  mov e2_i2, eax
  mov e2_first2, eax
  cmp e2_i1, esi
  jb near l_e2_delete_32
  
cmp e2_first1, 0
jnz l_e2_delete_37
  mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
  call e2_free
  test al, al
  jnz near l_e2_delete_9
  
  xor eax, eax
  mov e2_inode.i_block[TRIPLE_INDIRECT], eax
  
l_e2_delete_37:

l_e2_delete_8:
call e2_save_inode

l_e2_delete_9:
ret

// IN: ebx = inode, edx -> path/filenamez, e2_parentino, e2_ldiskn
// OUT: al = erc, es:edx -> fs_link, ebx = dir
// USES: e2_diflink, fd_buffer
e2_follow_link:
inc link_depth
cmp link_depth, MAX_LINK_DEPTH
jna l_e2_follow_link_1
  mov al, ERC_INFINITE_LINK
  ret
  
l_e2_follow_link_04:
  // fast symlink
  mov esi, offset e2_inode.i_block
  mov edi, VA_SYSTEM + offset fd_buffer
  mov ecx, 60 / 4
  cld
  rep movsd
  mov byte ptr fd_buffer[60 - 1], 0
  
  xor ecx, ecx
  
  l_e2_follow_link_05:
    cmp byte ptr fd_buffer[ecx], 0
    jz l_e2_follow_link_62
      inc ecx
      jmp short l_e2_follow_link_05
  
l_e2_follow_link_1:
// load link to fd_buffer
push ebx
 push edx
  call e2_load_inode
  xor ebx, ebx
  xor edx, edx
  mov ecx, e2_inode.i_size
  cmp ecx, 60
  jb l_e2_follow_link_04
  
  cmp ecx, MAX_PATH - 1
  jb l_e2_follow_link_61
    mov ecx, MAX_PATH - 1
    
  l_e2_follow_link_61:
  mov edi, VA_SYSTEM + offset fd_buffer
  push ecx
    call e2_read
  pop ecx
  mov byte ptr fd_buffer[ecx], 0
  
  l_e2_follow_link_62:
 pop edx
pop ebx

// process path in fd_buffer
mov e2_diflink, 0
xor esi, esi
cmp fd_buffer[1], ':'
jnz l_e2_follow_link_64
  add esi, 2
  mov al, fd_buffer[0]
  and al, 31
  cmp al, e2_ldiskn
  jz l_e2_follow_link_64
    // differrent disk
    mov e2_diflink, ERC_LINK
    xor esi, esi
    jmp short l_e2_follow_link_66
  
l_e2_follow_link_64:
cmp byte ptr fd_buffer[esi], '/'
jnz l_e2_follow_link_65
  // starting at root
  mov ebx, EXT2_ROOT_INO
  inc esi
  jmp short l_e2_follow_link_66
  
l_e2_follow_link_65:
  // relative path
  mov ebx, e2_parentino
  
l_e2_follow_link_66:
// merge fd_buffer with edx
mov edi, VA_SYSTEM + offset fd_buffer
add edi, ecx
cmp byte ptr [es:edi - 1], '/'
jz l_e2_follow_link_668
  mov al, '/'
  stosb

l_e2_follow_link_668:
cmp byte ptr [es:edx], 0
jnz l_e2_follow_link_67
  mov byte ptr [es:edi - 1], 0
  
l_e2_follow_link_67:
  mov al, [es:edx]
  stosb
  cmp al, 0
  jz l_e2_follow_link_671
    inc edx
    cmp edi, VA_SYSTEM + offset fd_buffer + MAX_PATH
    jb l_e2_follow_link_67
      mov al, ERC_TOO_LONG
      jmp l_e2_follow_link_9
      
l_e2_follow_link_671:
// copy fd_buffer to fs_link, set edx
mov edx, VA_SYSTEM + offset fs_link
mov edi, edx
add edx, esi
mov esi, offset fd_buffer

l_e2_follow_link_672:
  lodsb
  stosb
  cmp al, 0
  jnz l_e2_follow_link_672

mov al, e2_diflink
l_e2_follow_link_9:
ret

// IN: es:edx -> filenamez, ebx = 0 || dirino, al = ldiskn
// OUT: al = 0 || erc, ebx = ino, e2_parentino, e2_nameofs
e2_find_file:
cmp al, e2_ldiskn
jz l_e2_find_file_01
  push edx
   push ebx
    call e2_prepare
   pop ebx
  pop edx
  test al, al
  jnz near l_e2_find_file_9
  
l_e2_find_file_01:
test ebx, ebx
jnz l_e2_find_file_1
  mov ebx, EXT2_ROOT_INO

l_e2_find_file_1:
mov e2_parentino, ebx
mov e2_nameofs, edx

push edx
  call e2_load_inode
pop edx
mov ax, e2_inode.i_mode
test ax, EXT2_S_IFDIR
jnz l_e2_find_file_2
  mov al, ERC_PATH_NOT_FOUND
  jmp l_e2_find_file_9

l_e2_find_file_2:
xor ebx, ebx
cmp ebx, e2_inode.i_size
jb l_e2_find_file_5
  
  l_e2_find_file_3:
    mov al, [es:edx]
    cmp al, 0
    jz l_e2_find_file_54
    cmp al, '/'
    jz l_e2_find_file_54
    inc edx
    jmp short l_e2_find_file_3
  
l_e2_find_file_5:

push edx

  mov ecx, 8
  xor edx, edx
  mov edi, VA_SYSTEM + offset fd_buffer
  push ebx
    call e2_read
  pop ebx
  test al, al
  jnz near l_e2_find_file_7
  
  movzx ecx, byte ptr fd_buffer[6]  // name_len
  push ebx
   push ecx
    add ebx, 8
    xor edx, edx
    mov edi, VA_SYSTEM + offset fd_buffer + 8
    call e2_read
   pop ecx
  pop ebx
  test al, al
  jnz l_e2_find_file_7

  mov byte ptr fd_buffer[ecx + 8], 0

pop edx

mov esi, VA_SYSTEM + offset fd_buffer + 8
push ebx
  call fs_cmp
pop ebx
test al, al
jz l_e2_find_file_6
  // not found, try next
  movzx eax, word ptr fd_buffer[4]  // rec_len
  test eax, eax
  jz l_e2_find_file_58
  
  add ebx, eax
  cmp ebx, e2_inode.i_size
  
  jb l_e2_find_file_5
    
    call fs_next_edx
    
    l_e2_find_file_54:
    // eof
    cmp byte ptr [es:edx], 0
    jz l_e2_find_file_56
      mov al, ERC_PATH_NOT_FOUND
      jmp short l_e2_find_file_9
      
    l_e2_find_file_56:
    mov al, ERC_FILE_NOT_FOUND
    jmp short l_e2_find_file_9

l_e2_find_file_58:
mov al, ERC_FS
jmp short l_e2_find_file_9

l_e2_find_file_6:
// found
call fs_next_edx
mov ebx, dword ptr fd_buffer[0]

// link?
cmp byte ptr fd_buffer[7], EXT2_FT_SYMLINK
jz l_e2_find_file_60

cmp byte ptr [es:edx], 0
jz l_e2_find_file_8
  // not end of es:edx
  jmp l_e2_find_file_1

l_e2_find_file_7:
pop edx
jmp short l_e2_find_file_9

l_e2_find_file_8:
mov al, 0

l_e2_find_file_9:  
ret


// link
l_e2_find_file_60:
test take_link, 1
jz l_e2_find_file_608
  cmp byte ptr [es:edx], 0
  jz l_e2_find_file_8
  
l_e2_find_file_608:
call e2_follow_link
test al, al
jnz l_e2_find_file_9
  jmp l_e2_find_file_1

// IN: es:edx -> filenamez, e2_parentino, e2_dir2.ino, e2_dir2.file_type
//     e2_sb, e2_ldiskn, e2_diskmain
// OUT: e2_inode
e2_add_name:
mov ebx, e2_parentino
push edx
  call e2_load_inode
pop edx

// count filename len
mov ebx, edx

l_e2_add_name_15:
  cmp byte ptr [es:ebx], 0
  jz l_e2_add_name_18
    inc ebx
    jmp l_e2_add_name_15
    
l_e2_add_name_18:
sub ebx, edx
cmp ebx, 255
jna l_e2_add_name_19
  mov ebx, 255
  
l_e2_add_name_19:
mov e2_len, ebx
mov e2_dir2.name_len, bl

// check duplicate file name  keep edx
xor eax, eax
mov e2_ofs, eax

l_e2_add_name_25:
  mov eax, e2_ofs
  cmp eax, e2_inode.i_size
  jnb near l_e2_add_name_28
    push edx
      mov ebx, e2_ofs
      xor edx, edx
      mov ecx, 8
      mov edi, VA_SYSTEM + offset e2_dir
      push ebx
        call e2_read
      pop ebx
      
      // compare name lengths
      mov al, byte ptr e2_len
      cmp al, e2_dir.name_len
      jnz l_e2_add_name_258
        add ebx, 8
        xor edx, edx
        movzx ecx, al
        mov edi, VA_SYSTEM + offset hd_buffer
        call e2_read
        
        // compare names
    pop edx
    push edx
        movzx ecx, e2_dir.name_len
        mov byte ptr hd_buffer[ecx], 0
        mov esi, VA_SYSTEM + offset hd_buffer
        call fs_cmp
        test al, al
        jnz l_e2_add_name_258
          mov al, ERC_DUPLICATE_NAME
          jmp short l_e2_add_name_26
          
      l_e2_add_name_258:
      mov al, 0
      
      l_e2_add_name_26:
    pop edx
    
    cmp al, ERC_DUPLICATE_NAME
    jz near l_e2_add_name_9
      movzx eax, e2_dir.rec_len
      test eax, eax
      jz l_e2_add_name_27
        add e2_ofs, eax
        jmp l_e2_add_name_25
        
    l_e2_add_name_27:
    mov al, ERC_FS
    jmp near l_e2_add_name_9

l_e2_add_name_28:

// find free place
xor eax, eax
mov e2_ofs, eax
mov e2_ofs2, eax

l_e2_add_name_5:
  mov eax, e2_ofs
  cmp eax, e2_inode.i_size
  jnb l_e2_add_name_54
    push edx
      mov ebx, e2_ofs
      xor edx, edx
      mov ecx, 8
      mov edi, VA_SYSTEM + offset e2_dir
      call e2_read
    pop edx
    movzx eax, e2_dir.name_len
    add eax, e2_len
    add eax, 8 + 8
    cmp ax, e2_dir.rec_len
    jna l_e2_add_name_56
      movzx eax, e2_dir.rec_len
      add e2_ofs, eax
      jmp l_e2_add_name_5

l_e2_add_name_53:
mov al, ERC_DIR_TOO_BIG
jmp l_e2_add_name_9

l_e2_add_name_54:
// not found - add to end of file
mov eax, e2_len
add eax, 8
mov e2_dir2.rec_len, ax
push edx
  mov ebx, e2_ofs
  mov e2_ofs2, ebx
  xor edx, edx
  mov ecx, 8
  mov edi, VA_SYSTEM + offset e2_dir2
  call e2_write
pop edx

mov eax, e2_ofs
add eax, 8
add eax, e2_len
cmp eax, e2_ofs
jb l_e2_add_name_53

mov e2_inode.i_size, eax
call e2_save_inode  // keep edx
jmp l_e2_add_name_58

l_e2_add_name_56:
// found - add after dir
movzx ecx, e2_dir.rec_len

sub eax, e2_len
sub eax, 8
sub ecx, eax
mov e2_dir2.rec_len, cx

mov ebx, eax
add ebx, e2_ofs
mov e2_ofs2, ebx  // e2_ofs2 = new ofs
mov e2_dir.rec_len, ax

push edx
  mov ebx, e2_ofs
  xor edx, edx
  mov ecx, 8
  mov edi, VA_SYSTEM + offset e2_dir
  call e2_write
  
  mov ebx, e2_ofs2
  xor edx, edx
  mov ecx, 8
  mov edi, VA_SYSTEM + offset e2_dir2
  call e2_write
pop edx

l_e2_add_name_58:
// both - copy name
mov edi, edx
mov ebx, e2_ofs2
add ebx, 8
xor edx, edx
mov ecx, e2_len
call e2_write

l_e2_add_name_9:
ret

// BEFORE: e2_prepare, e2_load_inode
// KEEP: edx, e2_len
// USES: fd_buffer
e2_reduce_dir:
push edx
  xor eax, eax
  mov e2_ofs, eax
  mov e2_ofs2, eax
  
  l_e2_reduce_dir_5:
  mov eax, e2_ofs
  cmp eax, e2_inode.i_size
  jnb near l_e2_reduce_dir_8
    mov ebx, eax
    xor edx, edx
    mov ecx, 8
    mov edi, VA_SYSTEM + offset e2_dir
    push ebx
      call e2_read
    pop ebx
    
    cmp ebx, e2_ofs2
    jz l_e2_reduce_dir_6
      // ofs != ofs2 => copy dir rec
      xor edx, edx
      movzx ecx, byte ptr e2_dir.name_len
      add ecx, 8
      mov edi, VA_SYSTEM + offset fd_buffer
      push ecx
        call e2_read
      pop ecx
      
      mov word ptr fd_buffer[offset E2DirEntry.rec_len], cx  // gap
      mov ebx, e2_ofs2
      xor edx, edx
      mov edi, VA_SYSTEM + offset fd_buffer
      call e2_write
      jmp l_e2_reduce_dir_7
      
    l_e2_reduce_dir_6:
    movzx eax, byte ptr e2_dir.name_len
    movzx ecx, word ptr e2_dir.rec_len
    add eax, 8
    cmp eax, ecx
    jz l_e2_reduce_dir_7
      // gap, IN: ebx
      push eax
       push ecx
        mov e2_dir.rec_len, ax
        xor edx, edx
        mov ecx, 8
        mov edi, VA_SYSTEM + offset e2_dir
        call e2_write
       pop ecx
      pop eax
      jmp short l_e2_reduce_dir_72
    
    l_e2_reduce_dir_7:
    movzx eax, byte ptr e2_dir.name_len
    movzx ecx, word ptr e2_dir.rec_len
    add eax, 8
    
    l_e2_reduce_dir_72:
    add e2_ofs, ecx
    add e2_ofs2, eax
    jmp l_e2_reduce_dir_5

  l_e2_reduce_dir_8:
  cmp eax, e2_ofs2
  jz l_e2_reduce_dir_9
    // delete rest of file
    mov ebx, e2_ofs2
    xor edx, edx
    call e2_delete
    
  l_e2_reduce_dir_9:
pop edx
ret

// IN: es:edx -> filenamez, e2_parentino, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, e2_dir
// USES: hd_buffer
e2_rm_name:
mov ebx, e2_parentino
push edx
  call e2_load_inode
pop edx

// count filename len
mov ebx, edx

l_e2_rm_name_15:
  cmp byte ptr [es:ebx], 0
  jz l_e2_rm_name_18
    inc ebx
    jmp l_e2_rm_name_15
    
l_e2_rm_name_18:
sub ebx, edx
cmp ebx, 255
jna l_e2_rm_name_19
  mov ebx, 255
  
l_e2_rm_name_19:
mov e2_len, ebx

l_e2_rm_name_2:
// search
xor eax, eax
mov e2_ofs, eax  // 0
dec eax
mov e2_ofs2, eax // -1

l_e2_rm_name_5:
  mov eax, e2_ofs
  cmp eax, e2_inode.i_size
  jnb l_e2_rm_name_54
    push edx
      mov ebx, eax
      xor edx, edx
      mov ecx, 8
      mov edi, VA_SYSTEM + offset e2_dir
      push ebx
        call e2_read
      pop ebx
    pop edx
    
    // compare name lengths
    mov al, byte ptr e2_len
    cmp al, e2_dir.name_len
    jnz l_e2_rm_name_next
      push edx
        add ebx, 8
        xor edx, edx
        movzx ecx, al
        mov edi, VA_SYSTEM + offset hd_buffer
        call e2_read
      pop edx

      // compare names
      push edx
        movzx ecx, e2_dir.name_len
        mov byte ptr hd_buffer[ecx], 0
        mov esi, VA_SYSTEM + offset hd_buffer
        call fs_cmp
      pop edx
      test al, al
      jz l_e2_rm_name_56
      
    l_e2_rm_name_next:
    mov ebx, e2_ofs
    mov e2_ofs2, ebx
    movzx eax, e2_dir.rec_len
    add e2_ofs, eax
    jmp l_e2_rm_name_5
    
l_e2_rm_name_54:
// not found
mov al, ERC_FILE_NOT_FOUND
jmp l_e2_rm_name_9

l_e2_rm_name_55:
//mov al, ERC_TOO_BIG_HOLE
call e2_reduce_dir
jmp l_e2_rm_name_2

l_e2_rm_name_56:
// found
mov ebx, e2_ofs2
cmp ebx, -1
jnz l_e2_rm_name_561
  mov al, ERC_CANT_REMOVE
  jmp l_e2_rm_name_9
  
l_e2_rm_name_561:
push edx
  xor edx, edx
  mov ecx, 8
  mov edi, VA_SYSTEM + offset e2_dir2
  call e2_read
pop edx

movzx eax, e2_dir.rec_len
movzx ecx, e2_dir2.rec_len
add eax, ecx
cmp eax, 0x10000
jnb l_e2_rm_name_55

mov e2_dir2.rec_len, ax
// end of file?
add eax, e2_ofs2
cmp eax, e2_inode.i_size
jnz l_e2_rm_name_57
  // truncate file
  movzx eax, e2_dir2.name_len
  add eax, 8
  mov e2_dir2.rec_len, ax
  
  add eax, e2_ofs2
  mov ebx, eax
  xor edx, edx
  call e2_delete
  
l_e2_rm_name_57:
// save rec_len2
mov ebx, e2_ofs2
xor edx, edx
mov ecx, 8
mov edi, VA_SYSTEM + offset e2_dir2
call e2_write

l_e2_rm_name_9:
ret

// IN: bl = access rights, e2_inode, e2_ldiskn
// OUT: al = erc
// KEEP: edx
e2_check_access:
mov esi, p_current
mov cx, e2_inode.i_mode

// system file (only starter)
mov eax, ecx
test ax, EXT2_S_IFSYS
jz l_e2_check_access_1
  mov eax, [es:esi + offset ThreadRec.process]
  cmp eax, VA_PROCS
  jz l_e2_check_access_1
    mov al, ERC_ONLY_STARTER
    jmp l_e2_check_access_9
  
l_e2_check_access_1:

// ugo
mov edi, [es:esi + offset ThreadRec.uid]
and edi, 0xFFFFFF
jz l_e2_check_access_8  // root

movzx eax, e2_inode.i_uid
cmp eax, edi
jnz l_e2_check_access_2
  // user
  shr ecx, 6
  jmp short l_e2_check_access_5

l_e2_check_access_2:
mov edi, [es:esi + offset ThreadRec.gid]
and edi, 0xFFFFFF
movzx eax, e2_inode.i_gid
cmp eax, edi
jnz l_e2_check_access_5
  // group
  shr ecx, 3
  jmp short l_e2_check_access_5

l_e2_check_access_5:
//and cl, 7
and cl, bl
cmp cl, bl
jz l_e2_check_access_8
  mov al, ERC_ACCESS_DENIED
  jmp short l_e2_check_access_9

l_e2_check_access_8:
mov al, 0

l_e2_check_access_9:
ret

e2_init:
mov e2_ldiskn, -1
ret

// IN: es:edx -> filenamez, esi -> files, al = ldiskn || 1, ebx = 0 || dirino
// OUT: al = 0 || erc, esi = fhandle
e2_fopen:
push esi
  call e2_find_file
pop esi
test al, al
jz near l_e2_fopen_2
  cmp al, ERC_FILE_NOT_FOUND
  jnz l_e2_fopen_x
    test files.mode[esi], FOPEN_CREATE
    jnz l_e2_fopen_1
      test files.mode[esi], FOPEN_APPEND
      jnz l_e2_fopen_1
  
  l_e2_fopen_x:
  mov files.mode[esi], 0
  xor esi, esi
  jmp l_e2_fopen_9

l_e2_fopen_01: // rollback name
push eax
  mov edx, e2_nameofs
  call e2_rm_name
pop eax

l_e2_fopen_02:
push eax // rollback inode
  mov ebx, e2_dir2.ino
  call e2_free_inode
pop eax

l_e2_fopen_03:
pop esi
jmp l_e2_fopen_x

l_e2_fopen_1:
// * create file *
push esi
  // check valid chars
  mov edx, e2_nameofs
  call fs_check_valid
  test al, al
  jnz l_e2_fopen_03
  // alloc inode
  call e2_alloc_inode  // out e2_gb, e2_group
  test al, al
  jnz l_e2_fopen_03
  mov e2_dir2.ino, ebx
  // add name to parent
  mov edx, e2_nameofs
  test take_link, 1
  jz l_e2_fopen_11
    mov e2_dir2.file_type, EXT2_FT_SYMLINK
    jmp short l_e2_fopen_12
  
  l_e2_fopen_11:
    mov e2_dir2.file_type, EXT2_FT_REG_FILE
  
  l_e2_fopen_12:
  call e2_add_name  // out e2_inode
  test al, al
  jnz l_e2_fopen_02
  // check access
  mov bl, ACCESS_W
  call e2_check_access
  test al, al
  jnz l_e2_fopen_01
  // zero inode
  mov ebx, e2_dir2.ino
  call e2_load_inode
  xor eax, eax
  mov ecx, sizeof INode / 4
  mov edi, VA_SYSTEM + offset e2_inode
  cld
  rep stosd
  // init inode
  test take_link, 1
  jz l_e2_fopen_13
    mov e2_inode.i_mode, EXT2_S_IFLNK | ACCESS_DEFAULT
    jmp short l_e2_fopen_14
    
  l_e2_fopen_13:
    mov e2_inode.i_mode, EXT2_S_IFREG | ACCESS_DEFAULT
  
  l_e2_fopen_14:
  mov e2_inode.i_links_count, 1  // rfc
  mov esi, p_current
  mov eax, [es:esi + offset ThreadRec.uid]
  mov e2_inode.i_uid, ax
  mov eax, [es:esi + offset ThreadRec.gid]
  mov e2_inode.i_gid, ax
  // time
  call t_getunix
  mov e2_inode.i_ctime, eax
  mov e2_inode.i_atime, eax
  mov e2_inode.i_mtime, eax
  // save inode
  call e2_save_inode
pop esi
mov ebx, e2_dir2.ino
mov files.file[esi], ebx  // ino
jmp short l_e2_fopen_20

l_e2_fopen_2:
// * open file *
mov files.file[esi], ebx  // ino
push esi
  call e2_load_inode
pop esi
test al, al
jnz near l_e2_fopen_x

mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fopen_20
  push esi
    call t_getunix
    mov e2_inode.i_mtime, eax
    // save inode
    call e2_save_inode
  pop esi
  
l_e2_fopen_20:
// check not share write
mov al, 0
call fs_not_share_write
test al, al
jnz near l_e2_fopen_x
// check not directory
mov ax, e2_inode.i_mode
and ax, 0xE000
cmp ax, EXT2_S_IFDIR
jnz l_e2_fopen_21
  mov al, ERC_FILE_NOT_FOUND
  jmp l_e2_fopen_x
  
l_e2_fopen_21:
// check link  IN: ax
test take_link, 1
jz l_e2_fopen_218
  cmp ax, EXT2_S_IFLNK
  jz l_e2_fopen_218
    mov al, ERC_NOT_A_LINK
    jmp l_e2_fopen_x
  
l_e2_fopen_218:
// check access
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fopen_22
  mov bl, ACCESS_W | ACCESS_R
  jmp short l_e2_fopen_23

l_e2_fopen_22:
  mov bl, ACCESS_R

l_e2_fopen_23:
push esi
  call e2_check_access
pop esi
test al, al
jnz near l_e2_fopen_x
// link
mov ax, e2_inode.i_mode
and ax, 0xE000
cmp ax, EXT2_S_IFLNK
jnz l_e2_fopen_24
  or files.mode[esi], FOPEN_LINK
  
l_e2_fopen_24:
test files.mode[esi], FOPEN_CREATE
jz l_e2_fopen_31
  // rewrite
  xor edx, edx
  xor ebx, ebx
  push esi
    test files.mode[esi], FOPEN_LINK
    jz l_e2_fopen_25
      cmp e2_inode.i_size, 60
      jb l_e2_fopen_26
      
    l_e2_fopen_25:
    call e2_delete
    
    l_e2_fopen_26:
    xor eax, eax
    mov e2_inode.i_size, eax
    mov e2_inode.i_dir_acl, eax
    call e2_save_inode
  pop esi
  
l_e2_fopen_31:
// load file info
mov al, e2_ldiskn
mov files.disk[esi], al

mov eax, dword ptr e2_inoa[0]
mov edx, dword ptr e2_inoa[4]
mov dword ptr files.sectn[esi], eax
mov dword ptr files.sectn[esi + 4], edx

mov eax, e2_inode.i_size
mov edx, e2_inode.i_dir_acl
mov dword ptr files.size[esi], eax
mov dword ptr files.size[esi + 4], edx

test files.mode[esi], FOPEN_APPEND
jz l_e2_fopen_32
  // append
  mov dword ptr files.pos[esi], eax
  mov dword ptr files.pos[esi + 4], edx  
  jmp short l_e2_fopen_33
  
l_e2_fopen_32:
  // not append
  xor eax, eax
  mov dword ptr files.pos[esi], eax
  mov dword ptr files.pos[esi + 4], eax

l_e2_fopen_33:
shr esi, 5 // assert sizeof OpenFileRec = 32
mov al, 0

l_e2_fopen_9:
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizeread
e2_fread:
mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_fread_1
  push esi
   push edi
    push ecx
     call e2_prepare
    pop ecx
   pop edi
  pop esi
  
l_e2_fread_1:
mov ebx, files.file[esi]
push esi
 push edi
  push ecx
   call e2_load_inode
  pop ecx
 pop edi
pop esi

// link
test files.mode[esi], FOPEN_LINK
jz l_e2_fread_18
  cmp e2_inode.i_size, 60
  jnb l_e2_fread_18
    cmp dword ptr files.pos[esi], 0
    jnz l_e2_fread_16
    
    cmp ecx, 60
    jnb l_e2_fread_17
      
      l_e2_fread_16:
      mov al, ERC_INVALID_LINK
      jmp l_e2_fread_9
      
    l_e2_fread_17:
    push esi
     push edi
      mov esi, offset e2_inode.i_block
      mov ecx, 60 / 4
      cld
      rep movsd
      mov byte ptr [es:edi - 1], 0
     pop edi
    pop esi
    
    xor ecx, ecx
    
    l_e2_fread_175:
      cmp byte ptr [es:edi + ecx], 0
      jz l_e2_fread_8
        inc ecx
        jmp short l_e2_fread_175
    
l_e2_fread_18:
// check not after eof
push edi
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  
  mov edi, dword ptr files.size[esi + 4]
  mov eax, dword ptr files.size[esi]
  sub edi, edx
  sbb eax, ebx  // edi:eax = size - pos
  cmp edi, 0
  jnz l_e2_fread_2
    cmp eax, ecx
    jnb l_e2_fread_2
      mov ecx, eax
      
  l_e2_fread_2:
pop edi

push ecx
 push esi
  call e2_read
 pop esi
pop ecx
test al, al
jnz l_e2_fread_9

  l_e2_fread_8:
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  add ebx, ecx
  adc edx, 0
  mov dword ptr files.pos[esi], ebx
  mov dword ptr files.pos[esi + 4], edx
  
  mov al, 0
  
l_e2_fread_9:
ret

l_e2_fwrite_x:
mov al, ERC_READ_ONLY
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizewrite
e2_fwrite:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fwrite_x

mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_fwrite_1
  push esi
   push edi
    push ecx
     call e2_prepare
    pop ecx
   pop edi
  pop esi
  
l_e2_fwrite_1:
mov ebx, files.file[esi]
push esi
 push edi
  push ecx
    call e2_load_inode
  pop ecx
 pop edi
pop esi

// link
test files.mode[esi], FOPEN_LINK
jz l_e2_fwrite_18
  cmp dword ptr files.pos[esi], 0
  jz l_e2_fwrite_17
    
    l_e2_fwrite_16:
    mov al, ERC_INVALID_LINK
    jmp l_e2_fwrite_9
    
  l_e2_fwrite_17:
  cmp ecx, 60
  jnb l_e2_fwrite_177
    // ecx < 60
    push esi
     push edi
      push ecx
       push ds
        push es
        pop ds
        mov esi, edi
        mov edi, VA_SYSTEM + offset e2_inode.i_block
        cld
        rep movsb
        mov al, 0
        stosb
       pop ds
      pop ecx
     pop edi
    pop esi
    add dword ptr files.pos[esi], ecx
    mov dword ptr files.size[esi], ecx
    jmp l_e2_fwrite_88
    
  l_e2_fwrite_177:
  // ecx >= 60
  cmp e2_inode.i_size, 60
  jnb l_e2_fwrite_18
    // fsize < 60
    push edi
     push ecx
      xor eax, eax
      mov edi, VA_SYSTEM + offset e2_inode.i_block
      mov ecx, 60 / 4
      cld
      rep stosd
     pop ecx
    pop edi
    
l_e2_fwrite_18:
// write
mov ebx, dword ptr files.pos[esi]
mov edx, dword ptr files.pos[esi + 4]
push ecx
 push esi
  call e2_write
 pop esi
pop ecx
test al, al
jnz l_e2_fwrite_9
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  add ebx, ecx
  adc edx, 0
  
  cmp edx, dword ptr files.size[esi + 4]
  jnz l_e2_fwrite_7
    cmp ebx, dword ptr files.size[esi]
    
  l_e2_fwrite_7:
  jna l_e2_fwrite_8
    // pos > size
    mov dword ptr files.size[esi], ebx
    mov dword ptr files.size[esi + 4], edx
    
  l_e2_fwrite_8:
  mov dword ptr files.pos[esi], ebx
  mov dword ptr files.pos[esi + 4], edx
  
  l_e2_fwrite_88:
  // save inode
  push ecx
    call e2_save_inode
  pop ecx
  
l_e2_fwrite_9:
ret

// IN: esi = offset to files, edx:ebx = file offset
e2_fsetpos:
cmp edx, dword ptr files.size[esi + 4]
jnz l_e2_fsetpos_1
  cmp ebx, dword ptr files.size[esi]
  
l_e2_fsetpos_1:
jna l_e2_fsetpos_2
  // pos > size
  mov ebx, dword ptr files.size[esi]
  mov edx, dword ptr files.size[esi + 4]
  
l_e2_fsetpos_2:
mov dword ptr files.pos[esi], ebx
mov dword ptr files.pos[esi + 4], edx
ret

l_e2_fcut_x:
mov al, ERC_READ_ONLY
ret

// IN: esi -> files
e2_fcut:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fcut_x

mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_fcut_1
  push esi
    call e2_prepare
  pop esi
  
l_e2_fcut_1:
mov ebx, files.file[esi]
push esi
  call e2_load_inode
pop esi

mov ebx, dword ptr files.pos[esi]
mov edx, dword ptr files.pos[esi + 4]
push esi
  call e2_delete
pop esi
test al, al
jnz l_e2_fcut_9
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  mov dword ptr files.size[esi], ebx
  mov dword ptr files.size[esi + 4], edx
  mov e2_inode.i_size, eax
  mov e2_inode.i_dir_acl, edx
  call e2_save_inode
  
l_e2_fcut_9:
ret

// IN: esi = offset to files
e2_fclose:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fclose_98
  mov al, files.disk[esi]
  cmp al, e2_ldiskn
  jz l_e2_fclose_1
    push esi
      call e2_prepare
    pop esi
    
  l_e2_fclose_1:
  mov ebx, files.file[esi]
  push esi
    call e2_load_inode
  pop esi
  mov eax, dword ptr files.size[esi]
  mov edx, dword ptr files.size[esi + 4]
  mov e2_inode.i_size, eax
  mov e2_inode.i_dir_acl, edx
  push esi
    // time
    call t_getunix
    mov e2_inode.i_atime, eax
    // save
    call e2_save_inode
  pop esi
  
l_e2_fclose_8:
mov files.mode[esi], 0
ret

l_e2_fclose_98:
mov al, 0
jmp l_e2_fclose_8

// IN: es:edx -> path & dirname, al = ldiskn, ebx = dir ino
// OUT: al = 0 || erc
// USES: fd_buffer
e2_md:
call e2_find_file  // OUT e2_parentino, e2_nameofs
cmp al, ERC_FILE_NOT_FOUND
jz l_e2_md_2
  cmp al, 0
  jnz near l_e2_md_9
    mov al, ERC_DIR_ALREADY_EXISTS
    jmp l_e2_md_9
  
l_e2_md_2:
// check valid chars
mov edx, e2_nameofs
call fs_check_valid
test al, al
jnz near l_e2_md_9
// alloc inode
call e2_alloc_inode  // out e2_gb, e2_group
mov esi, e2_group
mov e2_group1, esi
test al, al
jnz near l_e2_md_9
  mov e2_dir2.ino, ebx
  // set bg_used_dirs_count
  inc e2_gb.bg_used_dirs_count
  mov ebx, e2_group1
  call e2_save_group_and_super
  // add name to parent
  mov edx, e2_nameofs
  mov e2_dir2.file_type, EXT2_FT_DIR
  call e2_add_name  // out e2_inode
  test al, al
  jnz near l_e2_md_82
    // check access
    mov bl, ACCESS_W
    call e2_check_access
    test al, al
    jnz near l_e2_md_81
    // zero inode
    mov ebx, e2_dir2.ino
    call e2_load_inode
    xor eax, eax
    movzx ecx, e2_sb.s_inode_size
    shr ecx, 2
    mov edi, VA_SYSTEM + offset e2_inode
    cld
    rep stosd
    // init inode
    mov e2_inode.i_mode, EXT2_S_IFDIR | ACCESS_DEFAULT
    mov e2_inode.i_links_count, 1  // rfc
    mov esi, p_current
    mov eax, [es:esi + offset ThreadRec.uid]
    mov e2_inode.i_uid, ax
    mov eax, [es:esi + offset ThreadRec.gid]
    mov e2_inode.i_gid, ax
    // time
    call t_getunix
    mov e2_inode.i_ctime, eax
    mov e2_inode.i_atime, eax
    mov e2_inode.i_mtime, eax
    // write . ..
    mov eax, e2_dir2.ino
    mov dword ptr fd_buffer[0], eax
    mov word ptr fd_buffer[4], 9  // rec len
    mov fd_buffer[6], 1  // name len
    mov fd_buffer[7], EXT2_FT_DIR
    mov fd_buffer[8], "."
    
    mov eax, e2_parentino
    mov dword ptr fd_buffer[9+0], eax
    mov word ptr fd_buffer[9+4], 10  // rec len
    mov fd_buffer[9+6], 2  // name len
    mov fd_buffer[9+7], EXT2_FT_DIR
    mov word ptr fd_buffer[9+8], ".."
    
    mov ecx, 19  // 9 + 10
    mov e2_inode.i_size, ecx
    xor ebx, ebx
    xor edx, edx
    mov edi, VA_SYSTEM + offset fd_buffer
    call e2_write
    test al, al
    jnz l_e2_md_81
      // save inode
      call e2_save_inode
      test al, al
      jz l_e2_md_9
    
l_e2_md_81: // rollback name
push eax
  mov edx, e2_nameofs
  call e2_rm_name
pop eax

l_e2_md_82: // rollback inode, bg_used_dirs_count
push eax
  mov ebx, e2_dir2.ino
  call e2_free_inode

  mov ebx, e2_group1
  call e2_load_group
  dec e2_gb.bg_used_dirs_count
  mov ebx, e2_group1
  call e2_save_group_and_super
pop eax
  
l_e2_md_9:
ret

// IN: al = ldiskn, es:edx -> path
e2_cd:
xor ebx, ebx
call e2_find_file
or al, al
jnz l_e2_cd_9
  
  mov edx, p_current
  mov al, e2_ldiskn
  mov [es:edx + offset ThreadRec.curdisk], al
  mov [es:edx + offset ThreadRec.curdir], ebx
  mov al, 0
  
l_e2_cd_9:
ret

// IN: es:edx -> path/name, al = ldiskn, ebx = dir ino
// OUT: al = 0 || erc
e2_rm:
call e2_find_file  // out e2_parentino, e2_nameofs
test al, al
jnz near l_e2_rm_9
 
 mov al, e2_ldiskn
 call fs_not_used  // keep all but ecx
 test cl, cl
 jz l_e2_rm_02
   mov al, cl
   jmp l_e2_rm_9
  
 l_e2_rm_02:
  mov e2_fileino, ebx
  // check file access
  call e2_load_inode
  mov bl, ACCESS_W
  call e2_check_access
  test al, al
  jnz near l_e2_rm_9
  // file, dir or symlink?
  mov e2_isdir, 0
  mov e2_islink, 0
  mov ax, e2_inode.i_mode
  and ax, 0xE000
  cmp ax, EXT2_S_IFLNK
  jnz l_e2_rm_03
    // symlink
    mov e2_islink, 1
    
  l_e2_rm_03:
  cmp ax, EXT2_S_IFDIR
  jnz l_e2_rm_1
    // dir
    mov e2_isdir, 1
    // . ..
    mov edx, e2_nameofs
    mov ax, [es:edx]
    cmp ax, 2Eh
    jz l_e2_rm_06
      mov eax, [es:edx]
      and eax, 0xFFFFFF
      cmp eax, 2E2Eh
      jz l_e2_rm_06
        // dir not empty
        cmp e2_inode.i_size, 24  // 12 + 12 || 9 + 10
        jna l_e2_rm_1
          call e2_reduce_dir
          call e2_save_inode
          cmp e2_inode.i_size, 24  // 12 + 12 || 9 + 10
          jna l_e2_rm_1
            mov al, ERC_DIR_NOT_EMPTY
            jmp l_e2_rm_9
          
    l_e2_rm_06:
    mov al, ERC_CANT_REMOVE
    jmp l_e2_rm_9
    
  l_e2_rm_1:
  // used_dirs_count
  test e2_isdir, 1
  jz l_e2_rm_2
    dec e2_gb.bg_used_dirs_count
    mov ebx, e2_group
    call e2_save_group_and_super
    
  l_e2_rm_2:
  // check dir access
  mov ebx, e2_parentino
  call e2_load_inode
  mov bl, ACCESS_W
  call e2_check_access
  test al, al
  jnz near l_e2_rm_9
  // time
  call t_getunix
  mov e2_inode.i_mtime, eax
  call e2_save_inode
  // remove file name
  mov edx, e2_nameofs
  call e2_rm_name
  test al, al
  jnz l_e2_rm_9
  // dec hardlinks
  mov ebx, e2_fileino
  call e2_load_inode
  dec e2_inode.i_links_count
  cmp e2_inode.i_links_count, 0
  jz l_e2_rm_3
    call e2_save_inode
    jmp l_e2_rm_9
    
  l_e2_rm_3:
  // delete file content, also dir
  test e2_islink, 1
  jz l_e2_rm_4
    // link
    cmp e2_inode.i_size, 60
    jb l_e2_rm_6
    
  l_e2_rm_4:
  xor edx, edx
  xor ebx, ebx
  call e2_delete

  l_e2_rm_6:
  // save
  call e2_save_inode  
  // free inode
  mov ebx, e2_fileino
  call e2_free_inode
  
l_e2_rm_9:
ret

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster, es:esi -> new filename
// OUT: al = erc
e2_rename:
push esi
  call e2_find_file
pop esi
test al, al
jnz near l_e2_rename_9

// check .
mov al, ERC_CANT_RENAME
mov ebx, e2_nameofs
cmp byte ptr [es:ebx], '.'
jz l_e2_rename_9

// check valid chars
mov edx, esi
call fs_check_valid  // keep esi
test al, al
jnz l_e2_rename_9

// check access
push esi
  mov ebx, e2_parentino
  call e2_load_inode
  mov bl, ACCESS_W
  call e2_check_access
pop esi
test al, al
jnz l_e2_rename_9

// remove name
mov edx, e2_nameofs
push esi
  call e2_rm_name
pop edx
test al, al
jnz l_e2_rename_9

// set e2_dir2, add name
mov eax, e2_dir.ino
mov e2_dir2.ino, eax
mov al, e2_dir.file_type
mov e2_dir2.file_type, al
call e2_add_name
test al, al
jnz l_e2_rename_81

// time
call t_getunix
mov e2_inode.i_mtime, eax

// save
call e2_save_inode
mov al, 0
jmp short l_e2_rename_9


l_e2_rename_81:
push eax
  mov edx, e2_nameofs
  call e2_add_name
  call e2_save_inode
pop eax

l_e2_rename_9:
ret

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster, es:esi -> new path
// OUT: al = erc
e2_move:
push esi
  call e2_find_file
pop esi
test al, al
jnz near l_e2_move_9

// copy file name
mov edx, e2_nameofs
mov edi, VA_SYSTEM + offset e2_name2
mov ecx, MAX_PATH - 1

l_e2_move_1:
  mov al, [es:edx]
  inc edx
  stosb
  cmp al, 0
  jz l_e2_move_19
    loop l_e2_move_1
      mov al, ERC_TOO_LONG
      jmp l_e2_move_9

l_e2_move_19:
// check . ..
mov al, ERC_CANT_MOVE
cmp word ptr e2_name2, '.'
jz near l_e2_move_9
cmp word ptr e2_name2, '..'
jz near l_e2_move_9

// check write access
mov al, e2_ldiskn
mov e2_ldiskn2, al  // e2_ldiskn2
mov ebx, e2_parentino
mov e2_parentino2, ebx  // parentino2
push esi
  call e2_load_inode
  mov bl, ACCESS_W
  call e2_check_access
pop esi
test al, al
jnz near l_e2_move_9

// new dir
mov edx, esi

l_e2_move_2:
  // get disk from path/cd
  call fs_disk  // IN/OUT edx
  cmp byte ptr [es:edx], 0
  jnz l_e2_move_206
    mov e2_ldiskn, al
    test ebx, ebx
    jnz l_e2_move_21
      mov ebx, EXT2_ROOT_INO
      jmp short l_e2_move_21
    
  l_e2_move_206:
  // get dir
  call e2_find_file  // out ebx
  cmp al, ERC_LINK
  jz l_e2_move_2

test al, al
jnz near l_e2_move_9

l_e2_move_21:
// on the same disk
mov al, e2_ldiskn
cmp al, e2_ldiskn2
jz l_e2_move_22
  mov al, ERC_OUT_OF_DISK
  jmp l_e2_move_9
  
l_e2_move_22:
// check directory, write access
mov e2_parentino, ebx
call e2_load_inode
mov ax, e2_inode.i_mode
test ax, EXT2_S_IFDIR
jnz l_e2_move_23
  mov al, ERC_PATH_NOT_FOUND
  jmp l_e2_move_9
  
l_e2_move_23:
mov bl, ACCESS_W
call e2_check_access
test al, al
jnz near l_e2_move_9

// remove
mov ebx, e2_parentino2
mov eax, e2_parentino
mov e2_parentino, ebx
mov e2_parentino2, eax
mov edx, VA_SYSTEM + offset e2_name2
call e2_rm_name
test al, al
jnz l_e2_move_9

// time
call t_getunix
mov e2_inode.i_mtime, eax

// save
call e2_save_inode

// add name
mov ebx, e2_parentino2
mov eax, e2_parentino
mov e2_parentino, ebx
mov e2_parentino2, eax
mov edx, VA_SYSTEM + offset e2_name2

mov eax, e2_dir.ino
mov e2_dir2.ino, eax
mov al, e2_dir.file_type
mov e2_dir2.file_type, al

call e2_add_name
test al, al
jnz l_e2_move_81

// time
call t_getunix
mov e2_inode.i_mtime, eax

// save
call e2_save_inode
jmp short l_e2_move_9


l_e2_move_81:  // rollback name  IN: e2_dir2
push eax
  mov ebx, e2_parentino2
  mov eax, e2_parentino
  mov e2_parentino, ebx
  mov e2_parentino2, eax
  mov edx, VA_SYSTEM + offset e2_name2
  call e2_add_name
pop eax

l_e2_move_9:
ret

// IN: al = ldiskn, ebx = dir, es:edx -> dir(mask)
//     fs_rec, fs_srchofs, fs_dosplit
e2_find_first:
cmp al, e2_ldiskn
jz l_e2_find_first_01
  push edx
   push ebx
    call e2_prepare
   pop ebx
  pop edx
  test al, al
  jnz near l_e2_find_first_9

l_e2_find_first_01:
test fs_dosplit, 1
jz l_e2_find_first_2
  call fs_split  // KEEP ebx
  test al, al
  jnz l_e2_find_first_9
  
l_e2_find_first_2:
// Find dir  IN: ebx
cmp byte ptr [es:edx], 0
jnz l_e2_find_first_3
  
  // no path
  test ebx, ebx
  jnz l_e2_find_first_4
    // root
    mov ebx, EXT2_ROOT_INO
    jmp short l_e2_find_first_4
  
l_e2_find_first_3:
  mov al, e2_ldiskn
  
  call e2_find_file
  
  cmp al, ERC_FILE_NOT_FOUND
  jnz l_e2_find_first_33
    mov al, ERC_PATH_NOT_FOUND
    
  l_e2_find_first_33:
  cmp al, ERC_LINK
  jz l_e2_find_first_99
  
  test al, al
  jnz l_e2_find_first_9
  
l_e2_find_first_4:
call e2_load_inode
test al, al
jnz l_e2_find_first_9

mov esi, fs_srchofs
mov eax, dword ptr e2_inoa[0]
mov ecx, dword ptr e2_inoa[4]
mov dword ptr srch.Cluster[esi], eax
mov dword ptr srch.Cluster[esi + 4], ecx
mov ecx, e2_inode.i_size
mov ebx, e2_inon
xor eax, eax
mov srch.Size[esi], ecx
mov srch.File[esi], ebx
mov srch.Offset[esi], eax

call e2_find_next

test al, al
jz l_e2_find_first_99

l_e2_find_first_9:
mov esi, fs_srchofs
mov word ptr srch.ThreadId[esi], -1

l_e2_find_first_99:
ret

// IN: fs_rec, fs_srchofs, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc
// USES: fd_buffer
e2_find_next:
mov esi, fs_srchofs
mov al, srch.Disk[esi]
cmp al, e2_ldiskn
jz l_e2_find_next_1
  push esi
    call e2_prepare
  pop esi
  
l_e2_find_next_1:
// load inode
mov ebx, dword ptr srch.Cluster[esi + 0]
mov edx, dword ptr srch.Cluster[esi + 4]
mov ecx, sizeof INode
mov edi, VA_SYSTEM + offset e2_inode
mov ah, 2  // read
mov al, e2_ldiskn
call e2_diskmain

l_e2_find_next_5:
// load fname
mov esi, fs_srchofs
mov ebx, srch.Offset[esi]
cmp ebx, srch.Size[esi]
jnb near l_e2_find_next_7

xor edx, edx
mov ecx, 8
mov edi, VA_SYSTEM + offset fd_buffer
push ebx
  call e2_read
pop ebx

xor edx, edx
add ebx, 8
movzx ecx, byte ptr fd_buffer[6]  // name_len
mov edi, VA_SYSTEM + offset fd_buffer + 8
call e2_read

mov esi, fs_srchofs  // esi = fs_srchofs
movzx eax, word ptr fd_buffer[4]  // rec_len
test eax, eax
jz near l_e2_find_next_6

add srch.Offset[esi], eax  // Offset + rec_len

// IsMatch?
movzx ecx, byte ptr fd_buffer[6]  // name_len
jecxz l_e2_find_next_5  // loop 5

add esi, offset srch.FileMask
mov edi, offset fd_buffer + 8

mov byte ptr fd_buffer[ecx + 8], 0  // fd_buffer[name_len + 8] = 0
call fs_ismatch
test al, al

jnz near l_e2_find_next_5  // loop 5


// * Found - copy to fs_rec *

// File name
mov esi, offset fd_buffer + 8
mov edi, fs_rec
add edi, offset SearchRec.FileName
movzx ecx, byte ptr fd_buffer[6] // name_len
inc ecx
rep movsb

// init fs_rec
mov edi, fs_rec
xor eax, eax
push edi
  mov ecx, 7
  rep stosd
pop edi

// inon
mov ebx, dword ptr fd_buffer[0]

// Link
cmp byte ptr fd_buffer[7], EXT2_FT_SYMLINK
jnz near l_e2_find_next_528
  or dword ptr [es:edi + offset SearchRec.FileAttributes], FILE_ATTRIBUTE_LINK
  mov eax, fs_srchofs
  mov eax, srch.File[eax]
  mov e2_parentino, eax
  xor eax, eax
  mov e2_tmp, eax
  mov edx, VA_SYSTEM + offset e2_tmp
  call e2_follow_link
  test al, al
  jz l_e2_find_next_526
    cmp al, ERC_LINK
    jnz near l_e2_find_next_9
      
      // * differrent disk *
      
      l_e2_find_next_51:
      // get disk from path/cd
      call fs_disk  // KEEP ecx, esi, edi
      
      // fsid
      push eax
      movzx edi, al
      shl edi, 5  // assert sizeof DiskInfoRec = 32
      mov al, disk_info.fsid[edi]
      or al, al
      jnz l_e2_find_next_520
        pop eax
        push eax
        call fs_load_fsid  // KEEP edx, ebx, esi, edi
        
      l_e2_find_next_520:
      cmp al, FSID_EXT2
      jnz l_e2_find_next_521
        pop eax
        call e2_find_file
        jmp short l_e2_find_next_528
        
      l_e2_find_next_521:
      cmp al, FSID_NTFS
      jnz l_e2_find_next_522
        pop eax
        //... NTFS_fopen
        mov al, ERC_NOT_IMPLEMENTED
        jmp l_e2_find_next_527
        
      l_e2_find_next_522:
      cmp al, FSID_FAT12
      jnz l_e2_find_next_523
        // FAT12
        pop eax
        mov al, ERC_NOT_IMPLEMENTED
        jmp l_e2_find_next_527
        
      l_e2_find_next_523:
      cmp al, FSID_CD
      jnz l_e2_find_next_524
        // CD
        pop eax
        mov al, ERC_NOT_IMPLEMENTED
        jmp l_e2_find_next_527
        
      l_e2_find_next_524:
      pop eax
      mov al, ERC_UNKNOWN_FILESYSTEM
      jmp l_e2_find_next_527
      
  l_e2_find_next_525:
  cmp al, ERC_LINK
  jz near l_e2_find_next_51
    test al, al
    jz l_e2_find_next_528
      jmp l_e2_find_next_527
  
  l_e2_find_next_526:
  // same disk
  mov take_link, 0
  mov al, e2_ldiskn
  call e2_find_file
  test al, al
  jz l_e2_find_next_528
    
    l_e2_find_next_527:
    xor eax, eax
    mov edi, VA_SYSTEM + offset e2_inode
    mov ecx, sizeof INode / 4
    cld
    rep stosd
    jmp short l_e2_find_next_529
  
l_e2_find_next_528:
call e2_load_inode

l_e2_find_next_529:
mov edi, fs_rec

// time
mov eax, e2_inode.i_ctime
call t_unix2ftime
mov [es:edi + offset SearchRec.CreationTime], eax
mov [es:edi + offset SearchRec.CreationTime + 4], edx
mov eax, e2_inode.i_atime
call t_unix2ftime
mov [es:edi + offset SearchRec.LastAccessTime], eax
mov [es:edi + offset SearchRec.LastAccessTime + 4], edx
mov eax, e2_inode.i_mtime
call t_unix2ftime
mov [es:edi + offset SearchRec.LastWriteTime], eax
mov [es:edi + offset SearchRec.LastWriteTime + 4], edx

// File size
mov ecx, e2_inode.i_size
mov [es:edi + offset SearchRec.FileSize], ecx
mov edx, e2_inode.i_dir_acl
mov [es:edi + offset SearchRec.FileSize + 4], edx

// File attributes
mov eax, FILE_ATTRIBUTE_LINUX
test e2_inode.i_mode, EXT2_S_IFDIR  // directory
jz l_e2_find_next_56
  or al, FILE_ATTRIBUTE_DIRECTORY
  
l_e2_find_next_56:
movzx edx, word ptr e2_inode.i_mode
shl edx, 8
or eax, edx  // fa += i_mode << 8

test edx, EXT2_S_IFSYS << 8
jz l_e2_find_next_57
  or al, FILE_ATTRIBUTE_SYSTEM  // ((imode >> 8) & 0E0h) = 80h => system file
  
l_e2_find_next_57:
or [es:edi + offset SearchRec.FileAttributes], eax

mov al, 0
jmp short l_e2_find_next_9

l_e2_find_next_6:
mov al, ERC_FS
jmp short l_e2_find_next_9

l_e2_find_next_7:
mov al, 1

l_e2_find_next_9:
ret

// IN: edx -> filename, esi = new atribs (<<8)
// OUT: al = erc
e2_chmod:
push esi
  call e2_find_file
pop edx
test al, al
jnz near l_e2_chmod_9
  push edx
    call e2_load_inode
  pop edx
  test al, al
  jnz l_e2_chmod_9
  // chk access
  mov eax, p_current
  mov edi, [es:eax + offset ThreadRec.uid]
  and edi, 0xFFFFFF  // root
  jz l_e2_chmod_0
    //mov al, e2_ldiskn
    //shl eax, 24
    movzx eax, e2_inode.i_uid
    cmp eax, edi
    jz l_e2_chmod_0
      mov al, ERC_ACCESS_DENIED
      jmp short l_e2_chmod_9
      
  l_e2_chmod_0:
  // atribs
  shr edx, 8
  mov ax, e2_inode.i_mode
  
  mov cx, ax
  and cx, EXT2_S_IFSYS
  mov bx, dx
  and bx, EXT2_S_IFSYS
  xor cx, bx
  jz l_e2_chmod_2
    push eax
      call s_chkstarter
    pop eax
    jz l_e2_chmod_1
      mov al, ERC_ONLY_STARTER
      jmp short l_e2_chmod_9
    
    l_e2_chmod_1:
    and ax, 0xFE00 - EXT2_S_IFSYS
    and dx, 0x01FF + EXT2_S_IFSYS
    jmp short l_e2_chmod_3
    
  l_e2_chmod_2:
  and ax, 0xFE00
  and dx, 0x01FF
  
  l_e2_chmod_3:
  or ax, dx
  mov e2_inode.i_mode, ax
  call e2_save_inode

l_e2_chmod_9:
ret

// IN: esi = offset to files
// OUT: al = erc, edx:ecx = ftime
e2_get_mtime:
mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_get_mtime_2
  push esi
    call e2_prepare
  pop esi

l_e2_get_mtime_2:
mov ebx, files.file[esi]
call e2_load_inode
mov eax, e2_inode.i_mtime
call t_unix2ftime
xchg eax, ecx
mov al, 0
ret

// IN: esi = offset to files, edx:ecx = ftime
// OUT: al = erc
e2_set_mtime:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jnz l_e2_set_mtime_1
  mov al, ERC_READ_ONLY
  jmp short l_e2_set_mtime_9

l_e2_set_mtime_1:
mov dword ptr fs_ftime[0], ecx
mov dword ptr fs_ftime[4], edx
mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_set_mtime_2
  push esi
    call e2_prepare
  pop esi

l_e2_set_mtime_2:
mov ebx, files.file[esi]
call e2_load_inode
mov eax, dword ptr fs_ftime[0]
mov edx, dword ptr fs_ftime[4]
call t_ftime2unix
mov e2_inode.i_mtime, eax
call e2_save_inode

l_e2_set_mtime_9:
ret

// IN: al = ldiskn
e2_backup:
cmp al, e2_ldiskn
jz l_e2_backup_1
  call e2_prepare
  
l_e2_backup_1:
movzx esi, e2_ldiskn
shl esi, 5  // assert sizeof DiskInfoRec = 32
test byte ptr disk_info.flags[esi], DISK_FLAGS_DIRTY
jnz l_e2_backup_2
  mov al, 0
  ret
  
l_e2_backup_2:
cmp disk_info.fsid[esi], FSID_EXT2
jz l_e2_backup_3
  mov al, ERC_FS
  ret
  
l_e2_backup_x:
mov al, ERC_FS
ret

l_e2_backup_3:
and byte ptr disk_info.flags[esi], -1 - DISK_FLAGS_DIRTY

// calc groups
mov eax, e2_sb.s_blocks_count
dec eax
dec eax
xor edx, edx
mov ecx, e2_sb.s_blocks_per_group
jecxz l_e2_backup_x

div ecx
inc eax
mov e2_groups, eax

// calc gblocks
mov eax, e2_groups
shl eax, 5  // assert sizeof GroupBlock = 32
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, 1
shl edx, cl
dec edx
add eax, edx
shr eax, cl
mov e2_gblocks, eax

// foreach block
xor ebx, ebx
inc ebx

l_e2_backup_5:
  cmp ebx, e2_groups
  jnb near l_e2_backup_6
    mov e2_group0, ebx
    call e2_load_group
    // eax = first block in group
    mov eax, e2_group
    mov ecx, e2_sb.s_blocks_per_group
    mul ecx
    inc eax
    
    mov ebx, eax
    inc eax // sb
    add eax, e2_gblocks
    cmp eax, e2_gb.bg_block_bitmap
    ja near l_e2_backup_58
      // * space for backup copies at block ebx *
      // super block
      mov eax, e2_group0
      mov e2_sb.s_block_group_nr, ax
      mov cl, byte ptr e2_sb.s_log_block_size
      add cl, 10
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl
      mov ecx, sizeof SuperBlock
      mov edi, VA_SYSTEM + offset e2_sb
      mov ah, 3  // write
      mov al, e2_ldiskn
      push edx
       push ebx
        call e2_diskmain
       pop ebx
      pop edx
      mov ecx, e2_sb.s_log_block_size
      mov eax, 1024
      shl eax, cl
      add ebx, eax  // ebx += block
      adc edx, 0
      // group blocks
      cmp cl, 0
      jnz l_e2_backup_52
        // 1024
        mov eax, 2048
        
      l_e2_backup_52:
      mov e2_ofs, eax
      
      inc ecx
      mov eax, e2_gblocks
      shl eax, cl
      xchg eax, ecx  // ecx = e2_gblocks << (log2 + 1)
      
      l_e2_backup_55:
        push edx
         push ebx
          push ecx
            xor edx, edx
            mov ebx, e2_ofs
            mov ecx, 512
            mov edi, VA_SYSTEM + offset hd_buffer
            mov ah, 2  // read
            mov al, e2_ldiskn
            call e2_diskmain
          pop ecx
         pop ebx
        pop edx
        add e2_ofs, 512
        push edx
         push ebx
          push ecx
            mov ecx, 512
            mov edi, VA_SYSTEM + offset hd_buffer
            mov ah, 3  // write
            mov al, e2_ldiskn
            call e2_diskmain
          pop ecx
         pop ebx
        pop edx
        add ebx, 512
        adc edx, 0
        loop l_e2_backup_55
      
    l_e2_backup_58:
    mov ebx, e2_group0
    inc ebx
    jmp l_e2_backup_5
  
l_e2_backup_6:
ret

// IN: al = ldiskn
// OUT: al = erc, edx:ecx = free bytes
e2_diskfree:
cmp al, e2_ldiskn
jz l_e2_diskfree_1
  call e2_prepare
  
l_e2_diskfree_1:
mov eax, e2_sb.s_free_blocks_count
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, eax
shl eax, cl
xor cl, 31
inc cl
shr edx, cl
xchg eax, ecx
mov al, 0
ret

RESERVED_INODES = EXT2_FIRST_INO - 1
LOG_INODES = 10 + 2

// IN: al = ldiskn, edi = logblocksize (0..3)
e2_format:
and al, 31
mov fs_ldiskn_format, al

// diskmain
movzx esi, al
shl esi, 5  // log2(DiskInfoRec)
mov esi, disk_info.main[esi]
or esi, esi
jnz l_e2_format_0
  mov al, ERC_INVALID_DISK_NUMBER
  ret

l_e2_format_0:
mov fs_diskmain_format, esi

cmp edi, 4
jb l_e2_format_1
  mov al, ERC_INVALID_VALUE
  ret
  
l_e2_format_1:
add edi, 10

// disk size
push edi
  mov ah, 4
  mov al, fs_ldiskn_format
  call fs_diskmain_format
  mov dword ptr e2_disksize[0], eax
  mov dword ptr e2_disksize[4], edx
pop edi

// super block
mov eax, dword ptr e2_disksize[0]
mov edx, dword ptr e2_disksize[4]
shr eax, LOG_INODES
mov ebx, edx
shr edx, LOG_INODES
shl ebx, 32 - LOG_INODES
or eax, ebx
mov e2_sb.s_inodes_count, eax

l_e2_format_10:
mov ecx, edi
mov ebx, 1
shl ebx, cl
mov eax, dword ptr e2_disksize[4]
xor edx, edx
div ebx
test eax, eax
jz l_e2_format_11
  inc edi
  cmp edi, 3
  jna l_e2_format_10
    dec edi
    mov eax, -1
    jmp short l_e2_format_12

l_e2_format_11:
mov eax, dword ptr e2_disksize[0]
div ebx  // assert blocks_count < 4 Gi

l_e2_format_12:
mov e2_sb.s_blocks_count, eax

mov e2_sb.s_r_blocks_count, 0
mov ecx, edi
sub cl, 10
jecxz l_e2_format_21
  mov e2_sb.s_first_data_block, 0 // 1024 1, else 0
  jmp short l_e2_format_22
  
l_e2_format_21:
  mov e2_sb.s_first_data_block, 1 // 1024 1, else 0

l_e2_format_22:
mov e2_sb.s_log_block_size, ecx
mov e2_sb.s_log_frag_size, ecx
mov ebx, 1
add cl, 10 + 3 // 8192 * block_size
shl ebx, cl
mov e2_sb.s_blocks_per_group, ebx
mov e2_sb.s_frags_per_group, ebx
mov e2_sb.s_inode_size, 128

// calc groups
mov eax, e2_sb.s_blocks_count
dec eax
dec eax
xor edx, edx
div e2_sb.s_blocks_per_group
inc eax
mov e2_groups, eax

// calc gblocks
mov eax, e2_groups
shl eax, 5  // assert sizeof GroupBlock = 32
mov ecx, edi
mov ebx, 1
shl ebx, cl
dec ebx  // ebx = block_size - 1
add eax, ebx
shr eax, cl
mov e2_gblocks, eax

// calc inodes per group, free inodes
mov eax, e2_sb.s_inodes_count
xor edx, edx
div e2_groups
shl eax, 7  // log s_inode_size
dec eax
or eax, ebx
inc eax
shr eax, 7  // log s_inode_size
mov e2_sb.s_inodes_per_group, eax
mul e2_groups
mov e2_sb.s_inodes_count, eax
sub eax, RESERVED_INODES
mov e2_sb.s_free_inodes_count, eax

// group blocks, free blocks
xor eax, eax
mov e2_sb.s_free_blocks_count, eax
xor esi, esi

l_e2_format_5:
  xor ebx, ebx
  cmp esi, 0
  jnz l_e2_format_52
    // group 0
    mov ebx, e2_gblocks
    add ebx, e2_sb.s_first_data_block
    jmp short l_e2_format_53
    
  l_e2_format_52:
  cmp esi, 1
  jnz l_e2_format_53
    // group 1
    mov ebx, e2_gblocks
    inc ebx
    
  l_e2_format_53:
  mov eax, esi
  mul e2_sb.s_blocks_per_group
  inc eax
  add eax, ebx
  
  mov e2_gb.bg_block_bitmap, eax
  // zero bitmap, keep eax, ebx, esi, edi
  push esi
   push edi
    push eax
     push ebx
      
      push edi
        mov edi, VA_SYSTEM + offset hd_buffer
        xor eax, eax
        mov ecx, 512 / 4
        cld
        rep stosd
      pop ecx
      
      mov ch, cl
      mov ebx, e2_gb.bg_block_bitmap
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl  // edx:ebx = block_bitmap << block_size_log
      
      mov cl, ch
      sub cl, 9
      mov eax, 1
      shl eax, cl
      xchg eax, ecx  // ecx = sectors512
      
      l_e2_format_535:
        push ecx
         push edx
          push ebx
            mov ecx, 512
            mov edi, VA_SYSTEM + offset hd_buffer
            mov ah, 3  // write
            mov al, fs_ldiskn_format
            call fs_diskmain_format
          pop ebx
         pop edx
        pop ecx
        add ebx, 512
        loop l_e2_format_535
        
     pop ebx
    pop eax
   pop edi
  pop esi

  inc eax
  mov e2_gb.bg_inode_bitmap, eax
  // zero bitmap, keep eax, ebx, esi, edi
  push esi
   push edi
    push eax
     push ebx
      
      mov ecx, edi
      
      mov ch, cl
      mov ebx, e2_gb.bg_inode_bitmap
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl  // edx:ebx = inode_bitmap << block_size_log
      
      mov cl, ch
      sub cl, 9
      mov eax, 1
      shl eax, cl
      xchg eax, ecx  // ecx = sectors512
      
      l_e2_format_536:
        push ecx
         push edx
          push ebx
            mov ecx, 512
            mov edi, VA_SYSTEM + offset hd_buffer
            mov ah, 3  // write
            mov al, fs_ldiskn_format
            call fs_diskmain_format
          pop ebx
         pop edx
        pop ecx
        add ebx, 512
        loop l_e2_format_536
        
     pop ebx
    pop eax
   pop edi
  pop esi

  
  // reserved inodes
  test esi, esi
  jnz l_e2_format_546
    push esi
     push edi
      push eax
       push ebx
        mov e2_tmp, (1 << RESERVED_INODES) - 1  // inodes reserved
        xor edx, edx
        mov ebx, eax
        mov ecx, edi
        shl ebx, cl
        mov ecx, 4
        mov edi, VA_SYSTEM + offset e2_tmp
        mov ah, 3  // write
        mov al, fs_ldiskn_format
        call fs_diskmain_format
       pop ebx
      pop eax
     pop edi
    pop esi
    
  l_e2_format_546:
  inc eax
  mov e2_gb.bg_inode_table, eax
  
  mov eax, e2_sb.s_inodes_per_group
  movzx ecx, e2_sb.s_inode_size
  mul ecx
  mov ecx, edi
  shr eax, cl
  
  mov edx, e2_sb.s_blocks_per_group
  sub edx, eax
  sub edx, ebx
  sub edx, 2  // edx = blocks_per_group - size_inode_table - ebx - 2
  mov e2_gb.bg_free_blocks_count, dx
  
  mov eax, e2_sb.s_inodes_per_group
  test esi, esi
  jnz l_e2_format_548
    sub eax, RESERVED_INODES  // inodes reserved
    
  l_e2_format_548:
  mov e2_gb.bg_free_inodes_count, ax
  
  mov e2_gb.bg_used_dirs_count, 0
  
  // last group, KEEP esi  IN ebx  OUT edx
  mov eax, esi
  inc eax
  cmp eax, e2_groups
  jnz l_e2_format_56
    dec eax
    mul e2_sb.s_blocks_per_group
    inc eax
    mov edx, e2_sb.s_blocks_count
    sub edx, eax  // edx = blocks_count - (esi * blocks_per_group) - 1
    mov eax, ebx
    add eax, 2  // eax = ebx + 2
    cmp edx, eax
    jnb l_e2_format_55
      xor eax, eax
      xor edx, edx
      mov e2_gb.bg_free_inodes_count, ax
      mov e2_gb.bg_free_blocks_count, dx
      jmp short l_e2_format_558
      
    l_e2_format_55:
    sub edx, eax  // edx - eax
    mov ebx, edx
    mov eax, e2_sb.s_inodes_per_group
    movzx ecx, e2_sb.s_inode_size
    mul ecx
    mov ecx, edi
    shr eax, cl  // eax = inodes_per_group * inode_size / block_size
    cmp ebx, eax
    jnb l_e2_format_551
      shl eax, cl
      xor edx, edx
      div ecx
      mov e2_gb.bg_free_inodes_count, ax
      xor edx, edx
      mov e2_gb.bg_free_blocks_count, dx
      jmp short l_e2_format_558
    
    l_e2_format_551:
    sub ebx, eax  // ebx = edx - eax
    mov edx, ebx
    mov e2_gb.bg_free_blocks_count, dx
    
    l_e2_format_558:  // new edx
  
  l_e2_format_56:
  // sb free blocks
  add e2_sb.s_free_blocks_count, edx
  
  // write gb, KEEP esi, edi
  push esi
   push edi
    mov ebx, esi
    shl ebx, 5  // assert sizeof GroupBlock = 32
    mov ecx, edi
    mov edx, 1
    shl edx, cl
    cmp cl, 10
    jnz l_e2_format_57
      add edx, 1024
      
    l_e2_format_57:
    add ebx, edx
    xor edx, edx
    mov edi, VA_SYSTEM + offset e2_gb
    mov ecx, sizeof GroupBlock
    mov ah, 3 // write
    mov al, fs_ldiskn_format
    call fs_diskmain_format
   pop edi
  pop esi
    
  // next esi
  inc esi
  cmp esi, e2_groups
  jb near l_e2_format_5

// root inode
push edi
  mov edi, VA_SYSTEM + offset e2_inode
  mov ecx, sizeof INode / 4
  xor eax, eax
  cld
  rep stosd
  mov e2_inode.i_mode, EXT2_S_IFDIR | ACCESS_DEFAULT
pop edi

mov eax, EXT2_ROOT_INO - 1
movzx ecx, e2_sb.s_inode_size
mul ecx
mov ebx, e2_gblocks
add ebx, e2_sb.s_first_data_block
add ebx, 1 + 1 + 1  // boot_block, block_bitmap, inode_bitmap
mov ecx, edi
shl ebx, cl
add ebx, eax
xor edx, edx
mov edi, VA_SYSTEM + offset e2_inode
mov ecx, sizeof INode
mov ah, 3 // write
mov al, fs_ldiskn_format
call fs_diskmain_format

// write sb
mov edi, VA_SYSTEM + offset e2_sb
mov ecx, sizeof SuperBlock
mov ebx, 1024
xor edx, edx
mov ah, 3 // write
mov al, fs_ldiskn_format
call fs_diskmain_format

ret

// only starter, root
// IN: edx -> filename, esi = new owner
// OUT: al = erc
e2_chown:
push esi
  call e2_find_file
pop esi
test al, al
jnz l_e2_chown_9
  // chkstarter
  call s_chkstarter
  test al, al
  jnz l_e2_chown_9
    // chk root
    mov eax, p_current
    mov eax, [es:eax + offset ThreadRec.uid]
    test eax, 0xFFFFFF
    jnz l_e2_chown_7
      // change owner
      push esi
        call e2_load_inode
      pop esi
      test al, al
      jnz l_e2_chown_9
        mov e2_inode.i_uid, si
        call e2_save_inode
        jmp short l_e2_chown_9
    
    l_e2_chown_7:
    mov al, ERC_ACCESS_DENIED
  
l_e2_chown_9:
ret

// only starter, root or owner
// IN: edx -> filename, esi = new group
// OUT: al = erc
e2_chgrp:
push esi
  call e2_find_file
pop esi
test al, al
jnz l_e2_chgrp_9
  // chkstarter
  call s_chkstarter
  test al, al
  jnz l_e2_chgrp_9
    // get inode
    push esi
      call e2_load_inode
    pop esi
    test al, al
    jnz l_e2_chgrp_9
      // chk root or owner
      mov eax, p_current
      mov edi, [es:eax + offset ThreadRec.uid]
      and edi, 0xFFFFFF
      jz l_e2_chgrp_4
        //mov al, e2_ldiskn
        //shl eax, 24
        movzx eax, e2_inode.i_uid
        cmp eax, edi
        jz l_e2_chgrp_4
          mov al, ERC_ACCESS_DENIED
          jmp short l_e2_chgrp_9
          
      l_e2_chgrp_4:
      // set gid
      mov e2_inode.i_gid, si
      call e2_save_inode
  
l_e2_chgrp_9:
ret

NTFS_HEADER_SIZE = 1024
NTFS_NODE_SIZE = 4096

PA_NT_NODEBUF = PA_DMA_BUFFERS + FD_CACHE_SIZE
PA_NT_NODEBUF2 = PA_DMA_BUFFERS + FD_CACHE_SIZE + NTFS_NODE_SIZE

NT_SMALL_INDEX = -2
NT_FILE_FLAGS_DEFAULT = FILE_ATTRIBUTE_ARCHIVE + FILE_ATTRIBUTE_NORMAL
INDEX_ENTRY_MIN_SIZE = 40

NTFS_ATR_STANDARD_INFORMATION = 10h
NTFS_ATR_ATTRIBUTE_LIST = 20h
NTFS_ATR_FILE_NAME = 30h
NTFS_ATR_OBJECT_ID = 40h
NTFS_ATR_SECURITY_DESCRIPTOR = 50h
NTFS_ATR_VOLUME_NAME = 60h
NTFS_ATR_VOLUME_INFORMATION = 70h
NTFS_ATR_DATA = 80h
NTFS_ATR_INDEX_ROOT = 90h
NTFS_ATR_INDEX_ALLOCATION = 0A0h
NTFS_ATR_INDEX_BITMAP = 0B0h
NTFS_ATR_REPARSE_POINT = 0C0h
NTFS_ATR_EA_INFORMATION = 0D0h
NTFS_ATR_EA = 0E0h
NTFS_ATR_PROPERTY_SET = 0F0h
NTFS_ATR_LOGGED_UTILITY_STREAM = 100h

MFT_MFT = 0
MFT_MFTMIRR = 1
MFT_LOGFILE = 2
MFT_VOLUME = 3
MFT_ATTRDEF = 4
MFT_ROOT = 5
MFT_BITMAP = 6
MFT_BOOT = 7
MFT_BADCLUS = 8
MFT_SECURE = 9
MFT_UPCASE = 10
MFT_EXTEND = 11
MFT_FIRST_FILE = 24

struct FileDescriptor{
  uns4 signature
  uns2 offset_update_seq, size_update_seq
  uns8 log_file_seq_n
  uns2 del_count, hard_links, first_atr_ofs, flags  // 0 free, 1 file, 3 dir
  uns4 real_size, allocated
  uns8 base_file
  uns2 next_atr_id
  uns1 padding[6]
  uns2 update_seq_n
  uns2 update_seq_array[2]
  uns1 padding2[2]
}

struct StandardHeader{
  uns4 atr_type, atr_size
  bool non_resident
  uns1 name_len
  uns2 name_ofs
  uns2 flags  // 1 compressed, 4000h encrypted, 8000h sparse
  uns2 atr_id
  uns4 atr_len
  uns2 atr_ofs
  uns1 idx_flag, padding1
  // +attribute
}

struct StandardInformation{
  // +StandardHeader
  DateTime created
  DateTime modified
  DateTime mft_modified
  DateTime accessed
  uns4 permissions
  uns4 max_versions // 0 - not limited
  uns4 version
}

struct FileNameAtr{
  // +StandardHeader
  uns8 parent_dir
  DateTime created
  DateTime modified
  DateTime mft_modified
  DateTime accessed
  uns8 allocated
  uns8 size
  uns4 flags  // 1 read only, 2 hidden, 4 system, 20h arch, 40h dev,
              // 100h tmp, 200h sparse, 400h reparse, 10000000h dir
  uns4 ea_reparse
  uns1 name_len, namespace
  uns2 name[256]  
}

struct DataAtr{  // also INDEX_ALLOCATION (non-resident)
  uns4 atr_type, atr_size
  bool non_resident
  uns1 name_len
  uns2 name_ofs
  uns2 flags  // 1 compressed, 4000h encrypted, 8000h sparse
  uns2 atr_id
  uns8 init_vcn, final_vcn
  uns2 data_runs_ofs, compression_unit_len
  uns4 padding
  uns8 atr_alloc_size, atr_real_size, init_data_len
  // +name?
  // +data runs
}

struct IndexAtr{
  // +StandardHeader
  // Index Root
  uns4 atr_type, collation, alloc_index_entry_size
  uns1 clusters_per_index_record, padding[3]
  // Index Header
  uns4 ofs_first_index_entry  // from index header - 0x10
  uns4 index_entries_total_len  // from index header - 0x28
  uns4 index_entries_alloc  // from index header - 0x28
  uns1 flags  // 0 small index, 1 large index
  uns1 padding[3]
  // +IndexEntry[]
}

struct StandardIndexHeader{
  uns4 signature  // INDX
  uns2 ofs_fixup_array
  uns2 entries_in_fixup_array
  uns8 log_file
  uns8 vcn_of_this_record
}

struct NodeHeader{
  uns4 ofs_start_index_entry_list  // from node header
  uns4 ofs_end_index_entry_list  // from node header
  uns4 ofs_end_allocated  // from node header
  uns4 flags  // 1:any children
}

struct IndexEntry{
  uns8 file_ref
  uns2 index_entry_size
  uns2 filename_ofs
  uns2 index_flags  // 1:points to a subnode, 2:last index entry in the node
  uns2 padding
  uns8 parent_ref
  uns8 created, modified, mftmodified, accessed
  uns8 allocated, real_size, file_flags
  uns1 filename_len, namespace
  // +file_name
  // +[index_entry_size - 8] VCN of the subnode, aligned 64
}

struct FullIndexEntry{
  IndexEntry entry
  word filename[256]
  uns8 subnode  // after filename
}

struct AtrListEntry{
  uns4 AttributeTypeCode
  uns2 RecordLength
  uns1 AttributeNameLength
  uns1 AttributeNameOffset
  uns8 LowestVcn
  uns8 SegmentReference
  uns8 Reserved
}

uns1 nt_ldiskn, nt_cluzlog, nt_mftrecsizelog, nt_mod8, nt_negative

[dalign 32]
uns4 nt_file, nt_node, nt_diskmain, nt_tmp, nt_relofs, nt_endrelofs
uns4 nt_parentino, nt_nameofs, nt_subnode, nt_rootnode, nt_atrofs
uns4 nt_file_ref, nt_atr, nt_lastofs, nt_size, nt_curnode

[dalign 64]
uns8 nt_mft, nt_mftmirr, nt_base, nt_count, nt_oldbase, nt_vcn, nt_lcn
uns8 nt_remain, nt_rw_base, nt_rw_count, nt_bitmapbase, nt_bitmapsize
uns8 nt_first_free, nt_tmp8, nt_filesize, nt_disksize

uns1 nt_buffer[NTFS_HEADER_SIZE]

FullIndexEntry nt_fullentry

// IN: al = ldiskn
// OUT: nt_ldiskn, nt_diskmain, nt_mft, nt_cluzlog, nt_mftrecsizelog
//      nt_bitmapbase, nt_bitmapsize, nt_first_free = 0
nt_prepare:
mov nt_ldiskn, al
mov nt_file, -1
mov nt_node, -1

// diskmain
movzx esi, al
shl esi, 5  // log2(DiskInfoRec)
mov esi, disk_info.main[esi]
or esi, esi
jnz l_nt_prepare_0
  mov al, ERC_INVALID_DISK_NUMBER
  jmp l_nt_prepare_9

l_nt_prepare_0:
mov nt_diskmain, esi

// cluster size
mov ah, 2  // read
mov al, nt_ldiskn
xor edx, edx
mov ebx, 13
mov ecx, 1
mov edi, VA_SYSTEM + offset nt_cluzlog
call nt_diskmain
test al, al
jnz near l_nt_prepare_9

mov al, nt_cluzlog
mov ah, 1
xor cl, cl

l_nt_prepare_2:
  test al, ah
  jnz l_nt_prepare_28
    shl ah, 1
    inc cl
    cmp cl, 8
    jb l_nt_prepare_2
      mov al, ERC_FS
      jmp l_nt_prepare_9
  
l_nt_prepare_28:
add cl, 9
mov nt_cluzlog, cl

// MFT adr
mov ah, 2  // read
mov al, nt_ldiskn
xor edx, edx
mov ebx, 48
mov ecx, 8
mov edi, VA_SYSTEM + offset nt_mft
call nt_diskmain
test al, al
jnz near l_nt_prepare_9

mov eax, dword ptr nt_mft[0]
mov edx, dword ptr nt_mft[4]
mov ebx, eax
mov cl, nt_cluzlog
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
mov dword ptr nt_mft[0], eax
mov dword ptr nt_mft[4], edx

// MFT mirr adr
mov ah, 2  // read
mov al, nt_ldiskn
xor edx, edx
mov ebx, 56
mov ecx, 8
mov edi, VA_SYSTEM + offset nt_mftmirr
call nt_diskmain
test al, al
jnz near l_nt_prepare_9

mov eax, dword ptr nt_mftmirr[0]
mov edx, dword ptr nt_mftmirr[4]
mov ebx, eax
mov cl, nt_cluzlog
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
mov dword ptr nt_mftmirr[0], eax
mov dword ptr nt_mftmirr[4], edx
/*
// Size of MFT record
mov ah, 2  // read
mov al, nt_ldiskn
xor edx, edx
mov ebx, 64
mov ecx, 1
mov edi, VA_SYSTEM + offset nt_mftrecsizelog
call nt_diskmain
test al, al
jnz l_nt_prepare_9

mov al, nt_mftrecsizelog
cmp al, 80h
jb l_nt_prepare_3
  neg al
  mov nt_mftrecsizelog, al
  jmp short l_nt_prepare_39
  
l_nt_prepare_3:
xor cl, cl
mov ah, 1

l_nt_prepare_35:
  test al, ah
  jnz l_nt_prepare_38
    shl ah, 1
    inc cl
    cmp cl, 8
    jb l_nt_prepare_35
      mov al, ERC_FS
      jmp short l_nt_prepare_9

l_nt_prepare_38:
mov nt_mftrecsizelog, cl
*/

mov nt_mftrecsizelog, 10  // :KLUDGE:

// Bitmap
xor eax, eax
mov dword ptr nt_first_free[0], eax
mov dword ptr nt_first_free[4], eax

mov esi, MFT_BITMAP
call nt_load_file
test al, al
jnz l_nt_prepare_48

mov eax, NTFS_ATR_DATA
call nt_find_atr
test esi, esi
jz l_nt_prepare_48

xor eax, eax
mov dword ptr nt_vcn[0], eax
mov dword ptr nt_vcn[4], eax
call nt_vcn2lcn
mov eax, dword ptr nt_lcn[0]
mov edx, dword ptr nt_lcn[4]
mov ebx, eax
mov cl, nt_cluzlog
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
mov dword ptr nt_bitmapbase[0], eax
mov dword ptr nt_bitmapbase[4], edx
mov eax, dword ptr nt_remain[0]
mov edx, dword ptr nt_remain[4]
mov ebx, eax
mov cl, nt_cluzlog
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
mov dword ptr nt_bitmapsize[0], eax
mov dword ptr nt_bitmapsize[4], edx
jmp l_nt_prepare_8

l_nt_prepare_48:
xor eax, eax
mov dword ptr nt_bitmapbase[0], eax
mov dword ptr nt_bitmapbase[4], eax
mov dword ptr nt_bitmapsize[0], eax
mov dword ptr nt_bitmapsize[4], eax

l_nt_prepare_8:
mov al, 0

l_nt_prepare_9:
ret

// IN: esi = file number, nt_file
// OUT: al = erc, nt_file
// BEFORE: nt_prepare
nt_load_file:
xor eax, eax
cmp esi, nt_file
jz l_nt_load_file_8
  mov nt_file, esi
  mov nt_node, -1
  
  mov cl, nt_mftrecsizelog
  mov eax, esi
  shl esi, cl
  xor cl, 31
  inc cl
  shr eax, cl
  
  mov ebx, dword ptr nt_mft[0]
  mov edx, dword ptr nt_mft[4]
  add ebx, esi
  adc edx, eax
  mov ecx, NTFS_HEADER_SIZE
  mov edi, VA_SYSTEM + offset nt_buffer
  mov al, nt_ldiskn
  mov ah, 2  // read
  call nt_diskmain
  
  push eax
    // update sequence
    movzx ebx, word ptr nt_buffer[offset FileDescriptor.offset_update_seq]
    mov ax, word ptr nt_buffer[ebx + 2]
    mov word ptr nt_buffer[510], ax
    mov ax, word ptr nt_buffer[ebx + 4]
    mov word ptr nt_buffer[1022], ax
  pop eax
  
l_nt_load_file_8:
ret

// IN: eax = type, nt_buffer
// OUT: ds:esi = offset || 0
// KEEP: edx, ebx, edi
nt_find_atr:
mov esi, offset nt_buffer
movzx ecx, word ptr nt_buffer[offset FileDescriptor.first_atr_ofs]
add esi, ecx

l_nt_find_atr_5:
cmp eax, [esi]
jz l_nt_find_atr_9
  cmp dword ptr [esi], -1
  jz l_nt_find_atr_8
    mov ecx, [esi + 4]
    jecxz l_nt_find_atr_8
      add esi, ecx
      cmp esi, offset nt_buffer + NTFS_HEADER_SIZE
      jb l_nt_find_atr_5
    
l_nt_find_atr_8:
xor esi, esi

l_nt_find_atr_9:
ret

// IN: nt_vcn, ds:esi -> non-resident atr
// OUT: al = erc, nt_lcn, nt_remain, nt_lastofs, nt_oldbase
nt_vcn2lcn:
mov ecx, [esi + offset DataAtr.atr_size]
add ecx, esi
movzx eax, word ptr [esi + offset DataAtr.data_runs_ofs]
add esi, eax

xor eax, eax
mov dword ptr nt_oldbase[0], eax
mov dword ptr nt_oldbase[4], eax
mov nt_lastofs, eax

cmp esi, ecx
jnb near l_nt_vcn2lcn_8

l_nt_vcn2lcn_1:
mov al, [esi]
inc esi
cmp al, 0
jz near l_nt_vcn2lcn_8
  mov edx, esi
  dec edx
  mov nt_lastofs, edx
  
  mov dl, al
  mov dh, al
  and dl, 0Fh
  shr dh, 4
  xor eax, eax
  mov dword ptr nt_base[0], eax
  mov dword ptr nt_base[4], eax
  mov dword ptr nt_count[0], eax
  mov dword ptr nt_count[4], eax
  
  // size
  xor edi, edi

  l_nt_vcn2lcn_21:
  cmp dl, 0
  jz l_nt_vcn2lcn_22
    mov al, [esi]
    inc esi
    mov byte ptr nt_count[edi], al
    inc edi
    dec dl
    jmp short l_nt_vcn2lcn_21
    
  l_nt_vcn2lcn_22:
  // base
  xor edi, edi

  l_nt_vcn2lcn_23:
  cmp dh, 0
  jz l_nt_vcn2lcn_24
    mov al, [esi]
    inc esi
    mov byte ptr nt_base[edi], al
    inc edi
    cmp dh, 1
    jnz l_nt_vcn2lcn_238
      cmp al, 80h
      jb l_nt_vcn2lcn_238
        // - base
        l_nt_vcn2lcn_235:
          cmp edi, 8
          jnb l_nt_vcn2lcn_238
            mov byte ptr nt_base[edi], 0FFh
            inc edi
            jmp short l_nt_vcn2lcn_235
      
    l_nt_vcn2lcn_238:
    dec dh
    jmp short l_nt_vcn2lcn_23
    
  l_nt_vcn2lcn_24:
  // base + oldbase
  mov eax, dword ptr nt_oldbase[0]
  mov edx, dword ptr nt_oldbase[4]
  add eax, dword ptr nt_base[0]
  adc edx, dword ptr nt_base[4]
  mov dword ptr nt_oldbase[0], eax
  mov dword ptr nt_oldbase[4], edx
  mov dword ptr nt_base[0], eax
  mov dword ptr nt_base[4], edx
  
  // nt_vcn ? nt_count
  mov edx, dword ptr nt_vcn[4]
  mov eax, dword ptr nt_vcn[0]
  mov ebx, dword ptr nt_count[4]
  mov ecx, dword ptr nt_count[0]
  cmp edx, ebx
  jnz l_nt_vcn2lcn_25
    cmp eax, ecx
    
  l_nt_vcn2lcn_25:
  jb l_nt_vcn2lcn_26
    // nt_vcn >= nt_count
    sub eax, ecx
    sbb edx, ebx
    mov dword ptr nt_vcn[0], eax
    mov dword ptr nt_vcn[4], edx
    jmp l_nt_vcn2lcn_1
    
  l_nt_vcn2lcn_26:
  sub ecx, eax
  sbb ebx, edx  // count - vcn
  add eax, dword ptr nt_base[0]
  add edx, dword ptr nt_base[4]
  mov dword ptr nt_remain[0], ecx
  mov dword ptr nt_remain[4], ebx  // remain = count - vcn
  mov dword ptr nt_lcn[0], eax
  mov dword ptr nt_lcn[4], edx  // lcn = vcn + base
  
  mov al, 0
  
  ret
  
l_nt_vcn2lcn_8:
xor eax, eax
mov dword ptr nt_remain[0], eax
mov dword ptr nt_remain[4], eax
mov dword ptr nt_lcn[0], eax
mov dword ptr nt_lcn[4], eax

mov al, ERC_FS
ret

// IN: edx:ebx = file offset, ecx = size
// OUT: nt_rw_base, nt_rw_count, nt_relofs, nt_endrelofs
// BEFORE: nt_prepare, nt_load_file
// KEEP: esi, edi
nt_prepare_values:
push edi
 push ecx
  push ebx
   push edx
    mov edi, 1
    mov cl, nt_cluzlog
    shl edi, cl
    dec edi
    mov eax, ebx
    and eax, edi
    mov nt_relofs, eax
    mov eax, edx
    shr ebx, cl
    shr edx, cl
    xor cl, 31
    inc cl
    shl eax, cl
    or ebx, eax
    mov dword ptr nt_rw_base[4], edx
    mov dword ptr nt_rw_base[0], ebx
   pop edx
  pop ebx
 pop ecx
 dec ecx
 mov eax, ebx
 add eax, ecx
 and eax, edi
 mov nt_endrelofs, eax
 add ebx, ecx
 adc edx, 0
 mov cl, nt_cluzlog
 mov eax, edx
 shr ebx, cl
 shr edx, cl
 xor cl, 31
 inc cl
 shl eax, cl
 or ebx, eax
 sub ebx, dword ptr nt_rw_base[0]
 sbb edx, dword ptr nt_rw_base[4]
 add ebx, 1
 adc edx, 0
 mov dword ptr nt_rw_count[0], ebx
 mov dword ptr nt_rw_count[4], edx
pop edi
ret

l_nt_read_x0:
mov al, 0
ret

// IN: ds:esi -> atr,
//     edx:ebx = file offset, ecx = size, es:edi -> data
// OUT: al = 0 || erc, ecx = sizeread
// BEFORE: nt_prepare, nt_load_file
nt_read:
jecxz l_nt_read_x0
mov nt_atrofs, esi
mov al, [esi + offset StandardHeader.non_resident]
test al, 1
jnz l_nt_read_09
  // resident
  test edx, edx
  jz l_nt_read_01
    
    l_nt_read_00:
    mov al, ERC_OUT_OF_RANGE
    jmp l_nt_read_9
    
  l_nt_read_01:
  mov edx, [esi + offset StandardHeader.atr_len]
  cmp ebx, edx
  ja l_nt_read_00
  
  mov eax, ecx
  add eax, ebx
  cmp eax, edx
  jna l_nt_read_02
    mov eax, edx
    sub eax, ebx
    mov ecx, eax
  
  l_nt_read_02:
  movzx eax, word ptr [esi + offset StandardHeader.atr_ofs]
  add eax, ebx
  add esi, eax
  push ecx
    cld
    rep movsb
  pop ecx
  jmp l_nt_read_8
  
l_nt_read_09:
// non-resident
call nt_prepare_values  // keep esi, edi
xor eax, eax
mov nt_size, eax

l_nt_read_1:
mov ecx, nt_size
cmp dword ptr nt_rw_count[4], 0
jnz l_nt_read_2
  cmp dword ptr nt_rw_count[0], 0
  jz near l_nt_read_8  // if nt_rw_count == 0 then goto l_nt_read_8

l_nt_read_2:

mov esi, nt_atrofs
mov eax, dword ptr nt_rw_base[0]
mov edx, dword ptr nt_rw_base[4]
mov dword ptr nt_vcn[0], eax
mov dword ptr nt_vcn[4], edx
push edi
  call nt_vcn2lcn
pop edi
test al, al
jnz near l_nt_read_9

mov cl, nt_cluzlog
mov ebx, dword ptr nt_lcn[0]
mov edx, dword ptr nt_lcn[4]
mov eax, ebx
shl ebx, cl
shl edx, cl
xor cl, 31
inc cl
shr eax, cl
or edx, eax  // edx:ebx = nt_lcn << cluzlog

mov ecx, dword ptr nt_rw_count[0]
mov eax, dword ptr nt_rw_count[4]
cmp eax, dword ptr nt_remain[4]
jnz l_nt_read_61
  cmp ecx, dword ptr nt_remain[0]

l_nt_read_61:
jna l_nt_read_62
  // eax:ecx > nt_remain
  mov ecx, dword ptr nt_remain[0]
  mov eax, dword ptr nt_remain[4]

l_nt_read_62:
// eax:ecx = min(nt_rw_count, nt_remain)
sub dword ptr nt_rw_count[0], ecx
sbb dword ptr nt_rw_count[4], eax  // nt_rw_count -= eax:ecx
add dword ptr nt_rw_base[0], ecx
adc dword ptr nt_rw_base[4], eax  // nt_rw_base += eax:ecx

mov esi, ecx
mov cl, nt_cluzlog
shl esi, cl
mov ecx, esi  // ecx << cluzlog
mov eax, nt_relofs
add ebx, eax
adc edx, 0  // edx:ebx += nt_relofs
sub ecx, eax  // ecx -= nt_relofs
xor eax, eax
mov nt_relofs, eax  // nt_relofs = 0

cmp dword ptr nt_rw_count[0], 0
jnz l_nt_read_64
  cmp dword ptr nt_rw_count[4], 0
  jnz l_nt_read_64
    // nt_rw_count == 0
    push ecx
      mov esi, 1
      mov cl, nt_cluzlog
      shl esi, cl
      dec esi
      sub esi, nt_endrelofs
    pop ecx
    sub ecx, esi  // ecx -= (1 << cluzlog) - 1 - endrelofs

l_nt_read_64:
// read from disk  IN: edx:ebx, ecx, edi
add nt_size, ecx
mov al, nt_ldiskn
mov ah, 2  // read
call nt_diskmain
test al, al
jnz l_nt_read_9
  jmp l_nt_read_1

l_nt_read_8:
mov al, 0

l_nt_read_9:
ret

// IN: ebx = node, nt_cluzlog, nt_buffer, nt_node
// OUT: al = erc, [PA_NT_NODEBUF]
// BEFORE: nt_prepare
nt_load_node:
xor eax, eax
cmp ebx, nt_node
jz near l_nt_load_node_9  
  mov nt_node, ebx
  
  mov eax, NTFS_ATR_INDEX_ALLOCATION
  call nt_find_atr
  test esi, esi
  jz l_nt_load_node_92
  
  mov ebx, nt_node
  mov cl, nt_cluzlog
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  mov ecx, NTFS_NODE_SIZE
  mov edi, VA_SYSTEM + PA_NT_NODEBUF
  call nt_read
  
  push eax
    
    // fixup update sequence
    movzx ebx, word ptr [offset StandardIndexHeader.ofs_fixup_array + PA_NT_NODEBUF]
    add ebx, PA_NT_NODEBUF + 2
    mov edi, PA_NT_NODEBUF + 510
    
    l_nt_load_node_5:
    cmp edi, PA_NT_NODEBUF + NTFS_NODE_SIZE
    jnb l_nt_load_node_8
      mov ax, [ebx]
      mov [edi], ax
      add ebx, 2
      add edi, 512
      jmp short l_nt_load_node_5
      
    l_nt_load_node_8:
    
  pop eax
  
l_nt_load_node_9:
ret

l_nt_load_node_92:
mov al, ERC_FS
ret

// OUT: al = erc, nt_rootnode, esi -> IndexAtr, edi -> end
// BEFORE: nt_prepare, nt_load_file
// KEEP: edx
nt_get_root_node:
mov eax, NTFS_ATR_INDEX_ROOT
call nt_find_atr
test esi, esi
jnz l_nt_get_root_node_2
  mov al, ERC_FS
  jmp l_nt_get_root_node_9
  
l_nt_get_root_node_2:
movzx eax, word ptr [esi + offset StandardHeader.atr_ofs]
add esi, eax  // esi -> root index
mov cl, byte ptr [esi + offset IndexAtr.flags]

mov eax, [esi + offset IndexAtr.ofs_first_index_entry]
mov edi, [esi + offset IndexAtr.index_entries_total_len]
add esi, eax
add edi, esi
add esi, 16  // esi -> root index entry

mov nt_rootnode, NT_SMALL_INDEX
test cl, 1  // large
jz l_nt_get_root_node_4
  
  mov eax, edi
  sub eax, esi
  cmp eax, INDEX_ENTRY_MIN_SIZE
  jnb l_nt_get_root_node_4
    movzx eax, word ptr [esi + offset IndexEntry.index_entry_size]
    add eax, esi
    mov ebx, [eax - 8]
    mov nt_rootnode, ebx
  
l_nt_get_root_node_4:

mov al, 0

l_nt_get_root_node_9:
ret

// IN: es:edx -> filenamez, ebx = 0 || dirino, al = ldiskn
// OUT: al = 0 || erc, ebx = ino, nt_parentino, nt_nameofs
nt_find_file:
cmp al, nt_ldiskn
jz l_nt_find_file_01
  push edx
   push ebx
    call nt_prepare
   pop ebx
  pop edx
  
l_nt_find_file_01:
test ebx, ebx
jnz l_nt_find_file_1
  mov ebx, MFT_ROOT


l_nt_find_file_1:
mov nt_parentino, ebx
mov nt_nameofs, edx

push edx
  mov esi, ebx
  call nt_load_file
pop edx

cmp byte ptr nt_buffer[offset FileDescriptor.flags], 3  // directory
jz l_nt_find_file_2
  mov al, ERC_PATH_NOT_FOUND
  jmp l_nt_find_file_9

l_nt_find_file_2:

// index root
call nt_get_root_node
test al, al
jnz near l_nt_find_file_9

mov ebx, nt_rootnode
cmp ebx, NT_SMALL_INDEX
jnz near l_nt_find_file_large

// small index  
l_nt_find_file_25:
  cmp esi, edi
  jnb near l_nt_find_file_notfound
    mov al, byte ptr [esi + offset IndexEntry.index_flags]
    test al, 2  // last
    jz l_nt_find_file_252
      // last
      
      l_nt_find_file_golarge:
      test al, 1  // has subnode
      jz near l_nt_find_file_notfound
        movzx eax, word ptr [esi + offset IndexEntry.index_entry_size]
        add esi, eax
        mov ebx, [esi - 8]
        jmp l_nt_find_file_large
        
    l_nt_find_file_252:
    movzx ecx, byte ptr [esi + offset IndexEntry.filename_len]
    push esi
     push edi
      add esi, sizeof IndexEntry
      mov edi, VA_SYSTEM + offset fs_utf8buf
      mov fs_bigendian, 0
      shl ecx, 1
      call fs_toutf8  // keep edx
      mov esi, VA_SYSTEM + offset fs_utf8buf
      call fs_cmp  // keep edx
     pop edi
    pop esi
    cmp al, 0  // equal
    jnz l_nt_find_file_26
      mov ebx, esi
      jmp l_nt_find_file_found
      
    l_nt_find_file_26:
    cmp al, -1  // smaller
    jnz l_nt_find_file_next
      mov al, byte ptr [esi + offset IndexEntry.index_flags]
      jmp l_nt_find_file_golarge
        
    l_nt_find_file_next:  // next
    movzx eax, word ptr [esi + offset IndexEntry.index_entry_size]
    test eax, eax
    jz near l_nt_find_file_notfound
      add esi, eax
      jmp l_nt_find_file_25
    
      
// large index
l_nt_find_file_large:  // IN: ebx = node
// read node
push edx
  call nt_load_node
pop edx
test al, al
jnz near l_nt_find_file_9

mov ebx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader
mov edi, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
add edi, PA_NT_NODEBUF + sizeof StandardIndexHeader

l_nt_find_file_521:
  cmp ebx, edi
  jnb l_nt_find_file_notfound  // end of node
  
  movzx esi, word ptr [ebx + offset IndexEntry.index_entry_size]
  add esi, ebx
  mov esi, dword ptr [esi - 8]  // esi = subnode
  
  mov al, [ebx + offset IndexEntry.index_flags]
  cmp al, 3  // last + subnode
  jnz l_nt_find_file_523
    
    l_nt_find_file_522:
    mov ebx, esi
    jmp l_nt_find_file_large
    
  l_nt_find_file_523:
  cmp al, 2  // last
  jz l_nt_find_file_notfound  // end of node
  
  push edx
   push edi
    push esi
      
      movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
      mov esi, sizeof IndexEntry
      add esi, ebx
      mov edi, VA_SYSTEM + offset fs_utf8buf
      push ebx
        mov fs_bigendian, 0
        shl ecx, 1
        call fs_toutf8  // keep edx
        /*
        //$$$
        mov esi, VA_SYSTEM + offset fs_utf8buf
        call wrs
        */
        mov esi, VA_SYSTEM + offset fs_utf8buf
        call fs_cmp  // keep edx
      pop ebx
      
    pop esi
   pop edi
  pop edx
  
  cmp al, 0  // equal
  jz l_nt_find_file_found
  
  cmp al, -1  // smaller
  jnz l_nt_find_file_528
    mov al, [ebx + offset IndexEntry.index_flags]
    test al, 1
    jnz l_nt_find_file_522  // subnode
      jmp short l_nt_find_file_notfound
    
  l_nt_find_file_528:
  movzx ecx, word ptr [ebx + offset IndexEntry.index_entry_size]
  jecxz l_nt_find_file_notfound
    add ebx, ecx
    jmp l_nt_find_file_521


l_nt_find_file_notfound:
// not found
call fs_next_edx

l_nt_find_file_54:
cmp byte ptr [es:edx], 0
jz l_nt_find_file_56
  mov al, ERC_PATH_NOT_FOUND
  jmp short l_nt_find_file_9
  
l_nt_find_file_56:
mov al, ERC_FILE_NOT_FOUND
jmp short l_nt_find_file_9


l_nt_find_file_found:  // IN: ebx -> IndexEntry
// found
call fs_next_edx  // keep ebx

mov eax, dword ptr [ebx + offset IndexEntry.real_size]
mov dword ptr nt_filesize[0], eax
mov eax, dword ptr [ebx + offset IndexEntry.real_size + 4]
mov dword ptr nt_filesize[4], eax

mov ebx, dword ptr [ebx + offset IndexEntry.file_ref]

// link?
//cmp byte ptr fd_buffer[7], EXT2_FT_SYMLINK
//jz l_nt_find_file_60

cmp byte ptr [es:edx], 0  // end of es:edx?
jnz near l_nt_find_file_1

l_nt_find_file_8:
mov al, 0

l_nt_find_file_9:  
ret


// link
l_nt_find_file_60:
test take_link, 1
jz l_nt_find_file_608
  cmp byte ptr [es:edx], 0
  jz l_nt_find_file_8
  
l_nt_find_file_608:
//call nt_follow_link
test al, al
jnz l_nt_find_file_9
  jmp l_nt_find_file_1

nt_init:
mov nt_ldiskn, -1
ret

// IN: es:edx -> filenamez, esi -> files, al = ldiskn || 1, ebx = 0 || dirino
// OUT: al = 0 || erc, esi = fhandle
nt_fopen:
push esi
  call nt_find_file
pop esi
test al, al
jnz near l_nt_fopen_x

mov files.file[esi], ebx  // ino

push esi
  mov esi, ebx
  call nt_load_file
pop esi
test al, al
jnz near l_nt_fopen_x

// check not directory
cmp byte ptr nt_buffer[offset FileDescriptor.flags], 1  // regular file
jz l_nt_fopen_1
  mov al, ERC_FILE_NOT_FOUND
  jmp l_nt_fopen_x
  
l_nt_fopen_1:
// check read
mov al, files.mode[esi]
and al, 3Fh
cmp al, 3
jna l_nt_fopen_2
  mov al, ERC_READ_ONLY
  jmp l_nt_fopen_x
  
l_nt_fopen_2:
// load file info
xor eax, eax
mov dword ptr files.pos[esi], eax
mov dword ptr files.pos[esi + 4], eax

push esi
  mov eax, NTFS_ATR_FILE_NAME
  call nt_find_atr
  mov ebx, esi
pop esi
test ebx, ebx
jnz l_nt_fopen_3
  mov al, ERC_FS
  jmp l_nt_fopen_x
  
l_nt_fopen_3:
mov eax, dword ptr nt_filesize[0]
mov edx, dword ptr nt_filesize[4]
mov dword ptr files.size[esi], eax
mov dword ptr files.size[esi + 4], edx

push esi
  mov eax, NTFS_ATR_DATA
  call nt_find_atr
  mov ebx, esi
pop esi
test ebx, ebx
jnz l_nt_fopen_4
  mov al, ERC_FS
  jmp l_nt_fopen_x
  
l_nt_fopen_4:
test byte ptr [ebx + offset StandardHeader.non_resident], 1
jnz l_nt_fopen_5
  // resident
  mov eax, [ebx + offset StandardHeader.atr_len]
  xor edx, edx
  mov dword ptr files.size[esi], eax
  mov dword ptr files.size[esi + 4], edx
  
l_nt_fopen_5:
shr esi, 5 // assert sizeof OpenFileRec = 32
mov al, 0

l_nt_fopen_9:
ret

l_nt_fopen_x:
mov files.mode[esi], 0
xor esi, esi
jmp short l_nt_fopen_9

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizeread
nt_fread:
mov al, files.disk[esi]
cmp al, nt_ldiskn
jz l_nt_fread_1
  push esi
   push edi
    push ecx
     call nt_prepare
    pop ecx
   pop edi
  pop esi
  
l_nt_fread_1:
push esi
 push edi
  push ecx
   mov esi, files.file[esi]
   call nt_load_file
  pop ecx
 pop edi
pop esi

push edi
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  
  mov edi, dword ptr files.size[esi + 4]
  mov eax, dword ptr files.size[esi]
  sub edi, edx
  sbb eax, ebx  // edi:eax = size - pos
  cmp edi, 0
  jnz l_nt_fread_2
    cmp eax, ecx
    jnb l_nt_fread_2
      mov ecx, eax
      
  l_nt_fread_2:
pop edi

push esi
 push ecx
  mov eax, NTFS_ATR_DATA
  call nt_find_atr  // keep edx, ebx, edi
 pop ecx
 call nt_read
pop esi
test al, al
jnz l_nt_fread_9
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  add ebx, ecx
  adc edx, 0
  mov dword ptr files.pos[esi], ebx
  mov dword ptr files.pos[esi + 4], edx
  
  mov al, 0
  
l_nt_fread_9:
ret

// IN: esi = offset to files
nt_fclose:
mov files.mode[esi], 0
mov al, 0
ret

// IN: esi = offset to files, edx:ebx = file offset
nt_fsetpos:
cmp edx, dword ptr files.size[esi + 4]
jnz l_nt_fsetpos_1
  cmp ebx, dword ptr files.size[esi]
  
l_nt_fsetpos_1:
jna l_nt_fsetpos_2
  // pos > size
  mov ebx, dword ptr files.size[esi]
  mov edx, dword ptr files.size[esi + 4]
  
l_nt_fsetpos_2:
mov dword ptr files.pos[esi], ebx
mov dword ptr files.pos[esi + 4], edx
ret

// IN: al = ldiskn, es:edx -> path
nt_cd:
xor ebx, ebx
call nt_find_file
or al, al
jnz l_nt_cd_9
  
  mov edx, p_current
  mov al, nt_ldiskn
  mov [es:edx + offset ThreadRec.curdisk], al
  mov [es:edx + offset ThreadRec.curdir], ebx
  mov al, 0
  
l_nt_cd_9:
ret

// IN: al = ldiskn, ebx = dir, es:edx -> dir(mask)
//     fs_rec, fs_srchofs, fs_dosplit
nt_find_first:
cmp al, nt_ldiskn
jz l_nt_find_first_01
  push edx
   push ebx
    call nt_prepare
   pop ebx
  pop edx

l_nt_find_first_01:
test fs_dosplit, 1
jz l_nt_find_first_2
  call fs_split  // KEEP ebx
  test al, al
  jnz near l_nt_find_first_9
  
l_nt_find_first_2:
// Find dir  IN: ebx
cmp byte ptr [es:edx], 0
jnz l_nt_find_first_3
  
  // no path
  test ebx, ebx
  jnz l_nt_find_first_4
    // root
    mov ebx, MFT_ROOT
    jmp short l_nt_find_first_4
  
l_nt_find_first_3:
  mov al, nt_ldiskn
  
  call nt_find_file
  
  cmp al, ERC_FILE_NOT_FOUND
  jnz l_nt_find_first_33
    mov al, ERC_PATH_NOT_FOUND
    
  l_nt_find_first_33:
  cmp al, ERC_LINK
  jz near l_nt_find_first_99
  
  test al, al
  jnz near l_nt_find_first_9
  
l_nt_find_first_4:
// set srch
mov esi, fs_srchofs
mov srch.File[esi], ebx

mov esi, ebx
call nt_load_file
test al, al
jnz l_nt_find_first_9

// index root
call nt_get_root_node
test al, al
jnz near l_nt_find_first_9

mov ebx, nt_rootnode
cmp ebx, NT_SMALL_INDEX
jnz l_nt_find_first_48
  // small index
  mov eax, esi
  mov ecx, edi
  jmp short l_nt_find_first_6

l_nt_find_first_48:
  // large index  IN: ebx = node
  call nt_load_node
  test al, al
  jnz l_nt_find_first_9
  
  mov eax, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
  mov ecx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
  
l_nt_find_first_6:
// both
mov ebx, nt_rootnode
xor edx, edx

mov esi, fs_srchofs
mov dword ptr srch.Cluster[esi], ebx
mov dword ptr srch.Cluster[esi + 4], edx
mov srch.Offset[esi], eax
mov srch.Size[esi], ecx  // offset of end

call nt_find_next

test al, al
jz l_nt_find_first_99

l_nt_find_first_9:
mov esi, fs_srchofs
mov word ptr srch.ThreadId[esi], -1

l_nt_find_first_99:
ret

// IN: fs_rec, fs_srchofs, nt_ldiskn, nt_diskmain
// OUT: al = 0 || erc
// USES: fd_buffer
nt_find_next:
mov esi, fs_srchofs
mov al, srch.Disk[esi]
cmp al, nt_ldiskn
jz l_nt_find_next_1
  push esi
    call nt_prepare
  pop esi
  
l_nt_find_next_1:
mov esi, srch.File[esi]
call nt_load_file

mov esi, fs_srchofs
mov ebx, dword ptr srch.Cluster[esi]
mov nt_subnode, ebx
cmp ebx, NT_SMALL_INDEX
jz l_nt_find_next_11
  // large index
  call nt_load_node
  test al, al
  jnz near l_nt_find_next_9
  
l_nt_find_next_11:
// both
mov esi, fs_srchofs
mov ebx, srch.Offset[esi]
mov ecx, srch.Size[esi]  // offset of end

mov eax, dword ptr srch.Cluster[esi]
cmp eax, NT_SMALL_INDEX
jnz l_nt_find_next_15
  // small index
  cmp ebx, ecx
  jnb near l_nt_find_next_7
    jmp short l_nt_find_next_16

l_nt_find_next_15:
  // large index
  cmp ebx, ecx
  jnb near l_nt_find_next_6
  
  add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader
  add ecx, PA_NT_NODEBUF + sizeof StandardIndexHeader
  
  l_nt_find_next_16:
  // both
  movzx eax, word ptr [ebx + offset IndexEntry.index_entry_size]
  add eax, ebx
  mov edx, dword ptr [eax - 8]  // edx = subnode

  mov al, [ebx + offset IndexEntry.index_flags]
  test al, 1  // has subnode
  jz l_nt_find_next_18
    // has child
    mov ebx, edx
    mov nt_subnode, ebx
    call nt_load_node
    test al, al
    jnz near l_nt_find_next_9
    
    mov esi, fs_srchofs
    mov ebx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
    mov ecx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
    mov eax, nt_subnode
    mov srch.Offset[esi], ebx
    mov srch.Size[esi], ecx
    mov dword ptr srch.Cluster[esi], eax
    jmp l_nt_find_next_15
    
l_nt_find_next_18:
// found  IN: al, ebx, esi
test al, 2  // last
jnz near l_nt_find_next_6

l_nt_find_next_2:
movzx eax, word ptr [ebx + offset IndexEntry.index_entry_size]
add srch.Offset[esi], eax

movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
mov esi, sizeof IndexEntry
add esi, ebx
mov edi, VA_SYSTEM + offset fs_utf8buf
mov fs_bigendian, 0
shl ecx, 1
push ebx
  call fs_toutf8
pop ebx
test al, al
jnz near l_nt_find_next_9

// IsMatch?
mov esi, fs_srchofs
add esi, offset srch.FileMask
mov edi, offset fs_utf8buf
push ebx
  call fs_ismatch
pop ebx
test al, al
jnz near l_nt_find_next_11

// Valid file?
mov eax, [ebx + offset IndexEntry.file_ref]
cmp eax, MFT_FIRST_FILE
jb near l_nt_find_next_11

// Not DOS?
mov al, [ebx + offset IndexEntry.namespace]
cmp al, 2  // DOS namespace
jz near l_nt_find_next_11

// * Found - copy to fs_rec *

// File name
mov esi, offset fs_utf8buf
mov edi, fs_rec
add edi, offset SearchRec.FileName

l_nt_find_next_25:
  mov al, [esi]
  mov [es:edi], al
  cmp al, 0
  jz l_nt_find_next_28
    inc esi
    inc edi
    jmp l_nt_find_next_25
    
l_nt_find_next_28:

// init fs_rec
mov edi, fs_rec
xor eax, eax
push edi
  mov ecx, 7
  rep stosd
pop edi

// time
mov eax, dword ptr [ebx + offset IndexEntry.created]
mov edx, dword ptr [ebx + offset IndexEntry.created + 4]
mov [es:edi + offset SearchRec.CreationTime], eax
mov [es:edi + offset SearchRec.CreationTime + 4], edx
mov eax, dword ptr [ebx + offset IndexEntry.modified]
mov edx, dword ptr [ebx + offset IndexEntry.modified + 4]
mov [es:edi + offset SearchRec.LastWriteTime], eax
mov [es:edi + offset SearchRec.LastWriteTime + 4], edx
mov eax, dword ptr [ebx + offset IndexEntry.accessed]
mov edx, dword ptr [ebx + offset IndexEntry.accessed + 4]
mov [es:edi + offset SearchRec.LastAccessTime], eax
mov [es:edi + offset SearchRec.LastAccessTime + 4], edx

// File size
mov eax, dword ptr [ebx + offset IndexEntry.real_size]
mov [es:edi + offset SearchRec.FileSize], eax
mov edx, dword ptr [ebx + offset IndexEntry.real_size + 4]
mov [es:edi + offset SearchRec.FileSize + 4], edx

// File attributes
mov eax, dword ptr [ebx + offset IndexEntry.file_flags]
test eax, 0x10000000
jz l_nt_find_next_3
  or eax, FILE_ATTRIBUTE_DIRECTORY
  
l_nt_find_next_3:
and eax, 0xFFFFFF
mov [es:edi + offset SearchRec.FileAttributes], eax

mov al, 0
jmp l_nt_find_next_9


l_nt_find_next_6:  // IN: ebx -> IndexEntry
// * end of node *
call nt_get_root_node
mov eax, nt_rootnode
cmp eax, nt_subnode
jz near l_nt_find_next_7

// copy the first name to fd_buffer
mov ebx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader

movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
mov esi, sizeof IndexEntry
add esi, ebx
mov edi, VA_SYSTEM + offset fd_buffer
mov fs_bigendian, 0
shl ecx, 1
call fs_toutf8

mov ebx, nt_rootnode

// find
l_nt_find_next_61:  // IN: ebx = node
mov nt_curnode, ebx
mov eax, nt_rootnode
cmp eax, nt_subnode
jz near l_nt_find_next_7

cmp ebx, NT_SMALL_INDEX
jnz l_nt_find_next_62
  // small
  mov eax, NTFS_ATR_INDEX_ROOT
  call nt_find_atr
  movzx eax, word ptr [esi + offset StandardHeader.atr_ofs]
  add esi, eax  // esi -> root index
  mov eax, [esi + offset IndexAtr.ofs_first_index_entry]
  mov edi, [esi + offset IndexAtr.index_entries_total_len]
  add esi, eax
  add edi, esi
  add esi, 16  // esi -> root index entry
  mov ebx, esi
  jmp short l_nt_find_next_65
  
l_nt_find_next_62:
  // large
  call nt_load_node
  mov ebx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
  add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader
  mov edi, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
  add edi, PA_NT_NODEBUF + sizeof StandardIndexHeader
  
l_nt_find_next_65:
  cmp ebx, edi
  jb l_nt_find_next_67
  
    l_nt_find_next_66:
    mov al, ERC_FS
    jmp l_nt_find_next_9
    
  l_nt_find_next_67:
  mov al, [ebx + offset IndexEntry.index_flags]
  test al, 2  // last
  jnz l_nt_find_next_676
  // compare
  push edi
    movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
    mov esi, sizeof IndexEntry
    add esi, ebx
    mov edi, VA_SYSTEM + offset fs_utf8buf
    push ebx
      mov fs_bigendian, 0
      shl ecx, 1
      call fs_toutf8
      mov esi, VA_SYSTEM + offset fs_utf8buf
      mov edx, VA_SYSTEM + offset fd_buffer
      call fs_cmp
    pop ebx
  pop edi
  
  cmp al, -1  // smaller
  jnz l_nt_find_next_68
    
    l_nt_find_next_676:
    mov al, [ebx + offset IndexEntry.index_flags]
    test al, 1  // has subnode
    jz l_nt_find_next_66
    
    // has child
    movzx esi, word ptr [ebx + offset IndexEntry.index_entry_size]
    add esi, ebx
    mov esi, dword ptr [esi - 8]  // esi = subnode
    cmp esi, nt_subnode
    jz l_nt_find_next_69
      mov ebx, esi
      jmp l_nt_find_next_61
    
  l_nt_find_next_68:
  cmp al, 0
  jz l_nt_find_next_66
  
  movzx ecx, word ptr [ebx + offset IndexEntry.index_entry_size]
  add ebx, ecx
  jmp l_nt_find_next_65
  
l_nt_find_next_69:
// parent node found (nt_curnode = parent, ebx -> indexentry)
mov al, [ebx + offset IndexEntry.index_flags]
test al, 2  // last
jz l_nt_find_next_697
  mov eax, nt_curnode
  mov nt_subnode, eax
  mov ebx, nt_rootnode
  jmp l_nt_find_next_61
  
l_nt_find_next_697:
mov eax, nt_curnode
cmp eax, NT_SMALL_INDEX
jnz l_nt_find_next_698
  // small
  mov ecx, edi
  mov edx, ebx
  jmp short l_nt_find_next_699
  
l_nt_find_next_698:
  // large
  mov ecx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
  mov edx, ebx
  sub edx, PA_NT_NODEBUF + sizeof StandardIndexHeader

l_nt_find_next_699:
mov esi, fs_srchofs
mov srch.Offset[esi], edx
mov srch.Size[esi], ecx
mov dword ptr srch.Cluster[esi], eax
jmp l_nt_find_next_2


l_nt_find_next_7:
mov al, 1

l_nt_find_next_9:
ret

// IN: esi = offset to files
// OUT: al = erc, edx:ecx = ftime
nt_get_mtime:
mov al, files.disk[esi]
cmp al, nt_ldiskn
jz l_nt_get_mtime_2
  push esi
    call nt_prepare
  pop esi

l_nt_get_mtime_2:
mov esi, files.file[esi]
call nt_load_file
test al, al
jnz l_nt_get_mtime_6

mov eax, NTFS_ATR_STANDARD_INFORMATION
call nt_find_atr
mov al, ERC_FS
test esi, esi
jz l_nt_get_mtime_6

mov edx, dword ptr [esi + sizeof StandardHeader + offset StandardInformation.modified + 4]
mov ecx, dword ptr [esi + sizeof StandardHeader + offset StandardInformation.modified + 0]
mov al, 0
ret

l_nt_get_mtime_6:
xor edx, edx
xor ecx, ecx
ret

// IN: al = ldiskn
// OUT: al = erc, edx:ecx = free bytes
// USES: fd_buffer, nt_tmp8, nt_disksize, nt_tmp
nt_diskfree:
cmp al, nt_ldiskn
jz l_nt_diskfree_1
  call nt_prepare
  
l_nt_diskfree_1:
xor eax, eax
mov dword ptr nt_tmp8[0], eax
mov dword ptr nt_tmp8[4], eax

// get disk size
mov ah, 4  // get disk size
mov al, nt_ldiskn
call nt_diskmain  // out edx:eax

mov cl, nt_cluzlog
mov ebx, edx
shr edx, cl
shr eax, cl
xor cl, 31
inc cl
shl ebx, cl
or eax, ebx  // edx:eax = size clusters

mov esi, eax
and esi, 0xFFF  // esi = size clusters % 4096
mov cl, 12
mov ebx, edx
shr edx, cl
shr eax, cl
mov cl, 32 - 12
shl ebx, cl
or eax, ebx  // edx:eax = size clusters / 4096
mov dword ptr nt_disksize[0], eax
mov dword ptr nt_disksize[4], edx

// get bitmap
xor ebx, ebx
xor edx, edx

l_nt_diskfree_5:
mov nt_tmp, 512
cmp dword ptr nt_disksize[0], 0
jnz l_nt_diskfree_51
  cmp dword ptr nt_disksize[4], 0
  jnz l_nt_diskfree_51
    // nt_disksize = 0
    mov nt_tmp, esi
    shr nt_tmp, 3
    jmp short l_nt_diskfree_52
    
l_nt_diskfree_51:
sub dword ptr nt_disksize[0], 1
sbb dword ptr nt_disksize[4], 0

l_nt_diskfree_52:
mov ecx, nt_tmp
mov edi, VA_SYSTEM + offset fd_buffer
mov al, nt_ldiskn
mov ah, 2  // read
push ebx
 push edx
  push esi
    add ebx, dword ptr nt_bitmapbase[0]
    adc edx, dword ptr nt_bitmapbase[4]
    call nt_diskmain
  pop esi
 pop edx
pop ebx
test al, al
jnz near l_nt_diskfree_x

xor ecx, ecx

l_nt_diskfree_55:  // process fd_buffer, keep edx, ebx
  mov al, fd_buffer[ecx]
  cmp al, 0
  jnz l_nt_diskfree_56
    add dword ptr nt_tmp8[0], 8
    adc dword ptr nt_tmp8[4], 0
    jmp short l_nt_diskfree_58
    
  l_nt_diskfree_56:
  cmp al, 255
  jz l_nt_diskfree_58
    
    mov ah, 8
    l_nt_diskfree_575:
      test al, 1
      jnz l_nt_diskfree_578
        add dword ptr nt_tmp8[0], 1
        adc dword ptr nt_tmp8[4], 0
        
      l_nt_diskfree_578:
      shr al, 1
      dec ah
      test ah, ah
      jnz l_nt_diskfree_575
    
  l_nt_diskfree_58:
  inc ecx
  cmp ecx, nt_tmp
  jb l_nt_diskfree_55

add ebx, 512
adc edx, 0

cmp dword ptr nt_disksize[0], 0
jnz near l_nt_diskfree_5
  cmp dword ptr nt_disksize[4], 0
  jnz near l_nt_diskfree_5

// out
mov edx, dword ptr nt_tmp8[4]
mov eax, dword ptr nt_tmp8[0]
mov cl, nt_cluzlog
mov ebx, eax
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
xchg eax, ecx

mov al, 0

l_nt_diskfree_9:
ret

l_nt_diskfree_x:
xor edx, edx
xor ecx, ecx
ret

fs_init:
// Clear files
xor esi, esi

l_fs_init_1:
  mov files.mode[esi], 0
  add esi, sizeof OpenFileRec
  cmp esi, sizeof OpenFileRec * MAX_FILES
  jb l_fs_init_1

// Clear srchrec
xor esi, esi
xor eax, eax
dec eax  // eax = -1

l_fs_init_5:
  mov srch.ThreadId[esi], ax
  add esi, sizeof InSrchRec
  cmp esi, sizeof InSrchRec * MAX_SRCH
  jb l_fs_init_5

// Init subs
call FAT12_init
call cd_init
call e2_init
call nt_init
ret

// IN: al = mode, es:edx -> fname, ah = take_link
// OUT: esi = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
fs_fopen:
call fs_enter

mov fs_mode, al
mov take_link, ah
mov link_depth, 0

l_fs_fopen_0:
// find place
xor esi, esi

l_fs_fopen_1:
cmp files.mode[esi], 0
jz l_fs_fopen_found
  add esi, sizeof OpenFileRec
  cmp esi, MAX_FILES * sizeof OpenFileRec
  jb l_fs_fopen_1

    mov al, ERC_TOO_MANY_OPEN_FILES
    jmp l_fs_fopen_9

l_fs_fopen_found:
// mode
mov files.mode[esi], al

// threadid
mov eax, p_current
sub eax, VA_THREADS
shr eax, 12  // assert sizeof ThreadRec = 4096
mov files.threadid[esi], ax

// get disk from path/cd
call fs_disk  // KEEP ecx, esi, edi
mov files.disk[esi], al

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_open_50
  pop eax
  push eax
  call fs_load_fsid  // KEEP edx, ebx, esi, edi

l_fs_open_50:
cmp al, FSID_EXT2
jnz l_fs_open_51
  // EXT2
  pop eax
  call e2_fopen
  jmp short l_fs_fopen_9

l_fs_open_51:
cmp al, FSID_NTFS
jnz l_fs_open_52
  // NTFS
  pop eax
  call nt_fopen
  jmp short l_fs_fopen_9

l_fs_open_52:
cmp al, FSID_FAT12
jnz l_fs_open_53
  // FAT12
  pop eax
  call FAT12_fopen
  jmp short l_fs_fopen_9

l_fs_open_53:
cmp al, FSID_CD
jnz l_fs_open_59
  // CD
  pop eax
  call cd_fopen
  jmp short l_fs_fopen_9

l_fs_open_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fopen_9:
cmp al, ERC_LINK
jnz l_fs_fopen_99
  mov al, fs_mode
  jmp l_fs_fopen_0
  
l_fs_fopen_99:
call fs_leave
ret

// IN: esi = fhandle, es:edi -> data, ecx = size
fs_fread:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fread_9

// fsid
push edi
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fread_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fread_50:
cmp al, FSID_EXT2
jnz l_fs_fread_51
  pop edi
  call e2_fread
  jmp short l_fs_fread_9

l_fs_fread_51:
cmp al, FSID_NTFS
jnz l_fs_fread_52
  pop edi
  call nt_fread
  jmp short l_fs_fread_9

l_fs_fread_52:
cmp al, FSID_FAT12
jnz l_fs_fread_53
  pop edi
  call FAT12_fread
  jmp short l_fs_fread_9

l_fs_fread_53:
cmp al, FSID_CD
jnz l_fs_fread_59
  pop edi
  call cd_fread
  jmp short l_fs_fread_9

l_fs_fread_59:
pop edi
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fread_9:
call fs_leave
ret

// IN: esi = fhandle, es:edi -> data, ecx = size
fs_fwrite:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fwrite_9

// fsid
push edi
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fwrite_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fwrite_50:
cmp al, FSID_EXT2
jnz l_fs_fwrite_51
  pop edi
  call e2_fwrite
  jmp short l_fs_fwrite_9

l_fs_fwrite_51:
cmp al, FSID_NTFS
jnz l_fs_fwrite_52
  pop edi
  //... NTFS_fwrite
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_fwrite_9

l_fs_fwrite_52:
cmp al, FSID_FAT12
jnz l_fs_fwrite_53
  pop edi
  call FAT12_fwrite
  jmp short l_fs_fwrite_9

l_fs_fwrite_53:
cmp al, FSID_CD
jnz l_fs_fwrite_59
  mov al, ERC_READ_ONLY
  jmp short l_fs_fwrite_9

l_fs_fwrite_59:
pop edi
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fwrite_9:
call fs_leave
ret

// IN: esi = fhandle, edx:ebx = file offset
fs_fsetpos:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fsetpos_9

// fsid
movzx edi, byte ptr files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fsetpos_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fsetpos_50:
cmp al, FSID_EXT2
jnz l_fs_fsetpos_51
  call e2_fsetpos
  jmp short l_fs_fsetpos_9

l_fs_fsetpos_51:
cmp al, FSID_NTFS
jnz l_fs_fsetpos_52
  call nt_fsetpos
  jmp short l_fs_fsetpos_9

l_fs_fsetpos_52:
cmp al, FSID_FAT12
jnz l_fs_fsetpos_53
  call FAT12_fsetpos
  jmp short l_fs_fsetpos_9

l_fs_fsetpos_53:
cmp al, FSID_CD
jnz l_fs_fsetpos_59
  call cd_fsetpos
  jmp short l_fs_fsetpos_9

l_fs_fsetpos_59:
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fsetpos_9:
call fs_leave
ret

// IN: esi = fhandle
fs_fcut:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fcut_9

// fsid
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fcut_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fcut_50:
cmp al, FSID_EXT2
jnz l_fs_fcut_51
  call e2_fcut
  jmp short l_fs_fcut_9

l_fs_fcut_51:
cmp al, FSID_NTFS
jnz l_fs_fcut_52
  //... NTFS_setpos
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_fcut_9

l_fs_fcut_52:
cmp al, FSID_FAT12
jnz l_fs_fcut_59
  call FAT12_fcut
  jmp short l_fs_fcut_9

l_fs_fcut_59:
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fcut_9:
call fs_leave
ret

// IN: esi = fhandle
fs_fclose:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fclose_9

// fsid
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fclose_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fclose_50:
cmp al, FSID_EXT2
jnz l_fs_fclose_51
  call e2_fclose
  jmp short l_fs_fclose_9

l_fs_fclose_51:
cmp al, FSID_NTFS
jnz l_fs_fclose_52
  call nt_fclose
  jmp short l_fs_fclose_9

l_fs_fclose_52:
cmp al, FSID_FAT12
jnz l_fs_fclose_53
  call FAT12_fclose
  jmp short l_fs_fclose_9

l_fs_fclose_53:
cmp al, FSID_CD
jnz l_fs_fclose_59
  call cd_fclose
  jmp short l_fs_fclose_9

l_fs_fclose_59:
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fclose_9:
call fs_leave
ret

// IN: es:edx -> path & dirname, ah = take_link
fs_md:
call fs_enter

mov take_link, ah
mov link_depth, 0

l_fs_md_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_md_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_md_50:
cmp al, FSID_EXT2
jnz l_fs_md_51
  pop eax
  call e2_md
  jmp short l_fs_md_9

l_fs_md_51:
cmp al, FSID_NTFS
jnz l_fs_md_52
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_md_9

l_fs_md_52:
cmp al, FSID_FAT12
jnz l_fs_md_53
  pop eax
  call FAT12_md
  jmp short l_fs_md_9

l_fs_md_53:
cmp al, FSID_CD
jnz l_fs_md_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_md_9

l_fs_md_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_md_9:
cmp al, ERC_LINK
jz l_fs_md_0

call fs_leave
ret

// IN: es:edx -> path, ah = take_link
fs_cd:
call fs_enter
sub esp, MAX_PATH

mov take_link, ah
mov link_depth, 0

l_fs_cd_0:
// merge
mov esi, p_current
add esi, offset ThreadRec.curdirtext

mov edi, esp
call fs_merge
or al, al
jnz near l_fs_cd_9

// disk
mov edx, esp
mov al, [es:edx]

and al, 31
add edx, 3

cmp byte[es:edx], 0
jnz l_fs_cd_2
  mov edi, p_current
  or al, 96
  mov [es:edi + offset ThreadRec.curdisk], al
  xor ebx, ebx
  mov [es:edi + offset ThreadRec.curdir], ebx
  mov al, 0
  jmp l_fs_cd_55
  
l_fs_cd_2:

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_cd_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_cd_50:
cmp al, FSID_EXT2
jnz l_fs_cd_51
  pop eax
  call e2_cd
  jmp short l_fs_cd_55

l_fs_cd_51:
cmp al, FSID_NTFS
jnz l_fs_cd_52
  pop eax
  call nt_cd
  jmp short l_fs_cd_55

l_fs_cd_52:
cmp al, FSID_FAT12
jnz l_fs_cd_53
  pop eax
  call FAT12_cd
  jmp short l_fs_cd_55

l_fs_cd_53:
cmp al, FSID_CD
jnz l_fs_cd_59
  pop eax
  call cd_cd
  //jmp short l_fs_cd_55

// Copy curdirtext
l_fs_cd_55:
or al, al
jnz l_fs_cd_9
  mov esi, esp
  mov edi, p_current
  add edi, offset ThreadRec.curdirtext
  mov ecx, MAX_PATH
  cld
  
  l_fs_cd_56:
    mov al, [es:esi]
    inc esi
    stosb
    cmp al, 0
    jz l_fs_cd_57
      loop l_fs_cd_56
  
  l_fs_cd_57:
  xor eax, eax
  jmp short l_fs_cd_9

l_fs_cd_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_cd_9:
cmp al, ERC_LINK
jz near l_fs_cd_0

add esp, MAX_PATH
call fs_leave
ret

// IN: es:edx -> filename, ah = take_link
fs_rm:
call fs_enter

mov take_link, ah
mov link_depth, 0

l_fs_rm_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_rm_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_rm_50:
cmp al, FSID_EXT2
jnz l_fs_rm_51
  pop eax
  call e2_rm
  jmp short l_fs_rm_9

l_fs_rm_51:
cmp al, FSID_NTFS
jnz l_fs_rm_52
  pop eax
  //... NTFS_rm
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_rm_9

l_fs_rm_52:
cmp al, FSID_FAT12
jnz l_fs_rm_53
  pop eax
  call FAT12_rm
  jmp short l_fs_rm_9

l_fs_rm_53:
cmp al, FSID_CD
jnz l_fs_rm_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_rm_9

l_fs_rm_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_rm_9:
cmp al, ERC_LINK
jz l_fs_rm_0

call fs_leave
ret

// IN: es:edx -> filename, es:esi -> new filename, ah = take_link
fs_rename:
call fs_enter

mov take_link, ah
mov link_depth, 0

l_fs_rename_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_rename_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_rename_50:
cmp al, FSID_EXT2
jnz l_fs_rename_51
  pop eax
  call e2_rename
  jmp short l_fs_rename_9

l_fs_rename_51:
cmp al, FSID_NTFS
jnz l_fs_rename_52
  pop eax
  //... NTFS_rename
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_rename_9

l_fs_rename_52:
cmp al, FSID_FAT12
jnz l_fs_rename_53
  pop eax
  call FAT12_rename
  jmp short l_fs_rename_9

l_fs_rename_53:
cmp al, FSID_CD
jnz l_fs_rename_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_rename_9

l_fs_rename_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_rename_9:
cmp al, ERC_LINK
jz l_fs_rename_0

call fs_leave
ret

// IN: es:edx -> filename, es:esi -> new path, ah = take_link
fs_move:
call fs_enter

mov take_link, ah
mov link_depth, 0

l_fs_move_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_move_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_move_50:
cmp al, FSID_EXT2
jnz l_fs_move_51
  pop eax
  call e2_move
  jmp short l_fs_move_9

l_fs_move_51:
cmp al, FSID_NTFS
jnz l_fs_move_52
  pop eax
  //... NTFS_move
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_move_9

l_fs_move_52:
cmp al, FSID_FAT12
jnz l_fs_move_53
  pop eax
  call FAT12_move
  jmp short l_fs_move_9

l_fs_move_53:
cmp al, FSID_CD
jnz l_fs_move_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_move_9

l_fs_move_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_move_9:
cmp al, ERC_LINK
jz l_fs_move_0

call fs_leave
ret

// IN: edx -> path&mask, edi -> SearchRec, ah = take_link
fs_find_first:
call fs_enter

mov take_link, ah
mov link_depth, 0

mov ebx, p_current
sub ebx, VA_THREADS
shr ebx, 12  // assert sizeof ThreadRec = 4096

// Find free pos  IN: bx = threadid
xor esi, esi
xor eax, eax
dec eax

l_fs_first_3:
cmp esi, sizeof InSrchRec * MAX_SRCH
jnb l_fs_first_4
  cmp srch.ThreadId[esi], ax
  jz l_fs_first_5
    add esi, sizeof InSrchRec
    jmp l_fs_first_3
  
l_fs_first_4:
mov al, ERC_TOO_MANY_SEARCHES
jmp l_fs_first_9

l_fs_first_5:
mov srch.ThreadId[esi], bx
cmp edi, VA_SYSTEM
jb l_fs_first_508
  mov al, ERC_INVALID_SHANDLE
  jmp l_fs_first_9

l_fs_first_508:
mov dword ptr [es:edi + offset SearchRec.Reserved], esi
mov fs_rec, edi
mov fs_srchofs, esi
mov fs_dosplit, 1

l_fs_first_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx  KEEP esi
mov srch.Disk[esi], al

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_first_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_first_50:
cmp al, FSID_EXT2
jnz l_fs_first_51
  pop eax
  call e2_find_first
  jmp short l_fs_first_9

l_fs_first_51:
cmp al, FSID_NTFS
jnz l_fs_first_52
  pop eax
  call nt_find_first
  jmp short l_fs_first_9

l_fs_first_52:
cmp al, FSID_FAT12
jnz l_fs_first_53
  pop eax
  call FAT12_find_first
  jmp short l_fs_first_9

l_fs_first_53:
cmp al, FSID_CD
jnz l_fs_first_59
  pop eax
  call cd_find_first
  jmp short l_fs_first_9

l_fs_first_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_first_9:
cmp al, ERC_LINK
jnz l_fs_first_99
  mov fs_dosplit, 0
  mov esi, fs_srchofs
  jmp l_fs_first_0
  
l_fs_first_99:
call fs_leave
ret

// IN: es:edi -> SearchRec
fs_find_next:
call fs_enter

cmp edi, VA_SYSTEM
jnb l_fs_next_3

mov ebx, p_current
sub ebx, VA_THREADS
shr ebx, 12  // assert sizeof ThreadRec = 4096

mov esi, dword ptr [es:edi + offset SearchRec.Reserved]
cmp esi, sizeof InSrchRec * MAX_SRCH - sizeof InSrchRec
ja l_fs_next_3

cmp srch.ThreadId[esi], bx
jz l_fs_next_4

  l_fs_next_3:
  mov al, ERC_INVALID_SHANDLE
  jmp l_fs_next_9
  
l_fs_next_4:
mov fs_rec, edi
mov fs_srchofs, esi
mov al, srch.Disk[esi]

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_next_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_next_50:
cmp al, FSID_EXT2
jnz l_fs_next_51
  pop eax
  call e2_find_next
  jmp short l_fs_next_9

l_fs_next_51:
cmp al, FSID_NTFS
jnz l_fs_next_52
  pop eax
  call nt_find_next
  jmp short l_fs_next_9

l_fs_next_52:
cmp al, FSID_FAT12
jnz l_fs_next_53
  pop eax
  call FAT12_find_next
  jmp short l_fs_next_9

l_fs_next_53:
cmp al, FSID_CD
jnz l_fs_next_59
  pop eax
  call cd_find_next
  jmp short l_fs_next_9

l_fs_next_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_next_9:
call fs_leave
ret

// IN: es:edi -> SearchRec
fs_find_close:
call fs_enter

cmp edi, VA_SYSTEM
jnb l_fs_find_close_3

mov ebx, p_current
sub ebx, VA_THREADS
shr ebx, 12  // assert sizeof ThreadRec = 4096

mov esi, dword ptr [es:edi + offset SearchRec.Reserved]
cmp esi, sizeof InSrchRec * MAX_SRCH - sizeof InSrchRec
ja l_fs_find_close_3

cmp srch.ThreadId[esi], bx
jz l_fs_find_close_4

  l_fs_find_close_3:
  mov al, ERC_INVALID_SHANDLE
  jmp l_fs_find_close_9
  
l_fs_find_close_4:
mov word ptr srch.ThreadId[esi], -1
mov al, 0

l_fs_find_close_9:
call fs_leave
ret

// IN: es:edx -> filename, esi = atrbs
fs_chmod:
call fs_enter

l_fs_chmod_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_chmod_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_chmod_50:
cmp al, FSID_EXT2
jnz l_fs_chmod_51
  pop eax
  call e2_chmod
  jmp short l_fs_chmod_9

l_fs_chmod_51:
cmp al, FSID_NTFS
jnz l_fs_chmod_52
  pop eax
  //... NTFS_chmod
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chmod_9

l_fs_chmod_52:
cmp al, FSID_FAT12
jnz l_fs_chmod_53
  pop eax
  call FAT12_chmod
  jmp short l_fs_chmod_9

l_fs_chmod_53:
cmp al, FSID_CD
jnz l_fs_chmod_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_chmod_9

l_fs_chmod_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_chmod_9:
cmp al, ERC_LINK
jz l_fs_chmod_0

call fs_leave
ret

// IN: esi = ldiskn
fs_resetdisk:
and esi, 31

call fs_enter

push esi

shl esi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[esi]
or al, al
jnz l_fs_reset_50
  pop eax
  push eax
  mov edi, esi
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_reset_50:
cmp al, FSID_EXT2
jnz l_fs_reset_51
  pop eax
  mov e2_ldiskn, -1
  mov disk_info.fsid[esi], 0
  mov al, 0
  jmp short l_fs_reset_9

l_fs_reset_51:
cmp al, FSID_NTFS
jnz l_fs_reset_52
  pop eax
  mov nt_ldiskn, -1
  mov disk_info.fsid[esi], 0
  mov al, 0
  jmp short l_fs_reset_9

l_fs_reset_52:
cmp al, FSID_FAT12
jnz l_fs_reset_53
  pop eax
  mov FAT12_ldiskn, -1
  jmp short l_fs_reset_9

l_fs_reset_53:
cmp al, FSID_CD
jnz l_fs_reset_59
  pop eax
  call cd_devicechange
  jmp short l_fs_reset_9

l_fs_reset_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_reset_9:
call fs_leave
ret

// IN: ebx = fhandle
// OUT: al = erc, edx:ecx = ftime
fs_get_mtime:
call fs_enter

mov esi, ebx
call fs_check_thread_esi
or al, al
jnz l_fs_get_mtime_9

// fsid
push edi
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_get_mtime_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_get_mtime_50:
cmp al, FSID_EXT2
jnz l_fs_get_mtime_51
  pop edi
  // EXT2
  call e2_get_mtime
  jmp short l_fs_get_mtime_9

l_fs_get_mtime_51:
cmp al, FSID_NTFS
jnz l_fs_get_mtime_52
  pop edi
  // NTFS
  call nt_get_mtime
  jmp short l_fs_get_mtime_9

l_fs_get_mtime_52:
cmp al, FSID_FAT12
jnz l_fs_get_mtime_53
  pop edi
  // FAT12
  call FAT12_get_mtime
  jmp short l_fs_get_mtime_9

l_fs_get_mtime_53:
cmp al, FSID_CD
jnz l_fs_get_mtime_59
  pop edi
  call cd_get_mtime
  jmp short l_fs_get_mtime_9

l_fs_get_mtime_59:
pop edi
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_get_mtime_9:
call fs_leave
ret

// IN: ebx = fhandle, edx:ecx = ftime
// OUT: al = erc
fs_set_mtime:
call fs_enter

mov esi, ebx
call fs_check_thread_esi
or al, al
jnz l_fs_set_mtime_9

// fsid
push edi
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_set_mtime_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_set_mtime_50:
cmp al, FSID_EXT2
jnz l_fs_set_mtime_51
  pop edi
  // EXT2
  call e2_set_mtime
  jmp short l_fs_set_mtime_9

l_fs_set_mtime_51:
cmp al, FSID_NTFS
jnz l_fs_set_mtime_52
  pop edi
  //... NTFS_set_mtime
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_set_mtime_9

l_fs_set_mtime_52:
cmp al, FSID_FAT12
jnz l_fs_set_mtime_53
  pop edi
  // FAT12
  call FAT12_set_mtime
  jmp short l_fs_set_mtime_9

l_fs_set_mtime_53:
cmp al, FSID_CD
jnz l_fs_set_mtime_59
  pop edi
  mov al, ERC_READ_ONLY
  jmp short l_fs_set_mtime_9

l_fs_set_mtime_59:
pop edi
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_set_mtime_9:
call fs_leave
ret

// IN: esi = ldiskn
// OUT: al = erc, edx:ecx = free bytes
fs_diskfree:
call fs_enter

// fsid
mov eax, esi
and al, 31
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_diskfree_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_diskfree_50:
cmp al, FSID_EXT2
jnz l_fs_diskfree_51
  pop eax
  call e2_diskfree
  jmp short l_fs_diskfree_9

l_fs_diskfree_51:
cmp al, FSID_NTFS
jnz l_fs_diskfree_52
  pop eax
  call nt_diskfree
  jmp short l_fs_diskfree_9

l_fs_diskfree_52:
cmp al, FSID_FAT12
jnz l_fs_diskfree_53
  pop eax
  call FAT12_diskfree
  jmp short l_fs_diskfree_9

l_fs_diskfree_53:
cmp al, FSID_CD
jnz l_fs_diskfree_59
  pop eax
  xor ecx, ecx
  xor edx, edx
  mov al, 0
  jmp short l_fs_diskfree_9

l_fs_diskfree_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_diskfree_9:
call fs_leave
ret

// only starter, root
// IN: es:edx -> filenamez, esi = new owner
// OUT: al = erc
fs_chown:
call fs_enter

l_fs_chown_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_chown_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_chown_50:
cmp al, FSID_EXT2
jnz l_fs_chown_51
  pop eax
  call e2_chown
  jmp short l_fs_chown_9

l_fs_chown_51:
cmp al, FSID_NTFS
jnz l_fs_chown_52
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chown_9

l_fs_chown_52:
cmp al, FSID_FAT12
jnz l_fs_chown_53
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chown_9

l_fs_chown_53:
cmp al, FSID_CD
jnz l_fs_chown_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_chown_9

l_fs_chown_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_chown_9:
cmp al, ERC_LINK
jz l_fs_chown_0

call fs_leave
ret

// only starter, root or owner
// IN: es:edx -> filenamez, esi = new group
// OUT: al = erc
fs_chgrp:
call fs_enter

l_fs_chgrp_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_chgrp_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_chgrp_50:
cmp al, FSID_EXT2
jnz l_fs_chgrp_51
  pop eax
  call e2_chgrp
  jmp short l_fs_chgrp_9

l_fs_chgrp_51:
cmp al, FSID_NTFS
jnz l_fs_chgrp_52
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chgrp_9

l_fs_chgrp_52:
cmp al, FSID_FAT12
jnz l_fs_chgrp_53
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chgrp_9

l_fs_chgrp_53:
cmp al, FSID_CD
jnz l_fs_chgrp_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_chgrp_9

l_fs_chgrp_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_chgrp_9:
cmp al, ERC_LINK
jz l_fs_chgrp_0

call fs_leave
ret

// IN: es:edx -> filenamez
// OUT: al = erc, ecx = uid, edx = gid
fs_fuidgid:
call fs_enter

mov take_link, 0
mov link_depth, 0

l_fs_fuidgid_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fuidgid_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fuidgid_50:
cmp al, FSID_EXT2
jnz l_fs_fuidgid_51
  pop eax
  call e2_find_file
  test al, al
  jnz l_fs_fuidgid_506
    call e2_load_inode
    test al, al
    jnz l_fs_fuidgid_506
      movzx ecx, word ptr e2_inode.i_uid
      movzx edx, word ptr e2_inode.i_gid
      
      //mov bl, e2_ldiskn
      //shl ebx, 24
      //or ecx, ebx
      //or edx, ebx
      jmp short l_fs_fuidgid_9
      
  l_fs_fuidgid_506:
  cmp al, ERC_LINK
  jz l_fs_fuidgid_0

  xor ecx, ecx
  xor edx, edx
  jmp short l_fs_fuidgid_9

l_fs_fuidgid_51:
cmp al, FSID_NTFS
jnz l_fs_fuidgid_52
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_fuidgid_9

l_fs_fuidgid_52:
cmp al, FSID_FAT12
jnz l_fs_fuidgid_53
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_fuidgid_9

l_fs_fuidgid_53:
cmp al, FSID_CD
jnz l_fs_fuidgid_59
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_fuidgid_9

l_fs_fuidgid_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fuidgid_9:

call fs_leave
ret

get_user_fname: db "c:/users/users.sys\0"
get_group_fname: db "c:/users/groups.sys\0"

// IN: users_disk
// OUT: al = users_disk
// KEEP: ecx, edi
get_users_disk:
cmp users_disk, 0
jnz l_get_users_disk_9
  push ecx
   push edi
    mov users_disk, 'C'
    
    l_get_users_disk_5:
    mov al, users_disk
    mov [PA_KERNEL_CODE + offset get_user_fname], al
    mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset get_user_fname
    mov al, FOPEN_READ
    call fs_fopen
    test al, al
    jz l_get_users_disk_6
      // errors to repeat
      cmp al, ERC_TOO_MANY_OPEN_FILES
      jnz l_get_users_disk_54
        
        l_get_users_disk_53:
        call p_noop
        jmp l_get_users_disk_5
        
      l_get_users_disk_54:
      cmp al, ERC_BUSY
      jz l_get_users_disk_53
      
      // next disk
      inc users_disk
      cmp users_disk, 'Z'
      jna l_get_users_disk_5
        // '['
        jmp l_get_users_disk_8
      
    l_get_users_disk_6:
    call fs_fclose
    
    l_get_users_disk_8:
   pop edi
  pop ecx
  
l_get_users_disk_9:
mov al, users_disk
ret

// IN: ecx = uid, edi -> byte[256]
get_user:
and ecx, 0xFFFFFF
call get_users_disk  // keep ecx, edi
mov [PA_KERNEL_CODE + offset get_user_fname], al
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset get_user_fname
mov al, FOPEN_READ
push ecx
 push edi
  call fs_fopen
 pop edi
pop ecx
test al, al
jnz l_get_user_9

xor edx, edx
mov ebx, ecx
shl ebx, 8  // assert sizeof UserInfo = 256
push esi
 push edi
  call fs_fsetpos
 pop edi
pop esi

mov ecx, 256  // assert sizeof UserInfo = 256
push esi
 push edi
  call fs_fread
 pop edi
pop esi

push ecx
  add edi, 128
  mov ecx, 64
  xor eax, eax
  cld
  rep stosb
  
  call fs_fclose
pop ecx

l_get_user_9:
ret

// IN: ecx = gid, edi -> byte[256]
// USES: fd_buffer
get_group:
and ecx, 0xFFFFFF
call get_users_disk  // keep ecx, edi
mov [PA_KERNEL_CODE + offset get_group_fname], al
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset get_group_fname
mov al, FOPEN_READ
push ecx
 push edi
  call fs_fopen
 pop edi
pop ecx
test al, al
jnz l_get_group_9

push edi
  
  l_get_group_5:
  jecxz l_get_group_6
    
    push ecx
    
      mov ecx, 256  // assert sizeof GroupInfo = 256
      mov edi, VA_SYSTEM + offset fd_buffer
      push esi
        call fs_fread
      pop esi
      
      push esi
        mov eax, dword ptr fd_buffer[256 - 4]
        shl eax, 2
        
        shl esi, 5 // assert sizeof OpenFileRec = 32
        mov ebx, dword ptr files.pos[esi]
        mov edx, dword ptr files.pos[esi + 4]
        add ebx, eax
        adc edx, 0
        shr esi, 5 // assert sizeof OpenFileRec = 32
        
        call fs_fsetpos
      pop esi
    
    pop ecx
    
    loop l_get_group_5  
    
  l_get_group_6:
pop edi

mov ecx, 256  // assert sizeof GroupInfo = 256
push esi
  call fs_fread
pop esi

push ecx
  call fs_fclose
pop ecx

l_get_group_9:
ret

